;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R02	10/16/96 AVN	Added 2M BIOS Support MXIC 28F2000PPC EEPROM.
;			Define 'MXIC_28F2000PPC'
;R01	09/23/96 AVN	Added 2M BIOS Support INTEL 28F002BXT EEPROM.
;			Fix Dummy Flash Routine Code Size Define by 2MROMLEN.INC
;			If (2M FLASH).NVM > Dummy Size And Show ERROR Message.
;R00	08/20/96 AVN	Initial Version.
;			Support 2M Type EEPROM, By Auto Detect EEPROM Tpye
;			And 2MEEPROM.NVM Code Include in ECODE, Then Copy
;			Usefull ERASE/PROGRAM Function To F000h Segment For
;			Save More Space in F000h - FFFFh

		include	btromseg.equ
		include	2MROMLEN.INC				;R01

ifdef	Flash_2M_support
ifdef	Flash_16K_8K_8K_Unit					;R02
SST_29EE020_Start:
		include	sst020.nvm
SST_29EE020_End:
AMD_29F002T_Start:
		include	am29f002.nvm
AMD_29F002T_End:
ATMEL_29C020_Start:
		include	atmel020.nvm
ATMEL_29C020_End:
INTEL_28F002BXT_Start:						;R01
		include	f002bxt.nvm				;R01
INTEL_28F002BXT_End:						;R01

SST_29EE020_LEN			EQU	offset SST_29EE020_End - offset SST_29EE020_Start
SST_29EE020_WRITE_OFFSET	EQU	offset SST020_Flash_Write - offset SST020_Flash_Erase
AMD_29F002T_LEN			EQU	offset AMD_29F002T_End - offset AMD_29F002T_Start
AMD_29F002T_WRITE_OFFSET	EQU	offset AM29F002T_Flash_Write - offset AM29F002T_Flash_Erase
ATMEL_29C020_LEN		EQU	offset ATMEL_29C020_End - offset ATMEL_29C020_Start
ATMEL_29C020_WRITE_OFFSET	EQU	offset ATMEL29C020_Flash_Write - offset ATMEL29C020_Flash_Erase
;R01 - START
INTEL_28F002BXT_LEN		EQU	offset INTEL_28F002BXT_End - offset INTEL_28F002BXT_Start
INTEL_28F002BXT_WRITE_OFFSET	EQU	offset F002BXT_Flash_Write - offset F002BXT_Flash_Erase

FLASH_CODE_SIZE_ERROR	=	0
IF	SST_29EE020_LEN GT _2M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	1
ENDIF
IF	AMD_29F002T_LEN GT _2M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	2
ENDIF
IF	ATMEL_29C020_LEN GT _2M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	3
ENDIF
IF	INTEL_28F002BXT_LEN GT _2M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	4
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	1
%OUT	ERROR: SST020.NVM code size is more then prepare in 2MROMLEN.INC
%OUT	       Please increase size in 2MROMLEN.INC
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	2
%OUT	ERROR: AM29F002.NVM code size is more then prepare in 2MROMLEN.INC
%OUT	       Please increase size in 2MROMLEN.INC
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	3
%OUT	ERROR: ATMEL020.NVM code size is more then prepare in 2MROMLEN.INC
%OUT	       Please increase size in 2MROMLEN.INC
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	4
%OUT	ERROR: F002BXT.NVM code size is more then prepare in 2MROMLEN.INC
%OUT	       Please increase size in 2MROMLEN.INC
ENDIF
;R01 - END

;R02 - start
elseifdef	Flash_4K_Unit
MXIC_28F2000PPC_Start:
		include	mx2mppc.nvm
MXIC_28F2000PPC_End:

MXIC_28F2000PPC_LEN		EQU	offset MXIC_28F2000PPC_End - offset MXIC_28F2000PPC_Start
MXIC_28F2000PPC_WRITE_OFFSET	EQU	offset MX_28f2000PPC_Flash_Write - offset MX_28f2000PPC_Flash_Erase

FLASH_CODE_SIZE_ERROR	=	0
IF	MXIC_28F2000PPC_LEN GT _2M_EEPROM_LEN
FLASH_CODE_SIZE_ERROR	=	1
ENDIF

IF	FLASH_CODE_SIZE_ERROR	EQ	1
%OUT	ERROR: MX2MPPC.NVM code size is more then prepare in 2MROMLEN.INC
%OUT	       Please increase size in 2MROMLEN.INC
ENDIF

endif;	Flash_16K_8K_8K_Unit
;R02 - end
endif;	Flash_2M_support
