;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R47    12/22/97 ATY    Added Funtion "FAN_CONTROL_BY_GPIO7"
;R14A	11/24/97 AVN	Added CPU 2.2v support in item for GEMLIGHT.
;R46	11/24/97 AVN	Added North bridge latency time value fixed in MODBIN.EXE
;R45	11/14/97 ATY    Added 'Showonly_SDRAM_CAS_LAT'for customs of needed.  
;R44    11/13/97 ATY    Added 'SPECIAL_CPU_PCI_post'for customer of needed.
;R43    11/13/97 ATY   	Added Register "8A,8B" for program "Modbin" can change
;			it.	
;R42 	11/11/97 PAL	Fixed CMOS conflict 41h to be 47h
;R41	11/11/97 ATY    Added 'SPECIAL_CPU_PCI_POST_WRITE'
;R40 	11/11/97 ATY    Added 'PCI_BUS_SYNC_MODE_AUTO_TABLE'
;R39    11/10/97 AVN    Added FAN control by GPIO5,
;			define 'FAN_CONTROL_BY_GPIO5'
;R38	11/03/97 AVN	Added thermal pin throttling function.
;R37	10/29/97 TNY	Modulize jumpless.
;R36	10/27/97 TNY	Support SiS software I2C programming.
;R35	10/08/97 AVN	Added LM78 support by GPCS0 decode 294h.
;R34	10/05/97 LAW	added use GPCS0 to decode 130h-137h
;R33	10/06/97 JKY	Added Romitem , from pfeature menuitem move to here .
;R32	09/17/97 RAY	Support kernel switch: New_Auto_Table_Method which is
;			a switch to support only auto-table with system speed
;			starting from 50Mhz to 83Mhz
;R26A	09/12/97 AVN	Fixed use NEC sdram (2T) warm boot will hang, because
;			SHADOW_OK_CMOS(46h) in cmos checksum locate and always
;			clear when write cmos from stack.
;			ALARM_CMOS had change define in BIOS.CFG
;R25A	05/13/97 AVN	Added open 0054h bit 0,1 in Auto table for GEMLIGHT
;			by define 'GEMLIGHT_SPECIAL_AUTO_TABLE'
;R31	08/20/97 AVN	Added DRAM driving current item by define 'DRAM_CURRENT_SETUP'
;R29A	08/04/97 AVN	Fixed coding error.
;R08A	08/04/97 AVN	Fixed coding error.
;R30A	07/17/97 JKY	Added battery low warning item for special support
;R30	07/16/97 JKY	Added battery low warning item for special support
;R29	07/11/97 AVN	change ring power up to default value useing last time
;			cmos setup value.
;R28	07/11/97 AVN	Added FUN control by GPCS0 function
;			define 'FAN_CONTROL_BY_GPCS0'
;			define 'GPCS0_FAN_Lo_Active' for output low turn fun on
;R27	06/27/97 JKY	Make sure early step GPIO5='0' for special customer
;R19D	05/19/97 AVN	Porting registers by SiS recommend
;R26	05/16/97 AVN	Support Resume by Alarm use Cmos 40h - 45h
;			Default Disable Hot Key Function
;			Default Set GPIO5 to Power Up Function
;R25	05/13/97 AVN	Added open 0056h bit 0,1,2 in Auto table for GEMLIGHT
;			by define 'GEMLIGHT_SPECIAL_AUTO_TABLE'
;R24	05/13/97 AVN	Added ACPILED function support by define 'SUSPEND_SHOW_ACPILED'
;R23	05/13/97 AVN	Added define 'NO_CPU_SPEED_ITEM' for GEMLIGHT
;R19C	04/30/97 AVN	Porting registers by SiS recommend
;R22	05/08/97 KEN	Always enabled USB host controller in POST stage.
;R21	05/08/97 JKY	Added special function for GPCS0 out (low active)
;			(i/o:16c,16d,16e,16f) def:GPCS0_IO_16C
;R20	04/30/97 JKY	Special support : flash write protect used GPIO0 
;			'h' active. def : FLASH_WP_USE_GPIO0 & GPIO0_H_ACTIVE
;R19B	04/30/97 AVN	Porting registers by SiS recommend
;R19A	04/25/97 LRY	Porting registers by SiS recommend
;R19	04/24/97 LRY	Porting registers by SiS recommend
;R06A	04/24/97 LRY	Added NA enable item again
;R18	04/23/97 LRY	Change cmos checksum location, the cmos 7Eh & 7Fh is
;			Day of month alarm & Month alarm
;R17	04/22/97 LRY	Support 'KLOCK_SELECT'  (OPTIONAL)
;R16	04/21/97 LRY	Fixed WD HDD unstable, the 5597 A0 will not show 80 port
;R09A	04/10/97 LRY	Change SDRAM cas latency cmos from 5Fh to 34h
;R15	04/10/97 LRY	Support "GPCS_SUPERIO equ 0/1", for 16 bit I/O decode
;R14	04/01/97 LRY	Support "GEMLIGHT_JUMPERLESS"  (OPTIONAL)
;R13	04/01/97 LRY	By SiS inform, wake up IRQ default enable
;R12	04/01/97 LRY	By SiS inform, IDE command timing use self register
;R11	03/24/97 LRY	To enhance IDE performance, enable fast IDE post-write
;			& CS_ timing
;R10	03/24/97 LRY	Fixed SDRAM screen garbage when testing memory
;R09	03/14/97 LRY	Added SDRAM CAS latency item
;R08	03/14/97 LRY	Support green assert GPIO pin  (OPTIONAL)
;R07	03/05/97 LRY	By SiS inform, L2 cache don't support write through
;R06	03/05/97 LRY	Removed NA# item, auto disable NA# when use VGA
;			shared memory
;R05	02/18/97 LRY	Fixed some sound card (Creative AWE32) enter Win95
;			system hang
;R04	01/31/97 LRY	Support 6205 VGA shared memory
;R03	01/21/97 LRY	Added some register at ROM-TABLE
;R02	01/13/97 LRY	Modify auto-table for 75MHz ISA clock to 7.159MHz
;R01	01/09/97 LRY	Fast reset latency set to 6us
;R00	01/07/97 LRY	Initial version

		PAGE	56,132
		.286
		include bios.cfg
		include bsetup.inc
		include common.mac
		include common.equ
		include cmos.equ

		include setup.ext
		extrn	PAGE_NAME_Y:ABS
		Extrn	Common_Startup_Str:Near
		Extrn	Ena_Str:Near
		Extrn	Dis_Str:Near
		Extrn	Std_Help_Str:Near
		Extrn	NullStr:Near

;R36 - start
ifdef	LM75_Support					
		extrn	DISP_Byte_INT2:Near		
		extrn	DISP_WORD_INT3:near		
		extrn	Get_LM75_Word:near		
endif;	LM75_Support					
		extrn	F000_call_proc:near		
		extrn	post_call_proc:near		
;R36 - end

		Public	Chip_Feature_Special_Do
		Public	Chip_Feature_Special_Show
		Public	Chip_Feature_Key_List
		Public	Chip_Feature_StartUp_Str
		Public	Chip_Feature_Start
 		Public	Chip_Feature_End
		Public	CHIP_STAT
		Public	Auto_Cfg_Item

		Public	Cmos_Check_Sum
		public	Rom_Table
		public	EndRom_Table
		public	Auto_String
		public	Auto_Table
		public	EndAuto_Table
		public	Auto_Dx2_Table

ifndef	New_Auto_Table_Method				;R32
		Public	Auto_CPU_386DX
		Public	Auto_CPU_386SX
		Public	Auto_CPU_386SL
		Public	Auto_CPU_486DX
		Public	Auto_CPU_486SX
		Public	Auto_CPU_486SLC
		Public	Auto_CPU_486DLC
		Public	Auto_CPU_IBM386SLC
		Public	Auto_CPU_P24T
		Public	Auto_CPU_486DX2
		Public	Auto_CPU_IBM486SLC2
		Public	Auto_CPU_486S
		Public	Auto_CPU_486S2
		Public	Auto_CPU_586
		Public	Auto_CPU_486DXS
		Public	Auto_CPU_486SXS
		Public	Auto_CPU_486DX2S
		Public	Auto_CPU_IBM486DLC3
endif;	New_Auto_Table_Method				;R32

CF_CMOS EQU	50h

DEFINE_ITEM	MACRO	MENU_NAME,GAP
IFB	<GAP>
	Yaxis = Yaxis + 1
ELSE	;
 IF	Yaxis GT 3		;if Yaxis great than the top row, process gap
  IFDEF LAST_GAP_POSITION
   IF	Xaxis+Yaxis NE LAST_GAP_POSITION
	Yaxis = Yaxis + 1
   ENDIF;
  ELSE	;
	Yaxis = Yaxis + 1
  ENDIF ;LAST_GAP_POSITION
	LAST_GAP_POSITION = Xaxis + Yaxis
 ENDIF	;
	Yaxis = Yaxis + GAP
ENDIF	;GAP
IF	Yaxis GT 23
	Xaxis = 42
	Yaxis = 4
 IFNB	<GAP>
  IF	GAP EQ 0
	Yaxis = 3
  ENDIF	;
 ENDIF	;
ENDIF	;
IFNB	<MENU_NAME>
	PUBLIC	MENU_NAME
	MENU_NAME:
ENDIF
		ENDM

DSP_IOCMOS	MACRO	CMOS_LOC
	if2
		%out	CMOS location = CMOS_LOC
	endif
		ENDM

EGROUP		GROUP	ECODE		;R36

DGROUP		GROUP	FCODE
FCODE		SEGMENT DWORD PUBLIC 'CODE'
		ASSUME	CS:DGROUP,DS:DGROUP

; Chipset Feature Page ------------------------------------------------ Start

Chip_Feature_Special_Do:
			dw	Chip_Feature_Do_NO
Chip_Feature_Do_NO	EQU	(($ - offset Chip_Feature_Special_Do)-2)/4

Chip_Feature_Special_Show:
			dw	Chip_Feature_Show_NO
ifdef	AGGRESSIVE_MODE_SUPP
			dw	Offset Auto_Cfg_Item,Offset Show_Auto_Cfg1
			dw	Offset Aggressive_Item,Offset Show_Aggre
else	;AGGRESSIVE_MODE_SUPP
			dw	Offset Auto_Cfg_Item,Offset Show_Auto_Cfg
endif	;AGGRESSIVE_MODE_SUPP
;R30 - start
ifdef	BATT_LOW_BEEP_SUPPORT
	 		dw	offset Batt_low_1st_percent,offset Show_Batt_Low_Beep
			dw	offset Batt_low_2nd_percent,offset Show_Batt_Low_Beep_2
endif	;BATT_LOW_BEEP_SUPPORT
;R30 - end
		include	sensor.shw					;R36
Chip_Feature_Show_NO	EQU	(($ - offset Chip_Feature_Special_Show)-2)/4

Chip_Feature_Key_List:
		dw	offset Seq_Up		;function for UP_ARROW
		dw	offset Seq_Down 	;function for DOWN_ARROW
		dw	offset Go_Left_Item	;function for LEFT_ARROW
		dw	offset Go_Right_Item	;function for RIGHT_ARROW

Chip_Feature_StartUp_Str	label	near
		STRSHOW <,,,offset Common_Startup_Str>
		POS	<,29,PAGE_NAME_Y>
		db	'CHIPSET FEATURES SETUP'
		db	0

;---------------------------------------------------------------------------

		ALIGN	4
Cmos_Check_Sum	label	near
		db	10H	;STD checksum start location
		db	2DH	;STD checksum end location
		db	2EH	;STD checkum low byte

		;Check sum for extended CMOS

	ifdef	RSM_BY_ALARM	;R26
;26A		db	40h	;R26
		db	ALARM_CMOS			;R26A
	else;	RSM_BY_ALARM	;R26
		db	48h
	endif;	RSM_BY_ALARM	;R26
		db	7Bh	;R18
		db	7Ch	;R18
;R18		db	7Dh
;R18		db	7Eh
;-------- USED CMOS TABLE -------- 04/30/97
;	34h - 35h	pcifeat.asm	new_ide_mode_3 34b1 ps2
;				      34b0 SDRAM cas latency, 35b0~1 fdd3mode
;	36h		pfeature.asm	NF_CMOS
;	37h - 39h	pcifeat.asm	MIRQ & MDRQ
;	40h		Notebook PM (NO Checksum)
;	40h - 45h	use by RSM ALARM		;if define RSM_BY_ALARM
;	46h		chipboot chippost	record system hang
;	48h -		iofeat.asm	IO_CMOS
;	4Ah - 4Eh	audio.asm
;	4Fh bit0~4	cfeature.asm	VGA_frequency
;	4Fh bit5~7	cfeature.asm	CF_CMOS
;	50h - 55h	cfeature.asm	CF_CMOS
;	56h bit0~3	iofeat.asm	USB, int_ide
;	56h bit4~7	pfeature.asm	modem ring
;	57h		pcifeat.asm	onboard switch items
;	58h - 5Ch	pcifeat.asm	PCI_CMOS
;	5Dh - 5Fh bit0	chippost.asm	password
;	5Fh bit7	cfeature.asm	SDRAM CAS latency
;	5Fh bit5~6	pcifeat.asm	pci-cfeature
;	5Fh bit2~4	cfeature.asm	share memory size
;	60h - 66h	pfeature.asm	PF_CMOS
;	7Ah - 7Bh	free
;-------- USED CMOS TABLE --------
		db	0	;end of checksum

		ALIGN	4
Rom_Table	label	near
;R06A ifdef	NA_EN_ITEM						;R06
		ROMITEM <2,000Dh,11111111b,0FFh>		;R46
ifndef	NO_NA_ITEM						;R06A
		ROMITEM <2,0050h,01011111b,000h>
else	;NA_EN_ITEM						;R06
		ROMITEM <2,0050h,11011111b,080h>		;R06
endif	;NA_EN_ITEM						;R06
;R19		ROMITEM <2,0052h,11101100b,080h>
		ROMITEM <2,0052h,11111111b,080h>	;R19
		ROMITEM <2,0053h,00111001b,018h>
ifndef	MDLE_DELAY_SELECTABLE			 ;R03
;R19		ROMITEM <2,0056h,11111111b,003h> ;R03
		ROMITEM <2,0056h,11111111b,083h> ;R03	;R19
endif	;MDLE_DELAY_SELECTABLE			 ;R03
;R17		ROMITEM <2,0057h,11000001b,000h> ;R03
	REG57_DFT=0					;R17
ifdef	KLOCK_SELECT					;R17
	REG57_DFT=REG57_DFT or 01h			;R17
endif	;KLOCK_SELECT					;R17
		ROMITEM <2,0057h,11000001b,REG57_DFT>	;R17
;R19C		ROMITEM <2,0058h,11111111b,048h>	;R19
		ROMITEM <2,0058h,11111111b,068h>	;R19C
;R19A		ROMITEM <2,0059h,11111111b,038h>
		ROMITEM <2,0059h,11111111b,0B8h>	;R19A
		ROMITEM <2,005Ah,11111111b,000h>
ifdef	SHARE_SiS6205				 ;R04
		ROMITEM <2,006Dh,11111111b,002h> ;R04
endif	;SHARE_SiS6205				 ;R04
		ROMITEM <2,0080h,11111111b,05Ch>
;R19		ROMITEM <2,0081h,11111111b,0C0h>
		ROMITEM <2,0081h,11111111b,0CCh>	;R19
;R19		ROMITEM <2,0082h,11001111b,00Eh>
		ROMITEM <2,0082h,11111111b,0CEh>	;R19
ifdef  SHOW_8A_8B_Reg 					;R43
                ROMITEM <2,008Ah,11111111b,000h>        ;R43
                ROMITEM <2,008Bh,11111111b,000h>        ;R43
endif; SHOW_8A_8B_Reg					;R43
;R01		ROMITEM <2,0083h,11110000b,0F0h>
	REG83_DFT=0D0h					;R01
ifdef	NO_A20_EMULATION				;R01
	REG83_DFT=REG83_DFT and 70h			;R01
endif	;NO_A20_EMULATION				;R01
ifdef	NO_RESET_EMULATION				;R01
	REG83_DFT=REG83_DFT and 0B0h			;R01
endif	;NO_RESET_EMULATION				;R01
		ROMITEM <2,0083h,11110000b,REG83_DFT>	;R01
		ROMITEM <2,0084h,11111111b,040h>	;R19
		ROMITEM <2,0085h,11111111b,000h>	;R19
		ROMITEM <2,0086h,11111111b,010h>	;R19
;R19		ROMITEM <2,0087h,11111111b,000h>
		ROMITEM <2,0087h,11111111b,040h>	;R19
ifdef	NON_CACHEABLE_BLOCK
		ROMITEM <2,0077h,11111000b,008h>
else	;NON_CACHEABLE_BLOCK
		ROMITEM <2,0077h,11111000b,000h>
		ROMITEM <2,0078h,11111111b,080h>
		ROMITEM <2,0079h,11111111b,0F0h>
endif	;NON_CACHEABLE_BLOCK
ifndef	MOVE_MENUITEM_TO_ROMITEM			;R33
		ROMITEM <2,0090h,01000111b,042h>
else	;MOVE_MENUITEM_TO_ROMITEM			;R33
		ROMITEM <2,0090h,11111111b,0FAh>	;R33
		ROMITEM <2,0091h,00111100b,004h>	;R33
endif	;MOVE_MENUITEM_TO_ROMITEM			;R33
		ROMITEM <2,0092h,11111111b,002h>
		ROMITEM <2,0094h,00001111b,008h>

		ROMITEM <2,0840h,01110000b,070h>	;R19D
		ROMITEM <2,0841h,11111111b,080h>
		ROMITEM <2,0842h,11111111b,080h>
		ROMITEM <2,0843h,11111111b,080h>
		ROMITEM <2,0844h,11111111b,080h>
;R16		ROMITEM <2,0846h,11111111b,001h>
		ROMITEM <2,0846h,11111111b,000h>	;R16
;R05		ROMITEM <2,0847h,11111111b,03Dh>
		ROMITEM <2,0847h,11111111b,03Eh>	;R05
		ROMITEM <2,0848h,11111111b,0FFh>
		ROMITEM <2,0849h,11111111b,0FFh>	
		ROMITEM <2,0862h,01000000b,040h>	;R22
ifdef	GPCS_SUPERIO				    	;R15
 if	GPCS_SUPERIO eq 0				;R15
		ROMITEM <2,0863h,11111111b,000h>	;R15
		ROMITEM <2,0865h,11111111b,000h>	;R15
		ROMITEM <2,0866h,11111111b,000h>	;R15
 else							;R15
		ROMITEM <2,0864h,11111111b,000h>	;R15
		ROMITEM <2,0867h,11111111b,000h>	;R15
		ROMITEM <2,0868h,11111111b,000h>	;R15
 endif							;R15
		ROMITEM <2,0869h,11101111b,084h>	;R15
endif	;GPCS_SUPERIO					;R15
ifdef	GPCS0_IO_16C					;R21
		ROMITEM <2,0866h,11111111b,001h>	;R21
		ROMITEM <2,0865h,11111111b,06ch>	;R21
		ROMITEM <2,0863h,11111111b,002h>	;R21
endif	;GPCS0_IO_16C					;R21
ifdef	Special_GPIO1					;R34
		ROMITEM <2,0866h,11111111b,001h>	;R34
		ROMITEM <2,0865h,11111111b,031h>	;R34
		ROMITEM <2,0863h,11111111b,000h>	;R34
endif;	Special_GPIO1					;R34
ifdef	GPCS0_Use_294h					;R35
		ROMITEM <2,0866h,11111111b,002h>	;R35
		ROMITEM <2,0865h,11111111b,094h>	;R35
		ROMITEM <2,0863h,11111111b,000h>	;R35
endif;	GPCS0_Use_294h					;R35
ifndef	MOVE_MENUITEM_TO_ROMITEM			;R33
		ROMITEM <2,0874h,00000101b,004h>	
else	;MOVE_MENUITEM_TO_ROMITEM			;R33
		ROMITEM <2,0874h,11111101b,004h>	;R33
		ROMITEM <2,0875h,11111111b,001h>	;R33
endif	;MOVE_MENUITEM_TO_ROMITEM			;R33
;R36		ROMITEM <2,086Dh,00000011b,000h>	;R26
		ROMITEM <2,086Dh,00000111b,004h>	;R36
ifdef	ONCHIP_IDE_ALWAYS_DISABLE
		ROMITEM <2,0904h,11111111b,000h>
else	;ONCHIP_IDE_ALWAYS_DISABLE
		ROMITEM <2,0909h,01001111b,04Ah>
		ROMITEM <2,090Dh,11111111b,000h>
;R11		ROMITEM <2,094Ah,01111001b,000h>
		ROMITEM <2,094Ah,11111001b,021h>	;R11
		ROMITEM <2,094Ch,11111111b,000h>
		ROMITEM <2,094Dh,11111111b,002h>
		ROMITEM <2,094Eh,11111111b,000h>
		ROMITEM <2,094Fh,11111111b,002h>
		ROMITEM <2,0952h,11111111b,008h>	;R12
endif	;ONCHIP_IDE_ALWAYS_DISABLE

;R28 - start
ifdef	FAN_CONTROL_BY_GPCS0
ifdef	GPCS0_FAN_Lo_Active
		ROMITEM <2,0863h,10010001b,000h>
else;	GPCS0_FAN_Lo_Active
		ROMITEM <2,0863h,10010001b,010h>
endif;	GPCS0_FAN_Lo_Active
endif;	FAN_CONTROL_BY_GPCS0
;R28 - end

;R20 - start
ifdef	FLASH_WP_USE_GPIO0
ifdef	GPIO0_H_ACTIVE
		ROMITEM <2,ACPI_R+18h,00000001b,0>	;JKY GPIO0='L'
		ROMITEM <2,ACPI_R+1ah,00000001b,1>	;JKY GPIO0=>OUT
endif	;GPIO0_H_ACTIVE
		ROMITEM <2,0870h,00010000b,0>		;JKY select GPIO0
endif	;FLASH_WP_USE_GPIO0
;R20 - end
;R27 - start
ifdef	DYNA2_NOTEBOOK
		ROMITEM <2,ACPI_R+18h,00100000b,0>	;GPIO5='L'
endif	;DYNA2_NOTEBOOK
;R27 - end

		ROMITEM <2,ACPI_R+17h,11111111b,080h>	;R13
;R08 - start
		APC_R2_DFT = 00h
ifndef	No_Ring_UP_Item					;R29
;R29A		APC_R3_MK  = 0FFh			;R29
		APC_R3_MK  = 0DFh			;R29A
else;	No_Ring_UP_Item					;R29
;R29A		APC_R3_MK  = 0DFh			;R29
		APC_R3_MK  = 0FFh			;R29A
endif;	No_Ring_UP_Item					;R29
		APC_R3_DFT = 40h
		APC_R4_MK  = 0FFh
		APC_R4_DFT = 0Eh
		GREEN_ASSERT_PIN = 0
ifdef	LINEAR_MODE_GPIO5
;R08A		APC_R4_MK  = APC_R4_MK  and 0FBh
		APC_R4_MK  = APC_R4_MK  or  004h	;R08A
		APC_R4_DFT = APC_R4_DFT and 0FBh
endif	;LINEAR_MODE_GPIO5
ifdef	GREEN_ASSERT_GPIO5
		APC_R4_DFT = APC_R4_DFT and 0FBh
 if	GREEN_ASSERT_GPIO5 eq 1
		GREEN_ASSERT_PIN = 1110h
 else
		GREEN_ASSERT_PIN = 0001h
 endif
endif	;GREEN_ASSERT_GPIO5

;R26 - start
ifndef	FAN_CONTROL_BY_GPIO5					;R39
ifndef	LINEAR_MODE_GPIO5
ifndef	GREEN_ASSERT_GPIO5
		APC_R4_DFT = APC_R4_DFT or 004h
endif;	GREEN_ASSERT_GPIO5
endif;	LINEAR_MODE_GPIO5
endif;	FAN_CONTROL_BY_GPIO5					;R39
;R26 - end

;R24 - start
ifdef	SUSPEND_SHOW_ACPILED
		APC_R4_DFT = APC_R4_DFT and 11110110b
		APC_R4_DFT = APC_R4_DFT or  00000010b
endif;	SUSPEND_SHOW_ACPILED
;R24 - end

;R39
ifdef	FAN_CONTROL_BY_GPIO5
		ROMITEM <2,ACPI_R+18h,00100000b,020h>
		APC_R4_MK  = APC_R4_MK or 004h
		APC_R4_DFT = APC_R4_DFT and 11111011b
endif;	FAN_CONTROL_BY_GPIO5
;R39

;R47 start
ifdef   FAN_CONTROL_BY_GPIO7
		ROMITEM <2,ACPI_R+1ah,10000000b,080h>
		ROMITEM <2,ACPI_R+18h,10000000b,080h>
endif;	FAN_CONTROL_BY_GPIO7
;R47 end

		ROMITEM <2,APC_R+02h,11111111b,APC_R2_DFT>
;R29		ROMITEM <2,APC_R+03h,11111111b,APC_R3_DFT>
		ROMITEM <2,APC_R+03h,APC_R3_MK,APC_R3_DFT>	;R29
		ROMITEM <2,APC_R+04h,APC_R4_MK,APC_R4_DFT>

if	GREEN_ASSERT_PIN ne 0
		Public	GPIO_STPCLK_DEF
GPIO_STPCLK_DEF:
		ROMITEM <3,0FFE0h,1111h,GREEN_ASSERT_PIN>
endif
;R08 - end

;R38 - start
ifdef	LM75_Support					
ifdef	Thermal_Enable
		ROMITEM <2,ACPI_R+1bh,00000010b,00h>	;GPIO9 input mode
		ROMITEM <2,ACPI_R+24h,01000000b,40h>	;GPIO9#/THRM# select
		ROMITEM <2,ACPI_R+1fh,00000010b,00h>	;GPIO9/THRM low active
		ROMITEM <2,ACPI_R+1ch,00001000b,08h>	;enable thermal throttling
		ROMITEM <2,ACPI_R+1dh,00000010b,00h>	;THRM# select
endif;	Thermal_Enable
endif;	LM75_Support					
;R38 - end

EndRom_Table	label	near

;------------------------------------------------------------------
		public	Auto_String
Auto_String	label	near
;R32 - start
ifdef	New_Auto_Table_Method
		db	'50 MHz',0
		db	'60 MHz',0
		db	'66 MHz',0
		db	'75 MHz',0
		db	'83 MHz',0
else;	New_Auto_Table_Method
		db	'40MHz    ',0
		db	'50/75MHz ',0
		db	'60/90MHz ',0
		db	'66/100MHz',0
ifdef	AUTO75_SUPPORT
		db	'75/150MHz',0		;for Cyrix 75*2 system
endif	;AUTO75_SUPPORT

ifdef	AGGRESSIVE_MODE_SUPP
		db	'40,Aggre ',0
		db	'50,Aggre ',0
		db	'60,Aggre ',0
		db	'66,Aggre ',0
 ifdef	AUTO75_SUPPORT
		db	'75,Aggre ',0		;for Cyrix 75*2 system
 endif	;AUTO75_SUPPORT
endif	;AGGRESSIVE_MODE_SUPP
endif;	New_Auto_Table_Method

;Auto-configuration items

		ALIGN	4
		Public	New_Auto_Table			;R32
New_Auto_Table	label	near				;R32
Auto_Table	label	near

		db	No_Of_Auto_Item

;R32 - start
ifdef	New_Auto_Table_Method
		dw	offset Auto_50Mhz	;for 50Mhz system
		dw	offset Auto_60Mhz	;for 60Mhz system
		dw	offset Auto_66Mhz	;for 66Mhz system
		dw	offset Auto_75Mhz	;for 66Mhz system
		dw	offset Auto_83Mhz	;for 66Mhz system
else	;New_Auto_Table_Method
;R32 - end

Auto_CPU_386DX:
Auto_CPU_386SX:
Auto_CPU_386SL:
Auto_CPU_486SLC:
Auto_CPU_486DLC:
Auto_CPU_IBM386SLC:
Auto_CPU_486S:
Auto_CPU_586:
Auto_CPU_486DXS:
Auto_CPU_486SXS:
Auto_CPU_486DX:
Auto_CPU_486SX:
Auto_CPU_P24T:
		dw	offset Auto_40Mhz	;for 40Mhz system
		dw	offset Auto_50Mhz	;for 50Mhz system
		dw	offset Auto_60Mhz	;for 60Mhz system
		dw	offset Auto_66Mhz	;for 66Mhz system
ifdef	AUTO75_SUPPORT
		dw	offset Auto_75Mhz	;for Cyrix 75*2 system
endif	;AUTO75_SUPPORT

ifdef	AGGRESSIVE_MODE_SUPP
Aggressive_Diff	EQU	($ - offset Auto_Table) - 1
		dw	offset Auto_40Mhz_a	;for 40Mhz system
 		dw	offset Auto_50Mhz_a	;for 50Mhz system
		dw	offset Auto_60Mhz_a	;for 60Mhz system
		dw	offset Auto_66Mhz_a	;for 66Mhz system
 ifdef	AUTO75_SUPPORT
		dw	offset Auto_75Mhz_a	;for Cyrix 75*2 system
 endif	;AUTO75_SUPPORT
endif	;AGGRESSIVE_MODE_SUPP
endif	;New_Auto_Table_Method				;R32

Auto_Dx2_Table	label	near
Auto_CPU_486DX2:
Auto_CPU_IBM486SLC2:
Auto_CPU_486S2:
Auto_CPU_486DX2S:


Auto_Dx3_Table	label	near
Auto_CPU_IBM486DLC3:
EndAuto_Table	label	near


		ALIGN	4
Auto_16Mhz	label	near

		ALIGN	4
Auto_20Mhz	label	near

		ALIGN	4
Auto_25Mhz	label	near

		ALIGN	4
Auto_50DX2	label	near
Auto_75DX3	label	near

		ALIGN	4
Auto_33Mhz	label	near

		ALIGN	4
Auto_66DX2	label	near
Auto_100DX3	label	near

		ALIGN	4
Auto_40Mhz	label	near

		ALIGN	4
Auto_50Mhz	label	near
		ROMITEM <2,0050h,00001100b,008h>
;R19A		ROMITEM <2,0053h,00000110b,002h>
;R19B		ROMITEM <2,0053h,00000110b,004h>	;R19A
		ROMITEM <2,0053h,00000110b,006h>	;R19B
;R19		ROMITEM <2,0054h,11000000b,040h>
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0054h,11111111b,0A8h>	;R25A
else;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0054h,11111100b,0A8h>	;R19
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0055h,00100000b,000h>	;R19
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25
		ROMITEM <2,0056h,00000111b,003h>	;R25
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25
ifdef	PCI_BUS_SYNC_MODE_AUTO_TABLE			;R40
		ROMITEM <2,0080h,00000010b,000h>	;R40
endif;	PCI_BUS_SYNC_MODE_AUTO_TABLE			;R40
		ROMITEM <2,0081h,11000000b,000h>
;R19A		ROMITEM <2,0082h,11000000b,000h>	;R19
;R19B		ROMITEM <2,0082h,11000000b,0C0h>	;R19A
		ROMITEM <2,0082h,11000000b,000h>	;R19B
ifndef SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0083h,00001001b,009h>	;R41
else							;R41
		ROMITEM <2,0083h,00001000b,008h>	;R41
endif; SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0845h,11000000b,080h>
No_Of_Auto_Item EQU	($-offset Auto_16Mhz)/ROMITEM_SIZE

		ALIGN	4
Auto_60Mhz	label	near
		ROMITEM <2,0050h,00001100b,008h>
;R19A		ROMITEM <2,0053h,00000110b,002h>
;R19B		ROMITEM <2,0053h,00000110b,004h>	;R19A
		ROMITEM <2,0053h,00000110b,006h>	;R19B
;R19		ROMITEM <2,0054h,11000000b,040h>
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0054h,11111111b,0A8h>	;R25A
else;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0054h,11111100b,0A8h>	;R19
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0055h,00100000b,000h>	;R19
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25
		ROMITEM <2,0056h,00000111b,003h>	;R25
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25
		ROMITEM <2,0081h,11000000b,0C0h>
;R19A		ROMITEM <2,0082h,11000000b,000h>	;R19
		ROMITEM <2,0082h,11000000b,0C0h>	;R19A
ifndef SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0083h,00001001b,009h>	;R41
else							;R41
		ROMITEM <2,0083h,00001000b,008h>	;R41
endif; SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0845h,11000000b,040h>

		ALIGN	4
Auto_66Mhz	label	near
		ROMITEM <2,0050h,00001100b,008h>
;R19A		ROMITEM <2,0053h,00000110b,002h>
;R19B		ROMITEM <2,0053h,00000110b,004h>	;R19A
		ROMITEM <2,0053h,00000110b,006h>	;R19B
;R19		ROMITEM <2,0054h,11000000b,040h>
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0054h,11111111b,0A8h>	;R25A
else;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0054h,11111100b,0A8h>	;R19
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0055h,00100000b,000h>	;R19
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25
		ROMITEM <2,0056h,00000111b,003h>	;R25
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25
ifdef	PCI_BUS_SYNC_MODE_AUTO_TABLE			;R40
		ROMITEM <2,0080h,00000010b,000h>	;R40
endif;	PCI_BUS_SYNC_MODE_AUTO_TABLE			;R40
		ROMITEM <2,0081h,11000000b,0C0h>
;R19A		ROMITEM <2,0082h,11000000b,000h>	;R19
		ROMITEM <2,0082h,11000000b,0C0h>	;R19A
ifndef SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0083h,00001001b,009h>	;R41
else							;R41
		ROMITEM <2,0083h,00001000b,008h>	;R41
endif; SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0845h,11000000b,040h>

ifndef	New_Auto_Table_Method				;R32
ifdef	AUTO75_SUPPORT
		ALIGN	4
Auto_75Mhz	label	near
		ROMITEM <2,0050h,00001100b,000h>
;R19A		ROMITEM <2,0053h,00000110b,000h>
;R19B		ROMITEM <2,0053h,00000110b,004h>	;R19A
		ROMITEM <2,0053h,00000110b,006h>	;R19B
;R19		ROMITEM <2,0054h,11000000b,080h>
;R19B		ROMITEM <2,0054h,11111100b,0F8h>	;R19
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0054h,11111111b,0A8h>	;R25A
else;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0054h,11111100b,0E8h>	;R19B
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25A
		ROMITEM <2,0055h,00100000b,020h>	;R19
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25
		ROMITEM <2,0056h,00000111b,003h>	;R25
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE			;R25
ifdef	PCI_BUS_SYNC_MODE_AUTO_TABLE			;R40
		ROMITEM <2,0080h,00000010b,000h>	;R40
endif;	PCI_BUS_SYNC_MODE_AUTO_TABLE			;R40
		ROMITEM <2,0081h,11000000b,0C0h>
		ROMITEM <2,0082h,11000000b,0C0h>	;R19
ifndef SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0083h,00001001b,009h>	;R41
else							;R41
		ROMITEM <2,0083h,00001000b,008h>	;R41
endif; SPECIAL_CPU_PCI_POST_WRITE			;R41
;R02		ROMITEM <2,0845h,11000000b,040h>
		ROMITEM <2,0845h,11000000b,000h>	;R02
endif	;AUTO75_SUPPORT
;R32 - start
else;	New_Auto_Table_Method
		ALIGN	4
Auto_75Mhz	label	near
		ROMITEM <2,0050h,00001100b,000h>
		ROMITEM <2,0053h,00000110b,006h>
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE
		ROMITEM <2,0054h,11111111b,0A8h>
else;	GEMLIGHT_SPECIAL_AUTO_TABLE
		ROMITEM <2,0054h,11111100b,0E8h>
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE
		ROMITEM <2,0055h,00100000b,020h>
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE
		ROMITEM <2,0056h,00000111b,003h>
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE
ifdef	PCI_BUS_SYNC_MODE_AUTO_TABLE			;R40
		ROMITEM <2,0080h,00000010b,000h>	;R40
endif;	PCI_BUS_SYNC_MODE_AUTO_TABLE			;R40
		ROMITEM <2,0081h,11000000b,0C0h>
		ROMITEM <2,0082h,11000000b,0C0h>
ifndef SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0083h,00001001b,009h>	;R41
else							;R41
		ROMITEM <2,0083h,00001000b,008h>	;R41
endif; SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0845h,11000000b,000h>

		ALIGN	4
Auto_83Mhz	label	near
		ROMITEM <2,0050h,00001100b,000h>
		ROMITEM <2,0053h,00000110b,006h>
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE
		ROMITEM <2,0054h,11111111b,0A8h>
else;	GEMLIGHT_SPECIAL_AUTO_TABLE
		ROMITEM <2,0054h,11111100b,0E8h>
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE
		ROMITEM <2,0055h,00100000b,020h>
ifdef	GEMLIGHT_SPECIAL_AUTO_TABLE
		ROMITEM <2,0056h,00000111b,003h>
endif;	GEMLIGHT_SPECIAL_AUTO_TABLE
ifdef	PCI_BUS_SYNC_MODE_AUTO_TABLE			;R40
		ROMITEM <2,0080h,00000010b,000h>	;R40
endif;	PCI_BUS_SYNC_MODE_AUTO_TABLE			;R40
		ROMITEM <2,0081h,11000000b,0C0h>
		ROMITEM <2,0082h,11000000b,0C0h>
ifndef SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0083h,00001001b,009h>	;R41
else							;R41
		ROMITEM <2,0083h,00001000b,008h>	;R41
endif; SPECIAL_CPU_PCI_POST_WRITE			;R41
		ROMITEM <2,0845h,11000000b,000h>
endif;	New_Auto_Table_Method
;R32 - end

ifdef	AGGRESSIVE_MODE_SUPP
		ALIGN	4
Auto_40Mhz_a	label	near
Auto_50Mhz_a	label	near
		ROMITEM <2,0050h,00001100b,00Ch>
;R19A		ROMITEM <2,0053h,00000110b,002h>
		ROMITEM <2,0053h,00000110b,006h>	;R19A
;R19		ROMITEM <2,0054h,11000000b,040h>
		ROMITEM <2,0054h,11111100b,094h>	;R19
		ROMITEM <2,0055h,00100000b,000h>	;R19
		ROMITEM <2,0081h,11000000b,000h>
		ROMITEM <2,0082h,11000000b,000h>	;R19
		ROMITEM <2,0083h,00001001b,009h>
		ROMITEM <2,0845h,11000000b,080h>

		ALIGN	4
Auto_60Mhz_a	label	near
		ROMITEM <2,0050h,00001100b,00Ch>
;R19A		ROMITEM <2,0053h,00000110b,002h>
		ROMITEM <2,0053h,00000110b,006h>	;R19A
;R19		ROMITEM <2,0054h,11000000b,040h>
		ROMITEM <2,0054h,11111100b,094h>	;R19
		ROMITEM <2,0055h,00100000b,000h>	;R19
		ROMITEM <2,0081h,11000000b,0C0h>
		ROMITEM <2,0082h,11000000b,000h>	;R19
		ROMITEM <2,0083h,00001001b,009h>
		ROMITEM <2,0845h,11000000b,040h>

		ALIGN	4
Auto_66Mhz_a	label	near
		ROMITEM <2,0050h,00001100b,00Ch>
;R19A		ROMITEM <2,0053h,00000110b,002h>
		ROMITEM <2,0053h,00000110b,006h>	;R19A
;R19		ROMITEM <2,0054h,11000000b,040h>
		ROMITEM <2,0054h,11111100b,094h>	;R19
		ROMITEM <2,0055h,00100000b,000h>	;R19
		ROMITEM <2,0081h,11000000b,0C0h>
		ROMITEM <2,0082h,11000000b,000h>	;R19
		ROMITEM <2,0083h,00001001b,009h>
		ROMITEM <2,0845h,11000000b,040h>

 ifdef	AUTO75_SUPPORT
		ALIGN	4
Auto_75Mhz_a	label	near
;R19		ROMITEM <2,0050h,00001100b,000h>
		ROMITEM <2,0050h,00001100b,008h>	;R19
;R19A		ROMITEM <2,0053h,00000110b,000h>
		ROMITEM <2,0053h,00000110b,006h>	;R19A
;R81		ROMITEM <2,0054h,11000000b,080h>
		ROMITEM <2,0054h,11111100b,0E8h>	;R19
		ROMITEM <2,0055h,00100000b,020h>	;R19
		ROMITEM <2,0081h,11000000b,0C0h>
		ROMITEM <2,0082h,11000000b,0C0h>	;R19
		ROMITEM <2,0083h,00001001b,001h>
;R02		ROMITEM <2,0845h,11000000b,040h>
		ROMITEM <2,0845h,11000000b,000h>	;R02
 endif	;AUTO75_SUPPORT
endif	;AGGRESSIVE_MODE_SUPP

Chip_Feature_Start	LABEL	NEAR
;------------------------------------------------------------------
Xaxis	=	15-13
Yaxis	=	4-1

DEFINE_ITEM	Auto_Cfg_Item
	menuitem <0,\
		  offset Auto_Cfg_Str,NOCT,01h,CF_CMOS,01h,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,00h,01h,offset Std_Help_Str>
ifdef	AGGRESSIVE_MODE_SUPP
DEFINE_ITEM	Aggressive_Item
	menuitem <0,\
		  offset Aggressive_Str,NOCT,01h,CF_CMOS+5,01h,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,00h,00h,offset Std_Help_Str>
	Yaxis = Yaxis - 1
endif	;AGGRESSIVE_MODE_SUPP

L2_Stat 	=	0
ifdef	L2_CACHE_AUTO
L2_Stat 	=	AUTOPROG
endif	;L2_CACHE_AUTO

DEFINE_ITEM	,0			;R07
ifdef	L2CACHE_ITEM_STILL  		;R07
;R07DEFINE_ITEM	L2Cache_Item,1
;R07	menuitem <2+L2_Stat,\
;R07		  offset L2Wb_Str,0051h,08h,CF_CMOS,02h,\
;R07		  offset Wb_Val,0,1,Xaxis,Yaxis,0h,02h,offset Std_Help_Str>
;R07 - start
DEFINE_ITEM	L2Cache_Item
	menuitem <2+L2_Stat,\
		  offset L2Wb_Str,0051h,08h,CF_CMOS,02h,\
		  offset Wb_Val,0,1,Xaxis,Yaxis,0h,02h,offset Std_Help_Str>
;R07 - end
endif	;L2CACHE_ITEM_STILL		;R07

ifndef	ALWAYS_TAG_8BITS
DEFINE_ITEM	TagLen_Item
	menuitem <2+EARLYPROG,\
		  offset TagLen_Str,NOCT,01h,CF_CMOS,04h,\
		  offset TagLen_Val,0,1,Xaxis,Yaxis,0h,04h,offset Std_Help_Str>
endif	;ALWAYS_TAG_8BITS
DEFINE_ITEM
	menuitem <2+EARLYPROG,\
		  offset SRAM_b2b_Str,0050h,20h,CF_CMOS,08h,\
		  offset Ena_Str,0,1,Xaxis,Yaxis,20h,0h,offset Std_Help_Str>
;R06A ifdef	NA_EN_ITEM						;R06
ifndef	NO_NA_ITEM						;R06A
DEFINE_ITEM	NA_en_Item
	menuitem <2,\
		  offset NA_en_Str,0050h,80h,CF_CMOS,10h,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,0h,10h,offset Std_Help_Str>
endif	;NA_EN_ITEM						;R06
DEFINE_ITEM
	menuitem <2,\
		  offset Start_Pag_Str,0053h,0C0h,CF_CMOS,60h,\
		  offset Start_Pag_Val,0,3,Xaxis,Yaxis,00h,0h,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2+AUTOPROG,\
		  offset Ref_Cyc_Str,0053h,06h,CF_CMOS+1,03h,\
		  offset Ref_Cyc_Val,0,3,Xaxis,Yaxis,0h,00h,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2+AUTOPROG,\
		  offset RAS_Pls_Str,0054h,0C0h,CF_CMOS+1,0Ch,\
		  offset RAS_Pls_Val,0,3,Xaxis,Yaxis,080h,08h,offset Std_Help_Str>	;R10
;R10		  offset RAS_Pls_Val,0,3,Xaxis,Yaxis,0C0h,0Ch,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2+AUTOPROG,\
		  offset RAS_Pre_Str,0054h,30h,CF_CMOS+1,30h,\
		  offset T2_5_Val,0,3,Xaxis,Yaxis,30h,10h,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2+AUTOPROG,\
		  offset RAS_CAS_Str,0054h,0Ch,CF_CMOS+1,0C0h,\
		  offset T2_5_Val,0,3,Xaxis,Yaxis,0Ch,40h,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2,\
		  offset CAS_FP_Str,0054h,02h,CF_CMOS+2,01h,\
		  offset CAS_Low_Val,0,1,Xaxis,Yaxis,0h,0h,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2,\
		  offset CAS_EDO_Str,0054h,01h,CF_CMOS+2,02h,\
		  offset CAS_Low_Val,0,1,Xaxis,Yaxis,01h,02h,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2,\
		  offset RAMW_Str,0055h,80h,CF_CMOS+2,04h,\
		  offset RAMW_Val,0,1,Xaxis,Yaxis,0h,0h,offset Std_Help_Str>
DEFINE_ITEM
;R19A	menuitem <2,\
;R19A		  offset CAS_Prec_EDO_Str,0055h,18h,CF_CMOS+2,18h,\
;R19A		  offset CAS_Prec_Val,0,2,Xaxis,Yaxis,10h,00h,offset Std_Help_Str>
;R19A - start
	menuitem <2,\
		  offset CAS_Prec_FP_Str,0055h,18h,CF_CMOS+2,18h,\
		  offset CAS_Prec_Val,0,2,Xaxis,Yaxis,10h,08h,offset Std_Help_Str>
;R19A - end
DEFINE_ITEM
;R19A	menuitem <2,\
;R19A		  offset CAS_Prec_FP_Str,0055h,06h,CF_CMOS-1,60h,\
;R19A		  offset CAS_Prec_Val,0,2,Xaxis,Yaxis,04h,00h,offset Std_Help_Str>
;R19A - start
	menuitem <2,\
		  offset CAS_Prec_EDO_Str,0055h,06h,CF_CMOS-1,60h,\
		  offset CAS_Prec_Val,0,2,Xaxis,Yaxis,04h,20h,offset Std_Help_Str>
;R19A - end
;R09 - start
ifndef	NO_SDRAM_CAS_LAT_ITEM
DEFINE_ITEM
;R09A	menuitem <2,\
;R09A		  offset SDRAM_CAS_Str,NOCT,10h,5Fh,80h,\
;R09A		  offset SDRAM_CAS_Val,0,1,Xaxis,Yaxis,10h,80h,offset Std_Help_Str>	;R11
;R09A - start
ifdef Showonly_SDRAM_CAS_LAT
	menuitem <2+SHOWONLY,\			    					;R45  
		  offset SDRAM_CAS_Str,NOCT,01h,34h,01h,\		   		;R45
		  offset SDRAM_CAS_Val,0,1,Xaxis,Yaxis,01h,01h,offset Std_Help_Str>	;R45 
else											;R45
	menuitem <2,\
		  offset SDRAM_CAS_Str,NOCT,01h,34h,01h,\
		  offset SDRAM_CAS_Val,0,1,Xaxis,Yaxis,01h,01h,offset Std_Help_Str>	;R11
;R09A - end
endif;	 Showonly_SDRAM_CAS_LAT
endif	;NO_SDRAM_CAS_LAT_ITEM
;R09 - end
DEFINE_ITEM
	menuitem <2,\
		  offset SDRAM_WR_Str,0057h,08h,CF_CMOS+2,20h,\
		  offset SDRAM_WR_Val,0,1,Xaxis,Yaxis,0h,0h,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2,\
		  offset SDRAM_WS_Str,0057h,04h,CF_CMOS-1,80h,\
		  offset SDRAM_WS_Val,0,1,Xaxis,Yaxis,0h,0h,offset Std_Help_Str>
;R31 - start
ifdef	DRAM_CURRENT_SETUP
DEFINE_ITEM	DRAM_CURRENT_Item
	menuitem <2,\
;R42		  offset DRAM_CURRENT_Str,NOCT,01h,41h,80h,\
		  offset DRAM_CURRENT_Str,NOCT,01h,47h,80h,\ ;R42
		  offset DRAM_CURRENT_Val,0,1,Xaxis,Yaxis,0h,0h,offset Std_Help_Str>
endif;	DRAM_CURRENT_SETUP
;R31 - end
DEFINE_ITEM
	menuitem <2,\
		  offset Enh_WR_Str,0082h,20h,CF_CMOS+2,40h,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,0h,0h,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2,\
		  offset RD_pref_Str,0082h,10h,CF_CMOS+2,80h,\
		  offset Ena_Str,0,1,Xaxis,Yaxis,10h,0h,offset Std_Help_Str>
ifndef SPECIAL_CPU_PCI_psot							       ;R44		
DEFINE_ITEM
	menuitem <2+AUTOPROG,\
		  offset CPU_PCI_post_Str,0083h,09h,CF_CMOS+3,03h,\
		  offset CPU_PCI_post_Val,1,3,Xaxis,Yaxis,08h,01h,offset Std_Help_Str>
else										       ;R44		
DEFINE_ITEM									       ;R44
	menuitem <2,\								       ;R44 
		  offset CPU_PCI_post_Str,0083h,09h,CF_CMOS+3,03h,\		       ;R44
		  offset CPU_PCI_post_Val,1,3,Xaxis,Yaxis,08h,01h,offset Std_Help_Str> ;R44
endif; SPECIAL_CPU_PCI_psot							       ;R44	
ifdef PCI_BUS_SYNC_MODE_AUTO_TABLE						       ;R40	
DEFINE_ITEM	  								       ;R40
	menuitem <2+AUTOPROG,\							       ;R40
		  offset PCI_BUS_SYNC_Str,0080h,02h,CF_CMOS+4,05h,\		       ;R40
		  offset PCI_BUS_SYNC_Val,0,1,Xaxis,Yaxis,00h,00h,offset Std_Help_Str> ;R40	
endif; PCI_BUS_SYNC_MODE_AUTO_TABLE						       ;R40
DEFINE_ITEM
	menuitem <2,\
		  offset CPU_PCI_bst_Str,0083h,02h,CF_CMOS+3,04h,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,0h,00h,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2+AUTOPROG,\
		  offset BusClk_Str,0845h,0C0h,CF_CMOS+3,18h,\
		  offset BusClk_Val,0,2,Xaxis,Yaxis,40h,08h,offset Std_Help_Str>
ifdef	MDLE_DELAY_SELECTABLE
DEFINE_ITEM
	menuitem <2+SHOWNUM,\
		  offset MDLE_dly_Str,0056h,07h,5Bh,07h,\
		  offset NullStr,0,7,Xaxis,Yaxis,03h,03h,offset NullStr>
endif	;MDLE_DELAY_SELECTABLE
ifdef	MA_CURRENT_RATING
DEFINE_ITEM	MA_Current_Item
	menuitem <2,\
		  offset MA_curr_Str,NOCT,01h,34h,01h,\
		  offset MA_curr_Val,0,1,Xaxis,Yaxis,01h,01h,offset Std_Help_Str>
endif	;MA_CURRENT_RATING
ifndef	No_Cacheable_item
DEFINE_ITEM	SysCache_Item
	menuitem <2,\
		  offset SysCache_Str,NOCT,01h,CF_CMOS+3,20h,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,0h,20h,offset Std_Help_Str>
DEFINE_ITEM	VideoCache_Item
	menuitem <2,\
		  offset VideoCache_Str,NOCT,01h,CF_CMOS+3,40h,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,0h,40h,offset Std_Help_Str>
ifndef	NON_CACHEABLE_BLOCK
DEFINE_ITEM	Memory_Hole_Item
	menuitem <2,\
		  offset MemHole_Str,0077h,04h,CF_CMOS+3,80h,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,00h,00h,offset Std_Help_Str>
else	;NON_CACHEABLE_BLOCK
DEFINE_ITEM
	menuitem <2,\
		  offset NonCache1_Ctrl_Str,0077h,04h,CF_CMOS+3,80h,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,00h,00h,offset Std_Help_Str>
DEFINE_ITEM
	menuitem <2+SHOWNUM+EARLYPROG+KEYIN+SHOWHEX+DIGIT3,\
		  offset NonCache1_Addr_Str,0079h,0FFh,CF_CMOS+4,1FFFh,\
		  offset NullStr,050h,07FFh,Xaxis,Yaxis,050h,050h,offset NullStr>
	menuitem <2+EARLYPROG+HIDDEN,\
		  offset NullStr,0078h,1Fh,CF_CMOS+5,1Fh,\
		  offset NullStr,0,07h,Xaxis,Yaxis,00h,00h,offset NullStr>
DEFINE_ITEM
	menuitem <2,\
		  offset NonCache1_Size_Str,0078h,0E0h,CF_CMOS+5,0E0h,\
		  offset NonCache1_Size_Var,0,7,Xaxis,Yaxis,00h,00h,offset Std_Help_Str>
endif	;NON_CACHEABLE_BLOCK
endif	;No_Cacheable_item

ifdef	VGA_SHARE_MEMORY
DEFINE_ITEM	ShareMem_Item
	menuitem <2+EARLYPROG,\
		  offset ShareSize_Str,NOCT,07h,5Fh,1Ch,\
		  offset Share_Val,0,7,Xaxis,Yaxis,1h,04h,offset Std_Help_Str>
 ifdef	SHARE_SiS6205
DEFINE_ITEM	VgaMemClk_Item
	menuitem <2,\
		  offset VgaClk_Str,NOCT,01Fh,CF_CMOS-1,1Fh,\
		  offset VgaClk_Val,0,30,Xaxis,Yaxis,0h,15,offset NullStr>
 endif	;SHARE_SiS6205
endif;	VGA_SHARE_MEMORY

ifndef	LINEAR_SRAM
DEFINE_ITEM	Linear_Mode_Item
	menuitem <2,\
		  offset Linear_Mode_Str,NOCT,00000001b,CF_CMOS,80h,\
		  offset Dis_Str,0,1,Xaxis,Yaxis,00h,00h,offset Std_Help_Str>
endif	;LINEAR_SRAM

;R14 - start
ifdef	GEMLIGHT_JUMPERLESS
DEFINE_ITEM	CPU_v_Item,1
	menuitem <2,\
		  offset CPU_v_Str,NOCT,00000111b,37h,07h,\
		  offset CPU_v_Val,0,7,Xaxis,Yaxis,00h,01h,offset Std_Help_Str>	;R14A
;R14A		  offset CPU_v_Val,0,6,Xaxis,Yaxis,00h,01h,offset Std_Help_Str>
ifndef	NO_CPU_SPEED_ITEM					;R23
DEFINE_ITEM	CPU_spd_Item
	menuitem <2,\
		  offset CPU_spd_Str,NOCT,01111000b,37h,78h,\
		  offset CPU_spd_Val,0,11,Xaxis,Yaxis,08h,08h,offset NullStr>
endif;	NO_CPU_SPEED_ITEM					;R23
endif	;GEMLIGHT_JUMPERLESS
;R14 - end
;R30 - start
ifdef	BATT_LOW_BEEP_SUPPORT
Yaxis = Yaxis + 1
DEFINE_ITEM	Batt_low_1st_percent
	menuitem <2,\
		  offset Batt_1st_percent_str,NOCT,00000011b,38h,00000011b,\
		  offset Batt_1st_percent_Val,0,3,Xaxis,Yaxis,00h,01h,offset NullStr>

DEFINE_ITEM	Batt_low_1st_beep
	menuitem <2,\
		  offset Batt_1st_beep_str,NOCT,00000100b,38h,00000100b,\
		  offset Batt_1st_beep_val,0,1,Xaxis,Yaxis,00h,00h,offset NullStr>

DEFINE_ITEM	Batt_low_2nd_percent
	menuitem <2,\
		  offset Batt_2nd_percent_str,NOCT,00110000b,38h,00110000b,\
		  offset Batt_2nd_percent_Val,0,3,Xaxis,Yaxis,00h,01h,offset NullStr>

DEFINE_ITEM	Batt_low_2nd_beep
	menuitem <2,\
		  offset Batt_2nd_beep_str,NOCT,01000000b,38h,01000000b,\
		  offset Batt_2nd_beep_val,0,1,Xaxis,Yaxis,00h,00h,offset NullStr>

DEFINE_ITEM	Batt_low_period_time
	menuitem <2,\
		  offset Batt_period_time_str,NOCT,00001111b,39h,00001111b,\
		  offset Batt_period_time_val,0,0fh,Xaxis,Yaxis,00h,01h,offset NullStr>

DEFINE_ITEM	period_active_suspend
	menuitem <2,\
		  offset period_to_suspend_str,NOCT,11110000b,39h,11110000b,\
		  offset period_to_suspend_val,0,0fh,Xaxis,Yaxis,00h,03h,offset NullStr>

endif	;BATT_LOW_BEEP_SUPPORT
;R30 - end
;R37 - start
ifdef   Jumpless_Support
		JUMPLESS_FOR_CFEATURE_ASM	=	1	
		include	JUMPLESS.INC				
endif;	Jumpless_Support
;R37 - end
		include	CLKCNTL.MNU			
		include	sensor.mnu			;R36
Chip_Feature_End	LABEL	NEAR
;----------------------------------------------------------
CHIP_ITEM_NO	EQU	$-offset CHIP_Feature_START
IF CHIP_ITEM_NO EQ	0
CHIP_STAT	EQU	ITEMDISABLE
ELSE
CHIP_STAT	EQU	0
ENDIF

;----------------------------------------------------------
Auto_Cfg_Str		db	'Auto Configuration      : ',0
ifdef	L2CACHE_ITEM_STILL					;R07
L2Wb_Str		db	'L2 Cache Update Mode    : ',0
Wb_Val			db	'WT',0
			db	'WB',0
endif	;L2CACHE_ITEM_STILL					;R07
ifndef	ALWAYS_TAG_8BITS
TagLen_Str		db	'L2 (WB) Tag Bit Length  : ',0
TagLen_Val		db	'7bits',0
			db	'8bits',0
endif	;ALWAYS_TAG_8BITS
SRAM_b2b_Str		db	'SRAM Back-to-Back       : ',0
;R06A ifdef	NA_EN_ITEM						;R06
ifndef	NO_NA_ITEM						;R06A
NA_en_Str		db	'NA# Enable              : ',0
endif	;NA_EN_ITEM						;R06
Start_Pag_Str		db	'Starting Point of Paging: ',0
Start_Pag_Val		db	'1T',0
			db	'2T',0
			db	'4T',0
			db	'8T',0
Ref_Cyc_Str		db	'Refresh Cycle Time (us) : ',0
Ref_Cyc_Val		db	'15.6 ',0
			db	'62.4 ',0
			db	'124.8',0
			db	'187.2',0
RAS_Pls_Str		db	'RAS Pulse Width Refresh : ',0
RAS_Pls_Val		db	'4T',0
			db	'5T',0
			db	'6T',0
			db	'7T',0
RAS_Pre_Str		db	'RAS Precharge Time      : ',0
T2_5_Val		db	'2T',0
			db	'3T',0
			db	'4T',0
			db	'5T',0
RAS_CAS_Str		db	'RAS to CAS Delay        : ',0
CAS_FP_Str		db	'CAS# Pulse Width (FP)   : ',0
CAS_Low_Val		db	'2T',0
			db	'1T',0
CAS_EDO_Str		db	'CAS# Pulse Width (EDO)  : ',0
RAMW_Str		db	'RAMW# Assertion Timing  : ',0
RAMW_Val		db	'3T',0
			db	'2T',0
CAS_Prec_EDO_Str	db	'CAS Precharge Time (EDO): ',0
CAS_Prec_Val		db	'1T   ',0
			db	'1T/2T',0
			db	'2T   ',0
CAS_Prec_FP_Str		db	'CAS Precharge Time (FP) : ',0
ifndef	NO_SDRAM_CAS_LAT_ITEM					;R09
SDRAM_CAS_Str		db	'SDRAM CAS Latency       : ',0	;R09
ifndef 	Showonly_SDRAM_CAS_LAT					;R45	
SDRAM_CAS_Val		db	'2T',0				;R09
			db	'3T',0				;R09
else								;R45
SDRAM_CAS_Val		db	'2T',0				;R45
			db	'3T',1				;R45
endif	;Showonly_SDRAM_CAS_LAT					;R45
endif	;NO_SDRAM_CAS_LAT_ITEM					;R09
SDRAM_WR_Str		db	'SDRAM WR Retire Rate    : ',0
SDRAM_WR_Val		db	'X-2-2-2',0
			db	'X-1-1-1',0
SDRAM_WS_Str		db	'SDRAM Wait State Control: ',0
SDRAM_WS_Val		db	'1WS',0
			db	'0WS',0
Enh_WR_Str		db	'Enhanced Memory Write   : ',0
RD_pref_Str		db	'Read Prefetch Memory RD : ',0
CPU_PCI_post_Str	db	'CPU to PCI Post Write   : ',0
CPU_PCI_post_Val	db	'4T     ',0
			db	'Disable',0
			db	'3T     ',0
PCI_BUS_SYNC_Str	db	'PCI bus using sync mode : ',0		;R40
PCI_BUS_SYNC_Val	db	'Disable',0				;R40
			db	'Enable ',0				;R40
CPU_PCI_bst_Str		db	'CPU to PCI Burst Mem. WR: ',0
BusClk_Str		db	'ISA Bus Clock Frequency : ',0
BusClk_Val		db	'7.159MHz',0
			db	'PCICLK/4',0
			db	'PCICLK/3',0

ifndef	No_Cacheable_item
SysCache_Str		db	'System BIOS Cacheable   : ',0
VideoCache_Str		db	'Video  BIOS Cacheable   : ',0

ifdef	NON_CACHEABLE_BLOCK
NonCache1_Ctrl_Str	db	'Non-Cacheable Block 1   : ',0
NonCache1_Addr_Str	db	'  Block 1 Start Address : ',0
NonCache1_Size_Str	db	'  Block 1 Size          : ',0
NonCache1_Size_Var	db	'64KB ',0
			db	'128KB',0
			db	'256KB',0
			db	'512KB',0
			db	'1MB  ',0
			db	'2MB  ',0
			db	'4MB  ',0
			db	'8MB  ',0
else	;NON_CACHEABLE_BLOCK
MemHole_Str		db	'Memory Hole at 15M-16M  : ',0
endif	;NON_CACHEABLE_BLOCK
endif	;No_Cacheable_item

ifdef	VGA_SHARE_MEMORY
ShareSize_Str:		db	'VGA Shared Memory Size  : ',0
Share_Val:		db	'0.5MB',0
			db	'1  MB',0
			db	'1.5MB',0
			db	'2  MB',0
			db	'2.5MB',0
			db	'3  MB',0
			db	'3.5MB',0
			db	'4  MB',0
 ifdef	SHARE_SiS6205
VgaClk_Str:		db	'VGA Memory Clock (MHz)  : ',0
VgaClk_Val:
  ifdef GIGA_SPECIAL_MEMORY_CLK
			db	'85 ',0
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'80 ',0
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'75 ',0
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'70 ',0
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'60 ',0
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'60+',0
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'   ',1
			db	'EDO',0
  else	;GIGA_SPECIAL_MEMORY_CLK
			db	'40',0
			db	'41',0
			db	'42',0
			db	'43',0
			db	'44',0
			db	'45',0
			db	'46',0
			db	'47',0
			db	'48',0
			db	'49',0
			db	'50',0
			db	'51',0
			db	'52',0
			db	'53',0
			db	'54',0
			db	'55',0
			db	'56',0
			db	'57',0
			db	'58',0
			db	'59',0
			db	'60',0
			db	'61',0
			db	'62',0
			db	'63',0
			db	'64',0
			db	'65',0
			db	'66',0
			db	'67',0
			db	'68',0
			db	'69',0
			db	'70',0
  endif ;GIGA_SPECIAL_MEMORY_CLK
 endif	;SHARE_SiS6205
endif	;VGA_SHARE_MEMORY

ifndef	LINEAR_SRAM
Linear_Mode_Str 	db	'Linear Mode SRAM Support: ',0
endif	;LINEAR_SRAM

ifdef	MDLE_DELAY_SELECTABLE
MDLE_dly_Str		db	'MDLE Delay (ns)         : ',0
endif	;MDLE_DELAY_SELECTABLE
ifdef	MA_CURRENT_RATING
MA_curr_Str		db	'MA Current Rating       : ',0
MA_curr_Val		db	'8mA ',0
			db	'16mA',0
endif	;MA_CURRENT_RATING
ifdef	AGGRESSIVE_MODE_SUPP
Aggressive_Str		db	'Aggressive Mode         : ',0
endif	;AGGRESSIVE_MODE_SUPP

;R14 - start
ifdef	GEMLIGHT_JUMPERLESS
CPU_v_Str		db	'CPU Core Voltage        : ',0
CPU_v_Val		db	'Disable',0
			db	'Auto   ',0
			db	'2.8    ',0
			db	'2.9    ',0
			db	'3.2    ',0
			db	'3.3    ',0
			db	'3.52   ',0
			db	'2.2   ',0		;R14A
ifndef	NO_CPU_SPEED_ITEM					;R23
CPU_spd_Str		db	'CPU Frequency           : ',0
CPU_spd_Val		db	' 75',1		;P54C, K5, [M1]
			db	' 90',0
			db	'100',0
			db	'110',0
			db	'120',0
			db	'133',0
			db	'150',0
			db	'166',0
			db	'180',0
			db	'200',0
			db	'233',0
			db	'266',0
endif;	NO_CPU_SPEED_ITEM					;R23
endif	;GEMLIGHT_JUMPERLESS
;R14 - end
;R30 - start
ifdef	BATT_LOW_BEEP_SUPPORT
Batt_1st_percent_str	db	'Batt low warning 1st (%): ',0
Batt_1st_percent_Val	db	'Disabled',0
			db	'30%     ',1
			db	'25%     ',0
			db	'20%     ',0
Batt_1st_beep_str	db	'1st warning Beep        : ',0
Batt_1st_beep_val	db	'3',0
			db	'5',0
Batt_2nd_percent_str	db	'Batt low warning 2nd (%): ',0
Batt_2nd_percent_Val	db	'Disabled',0
			db	'20%     ',1
			db	'15%     ',0
			db	'10%     ',0
Batt_2nd_beep_str	db	'2nd warning Beep        : ',0
Batt_2nd_beep_val	db	'1',0
			db	'2',0
Batt_period_time_str	db	'Batt Low Beep repeat    : ',0 	
Batt_period_time_val	db	'XXXXXX',1	;R30A
			db	'16Sec ',0
			db	'32Sec ',0
			db	'48Sec ',0
			db	'64Sec ',0
			db	'80Sec ',0
			db	'96Sec ',0
			db	'112Sec',0
			db	'128Sec',0
			db	'144Sec',0
			db	'160Sec',0
			db	'176Sec',0
			db	'192Sec',0
			db	'208Sec',0
			db	'224Sec',0
			db	'240Sec',0
;R30A			db	'256Sec',0
period_to_suspend_str	db	'Repeat to suspend       : ',0 
period_to_suspend_val	db	'XX',1		;R30A
;R30A			db	'1 ',0
			db	'2 ',0
			db	'3 ',0
			db	'4 ',0
			db	'5 ',0
			db	'6 ',0
			db	'7 ',0
			db	'8 ',0
			db	'9 ',0
			db	'10',0
			db	'11',0
			db	'12',0
			db	'13',0
			db	'14',0
			db	'15',0
			db	'16',0
endif	;BATT_LOW_BEEP_SUPPORT
;R30 - end

;R31 - start
ifdef	DRAM_CURRENT_SETUP
DRAM_CURRENT_Str	db	'DRAM Driving Current    : ',0
DRAM_CURRENT_Val	db	'Normal',0
			db	'Full  ',0
endif;	DRAM_CURRENT_SETUP
;R31 - end

		COLLON_LOC = 24				;R36
		include	sensor.str			;R36
		include	CLKCNTL.STR

;R37 - start
ifdef	Jumpless_Support
		JUMPLESS_FOR_CFEATURE_ASM	=	2	
		include	JUMPLESS.INC				
endif;	Jumpless_Support
;R37 - end

;;; Second Page ----------------------------------------------------- end
;[]======================================================================[]
;Function :	Decide whether a item's BIOS default is to be programmed
;		(in PRG_CHIPSET_DEFAULT) or not!
;
;		Usage:
;			if you have a item AT_CLOCK, for example, such that
;			its meaning is varies upon different CPU. The ordinary
;			way of doing this item is setup is to define:
;
;
;		Clock_486_Item:
;			menuitem <0,\
;				offset AT_Clock_486_Str,\
;				25h,00000011b,34H,00000011b,\
;				offset Clk_Div_6_Str,0,4,\
;				Xaxis,Yaxis,0,0,offset Std_Help_Str>
;		Clock_386_Item:
;			menuitem <0,\
;				offset AT_Clock_386_Str,\
;				25h,00000011b,34H,00000011b,\
;				offset Clk_Div_6_Str_1,0,4,\
;				Xaxis,Yaxis,0,0,offset Std_Help_Str>
;
;		and then to disable/enable the correct item during run time.
;
;		Howerver, the BIOS default value of the Clock_386_Item will
;		be overwritten to register 25h whatever the BIOS default of
;		Clock_386_Item is!.
;
;		So define SPECIALPRG for both items. Then in this routine
;
;		Clock_386_Item:
;				Return CF if CPU type != 386
;				Return NC if CPU type = 386
;		Clock_486_Item:
;				Return CF if CPU type != 486
;				Return NC if CPU type = 486
;
;		Example: see 214UC000.ASM (CFEATURE)
;
;Input :	BX point to menuitem
;
;Output :	CF - this item should not be programmed
;		NC - this item should be programmed
;
;Registers :	BX, SI, DI must be preserved
;
;Note : 	1. no stack available
;		2. call from PRG_CHIPSET_DEFAULT in ct_table.asm
;[]======================================================================[]
		Public	Cf_Special_Prg
Cf_Special_Prg	Proc	Near

		clc
		ret

Cf_Special_Prg	Endp

;[]==============================================================[]
;Ct_ReTable_Auto:
; Modify auto-table offset to program registers and to load setup
; defaults for auto-configuration if system support 1x & 2x clocks
; and it can detected by software.
;Save  : all but SI
;Input : si : normal offset of auto-table ( referenced by CPU type )
;Output: si : modified offset of auto_table
;Note  : 1. Read clock phase from register or I/O port.
;	 2. Modify SI to second table if 2x clock installed
;	 3. You must build two sets of auto-table for 1x & 2x
;	    clock
;	 4. See 214k5000.asm for instance
;[]==============================================================[]
		public	Ct_ReTable_Auto
Ct_ReTable_Auto proc	near
ifndef	New_Auto_Table_Method				;R32
		sub	si, 4*2
ifdef	AUTO75_SUPPORT
		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX
		jne	short NotM1_Cpu

		cmp	byte ptr CPU_INT_CLOCK[bp],150		;150Mhze ?
		jne	short NotM1_Cpu

		test	byte ptr OVERRIDE[bp],DOUBLE_CLOCK	;2x mode ?
		jz	short NotM1_Cpu

	;redirect auto table
		inc	si
		inc	si
NotM1_Cpu:
endif	;AUTO75_SUPPORT
ifdef	AGGRESSIVE_MODE_SUPP
		push	si
		mov	si,offset Aggressive_Item
		extrn	GetItem_Or:near
		call	GetItem_Or
		pop	si
		jz	short not_aggressive
		add	si,Aggressive_Diff
not_aggressive:
endif	;AGGRESSIVE_MODE_SUPP
endif;	New_Auto_Table_Method				;R32
		ret
Ct_ReTable_Auto endp

ifdef	AGGRESSIVE_MODE_SUPP
Show_Auto_Cfg1	Proc	Near

		cmp	al, special_Before
		je	short @F

		mov	di, offset _AAA_Tbl
		xor	cx, cx
		call	If_CX_Then_Dis
	@@:
		call	Show_Auto_Cfg
		ret

Show_Auto_Cfg1	Endp

_AAA_Tbl:
		dw	offset Aggressive_Item
		dw	-1

Show_Aggre	Proc	Near
		cmp	al, Special_Before
		je	short @F

		cmp	word ptr TEMP_YEAR[bp],0FFAAh ;prevent recursive
		je	short @F		      ;prevent recursive
		push	word ptr TEMP_YEAR[bp]	      ;prevent recursive
		mov	word ptr TEMP_YEAR[bp],0FFAAh ;prevent recursive

		push	word ptr CURSOR_X[bp]
		pusha
		mov	bx, offset Auto_Cfg_Item
		call	Display_Whole_item
		popa
		pop	word ptr CURSOR_X[bp]
		pop	word ptr TEMP_YEAR[bp]	      ;prevent recursive
	@@:
		clc
		ret
Show_Aggre	Endp
endif	;AGGRESSIVE_MODE_SUPP
;R30 - start
ifdef	BATT_LOW_BEEP_SUPPORT
Show_Batt_Low_Beep	Proc	Near
		cmp	al, special_Before
		je	short @F

		mov	di, offset _Batt_Tbl
		xor	cx, cx
		call	If_CX_Then_Dis
@@:
		ret
Show_Batt_Low_Beep	Endp
_Batt_Tbl:
		dw	Batt_low_1st_beep
		dw	-1

Show_Batt_Low_Beep_2	Proc	Near
	    	
		cmp	al, special_Before
		je	short @F

		mov	di, offset _Batt_Tbl_2
		xor	cx, cx
		call	If_CX_Then_Dis
@@:
		ret
Show_Batt_Low_Beep_2	Endp
_Batt_Tbl_2:
		dw	Batt_low_2nd_beep
		dw	Batt_low_period_time
		dw	period_active_suspend
		dw	-1
endif	;BATT_LOW_BEEP_SUPPORT
;R30 - end
FCODE		ENDS
;R36 - start
;--------------------------------------------------------------
;--------------------------------------------------------------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;----- The following codes will be located at E000 ! ----------
;--------------------------------------------------------------
;--------------------------------------------------------------
.386
ECODE		SEGMENT USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP, ES:EGROUP

		include	sensor.e8	;R16
;R36 - end

ECODE		ENDS
		END


