;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;
;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R33    12/16/97 ATY    Added AT/ATX Select by GPIO5
;R08H	11/24/97 AVN	Added CPU 2.2v support in item for GEMLIGHT.
;R08G	11/18/97 AVN	Chnage new AMD K6 to 2.2v, and save code.
;R32A	11/11/97 AVN	Fixed R32 Coding Fail.
;R32    11/11/97 ATY	Added AT/ATX power auto scan by GPIO8,input high =>ATX
;							      input low  =>AT				
;R31	10/29/97 TNY	Modulize jumpless.
;R30	10/27/97 TNY	Support SiS software I2C programming.
;R24A	10/17/97 AVN	AT/ATX power select by GPCS0, when input high => ATX
;						      when input low  => AT
;R28B	10/09/97 AVN	Fixed Compile fail.
;R29	10/07/97 AVN	Fixed Coding error.
;R28A	10/06/97 AVN	Fixed Compile fail.
;R28	10/06/97 AVN	Added AT/ATX power auto scan by input GPCS1, and
;			define 'AT_ATX_SELECT_BY_GPCS1'
;R06B	09/18/97 AVN	Sizing SDRAM setting CAS latency time by setup, when
;			sizing fail toggle latency time	and test again, but
;			setup value no change. define 'AUTO_SDRAM_CAS_LAT'
;R27	09/12/97 AVN	Fixed use NEC sdram (2T) warm boot will hang, because
;			SHADOW_OK_CMOS(46h) in cmos checksum locate and always
;			clear when write cmos from stack.
;			ALARM_CMOS had change define in BIOS.CFG
;R08F	09/02/97 AVN	Added new AMD K6 2.1v support for gemlight, if K6 21.v
;			plug and GPIO8 => Hi, GPIO7 => Lo, and only AMD K6
;			3.2v with 233MHz upper GPCS0 => Hi else => Lo
;R26	08/20/97 AVN	If setting cache write through mode must disable NA,
;			suggestby SiS.
;R25	08/20/97 AVN	Added DRAM driving current item by define 'DRAM_CURRENT_SETUP'
;R23A	08/13/97 JKY	Move to kernel . See pcipost.asm R231
;R24	08/04/97 AVN	Added AT/ATX power auto scan by input GPCS0, and
;			define 'AT_ATX_SELECT_BY_GPCS0'
;R23	07/30/97 JKY	Disable C8000-CBFFF shadow if video ROM size is less than 32k
;R22A	07/28/97 AVN	Fixed coding error.
;R22	07/25/97 AVN	special modify cyrix M2 reg c2 by modbin for gemlight
;			by define 'Special_Prg_M2_For_Gemlight'
;			Ps: reg c2h is also prgram if M1 plug.
;R21	07/11/97 AVN	Fixed compile fail.
;R08E	07/11/97 AVN	Modify GPIO table for Gemlight, if CYRIX M2 => 2.9v
;R18D	07/07/97 JKY	When USB control disable , IRQ restore to edge trigged
;R18C	07/07/97 JKY	Fixed mistake for USB Remapping Disable
;R18B	07/04/97 JKY	When USB control disable , USBIRQ remapping need disable	
;R20A	07/04/97 AVN	Move USB control from Ct_Early_Shadow to CT_FINAL_INIT
;			and disable I/O memory decoding.
;R20	06/27/97 RCH
;This chipset not fully disable ALL I/O and memory decoding while the USB
;controller is disabled by PCI-TO-ISA bridge. That means if the command
;register of USB controller is enabled the USB still decode all I/O and
;memory space.
;R19	06/24/97 AVN	Disable NA# assert on all single write cycle if cache
;			enable and use AMD K6 CPU.
;R18A	06/23/97 JKY	Move code to final step & fixed bugs.
;R18	06/20/97 JKY	Change USB host controller disable step from early to
;			here.
;R06A	06/17/97 RAY	The boot successful flag should be added in earlier
;			place of POST
;R17	06/16/97 AVN	Added define GPCS0 control LINEAR mode.
;R08D	05/24/97 AVN	Modify GPIO table for Gemlight
;R16	05/09/97 AVN	Move form chiprun.asm (Ct_Vray_Early_Init)
;			Added Write device 1, function 1 Reg 2Ch, 2Dh, 2Eh, 2Fh
;			once, those Reg is write one time only, and using by
;			customer for product serial number.
;			if those Reg had never wrote and WIN95 SCT test fail.
;R01B	06/10/97 AVN	Change Default always disable onboard VGA, and enable
;			onboard VGA in here.
;R15	05/23/97 RCH	Kill unused codes
;R08C	05/21/97 AVN	Added GPIO 7,8 output status to Hi if AMD K6 with 233
;			CPU clock or more, for GEMLIGHT
;R14	05/20/97 AVN	Fixed install two single side SDARM fail, those code
;			is for SiS 5571 only.
;R13	05/16/97 AVN	Add Alarm Power Up by define 'RSM_BY_ALARM', and add
;			Power Button override function,	Ring Up, GPIO5 Power Up.
;R08B	05/13/97 AVN	Move GEMLIGHT_JUMPERLESS to memory test before and
;			added GPCS0 output, if CPU CORE VOLTAGE item value is
;			AUTO, 3.2 => if use AMD K6 and >= 233MHz
;			     then set GPCS0 output Hi.
;			otherwise set GPCS0 output Lo.
;R12	05/13/97 AVN	Added define 'NO_CPU_SPEED_ITEM' for GEMLIGHT
;R11	05/12/97 JKY	Added CARDBUS support
;R08A	04/24/97 LRY	Modify GPIO table for Gemlight
;R02A	04/24/97 LRY	Added NA enable item again
;R10	04/24/97 LRY	Set vga frequency to 40MHz when cmos checksum error
;R05B	04/17/97 LRY	Fixed ACPI base error coding
;R09	04/07/97 LRY	Added "Ultra_DMA33_support"
;R05A	04/02/97 LRY	Porting ACPI base,  auto detect A or B version
;R08	04/02/97 LRY	Support "GEMLIGHT_JUMPERLESS"  (OPTIONAL)
;R07	03/24/97 LRY	By SiS inform, modify IDE/PIO table for 75MHz CPU
;R06	03/14/97 LRY	Added SDRAM CAS latency item
;R05	03/14/97 LRY	Assign ACPI/SCI base address at IO 6100h
;R04	03/10/97 LRY	The configuration table dram type can show Row 0...
;			Row 2 instead of Bank0... Bank2  (OPTIONAL)
;R03	03/05/97 LRY	By SiS inform, L2 cache don't support write through
;R02	03/05/97 LRY	Removed NA# item, auto disable NA# when use VGA
;			shared memory
;R01A	03/05/97 LRY	Fixed use onboard VGA & bank0 no DRAM then system
;			hang at 0Bh
;R01	01/31/97 LRY	Support 6205 VGA shared memory
;R00	01/07/97 LRY	Initial version
.386p
		PAGE	56,132
		TITLE	CHIPSET  -- 386/486 EISA ROM/BIOS

		INCLUDE BIOS.CFG
		INCLUDE COMMON.MAC
		INCLUDE POST.EQU
		INCLUDE POST.EXT
		INCLUDE POST.MAC
		include CPU.EQU
		extrn	Clear_Parity:near
		extrn	Set_Cmos:near
		extrn	Get_Cmos:near
		extrn	Move_Codes:near
		extrn	Cpu_Cache:near
		extrn	Auto_Cfg_Item:Near
		extrn	GetItem_Value:Near
		extrn	ExtCache_Item:Near

		extrn	Get_Ct:Near
		extrn	Set_Ct:Near
		extrn	Get_Set_Ct:Near
ifdef	PCI_BUS
		extrn	Pci_IO_Mem_Init:near
endif	;PCI_BUS

		extrn	CONFIG_TABLE:byte

ifndef	NON_CACHEABLE_BLOCK
		extrn	Memory_Hole_Item:near		;for memory hole
endif	;NON_CACHEABLE_BLOCK

		extrn	F000_GetItem_Value:near

;R13 - start
ifdef	RSM_BY_ALARM
		extrn	ALARM_ITEM:near
		extrn	ALARM_MONTH_Item:near
		extrn	ALARM_DATE_Item:near
		extrn	ALARM_HOUR_Item:near
		extrn	ALARM_MIN_Item:near
		extrn	ALARM_SEC_Item:near
		extrn	HEX_TO_BCD:near
		extrn	BCD_TO_HEX:near
endif;	RSM_BY_ALARM
;R13 - end

;R25 - start
ifdef	DRAM_CURRENT_SETUP
		extrn	DRAM_CURRENT_Item:near
endif;	DRAM_CURRENT_SETUP
;R25 - end

;R22 - start
ifdef	Special_Prg_M2_For_Gemlight
		extrn	UNlock_Cyrix:near
		extrn	Get_Cyrix:near
		extrn	Set_Cyrix:near
		extrn	lock_Cyrix:near
endif;	Special_Prg_M2_For_Gemlight
;R22 - end
ifdef		USB_SUPPORT			;R21
		extrn	USB_ITEM:near		;R21
endif;		USB_SUPPORT			;R21

CONFIG_ADDR	EQU	0cf8h

G_RAM		SEGMENT USE16 AT 0

		ORG	04H*4
		INCLUDE SEG_0.INC

		ORG	400H
		INCLUDE G_RAM.INC

G_RAM		ENDS

		extrn	Display_String:near
		extrn	Post_call_proc:near
		extrn	F000_call_proc:near
EGROUP		GROUP	ECODE
DGROUP		GROUP	FCODE

DGROUP		GROUP	FCODE
FCODE		SEGMENT USE16 PARA PUBLIC 'CODE'
		ASSUME	CS:DGROUP

ifndef	COMPRESS_CODE
		extrn	GDTR1:near
		extrn	GDT1:near
		extrn	DATA1_DT:near
		extrn	DATA1_INDEX:ABS
		include chipboot.asm
endif	;COMPRESS_CODE

;[]==============================================================[]
;
; Enable_Linear_Burst:
;
;	Turn on chipset linear burst function to support Cyrix M1 CPU
;
; Saves: SP
; Entry: None
;  Exit: Cy = 0  Support Linear Burst Function
;	 Cy = 1  Not Support Linear Burst Function
; Note : 1. Stack Available
;[]==============================================================[]
		Public	Enable_Linear_Burst
Enable_Linear_Burst	Proc	Near
		mov	cx,94h			;set CPU type
		mov	bx,20DFh
		call	Get_Set_Ct

		mov	cl,51h
		call	Get_Ct
		shr	al,3
		cmc
		ret
Enable_Linear_Burst	Endp

;[]==============================================================[]
;
; Ct_Early_Shadow:
;
;	Shadowing system and video BIOS to speedup booting.
;
;Saves:
;
;	All except ax,dx,es,ds,flag
;Input : None
;Output: None
;
;[Notes]
;
;	1. This routine will shadow system BIOS in early stage
;	   of POST.
;	2. Stack available
;[]==============================================================[]
		align 4
		public	Ct_Early_Shadow
Ct_Early_Shadow proc	near

;R20A ;R20 - start
;R20A 		extrn	USB_ITEM:near
;R20A 		mov	si,Offset USB_ITEM
;R20A 		call	GetItem_Value
;R20A 		or	al,al
;R20A 		jnz	short @F
;R20A 		mov	cx,0862h
;R20A 		mov	bx,00bfh
;R20A 		call	Get_Set_Ct
;R20A 	@@:
;R20A ;R20 - end

;R06A - start
ifndef	AUTO_SDRAM_CAS_LAT				;R06B
ifndef	NO_SDRAM_CAS_LAT_ITEM
;R27 SHADOW_OK_CMOS	equ	46h
SHADOW_OK_CMOS	equ	40h				;R27
SHADOW_OK_FLAG	equ	9Dh
		mov	ax,(SHADOW_OK_FLAG shl 8) + SHADOW_OK_CMOS NMI_OFF
		call	Set_Cmos
endif	;NO_SDRAM_CAS_LAT_ITEM
endif;	AUTO_SDRAM_CAS_LAT				;R06B
;R06A - end

ifdef	PS2_IRQ12_Thru_MIRQ

		mov	cx,0861H	;MIRQ
		mov	al,4Ch		;Enable MIRQ --> IRQ 12
		call	Set_Ct

endif	;PS2_IRQ12_Thru_MIRQ

ifdef	PCI_BUS
		call	Pci_IO_Mem_Init
;R05 - start
		mov	cx,08h		;get version number	;R05A
;R05B		call	Set_Ct					;R05A
		call	Get_Ct					;R05B
		or	al,al					;R05A
		jnz	short skip_set_acpi_base		;R05A
		mov	cx,810h			;ACPI/SCI base address
		mov	al,ACPI_BASE_IO_ADDR mod 100h
		call	Set_Ct
		inc	cx	;then cl=11h
		mov	al,ACPI_BASE_IO_ADDR / 100h
		call	Set_Ct
skip_set_acpi_base:						;R05A
;R05 - end
ifdef	SHARE_SiS6205
		push	0F000h
		pop	ds
		call	F000_Shadow_W
		FAR_CALL	Ct_Early_Shadow1,0E000h
		call	F000_Shadow_R
endif	;SHARE_SiS6205
		
endif;	PCI_BUS
;R11 - start
ifdef	CARDBUS_USE_LAGECY

		mov	cx,( CARDBUS_USE_LAGECY shl 8 ) + 04h
		mov	al,07		
		Call	Set_Ct

		mov	cx,( CARDBUS_USE_LAGECY shl 8 ) + 44h
		mov	al,0E1h
		Call	Set_Ct

		mov	cx,( CARDBUS_USE_LAGECY shl 8 ) + 45h
		mov	al,003h
		Call	Set_Ct

		mov	cx,( CARDBUS_USE_LAGECY shl 8 ) + 82h
		mov	al,024h
		Call	Set_Ct

		mov	cx,( CARDBUS_USE_LAGECY shl 8 ) + 92h
		mov	al,072h
		Call	Set_Ct
endif	;CARDBUS_USE_LAGECY
;R11 - end
;R16 - start
		mov	bl,4
		mov	cx,92Ch
		xor	al,al
@@:
		Call	Set_Ct
		inc	cl
		dec	bl
		or	bl,bl
		jnz	@b
;R16 - end
		clc
		ret
Ct_Early_Shadow ENDP

;[]===================================================================[]
;
; CT_CACHE:
;
;	Turn secondary cache on/off routine.
;
;ENTRY: AL	Turn on (TRUE) or off (FALSE) cache
;EXIT:	NONE
;
;SAVES: BP, FS + NO STACK
;
;[]===================================================================[]
		align	4
		PUBLIC	CT_CACHE
CT_CACHE	PROC	NEAR
		extrn	A20_On:near
		extrn	A20_Off:near

		pushad
		push	ds
		push	ax
		call	A20_On

		mov	al,TRUE
		call	Cpu_Cache

L2WriteThrough:
		pop	ax

		cmp	al,TRUE
		jne	short Cache_Off

		mov	cx,51h
		call	Get_Ct
		test	al,30h		;cache existed ?
		jz	short Cache_Off

;R19 - start
		mov	cx,50h
		call	Get_Ct
		and	al,not 40h
		xor	bl,bl
		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_AMD
		jne	short Enable_Single_Write_Cycle
		mov	bl,40h

Enable_Single_Write_Cycle:
		or	al,bl
		call	Set_Ct
;R19 - end
		mov	eax,80000050H
		mov	dx,CONFIG_ADDR
		out	dx,eax
		add	dl,4
		in	eax,dx


;First set write through mode
		or	ah,0C0h 	;cache exist, enable cache
		mov	ebx,eax 	;save original register value
		and	ah,NOT 08H	;set write through
		out	dx,eax
		SIODELAY

	;Flush cache

		mov	di,offset @F		;di=return address
		jmp	short Flush_Cache
	@@:

;R26 - start
ifdef	L2CACHE_ITEM_STILL
extrn	L2Cache_Item:near
		mov	si,offset L2Cache_Item
		call	GetItem_Value
		test	al,al
		jnz	short Cache_WB_Mode
		and	bl,0fh
Cache_WB_Mode:
endif;	L2CACHE_ITEM_STILL
;R26 - end

;Second set write back mode if required
		mov	eax,80000050H
		mov	dx,CONFIG_ADDR
		out	dx,eax
		add	dl,4
		mov	eax,ebx 	;save original register value
		out	dx,eax
		SIODELAY

	;Flush cache

		mov	di,offset @F		;di=return address
		jmp	short Flush_Cache
	@@:

		call	A20_Off

		jmp	short Cache_Exit

Cache_Off:
Cache_Exit:

		pop	ds
		popad

		clc
		ret
CT_CACHE	ENDP
;--------------------------------

		align	4
Flush_Cache	Proc	Near
		cli
		mov	al,bh			;get cache size
		and	al,30h
		shr	al,4
		add	al,16
		mov	cl,al
ifdef	COMPRESS_CODE
		extrn	GDTR1:fword
endif	;COMPRESS_CODE
		lgdt	fword ptr cs:[GDTR1]

		mov	eax,cr0
		or	al,01h			;sw to protect mode
		mov	cr0,eax 		;load msw to enter protect mode
		jmp	short $+2		;flush processor queue

ifdef	COMPRESS_CODE
		extrn	DATA1_INDEX:ABS
endif	;COMPRESS_CODE
		mov	ax,DATA1_INDEX
		mov	ds,ax

		cld
		mov	esi,1024*1024*1 	;start from address 1Mb
		mov	eax,1
		shl	eax,cl
		mov	ecx,eax

		align	4
		db	66h			;must use this instruction
		rep	lods dword ptr [esi]	;do not use "rep lodsd"

		mov	eax,cr0 		;
		and	al,not 01h		;reset to real mode
		mov	cr0,eax 		;
		FAR_JMP $+4,0f000h		;flush CPU instruction queue

		jmp	di			;return to caller

Flush_Cache	Endp

;[]==============================================================[]
;CACHE_INIT:
;	Cache controller initialization after first testing
;	first 64k memory.
;Saves: ALL but flags
;Input: none
;Output:none
;
;[Notes] 1. Stack is available
;	 2. This function can be used to sizing cache size
;[]==============================================================[]
		align 4
		public	Cache_Init
Cache_Init	proc	near
		clc
		ret
Cache_Init	endp

;[]==============================================================[]
;Ct_Parity_Control:
;	Programming chipset registers of memory parity check
;Saves: all but flags
;Input: AL - 0 = disable parity check
;	   - 1 = enable parity check
;Output:none
;
;[Notes] 1. Stack and BP is available
;	 2. This function can be used to program special chipset
;	    registers about memory parity check
;[]==============================================================[]
		align	4
		public	Ct_Parity_Control
Ct_Parity_Control	proc	near
		ret
Ct_Parity_Control	endp

;[]==============================================================[]
;CT_FINAL_INIT:
;	Programming chipset registers before boot
;Saves: all but flags
;Input: none
;Output:none
;
;[Notes] 1. Stack and BP is available
;	 2. This function can be used to program special chipset
;	    registers before boot
;[]==============================================================[]
		align	4
		public	CT_FINAL_INIT
CT_FINAL_INIT	proc	near
		FAR_CALL	CT_FINAL_INIT1,0E000h

;R21 ;R18A - start
;R21 ifdef		USB_SUPPORT			;R18D
;R21 		extrn	USB_ITEM:near
;R21 		mov	si,Offset USB_ITEM
;R21 		call	GetItem_Value
;R21 		or	al,al
;R21 		jnz	short @F
;R21 
;R21 ;R20A - start
;R21 		mov	eax,80000A04h
;R21 		mov	dx,0CF8h
;R21 		out	dx,eax
;R21 		mov	dx,0CFCh
;R21 		in	al,dx
;R21 		and	al,not 03h
;R21 		out	dx,al
;R21 
;R21 		mov	eax,80000A10h
;R21 		mov	dx,0CF8h
;R21 		out	dx,eax
;R21 		mov	eax,0FFFFFFFFh
;R21 		mov	dx,0CFCh
;R21 		out	dx,eax
;R21 ;R20A - end		
;R21 ;R18D - start
;R21 		mov	cx,0a3ch
;R21 		call	Get_Ct
;R21 		cmp	al,0ffh
;R21 		je	short USB_IRQ_FAIL
;R21 		mov	cl,al
;R21 		mov	ax,1
;R21 		shl	ax,cl
;R21 		mov	bx,ax
;R21 		mov	dx,4d0h
;R21 		test	bl,bl
;R21 		jnz	short IRQ_0_7
;R21 
;R21 		xchg	bl,bh
;R21 		inc	dx
;R21 IRQ_0_7:
;R21 		in	al,dx
;R21 		not	bl
;R21 		and	al,bl
;R21 		out	dx,al
;R21 
;R21 USB_IRQ_FAIL:
;R21 ;R18D - end
;R21 
;R21 		mov	cx,0862h
;R21 ;R18B		mov	bx,00bfh
;R21 ;R18C		mov	bx,0030h		;R18B
;R21 		mov	bx,8030h		;R18C USB remapping disable
;R21 						;     Interrupt remapping reserved
;R21 		call	Get_Set_Ct
;R21 	@@:
;R21 endif;		USB_SUPPORT			;R18D
;R21 ;R18A - end

		clc
		ret
CT_FINAL_INIT	endp


;[]==============================================================[]
;Get_Cache_Size:
;	Return chipset cache size to display
;Input : None
;Output: AL -  0 = 0K, 1=16K , 2=32K , 3=64K , 4=128K , 5=256K
;	       6 =512K, 7=1024K ,etc...
;[]==============================================================[]
		ALIGN 4
		PUBLIC	Get_Cache_Size
Get_Cache_Size	PROC	NEAR
		FAR_CALL	E000_Get_Cache_Size,0E000h
		ret
Get_Cache_Size	ENDP

;[]==============================================================[]
;GET_CPU_SPEED:
;	Program some chipset registers according to CPU clock
;	in G_RAM:CPU_CLOCK
;Saves: all but flags
;Input: none
;Output:none
;
;[Notes] 1. Stack and BP is available
;	 2. You can program AT bus clock to about 8Mhz according
;	    to cpu clock
;[]==============================================================[]
;R24 - start
E000_GET_CPU_SPEED_REQ	=	0
AT_ATX_SELECT_BY_GPCS	=	0				;R28A
AT_ATX_SELECT_BY_GPIO	=	0				;R32A
ifdef	AT_ATX_SELECT_BY_GPCS0
E000_GET_CPU_SPEED_REQ	=	1
AT_ATX_SELECT_BY_GPCS	=	1				;R28
endif;	AT_ATX_SELECT_BY_GPCS0
;R24 - end
ifdef	AT_ATX_SELECT_BY_GPCS1					;R28
E000_GET_CPU_SPEED_REQ	=	1				;R28
AT_ATX_SELECT_BY_GPCS	=	1				;R28
endif;	AT_ATX_SELECT_BY_GPCS1					;R28
;R32 - start
;R32A ifdef	AT_ATX_SELECT_BY_GPIO
;R32A E000_GET_CPU_SPEED_REQ	=	1
;R32A AT_ATX_SELECT_BY_GPIO	=	1			
;R32A endif;	AT_ATX_SELECT_BY_GPIO
ifdef AT_ATX_SELECT_BY_GPIO8
E000_GET_CPU_SPEED_REQ	=	1
AT_ATX_SELECT_BY_GPIO	=	1
endif; AT_ATX_SELECT_BY_GPIO8
;R32 - end

ifdef AT_ATX_SELECT_BY_GPIO5					;R33
E000_GET_CPU_SPEED_REQ	=	1				;R33
AT_ATX_SELECT_BY_GPIO	=	1				;R33
endif; AT_ATX_SELECT_BY_GPIO5					;R33
		ALIGN 4
		PUBLIC	Get_CPU_Speed
Get_Cpu_Speed	proc	near

;R24 - start
if	E000_GET_CPU_SPEED_REQ	eq	1
 		FAR_CALL	E000_Get_Cpu_Speed,0E000h
endif;	E000_GET_CPU_SPEED_REQ
;R24 - end

		ret
Get_Cpu_Speed	endp

;[]==============================================================[]
;CT_REMAP:
;	Remap unused memory from 640k to 1M
;Saves: all but flags
;Input: none
;Output:none
;[Notes] 1. Program chipset register if remap allowed.
;[]==============================================================[]
;R17 - start
E000_CT_REMAP_REQ	=	0
ifdef	GEMLIGHT_JUMPERLESS
E000_CT_REMAP_REQ	=	1
endif	;GEMLIGHT_JUMPERLESS
ifdef	GPCS0_AS_LINEAR_PIN
E000_CT_REMAP_REQ	=	1
endif;	GPCS0_AS_LINEAR_PIN
;R17 - end
		align	4
		public	Ct_Remap
Ct_Remap	proc	near
;R17 ;R08B - start
;R17 ifdef	GEMLIGHT_JUMPERLESS
;R17 		FAR_CALL	E000_Ct_Remap,0E000h
;R17 endif	;GEMLIGHT_JUMPERLESS
;R17 ;R08B - end
;R17 - start
if	E000_CT_REMAP_REQ	eq	1
 		FAR_CALL	E000_Ct_Remap,0E000h
endif;	E000_CT_REMAP_REQ
;R17 - end

;R23 - start
;R23A	;Disable C8000-CBFFF shadow if video ROM size is less than 32k
;R23A		pusha
;R23A		mov	ax,0c000h		;video ROM location
;R23A		mov	ds,ax
;R23A		cmp	byte ptr ds:[2],40h	;below 32Kb
;R23A		ja	short Above32K
;R23A
;R23A		mov	cx,71h
;R23A		mov	bx,0001Fh		;disable shadow
;R23A		call	Get_Set_Ct
;R23A
;R23AAbove32K:
;R23A		popa
;R23 - end
		clc
		ret
Ct_Remap	endp

;[]==============================================================[]
;Ct_Disable_Onboard_Vga:
;	Disable onboard C000H video ROM by setting chipset register
; Input : None
; Output: None
; Save: all
; [Note]: 1. This is used to auto-detect onboard C0000H video ROM
;	     and video ROM on slot.
;[]==============================================================[]
		align	4
		public	Ct_Disable_Onboard_Vga
Ct_Disable_Onboard_Vga	proc	near
		ret
Ct_Disable_Onboard_Vga	endp

;[]==============================================================[]
;Ct_Enable_Onboard_Vga
;	Enable onboard C000H video ROM by setting chipset register
; Input : None
; Output: None
; Save: all
; [Note]: 1. This is used to auto-detect onboard C0000H video ROM
;	     and video ROM on slot.
;[]==============================================================[]
		align	4
		public	Ct_Enable_Onboard_Vga
Ct_Enable_Onboard_Vga	proc	near
Ct_Enable_Onboard_Vga	endp


;[]==============================================================[]
;Ct_Disable_E000_Vga:
;	Disable onboard E000H video ROM by setting chipset register
; Input : None
; Output: None
; Save: all
; [Note]: 1. This is used to auto-detect onboard E0000H video ROM
;	     and video ROM on slot.
;[]==============================================================[]
		align	4
		public	Ct_Disable_E000_Vga
Ct_Disable_E000_Vga	proc	near
Ct_Disable_E000_Vga	endp

;[]==============================================================[]
;Ct_Enable_E000_Vga:
;	Enable onboard E000H video ROM by setting chipset register
; Input : None
; Output: None
; Save: all
; [Note]: 1. This is used to auto-detect onboard E0000H video ROM
;	     and video ROM on slot.
;[]==============================================================[]
		align	4
		public	Ct_Enable_E000_Vga
Ct_Enable_E000_Vga	proc	near
		ret
Ct_Enable_E000_Vga	endp

;[]==============================================================[]
;Ct_Check_System_Shadow:
;	Check sytem BIOS is shadowed or not.
; Input : None
; Output: flag zero set - System BIOS is shadowed
;	       zero clear - System BIOS is not shadowed
; Save: all except ax
; [Note]: 1. This is used to fix NOVELL problem on user-defined
;	     hard disk.
;	  2. You must return real status of system shadow,
;	     otherwise may boot fail on HDD.
;[]==============================================================[]
		align	4
		public	Ct_Check_System_Shadow
Ct_Check_System_Shadow	proc	near
;R15		pusha
;R15		mov	cx,76h
;R15		call	Get_Ct
;R15		and	al,80h
;R15		cmp	al,80h
;R15		popa
		ret
Ct_Check_System_Shadow	endp

;[]==============================================================[]
; Ct_Init_Cyrix :
;	Program chipset register for CYRIX CPU
; Input : None
; Output: None
; Save: all
; [Note]: 1. Just return if chipset did not need programming
;[]==============================================================[]
		align	4
		public	Ct_Init_Cyrix
Ct_Init_Cyrix	proc	near
		ret
Ct_Init_Cyrix	endp

;[]==============================================================[]
;Check C0000-EFFFF shadow allowed or not
;	Some chipset's shadow is dependent on F0000 shadowing, i.e.
;	If F0000 was not shadowed, all other segment of ROM can't be
;	shadowed.
;Input : none
;Output: zero set - shadow allow
;	 zero not set - shdow not allow
;[]==============================================================[]
		align	4
		public	Ct_Shadow_Alone_Check
Ct_Shadow_Alone_Check	proc	near
		xor	al,al		;always shadowable
		ret
Ct_Shadow_Alone_Check	endp

;[]==============================================================[]
;F000_Shadow_W:
;	Set system BIOS(F000) shadow enable & writeable
;Input : none
;Output: none
;[]==============================================================[]
TEMP_MEM	EQU	1000H
		align	4
		public	F000_Shadow_W
F000_Shadow_W	proc	near
		pusha
		mov	cx,76h
		mov	bx,0A05Fh
		call	Get_Set_Ct
		popa
		ret
F000_Shadow_W	endp

;[]==============================================================[]
;F000_Shadow_R:
;	Set system BIOS(F000) shadow readonly
;Input : none
;Output: none
;[]==============================================================[]
		align	4
		public	F000_Shadow_R
F000_Shadow_R	proc	near
		pusha
		mov	cx,76h
		mov	bx,0805Fh
		call	Get_Set_Ct
		popa
		ret
F000_Shadow_R	endp

;[]==============================================================[]
;C000_Shadow_RW:
;	Set video BIOS(C000-C800) shadow enable & writeable
;Input : none
;Output: none
;[]==============================================================[]
		align	4
		public	C000_Shadow_RW
C000_Shadow_RW	proc	near
		pusha
		mov	cx,70H
		mov	bx,0AA55h		;enable shadow R & W
		call	Get_Set_Ct
		popa
		ret
C000_Shadow_RW	endp

;[]==============================================================[]
;C000_Shadow_R:
;	Set video BIOS(C000-C800) shadow readonly
;Input : none
;Output: none
;[]==============================================================[]
		align	4
		public	C000_Shadow_R
C000_Shadow_R	proc	near
		pusha
		mov	cx,70H
		mov	bx,08855h		;enable shadow RO
		call	Get_Set_Ct
		popa
		ret
C000_Shadow_R	endp

;[]==============================================================[]
;E000_Shadow_W:
;	Set video BIOS(E000-E800) shadow enable & writeable
;Input : none
;Output: none
;[]==============================================================[]
		align	4
		public	E000_Shadow_W
E000_Shadow_W	proc	near
E000_Shadow_W	endp

;[]==============================================================[]
;E000_Shadow_R:
;	Set video BIOS(E000-E800) shadow readonly
;Input : none
;Output: none
;[]==============================================================[]
		align	4
		public	E000_Shadow_R
E000_Shadow_R	proc	near
E000_Shadow_R	endp

;[]==============================================================[]
;C800_Shadow:
;	Shadow adaptor ROM C8000-CBFFF
;Input : none
;Output: none
;[]==============================================================[]
TEMP_AREA	EQU	2000H
		public	C800_Shadow
C800_Shadow	proc	near
C800_Shadow	endp


;[]==============================================================[]
;CC00_Shadow:
;	Shadow adaptor ROM CC000-CFFFF
;Input : none
;Output: none
;[]==============================================================[]
		public	CC00_Shadow
CC00_Shadow	proc	near
CC00_Shadow	endp

;[]==============================================================[]
;D000_Shadow:
;	Shadow adaptor ROM D0000-D3FFF
;Input : none
;Output: none
;[]==============================================================[]
		public	D000_Shadow
D000_Shadow	proc	near
D000_Shadow	endp

;[]==============================================================[]
;D400_Shadow:
;	Shadow adaptor ROM D4000-D7FFF
;Input : none
;Output: none
;[]==============================================================[]
		public	D400_Shadow
D400_Shadow	proc	near
D400_Shadow	endp

;[]==============================================================[]
;D800_Shadow:
;	Shadow adaptor ROM D8000-DBFFF
;Input : none
;Output: none
;[]==============================================================[]
		public	D800_Shadow
D800_Shadow	proc	near
D800_Shadow	endp

;[]==============================================================[]
;DC00_Shadow:
;	Shadow adaptor ROM DC000-DFFFF
;Input : none
;Output: none
;[]==============================================================[]
		public	DC00_Shadow
DC00_Shadow	proc	near
DC00_Shadow	endp

;[]==============================================================[]
;E000_Shadow:
;	Shadow adaptor ROM E0000-E3FFF
;Input : none
;Output: none
;[]==============================================================[]
		public	E000_Shadow
E000_Shadow	proc	near
E000_Shadow	endp

;[]==============================================================[]
;E400_Shadow:
;	Shadow adaptor ROM E4000-E7FFF
;Input : none
;Output: none
;[]==============================================================[]
		public	E400_Shadow
E400_Shadow	proc	near
E400_Shadow	endp

;[]==============================================================[]
;E800_Shadow:
;	Shadow adaptor ROM E8000-EBFFF
;Input : none
;Output: none
;[]==============================================================[]
		public	E800_Shadow
E800_Shadow	proc	near
E800_Shadow	endp

;[]==============================================================[]
;EC00_Shadow:
;	Shadow adaptor ROM EC000-EFFFF
;Input : none
;Output: none
;[]==============================================================[]
		public	EC00_Shadow
EC00_Shadow	proc	near
		ret
EC00_Shadow	endp

;[]==============================================================[]
;Set_High_Speed:
;	Set system to high speed before CPU clock detecting
;	during POST
;Input : none
;Output: none
;[]==============================================================[]
		Public	Set_High_Speed
Set_High_Speed	Proc	Near
		FAR_CALL	E000_Set_High_Speed,0E000h
		ret
Set_High_Speed	Endp

;[]==============================================================[]
;Restore_Speed:
;	Restore system speed after CPU clock detecting set by
;	Set_High_Speed routine during POST if needed
;Input : none
;Output: none
;[]==============================================================[]
		Public	Restore_Speed
Restore_Speed	Proc	Near
		ret
Restore_Speed	Endp


;[]==============================================================[]
;Init_Onboard_Io:
;      Initial onboard I/O chip
;Save  : all but flags
;Input : none
;Output: none
;Note  : 1. This routine will be called before I/O installation.
;	 2. This is a customerization routine if you need.
;[]==============================================================[]
	       public	Init_Onboard_Io
Init_Onboard_Io proc	near
		FAR_CALL	E000_Init_Onboard_Io,0E000h
		clc
		ret
Init_Onboard_Io endp
;[]==============================================================[]
;Ct_Before_Setup:
;      Program some improper registers if problem occured when
;	entering setup
;Save  : all but flags
;Input : none
;Output: none
;Note  : 1. This routine will be called before entering setup
;	 2. Some chipset will hang or improper operation while
;	    entering setup.
;[]==============================================================[]
		public	Ct_Before_Setup
Ct_Before_Setup proc	near
		ret
Ct_Before_Setup endp
;[]==============================================================[]
;Ct_Auto_Check:
;      Check if program chipset registers with AUTO table or not
;Save  : all but flags
;Input : none
;Output: zero flag set - No auto-config.
;	 zero flag clear - Program with AUTO table
;Note  : 1. This routine will be called before auto-programming
;	 2. You must read setup value (according setup item )
;	    to judge auto-programming is allowed or not. and return
;	    correct zero flag.
;[]==============================================================[]
		public	Ct_Auto_Check
Ct_Auto_Check	proc	near
;R18 - start
;R18A		extrn	USB_ITEM:near
;R18A		mov	si,Offset USB_ITEM
;R18A		call	GetItem_Value
;R18A		or	al,al
;R18A		jnz	short @F
;R18A		mov	cx,0864h
;R18A		mov	bx,00bfh
;R18A		call	Get_Set_Ct
;R18A	@@:
;R18 - end
		mov	si,Offset Auto_Cfg_Item
		call	GetItem_Value
		or	al,al
		ret
Ct_Auto_Check	endp

;[]==============================================================[]
;Ct_Shadow_Allow:
;      Check if any shadow RAM available
;Save  : all but flags
;Input : none
;Output: zero flag set - shadow RAM available
;	 zero flag clear - No shadow RAM
;Note  : 1. This routine will be called before shadowing
;	 2. You must return non-zero flag if your system have no
;	    shadow RAMs or total memory is 512k only
;[]==============================================================[]
		public	Ct_Shadow_Allow
Ct_Shadow_Allow proc	near
		xor	al,al			;shadow RAM available
		ret
Ct_Shadow_Allow endp

;[]==============================================================[]
;Ct_Ext_Mem_Limit:
;      Limit maximum memory size according to onboard DRAM
;Save  : all but flags
;Input : AX - No. of 1k memory size
;Output: AX - max. No. of 1m memory size return
;Note  : 1. This routine will be called after memory sizing
;	 2. This routine is optional , because our BIOS can not
;	    detect memory size for some special chipset.
;	    For example : actual memory size is 16384 Kb , Our BIOS
;			  detect it as 64512 Kb , and I known it is
;			  real 16384 Kb only.
;[]==============================================================[]
		public	Ct_Ext_Mem_Limit
Ct_Ext_Mem_Limit proc	near
		ret
Ct_Ext_Mem_Limit endp

;[]==============================================================[]
;Later_Cache_Sizing:
;      Do external cache sizing before diplay cache size to screen
;Save  : all but flags
;Input : none
;Output: none
;Note  : 1. We do cache sizing just after onboard memory configuration
;	    detection mostly. If it cann't detect cache sizing
;	    correctly , you can do it here.
;	 2. Stack is available now.
;[]==============================================================[]
		public	Later_Cache_Sizing
Later_Cache_Sizing	proc	near


ifdef	PS2_IRQ12_Thru_MIRQ
		test	byte ptr cs:[CONFIG_TABLE+5],04H	;PS2 existed ?
		jnz	short PS2_Mouse_Installed

		mov	cx,0861H	;MIRQ
		xor	al, al		;Disable MIRQ
		call	Set_Ct

PS2_Mouse_Installed:
endif	;PS2_IRQ12_Thru_MIRQ

ifdef 	IRQ12_Ctl_By_Ct
		mov	ah,byte ptr cs:[CONFIG_TABLE+5]
		and	ah,04h
		extrn	Ct_IRQ12_Control:near
		call	DGROUP:Ct_IRQ12_Control
endif	;IRQ12_Ctl_By_Ct

		ret

Later_Cache_Sizing	endp

;[]==============================================================[]
;Ct_Math_Detect:
;      Detect coprocessor presence by special method.
;Save  : all but flags and AL
;Input : none
;Output: carry set  : No special method
;	 carry clear: Special detection
;		      AL - 0	- no coprocessor
;			 - 1	- 287
;			 - 2	- 387
;Note  : 1. Some chipsets can not detect coproessor by standard
;	    method and it offer special register to indicate
;	    coprocessor presence. In this case, programmer
;	    should return actual coprocessor value in AL.
;	 2. Stack is available now.
;[]==============================================================[]
		public	Ct_Math_Detect
Ct_Math_Detect	proc	near
		stc			;No special detect
		ret
Ct_Math_Detect	endp
;[]==============================================================[]
;Ct_Option_Rom_Scan:
;      Initialize special adaptor ROMs
;Save  : all but flags
;Input : none
;Output: none
;Note  : 1. Initialize special adaptor ROMs for customerization.
;	 2. typically used is to scan E8000-EFFFF ROMs
;[]==============================================================[]
		public	Ct_Option_Rom_Scan
Ct_Option_Rom_Scan	proc	near
		ret			;no special option ROM
Ct_Option_Rom_Scan	endp
;[]==============================================================[]
;Ct_Show_Config:
;      Special string display after showing system configuration
;Save  : all but flag
;Input : none
;Output: none
;Note  : 1. Some customer want to show their own messages after
;	    system configuration display.
;	 2. Please use "Display_String" to display these strings
;[]==============================================================[]

		public	Ct_Show_Config
Ct_Show_Config	proc	near
		FAR_CALL	Ct_Show_Config1,0E000h
		ret
Ct_Show_Config	endp

;[]===============================================================[]
;
; DOS_SETUP_INFO:
;
;	Low level routine to provide the screen save and stack area
;	for DOS accessible setup.
;
; Entry:ds	: point to G_RAM segment
;	cx	: amount of stack space required
;	dx	: amount of video save space required
;	al = 0	: open	video save/stack area
;	     1	: close video save/stack area
;
;
; Exit: c = set : if illegal call or chipset does not support.
;	    clr : if legal call.
;
;	al was 0 : dx:ax = location to store ss:sp
;		   es	 = video save segment (about 4k)
;	al was 1 : none
;
; Kill: es,dx,ax,flags
;
; Note: 1. This routine is OEM specific and chipset dependent
;	2. Shadow has to be on for this particular case
;
;[]==================================================================[]
		extrn	Get_Cmos:near
		extrn	Set_Cmos:near
		PUBLIC	DOS_SETUP_INFO
DOS_SETUP_INFO	PROC	NEAR
		stc		; Return error
		ret
DOS_SETUP_INFO	ENDP

		public	Cyrix_Cache_Reg
		public	NO_OF_CYRIX_REG
CYRIXREG	STRUC
		db	?	;register index
		db	?	;register value
CYRIXREG	ENDS

		align	4
Cyrix_Cache_Reg:
		CYRIXREG <0c0h,002h>
		CYRIXREG <0c1h,082h>
		CYRIXREG <0c2h,080h>

		CYRIXREG <0c4h,000h>
		CYRIXREG <0c5h,00Ah>
		CYRIXREG <0c6h,006h>
 		CYRIXREG <0dch,009h>

		CYRIXREG <0c7h,000h>
		CYRIXREG <0c8h,00Ch>
		CYRIXREG <0c9h,007h>
		CYRIXREG <0ddh,001h>

		CYRIXREG <0d9h,000h>
		CYRIXREG <0dah,000h>
		CYRIXREG <0e3h,00bh>

		CYRIXREG <0e8h,010h>		;io cycle delay
		CYRIXREG <0e9h,021h>

ifdef	SMBASE_USE_E000H
		CYRIXREG <0cdh,000h>
		CYRIXREG <0ceh,00eh>		;SM base 0E000H
		CYRIXREG <0cfh,004h>
else	;SMBASE_USE_E000H
		CYRIXREG <0cdh,000h>
		CYRIXREG <0ceh,00ah>		;SM base 0A000H
		CYRIXREG <0cfh,004h>
endif	;SMBASE_USE_E000H
		CYRIXREG <0dfh,009h>		;Rtt

NO_OF_CYRIX_REG EQU	($ - Cyrix_Cache_Reg) / 2

;[]========================================================================[]
;Procedure:	Ct_Restore_Cyrix_Reg
;
;Function :	To restore the Cyrix registers during shutdown or warm-reset.
;
;Input	  :	None
;
;Output   :	None
;
;Registers:	All registers should be preserved
;
;Note	  :	1. stack available
;		2. Should check if it is M7/M6 before restoring.
;		3. Usually, code to resotre SMBASE reg.(CEh, CFh) is
;		   placed in this routine.
;[]========================================================================[]
		align	4
		Public	Ct_Restore_Cyrix_Reg
Ct_Restore_Cyrix_Reg	Proc	Near

		ret

Ct_Restore_Cyrix_Reg	Endp



;[]========================================================================[]
;Procedure:	Ct_Disable_C8_To_DF_Shadow
;Function :	Disable C8000-DFFFF adaptor ROM shadow
;Input	  :	None
;Output   :	None
;Registers:	all
;Note	  :	1. stack available
;		2. This routine should coding correct , otherwise some
;		   adaptor ROMs initial failure while shadowing
;		3. Don't touch E0000-FFFFF shadow area.
;[]========================================================================[]
		public	Ct_Disable_C8_To_DF_Shadow
Ct_Disable_C8_To_DF_Shadow	proc	near
;R15		pusha
;R15
;R15		mov	cx,71h
;R15		xor	al,al
;R15@@:
;R15		call	Set_Ct
;R15		inc	cx
;R15		cmp	cl,73h
;R15		jbe	short @B
;R15
;R15		popa
		ret
Ct_Disable_C8_To_DF_Shadow	endp

ifdef	Double_Password
;[]========================================================================[]
;Procedure:	Ct_User_Password_Location
;
;Function :	Claim the CMOS locations for two-layer password operation
;
;Input	  :	None
;
;Output   :	DI - First CMOS location to store hashed password, this need
;		     2 bytes of CMOS
;		SI - CMOS location to save password setting flag
;		DL - Mask byte for checking password settging
;
;
;Registers:	all except DI,SI and DL
;
;Note	  :	1. stack available
;		2. The programmer should implement this routine to support
;		   two-layer password.
;		3. The routine must offer 3 bytes of CMOS to caller.
;[]========================================================================[]
		Public	Ct_User_Password_Location
Ct_User_Password_Location	Proc	Near

	mov	di,5dh		;CMOS 5dh, 5eh for hashed user password

	mov	si,5fh		;CMOS 5fh bit 0 = 0 user password not set
	mov	dl,01h		;		  1 user password set

	ret
Ct_User_Password_Location	Endp
endif;	Double_Password

ifdef	NEW_IDE_MODE_3
;[]==============================================================[]
;
; Ct_Set_IDE_Timing:
;
;	Programing I/O chip registre for IDE PIO mode 3 support
;
; SAVES : all
;
; ENTRY : HDD_0_MODE[bp] :
;	   Byte 0 - 3 = drive 0-3  PIO mode detected
;
;  EXIT : None
;
;  NOTE : 1. Stack available
;
;[]==============================================================[]

		Public	Ct_Set_IDE_Timing
Ct_Set_IDE_Timing	proc	near
		FAR_CALL	E000_Ct_Set_IDE_Timing,0E000h
		ret
Ct_Set_IDE_Timing	endp
endif	;NEW_IDE_MODE_3

	public	E000_64K_shadow_RW
E000_64K_shadow_RW:
		mov	bx,0AAFFh
		jmp	short Set_E000_Shadow
	public	E000_64K_shadow_R
E000_64K_shadow_R:
		mov	bx,088DDh
 Set_E000_Shadow:
		mov	cx,74h
		call	Get_Set_Ct
		inc	cx
		call	Get_Set_Ct
		ret


ifdef	NEW_SUPERIDE_KERNEL
;[]===========================================================[]
; Procedure Name: Ct_Get_Ct_Clock
;	This routine is used to get Onboard PCI Bus working
; frequence , for set Onboard PCI IDE controller timing
;
; Save : None
;
; Input: None
;
; Output CL   0 : 20 MHz
;	      1 : 25 MHz
;	      2 : 30 MHz
;	      3 : 33 MHz
;	      4 : 40 MHz
;[]===========================================================[]
			public	Ct_Get_Ct_Clock
Ct_Get_Ct_Clock	Proc	Near
			mov	cl,3
			ret
Ct_Get_Ct_Clock	endp

endif	;NEW_SUPERIDE_KERNEL

;R01 - start
ifdef	VGA_SHARE_MEMORY
;[]===========================================================[]
; Procedure Name: Ct_Share_Memory_Size
;	This routine is used to get VGA Shared Memory Size
;
; Save : All but AX, SI
;
; Input: None
;
; Output AX : No. of 1k share memory size
;[]===========================================================[]
		public	Ct_Share_Memory_Size
Ct_Share_Memory_Size	Proc	Near

ifdef	SHARE_SiS6205
		push	bx
		push	cx
		mov	cx,6Ch
		call	Get_Ct
		shl	al,1
		jc	short @F
		xor	ax,ax
		jmp	short Ct_Share_Size_Exit
@@:
		shr	al,4
		shl	al,2
		mov	bl,128
		mul	bl
Ct_Share_Size_Exit:
		pop	cx
		pop	bx
		ret
endif	;SHARE_SiS6205
		ret

Ct_Share_Memory_Size	endp
endif	;VGA_SHARE_MEMORY
;R01 - end


		public	Disable_E000_ROM_Shadow
Disable_E000_ROM_Shadow proc	near
	;disable onboard E0000 ROM
		mov	cx,(08H SHL 8)+040h
		call	Get_Ct
		and	al,NOT 02H
		call	Set_Ct


	;disable E0000 shadow RAM
		mov	cx,74h
		xor	al,al
		call	Set_Ct
		inc	cx
		call	Set_Ct

		ret
Disable_E000_ROM_Shadow endp

;[]=============================================================[]
;Procedure :	Ct_OnChip_IDE_Chk
;Function :     Return status of On-chip IDE for PCI add-in PCI/IDE
;		controlling
;	  	
;Input	:	none
;
;Output	:	carry set - OnChip IDE disabled
;		no carry  - Onchip IDE enabled
;Note   : 	This function should return right status of on-chip
;		IDE, otherwise IDE port will be conflicted if 
;		PCI/IDE card is plugged
;[]=============================================================[]
		public	Ct_OnChip_IDE_Chk
Ct_OnChip_IDE_Chk	proc	near
ifndef	ONCHIP_IDE_ALWAYS_DISABLE
		pusha
		extrn	Int_IDE_Item:near
		mov	si,offset Int_IDE_Item
		call	GetItem_Value
		shr	al,1				;primary IDE enabled?
		cmc
		popa
endif	;ONCHIP_IDE_ALWAYS_DISABLE
		ret
Ct_OnChip_IDE_Chk	endp
;Function : return memory hole at 15Mb-16Mb status
;Input    : none
;Output   : AL - 0 = hole disabled
;		 1 = hole enabled
		public	Ct_MemHole_Status
Ct_MemHole_Status	proc	near
ifdef	NON_CACHEABLE_BLOCK
		xor	al,al
else	;NON_CACHEABLE_BLOCK
		mov	si,offset Memory_Hole_Item
		call	GetItem_Value
endif	;NON_CACHEABLE_BLOCK
		ret
Ct_MemHole_Status	endp
		Public	GetItem_Or
GetItem_Or:
		call	GetItem_Value
		or	al,al
		ret

FCODE		ENDS


ECODE		SEGMENT USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP,DS:NOTHING,ES:NOTHING

		
		Public	F000_Get_Ct
F000_Get_Ct:
		F000_call	Get_Ct
		ret
		Public	F000_Set_Ct
F000_Set_Ct:
		F000_call	Set_Ct
		ret
		Public	F000_Get_Set_Ct
F000_Get_Set_Ct:
		F000_call	Get_Set_Ct
		ret
		Public	F000_GetItem_Or
F000_GetItem_Or:
		F000_call	GetItem_Value
		or	al,al
		ret


;[]-----------------------------------------------------------[]
;[]-----------------------------------------------------------[]
;R01 - start
ifdef	PCI_BUS
ifdef	SHARE_SiS6205
		ASSUME	DS:DGROUP
Ct_Early_Shadow1	Proc	Far
		mov	cx,63h		;bank0 has DRAM ?	;R01A
		call	F000_Get_Ct				;R01A
		test	al,01h					;R01A
		jz	short Share_6205_Absence		;R01A
		mov	cx,(ONBOARD_PCI_VGA SHL 11)+04h
		call	F000_Get_Ct			;get command register
		cmp	al, -1				;6205 exist ?
		je	short Share_6205_Absence
		test	al,11b				;chip disabled ?
		jnz	short Share_6205_Exist		;yes !

	;-------------------------------------------------
	;if 6205 is not presence or not enabled,
	;hidden ShareMem_Item & VgaMemClk_Item in setup
	;-------------------------------------------------

	Share_6205_Absence:

		extrn	VgaMemClk_Item:Near
		or	word ptr ds:[ShareMem_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr ds:[VgaMemClk_Item].ITEMSTAT,ITEMDISABLE
		mov	cx,6Ch		;disable on chip VGA
		xor	al,al
		call	F000_Set_Ct
		jmp	end_VGA_SHARE


	Share_6205_Exist:

;----------------------------------------------------------------------
;Disable advanced snoop in master read cycle if 6205 present to prevent
;file transfer error between IDE HDD & SCSI HDD when 6205 VGA & AHA2940
;both installed !
;----------------------------------------------------------------------
		mov	cx, 80h
		mov	bx, (00000000b shl 8)+11111011b
		call	F000_Get_Set_Ct

;R02 - start
		mov	cl,50h		;disable NA# when shared memory
		mov	bx,007Fh
		call	F000_Get_Set_Ct
;R02A - start
ifndef	NO_NA_ITEM
		extrn	NA_en_Item:near
		mov	cl,08h		;get version number
		call	F000_Get_Ct
		or	al,al		;A version can't enable NA
		jnz	short skip_prg_NA
		or	word ptr ds:[NA_en_Item].ITEMSTAT,ITEMDISABLE
		mov	word ptr ds:[NA_en_Item].CtReg   ,NOCT
skip_prg_NA:
endif	;NO_NA_ITEM
;R02A - end
;R02 - end

ifdef	VUMA
		extrn	Shared_Mem_Addr:Word
		extrn	Shared_Mem_Size:Word
		extrn	Shared_Mem_RAS :Word
		extrn	Shared_Mem_Type:Byte

;R10 - start
		test	byte ptr CMOS_STATUS[bp],CKSM_STATUS ;checksum error?
		jz	short ChecksumOk
		mov	ax,(0 shl 8) + 4Fh NMI_OFF	     ;vga freq. 40MHz
		extrn	F000_Set_Cmos:near
		call	EGROUP:F000_Set_Cmos
ChecksumOk:
;R10 - end
		mov	cx,60h
		call	F000_Get_Ct
		and	al,0C0h
		shr	al,6
		cmp	al,3
		mov	cl,6Eh
		mov	bx,807Fh
		jae	short @F
		xor	bh,bh
		inc	ax
@@:
		mov	DGROUP:[Shared_Mem_Type],al
		call	F000_Get_Set_Ct


						;check size
		extrn	ShareMem_Item:near
		mov	si,offset DGROUP:ShareMem_Item
		call	F000_GetItem_Or

		inc	ax
		mov	dl,al

		shl	al,3
		mov	cl,6Ch
		mov	bh,al
		or	bh,80h			;R01B
		mov	bl,087h
		call	F000_Get_Set_Ct

		mov	al,dl
		mov	bl,8
		mul	bl
		mov	DGROUP:[Shared_Mem_Size],ax


						;check address
		mov	ax,0F401h	;get bank0 size
		mov	bl,06h
		mov	cx,01h
		int	15h		;then bank size in DX

		mov	DGROUP:[Shared_Mem_Addr],dx
endif	;VUMA

end_VGA_SHARE:
		ret
		ASSUME	DS:NOTHING
Ct_Early_Shadow1	Endp
endif	;SHARE_SiS6205
endif;	PCI_BUS
;R01 - end
;[]-----------------------------------------------------------[]
;[]-----------------------------------------------------------[]
E000_Get_Cache_Size	Proc	Far
		push	cx
		mov	cx,51h
		call	F000_Get_Ct
		shr	al,4
		and	al,00000011b
		jz	short Get_Cache_Size_End
		add	al,4
Get_Cache_Size_End:
		pop	cx
		ret
E000_Get_Cache_Size	Endp
;[]-----------------------------------------------------------[]
;[]-----------------------------------------------------------[]
E000_Set_High_Speed	Proc	Far
		pusha
		push	ds
;set cache tag bit size according to setup item
		mov	bx,02FDh
ifndef	ALWAYS_TAG_8BITS
;R03		extrn	L2Cache_Item:Near
;R03		mov	si,offset DGROUP:L2Cache_Item
;R03		call	F000_GetItem_Or
;R03		jz	short @F
		extrn	TagLen_Item:Near
		mov	si,offset DGROUP:TagLen_Item
		call	F000_GetItem_Or
		jnz	short @F
		xor	bh,bh
	@@:
endif	;ALWAYS_TAG_8BITS
		mov	cx,51h
		call	F000_GET_SET_CT

		pop	ds
		popa
		ret
E000_Set_High_Speed	Endp
;[]-----------------------------------------------------------[]
;[]-----------------------------------------------------------[]
ifdef	NEW_IDE_MODE_3						;R09
E000_Ct_Set_IDE_Timing	proc	Far
		pushf
		pushad
		push	ds
		push	es
ifdef	NEW_SUPERIDE_KERNEL
		extrn	Prg_Super_IDE_Chip:abs
		cli
		call	Prg_Super_IDE_Chip
endif	;NEW_SUPERIDE_KERNEL

ifndef	ONCHIP_IDE_ALWAYS_DISABLE
		mov	cx,94Bh		;if CDROM not exist, 
					;then enable postwrite & prefetch
		mov	bl,byte ptr CDROM_Exist_Flag[bp]
		and	bl,0Fh
		xor	bl,0Fh
		mov	bh,bl
		shl	bl,4
		shl	bx,4
		call	F000_Get_Set_Ct
		
		extrn	Int_IDE_Item:near
		mov	si,offset DGROUP:Int_IDE_Item
		call	F000_GetItem_Or
		jz	short ide_dis_5513
		extrn	IdeA_Mode_Item:near
		extrn	Ide_mode_diff:abs
		xor	di,di			;di = drive number
		mov	si,offset DGROUP:IdeA_mode_Item
SiS_4DRIVE_LOOP:
		push	si
		call	F000_GetItem_Or
		jz	short SiS_mode_in_BP
		dec	ax			;manual mode setting
		mov	HDD_0_MODE[bp+di],al
SiS_mode_in_BP:
		mov	al,HDD_0_MODE[bp+di]
		mov	cl,40h
		shl	di,1
		add	cx,di
		shr	di,1
		mov	bx,offset SiS_MODE3_TBL
 ifdef	AUTO75_SUPPORT
		call	Check_Cyrix_75x2
 endif	;AUTO75_SUPPORT
		xlat	cs:SiS_MODE3_TBL
		shl	ax,4
		shr	al,4
		mov	bl,0F0h
		mov	bh,al
		call	F000_Get_Set_Ct
		inc	cx
ifndef	Ultra_DMA33_support			;R09
		mov	bl,0F8h
		mov	bh,ah
;R09 - start
else	;Ultra_DMA33_support
		extrn	IdeA_Sdma_Item:near
		push	ax
		mov	bx,di
		mov	si,offset DGROUP:IdeA_Sdma_Item
calc_Ide_Sdma:
		or	bx,bx
		jz	short calc_Sdma_ok
		add	si,Ide_mode_diff
		dec	bx
		jmp	short calc_Ide_Sdma
calc_Sdma_ok:
		call	F000_GetItem_Or
		jz	short Sdma_dis
		cmp	al,1
		je	short SiS_Sdma_in_BP
		dec	ax			;manual mode setting
Sdma_dis:	dec	ax
		mov	HDD_0_UltraDMA[bp+di],al
SiS_Sdma_in_BP:
		mov	al,HDD_0_UltraDMA[bp+di]
		inc	ax
		mov	bx,offset SiS_SDMA_TBL
		xlat	cs:SiS_SDMA_TBL
		pop	bx
		or	bh,al
		mov	bl,18h
endif	;Ultra_DMA33_support
;R09 - end
		call	F000_Get_Set_Ct

		pop	si
		add	si,Ide_mode_diff
		inc	di
		cmp	di,3
		jbe	short SiS_4DRIVE_LOOP
ide_dis_5513:
endif	;ONCHIP_IDE_ALWAYS_DISABLE

Prg_ok:
		pop	es
		pop	ds
		popad
		popf
		ret
E000_Ct_Set_IDE_Timing	endp

ifndef	ONCHIP_IDE_ALWAYS_DISABLE
;R09 - start
ifdef	Ultra_DMA33_support
;-------------------  disable mode0 mode1 mode2  -----
SiS_SDMA_TBL	db	000h ,0E0h ,0C0h ,0A0h
endif	;Ultra_DMA33_support
;R09 - end

 ifndef	GEMLIGHT_5513_TIMING
 ifndef	MICROSTAR_5513_TIMING
 ifndef	MODE34_TBL_ADD
;----------------- mode	 0   1	 2   3	 4 -----------
;			    active time	   recovery time
;					\/
SiS_MODE3_TBL	db	00h,6Ah,68h,33h,31h
 endif	;MODE34_TBL_ADD
 endif	;MICROSTAR_5513_TIMING
 endif	;GEMLIGHT_5513_TIMING

 ifdef	MODE34_TBL_ADD
SiS_MODE3_TBL	db	00h,6Ah,68h,43h,32h
 endif	;MODE34_TBL_ADD
 ifdef	MICROSTAR_5513_TIMING
SiS_MODE3_TBL	db	00h,6Ah,68h,43h,43h
 endif	;MICROSTAR_5513_TIMING
 ifdef	GEMLIGHT_5513_TIMING
SiS_MODE3_TBL	db	00h,6Ah,68h,55h,31h
 endif	;GEMLIGHT_5513_TIMING
 ifdef	AUTO75_SUPPORT
;R07SiS_MODE3_TBL_Cyrix	db	00h,6Ah,68h,33h,31h
SiS_MODE3_TBL_Cyrix	db	00h,6Ah,68h,43h,41h	;R07
Check_Cyrix_75x2:
		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX
		jne	short NotM1_Cpu

		cmp	byte ptr CPU_INT_CLOCK[bp],150		;150Mhze ?
		jne	short NotM1_Cpu

		test	byte ptr OVERRIDE[bp],DOUBLE_CLOCK	;2x mode ?
		jz	short NotM1_Cpu

	;redirect IDE table
		mov	bx,offset SiS_MODE3_TBL_Cyrix
NotM1_Cpu:
		ret
endif	;AUTO75_SUPPORT
endif	;ONCHIP_IDE_ALWAYS_DISABLE
endif	;NEW_IDE_MODE_3						;R09
;[]----------------------------------------------------------[]
;[]----------------------------------------------------------[]
ifndef	ONCHIP_IDE_ALWAYS_DISABLE
IdeIo_Init_Tbl:
		dd	1f1h		;10-13H
		dd	3f5h		;14-17H
		dd	171h		;18-1bh
		dd	375h		;1c-1fh
		dd	4001h		;20-23h
endif	;ONCHIP_IDE_ALWAYS_DISABLE

;R24 - start
E000_Get_Cpu_Speed	proc	far
;R28 ifdef	AT_ATX_SELECT_BY_GPCS0
;R32A if	AT_ATX_SELECT_BY_GPCS	eq	1		;R28
;R32A else
;R32A if	AT_ATX_SELECT_BY_GPIO	eq	1		;;;R32
;R27 ALARM_CMOS	EQU	40h
if	(AT_ATX_SELECT_BY_GPIO or AT_ATX_SELECT_BY_GPCS)	eq	1	;R32A

		push	ds
		push	seg DGROUP
		pop	ds
		ASSUME	CS:EGROUP,DS:DGROUP

ifdef	AT_ATX_SELECT_BY_GPCS0				;R28
		mov	cx,863h
		F000_call Get_Ct
ifdef	GPCS0_HIGH_ACTIVE_FOR_ATX			;R24A
	        test	al,08h				;R24A
	 	jnz	short AT_POWER_SELECT		;R24A
else;	GPCS0_HIGH_ACTIVE_FOR_ATX			;R24A
	        test	al,08h
	 	jz	short AT_POWER_SELECT		
endif;	GPCS0_HIGH_ACTIVE_FOR_ATX			;R24A
endif;	AT_ATX_SELECT_BY_GPCS0				;R28
ifdef	AT_ATX_SELECT_BY_GPCS1				;R28
		mov	cx,864h				;R28 Active Hi
    	     	F000_call Get_Ct			;R28
		and	al,not 08h			;R28
		F000_call Set_Ct			;R28
         	or      al,40h   			;R28
		F000_call Set_Ct			;R28
           	F000_call Get_Ct			;R28
	    	test	al,08h   			;R28
		jz	short AT_POWER_SELECT		;R28
endif;	AT_ATX_SELECT_BY_GPCS1				;R28

;;;R32 - start
ifdef	AT_ATX_SELECT_BY_GPIO8
	;; Set GPIO8 to Input Mode
		mov	dx,ACPI_BASE_IO_ADDR+1ah	;R32A
		in	ax,dx				;R32A
		and	ah,not 01h   			;R32A
		out	dx,ax				;R32A
		IODELAY					;R32A

		mov	dx,ACPI_BASE_IO_ADDR+18h
		in	ax,dx
ifdef	GPIO_HIGH_ACTIVE_FOR_ATX
	        test	ah,01h				
	 	jnz	short AT_POWER_SELECT		
else;	GPIO_HIGH_ACTIVE_FOR_ATX			
	        test	ah,01h				
	 	jz	short AT_POWER_SELECT		
endif;	GPIO_HIGH_ACTIVE_FOR_ATX			
endif;  AT_ATX_SELECT_BY_GPIO				;R32A

;R33 start
ifdef   AT_ATX_SELECT_BY_GPIO5				
		mov	cx,APC_R+04h
		mov	bx,04ffh
		call    F000_Get_Set_Ct

		mov	cx,ACPI_R+1eh
		mov    	bx,20ffh		;Activity Hi
		call    F000_Get_Set_Ct

		mov	cx,ACPI_R+18h
		call    F000_Get_Ct
ifdef	GPIO5_HIGH_ACTIVE_FOR_ATX
	        test	al,20h					
	 	jz	short AT_POWER_SELECT			 
else;	GPIO5_HIGH_ACTIVE_FOR_ATX
	        test	al,20h
	 	jnz	short AT_POWER_SELECT
endif;	GPIO5_HIGH_ACTIVE_FOR_ATX

endif;	AT_ATX_SELECT_BY_GPIO5			 
;R33 end

;R32A endif;	AT_ATX_SELECT_BY_GPIO8				
;R32A 
;R32A ifdef	AT_ATX_SELECT_BY_GPIO8				
;R32A 		mov	dx,ACPI_BASE_IO_ADDR+1ah	 ;;;R32 Active Hi
;R32A     	     	in	ax,dx				
;R32A 		and	ah,not 01h   			
;R32A 		out	dx,ax				
;R32A 		mov	cx,ACPI_BASE_IO_ADDR+1eh	
;R32A 		in	ax,dx				
;R32A          	or      ah,01h   			
;R32A 		out	dx,ax				
;R32A 		mov	cx,ACPI_BASE_IO_ADDR+18h	
;R32A            	in	ax,dx				
;R32A 	    	test	ah,01h   			
;R32A 		jz	short AT_POWER_SELECT		
;R32A endif;	AT_ATX_SELECT_BY_GPIO8				
;;;R32 - end
		mov	al,ALARM_CMOS NMI_OFF
		F000_call Get_CMOS
		and	al,04h
		shl	al,3
		xchg	bl,al

		mov	cx,APC_R+03h
		F000_call Get_Ct
		and	al,not 20h
		or	al,bl
		F000_call Set_Ct
		pop	ds
		ret

AT_POWER_SELECT:
		extrn	Power_B_O_R_Item:Near
		extrn	Ring_Up_Item:Near
		extrn	ALARM_ITEM:Near
		extrn	ALARM_MONTH_Item:Near
		extrn	ALARM_DATE_Item:Near
		extrn	ALARM_WEEK_SHOW:Near
		extrn	ALARM_WEEK_SHOW1:Near
		extrn	ALARM_WEEK_1_Item:Near
		extrn	ALARM_WEEK_2_Item:Near
		extrn	ALARM_WEEK_3_Item:Near
		extrn	ALARM_WEEK_4_Item:Near
		extrn	ALARM_WEEK_5_Item:Near
		extrn	ALARM_WEEK_6_Item:Near
		extrn	ALARM_WEEK_7_Item:Near
		extrn	ALARM_HOUR_Item:Near
		extrn	ALARM_MIN_Item:Near
		extrn	ALARM_SEC_Item:Near
;R28B - start
ifndef	No_GPIO5_Power_UP_Item
ifndef	LINEAR_MODE_GPIO5
ifndef	GREEN_ASSERT_GPIO5
		extrn	GPIO5_Power_Up_Item:near		;R28
endif;	LINEAR_MODE_GPIO5
endif;	GREEN_ASSERT_GPIO5
endif;	No_GPIO5_Power_UP_Item
;R28B - end
		F000_call	F000_Shadow_W
		or	word ptr DGROUP:[Power_B_O_R_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[Ring_Up_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_ITEM].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_MONTH_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_DATE_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_WEEK_SHOW].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_WEEK_SHOW1].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_WEEK_1_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_WEEK_2_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_WEEK_3_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_WEEK_4_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_WEEK_5_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_WEEK_6_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_WEEK_7_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_HOUR_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_MIN_Item].ITEMSTAT,ITEMDISABLE
		or	word ptr DGROUP:[ALARM_SEC_Item].ITEMSTAT,ITEMDISABLE
;R28 - start
ifndef	No_GPIO5_Power_UP_Item
ifndef	LINEAR_MODE_GPIO5
ifndef	GREEN_ASSERT_GPIO5
		or	word ptr DGROUP:[GPIO5_Power_UP_Item].ITEMSTAT,ITEMDISABLE	;R28
endif;	LINEAR_MODE_GPIO5
endif;	GREEN_ASSERT_GPIO5
endif;	No_GPIO5_Power_UP_Item
;R28 - end
		pop	ds
		ret
;R28 endif;	AT_ATX_SELECT_BY_GPCS0
;R32A endif;	AT_ATX_SELECT_BY_GPCS				;R28
;R32A endif;  AT_ATX_SELECT_BY_GPIO           		;;;R32
endif;	(AT_ATX_SELECT_BY_GPIO or AT_ATX_SELECT_BY_GPCS)	;R32A
E000_Get_Cpu_Speed	endp
;R24 - end

;R08B - start
ifdef	GEMLIGHT_JUMPERLESS

GPIO_P54C	EQU	1
GPIO_P55C	EQU	2
GPIO_K5		EQU	3
GPIO_K6		EQU	4
GPIO_M1		EQU	5
GPIO_M2		EQU	6
GPCS0_CMOS	EQU	44h
GPCS1_CMOS	EQU	45h
GPIO_TBL_CMOS	EQU	47h
		extrn	CPU_v_Item:near
ifndef	NO_CPU_SPEED_ITEM					;R12
		extrn	CPU_spd_Item:near
endif;	NO_CPU_SPEED_ITEM					;R12
		extrn	Check_K6_CPU:near
		extrn	Read_CpuID:near
		extrn	F000_Get_Cmos:near
		extrn	F000_Set_Cmos:near
endif;	GEMLIGHT_JUMPERLESS				;R17

if	E000_CT_REMAP_REQ	eq	1		;R17

E000_Ct_Remap	proc	far

ifdef	GEMLIGHT_JUMPERLESS				;R17
		mov	si,offset DGROUP:CPU_v_Item
		call	F000_GetItem_Or
		cmp	al,1
		jne	manual_volt

		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX
		jne	short Not_Cyrix_Vcore
		mov	al,0FEh
		out	22h,al
		in	al,23h
		cmp	al,51h
		jb	short Check_M1_Vcore
		cmp	al,5Fh
		ja	short Check_M1_Vcore
;R22 - start
ifdef	Special_Prg_M2_For_Gemlight
		push	ds
		push	0f000h
		pop	ds
		mov	si,offset Cyrix_Cache_Reg
		mov	bx,word ptr ds:[si+4]	;reg c2h
		F000_call	UNlock_Cyrix
;R22A		mov	cl,bh
;R22A		and	al,bl
		mov	cl,bl				;R22A
		mov	al,bh				;R22A
		F000_Call	Set_Cyrix
		F000_call	lock_Cyrix
		pop	ds
endif;	Special_Prg_M2_For_Gemlight
;R22 - end
;R08E		mov	al,2			;2.8v
		mov	al,3			;R08E 2.9v
		jmp	short manual_volt
Check_M1_Vcore:
		mov	al,0FFh
		out	22h,al
		in	al,23h
		cmp	al,20h			;6x86L ?
		mov	al,6			;3.52v
		jb	short manual_volt
		mov	al,2			;2.8v
		jmp	short manual_volt
Not_Cyrix_Vcore:
		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_AMD
		jne	short Not_AMD_Vcore
 		call	Check_K6_CPU
		mov	al,6			;3.52v
		jne	short manual_volt
;R08F - start
		mov	eax,1			;read cache isze
		db	0Fh,0A2h		;OP code: CPUID
		mov	bx,ax
;R08G		mov	al,3			;2.1v
		mov	al,5			;R08G 2.2v
		and	bl, 0F0h
		cmp	bx, 0590h
		je	short manual_volt	;skip if new K6
		cmp	bx, 0580h
		je	short manual_volt	;skip if new K6
		cmp	bx, 0570h
		je	short manual_volt	;skip if new K6
;R08F - end
		mov	al,3			;2.9v
		cmp	word ptr CPU_INT_CLOCK[bp],200	;over 200Mhz ?
		jbe	short manual_volt
;R08G		mov	al,4			;3.2v
		mov	al,2			;R08G 3.2v
		jmp	short manual_volt
Not_AMD_Vcore:					;intel
		call 	Read_CpuID
;R08A		shr	edx,16
;R08A		test	dl,80H			;With MMX ? (bit23 = 1 ?)
		cmp	al,40h				;R08A
		mov	al,2			;2.8v
;R08A		jnz	short manual_volt
		jae	short manual_volt		;R08A
		mov	al,5			;3.3v

manual_volt:
		mov	bx,offset gemlight_volt_tbl
		db	2Eh	;CS:
		xlat
		push	ax
		mov	dx,ACPI_BASE_IO_ADDR + 1Ah
		in	ax,dx
		or	ax,0180h
		out	dx,ax
		pop	bx
		dec	dx
		dec	dx	;then dx= ACPI_BASE_IO_ADDR + 18h
		in	ax,dx
		xor	bh,bh
		shl	bx,7
		and	ax,not 0180h
		or	ax,bx
;R08G ;R08C - start
;R08G 		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_AMD
;R08G 		jne	short @f
;R08G  		call	Check_K6_CPU
;R08G 		jne	short @f
;R08G 		cmp	word ptr CPU_INT_CLOCK[bp],233	;over 233Mhz ?
;R08G 		jb	short @f
;R08G 		or	ax,0180h
;R08G @@:
;R08G ;R08C - end
		out	dx,ax

		mov	si,offset DGROUP:CPU_v_Item
		call	F000_GetItem_Or
		cmp	al,1				;Is auto ?
		je	short Set_GPCS0_to_Hi		;Yes, skip.
		cmp	al,4				;Is 3.2
		je	short Set_GPCS0_to_Hi		;Yes, skip.

Set_GPCS0_to_Lo:
		mov	bx,(00000000b shl 8) or 01101110b
		jmp	short Set_GPCS0

Set_GPCS0_to_Hi:
		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_AMD
		jne	short Set_GPCS0_to_Lo
 		call	Check_K6_CPU
		jne	short Set_GPCS0_to_Lo
;R08F - start
		mov	eax,1			;read cache isze
		db	0Fh,0A2h		;OP code: CPUID
		and	al, 0F0h
		cmp	ax, 0590h
		je	short Set_GPCS0_to_Lo	;skip if new K6
		cmp	ax, 0580h
		je	short Set_GPCS0_to_Lo	;skip if new K6
		cmp	ax, 0570h
		je	short Set_GPCS0_to_Lo	;skip if new K6
;R08F - end
		cmp	word ptr CPU_INT_CLOCK[bp],233	;over 200Mhz ?
		jb	short Set_GPCS0_to_Lo

		mov	bx,(00010000b shl 8) or 01101110b

Set_GPCS0:
		mov	cx,0863h
		call	F000_Get_Set_Ct

		mov	cx,0865h
		mov	bx,(00000010b shl 8) or 11111100b
		call	F000_Get_Set_Ct
endif;	GEMLIGHT_JUMPERLESS				;R17

;R17 - start
ifdef	GPCS0_AS_LINEAR_PIN
		pusha

		mov	bx,(00010000b shl 8) or 01101110b
		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX
		jne	short Set_GPCS0
		mov	bx,(00000000b shl 8) or 01101110b

Set_GPCS0:
		mov	cx,0863h
		call	F000_Get_Set_Ct

		mov	cx,0865h
		mov	bx,(00000010b shl 8) or 11111100b
		call	F000_Get_Set_Ct
		popa
endif;	GPCS0_AS_LINEAR_PIN
;R17 - end

		ret
E000_Ct_Remap	endp
;R17 endif	;GEMLIGHT_JUMPERLESS
;R08B - end
endif;	E000_CT_REMAP_REQ				;R17

E000_Init_Onboard_Io proc	Far
		push	ds

		push	seg DGROUP
		pop	ds
		ASSUME	CS:EGROUP,DS:DGROUP

;R06A ;R06 - start
;R06A ifndef	NO_SDRAM_CAS_LAT_ITEM
;R06A SHADOW_OK_CMOS	equ	46h
;R06A SHADOW_OK_FLAG	equ	9Dh
;R06A 		mov	ax,(SHADOW_OK_FLAG shl 8) + SHADOW_OK_CMOS NMI_OFF
;R06A 		extrn	F000_Set_Cmos:near
;R06A 		call	EGROUP:F000_Set_Cmos
;R06A endif	;NO_SDRAM_CAS_LAT_ITEM
;R06A ;R06 - end

ifndef	LINEAR_SRAM
		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX
		je	short skip_mask_linear
		F000_call	F000_Shadow_W
		extrn	Linear_Mode_Item:Near
		or	word ptr DGROUP:[Linear_Mode_Item].ITEMSTAT,ITEMDISABLE
skip_mask_linear:
endif	;LINEAR_SRAM

;R08B ;R08 - start
;R08B ifdef	GEMLIGHT_JUMPERLESS
;R08B GPIO_P54C	EQU	1
;R08B GPIO_P55C	EQU	2
;R08B GPIO_K5		EQU	3
;R08B GPIO_K6		EQU	4
;R08B GPIO_M1		EQU	5
;R08B GPIO_M2		EQU	6
;R08B GPCS0_CMOS	EQU	44h
;R08B GPCS1_CMOS	EQU	45h
;R08B GPIO_TBL_CMOS	EQU	47h
;R08B 		extrn	CPU_v_Item:near
;R08B ifndef	NO_CPU_SPEED_ITEM					;R12
;R08B 		extrn	CPU_spd_Item:near
;R08B endif;	NO_CPU_SPEED_ITEM					;R12
;R08B  		extrn	Check_K6_CPU:near
;R08B 		extrn	Read_CpuID:near
;R08B  		extrn	F000_Get_Cmos:near
;R08B  		extrn	F000_Set_Cmos:near
;R08B 		mov	si,offset DGROUP:CPU_v_Item
;R08B 		call	F000_GetItem_Or
;R08B 		cmp	al,1
;R08B 		jne	manual_volt
;R08B 
;R08B 		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX
;R08B 		jne	short Not_Cyrix_Vcore
;R08B 		mov	al,0FEh
;R08B 		out	22h,al
;R08B 		in	al,23h
;R08B 		cmp	al,51h
;R08B 		jb	short Check_M1_Vcore
;R08B 		cmp	al,5Fh
;R08B 		ja	short Check_M1_Vcore
;R08B 		mov	al,2			;2.8v
;R08B 		jmp	short manual_volt
;R08B Check_M1_Vcore:
;R08B 		mov	al,0FFh
;R08B 		out	22h,al
;R08B 		in	al,23h
;R08B 		cmp	al,20h			;6x86L ?
;R08B 		mov	al,6			;3.52v
;R08B 		jb	short manual_volt
;R08B 		mov	al,2			;2.8v
;R08B 		jmp	short manual_volt
;R08B Not_Cyrix_Vcore:
;R08B 		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_AMD
;R08B 		jne	short Not_AMD_Vcore
;R08B  		call	Check_K6_CPU
;R08B 		mov	al,6			;3.52v
;R08B 		jne	short manual_volt
;R08B 		mov	al,3			;2.9v
;R08B 		cmp	word ptr CPU_INT_CLOCK[bp],200	;over 200Mhz ?
;R08B 		jbe	short manual_volt
;R08B 		mov	al,4			;3.2v
;R08B 		jmp	short manual_volt
;R08B Not_AMD_Vcore:					;intel
;R08B 		call 	Read_CpuID
;R08B ;R08A		shr	edx,16
;R08B ;R08A		test	dl,80H			;With MMX ? (bit23 = 1 ?)
;R08B 		cmp	al,40h				;R08A
;R08B 		mov	al,2			;2.8v
;R08B ;R08A		jnz	short manual_volt
;R08B 		jae	short manual_volt		;R08A
;R08B 		mov	al,5			;3.3v
;R08B 
;R08B manual_volt:
;R08B 		mov	bx,offset gemlight_volt_tbl
;R08B 		db	2Eh	;CS:
;R08B 		xlat
;R08B 		push	ax
;R08B 		mov	dx,ACPI_BASE_IO_ADDR + 1Ah
;R08B 		in	ax,dx
;R08B 		or	ax,0180h
;R08B 		out	dx,ax
;R08B 		pop	bx
;R08B 		dec	dx
;R08B 		dec	dx	;then dx= ACPI_BASE_IO_ADDR + 18h
;R08B 		in	ax,dx
;R08B 		xor	bh,bh
;R08B 		shl	bx,7
;R08B 		and	ax,not 0180h
;R08B 		or	ax,bx
;R08B 		out	dx,ax
;R08B endif	;GEMLIGHT_JUMPERLESS
;R08B ;R08 - end

ifndef	ONCHIP_IDE_ALWAYS_DISABLE
		extrn	Int_IDE_Item:near
		mov	si,offset DGROUP:Int_IDE_Item
		call	F000_GetItem_Or
else	;ONCHIP_IDE_ALWAYS_DISABLE
		xor	al,al
endif	;ONCHIP_IDE_ALWAYS_DISABLE

		mov	cx,094Ah	;set IDE reg.4Ah
		mov	bl,not 06h
		mov	bh,al
		shl	bh,1
		call	F000_Get_Set_Ct

		mov	cl,04h		;set IDE reg.04
		mov	bl,0F8h
		or	bh,bh
		jz	short @F
		mov	bh,07h
@@:		call	F000_Get_Set_Ct
ifndef	ONCHIP_IDE_ALWAYS_DISABLE
		mov	cl,3Ch 		;on-chip IDE interrupt line
		or	bh,bh
		jz	short @F
		mov	bh,0Eh		;IRQ 14
@@:		xor	bl,bl
		call	F000_Get_Set_Ct
;Program On-chip IDE controller to legacy I/O port address
		extrn	Set_CfgSpace_Dword:near
		mov	si,offset IdeIo_Init_Tbl
		mov	cl,10H
Next_Io_Init:
		lods	dword ptr cs:[si]
		F000_call	DGROUP:Set_CfgSpace_Dword
		add	cl,4
		cmp	cl,20H
		jbe	short Next_Io_Init
endif	;ONCHIP_IDE_ALWAYS_DISABLE


ifdef	MIRQ
		extrn	MIRQ_Item:Near
		mov	si,offset DGROUP:MIRQ_Item
		call	F000_GetItem_Or
		mov	cx,861h
		mov	bx,0C03Fh
		or	al,al
		jz	short @F
		mov	bh,40h		;sharing disable
@@:		call	F000_Get_Set_Ct
endif	;MIRQ


ifndef	NON_CACHEABLE_BLOCK
		mov	si,offset DGROUP:Memory_Hole_Item
		call	F000_GetItem_Or
		or	al,al
		jz	short @F
		mov	eax,( 0eH SHL 10 )		;maximum is 15Mb
		cmp	EXT_MEM_SIZE[bp],eax
		jbe	short @F
		mov	EXT_MEM_FOUND[bp],ax
@@:
endif	;NON_CACHEABLE_BLOCK

;R13 - start
ifdef	RSM_BY_ALARM
;--------------------------------------------------
;	calculate no. of days since 1-1-xx00
;--------------------------------------------------
		pusha
		mov	al,09h NMI_OFF		;Read Year
		F000_call	Get_Cmos
		mov	bh,al			;Save Year
		F000_call	BCD_TO_HEX
		xor	cx,cx
		mov	cl,al
		mov	ax,365			;365 days per year
		mul	cx			;no of days in ax

;add 1 day for 	every four years

		shr	cx,2
		add	ax,cx

;e.g. add 31 if it is February
;	  31+28 for March ....
		push	ax
		mov	al,08h NMI_OFF		;Read Month
		F000_call	Get_Cmos
		mov	bl,al			;Save Month
		F000_call	BCD_TO_HEX
		mov	cl,al
		xor	ch,ch
		sub	cx,1
		shl	cx,1
		pop	ax

		mov	si,offset cs:Day_Accum
		add	si,cx
		add	ax,cs:[si]

		test	bh,3h			;4 YEAR	?
		jnz	short @F
		cmp	bl,2h			;is Feb ?
		ja	short @F
		dec	ax
@@:

;add day of month

		push	ax
		mov	al,07h NMI_OFF		;Read Month
		F000_call	Get_Cmos
		F000_call	BCD_TO_HEX
		mov	cl,al
		xor	ch,ch
		pop	ax
		add	ax,cx

;tune for 19xx & 20xx
		push	ax
		mov	al,32h NMI_OFF		;Read Month
		F000_call	Get_Cmos
		cmp	al,19h
		pop	ax
		je	short @F

		add	ax,6
@@:
;--------------------------------------------------
;get the residue of ax/7 in dx
; Output
;  ax = 1 - Sunday
;  ax = 2 - Monday ...
;--------------------------------------------------
		sub	ax,7
		jae	short @B
		add	ax,8

		mov	ah,al
		mov	al,06h NMI_OFF		;Set Day of Week
		F000_call	Set_Cmos

	;; Disable Power Up Function
		mov	cx,APC_R+02h
		call	F000_Get_Ct
		and	al,not 01h
		call	F000_Set_Ct

		mov	cx,APC_R+03h
		call	F000_Get_Ct
		and	al,not 04h
		call	F000_Set_Ct

	;; Dont Care Month/Day Alarm
		mov	ax,(0C0h shl 8)+7Eh NMI_OFF
		F000_call	Set_Cmos
		mov	ax,(0C0h shl 8)+7Fh NMI_OFF
		F000_call	Set_Cmos

		mov	si,offset ALARM_ITEM
		F000_call	GetItem_Value
		test	al,al
		jz	Set_Pwr_Up_Time_Exit

Set_Pwr_Up_Time:
		mov	si,offset ALARM_HOUR_Item
		F000_call	GetItem_Value
		xchg	al,ah
		F000_call	HEX_TO_BCD
		mov	al,05h NMI_OFF
		F000_call	Set_Cmos

		mov	si,offset ALARM_MIN_Item
		F000_call	GetItem_Value
		xchg	al,ah
		F000_call	HEX_TO_BCD
		mov	al,03h NMI_OFF
		F000_call	Set_Cmos

		mov	si,offset ALARM_SEC_Item
		F000_call	GetItem_Value
		xchg	al,ah
		F000_call	HEX_TO_BCD
		mov	al,01h NMI_OFF
		F000_call	Set_Cmos


	;;Enable Week Alarm in every days
;R29		mov	al,42h NMI_OFF
		mov	al,(ALARM_CMOS+2) NMI_OFF		;R29
		F000_call	Get_Cmos
		test	al,0FEh
		jz	short Set_Pwr_Up_Time_by_Month

		or	al,01h				;enable Week Alarm
		mov	cx,APC_R+02h
		call	F000_Set_Ct

		jmp	short Set_Pwr_Up_Time_Exit

Set_Pwr_Up_Time_by_Month:
		mov	cx,APC_R+03h
		call	F000_Get_Ct
		or	al,04h
		call	F000_Set_Ct

		mov	si,offset ALARM_MONTH_Item
		F000_call	GetItem_Value
		test	al,al
		jz	short Dont_Care_Month_Alarm

		xchg	al,ah
		F000_call	HEX_TO_BCD
		mov	al,7Fh NMI_OFF
		F000_call	Set_Cmos
		
Dont_Care_Month_Alarm:
		mov	si,offset ALARM_DATE_Item
		F000_call	GetItem_Value
		test	al,al
		jz	short Set_Pwr_Up_Time_Exit

		xchg	al,ah
		F000_call	HEX_TO_BCD
		mov	al,7Eh NMI_OFF
		F000_call	Set_Cmos

Set_Pwr_Up_Time_Exit:

		popa
endif;	RSM_BY_ALARM
;R13 - end

ifdef   Jumpless_Support
		call	Update_Jumpless_Screen
endif;   Jumpless_Support

		pop	ds
		ret
E000_Init_Onboard_Io endp

;R13 - start
ifdef	RSM_BY_ALARM
Day_Accum	dw	00					;January
		dw	00+31					;February
		dw	00+31+28				;March
		dw	00+31+28+31				;April
		dw	00+31+28+31+30				;May
		dw	00+31+28+31+30+31			;June
		dw	00+31+28+31+30+31+30			;July
		dw	00+31+28+31+30+31+30+31			;August
		dw	00+31+28+31+30+31+30+31+31		;September
		dw	00+31+28+31+30+31+30+31+31+30		;October
		dw	00+31+28+31+30+31+30+31+31+30+31	;November
		dw	00+31+28+31+30+31+30+31+31+30+31+30	;December
		dw	00+31+28+31+30+31+30+31+31+30+31+30+31	;January
endif;	RSM_BY_ALARM
;R13 - end
;[]----------------------------------------------------------[]
;[]----------------------------------------------------------[]
CT_FINAL_INIT1	proc	Far

;R25 - start
ifdef	DRAM_CURRENT_SETUP
		mov	si,Offset DRAM_CURRENT_Item
		F000_call	GetItem_Value
		or	al,al
		jz	short Normal_DRAM_CURRENT
		mov	cx,59h
		mov	al,0ffh
		F000_call	Set_Ct
Normal_DRAM_CURRENT:
endif;	DRAM_CURRENT_SETUP
;R25 - end

ifdef	TURN_ON_IO_CHECK
		in	al,61h		;by customer, if disable parity,
		iodelay 		;still need io_channel_check
		and	al,NOT 08h
		out	61h,al
endif	;TURN_ON_IO_CHECK


;Bit of command register(04H) of ATI PCI/VGA should
;set to '1', otherwise screen no good under WINDOWS
;v3.1 and running "WRITER"
		mov	ax,0b102H
		mov	cx,4158H		;device ID
		mov	dx,1002H		;vendor ID
		xor	si,si
		int	1AH			;scan PCI device

		or	ah,ah			;device found ?
		jnz	short @F

		mov	ax,0b108H
		mov	di,4
		int	1AH			;read PCI byte

		or	cl,80H
		mov	ax,0b10bh
		mov	di,4
		int	1AH
@@:

		extrn	Suspend_Sw_Item:Near
		mov	si,offset DGROUP:Suspend_Sw_Item
		call	F000_GetItem_Or
		mov	cx,93h		;enable deturbo-sw
		cmp	al,1
		jne	short @F
		mov	bx,01FBh
		call	F000_Get_Set_Ct
@@:

		cmp	byte ptr CPU_BRAND[bp],CPU_BRAND_CYRIX
		je	short Cyrix_Skip_Fifo
		mov	cl,52h
		mov	bx,409Fh
		call	F000_Get_Set_Ct
Cyrix_Skip_Fifo:
ifdef	MA_CURRENT_RATING
		extrn	MA_Current_Item:near
		mov	si,offset DGROUP:MA_Current_Item
		call	F000_GetItem_Or
		jnz	short Is_16mA
		mov	cl,59h
		mov	bx,00C7h
		call	F000_Get_Set_Ct
Is_16mA:
endif	;MA_CURRENT_RATING
;;		mov	cl,50h		;if NA disable then skip
;;		call	F000_GET_CT
;;		test	al,80h
;;		jz	short @F
;;
;;		mov	cl,83h
;;		call	F000_GET_CT
;;		test	al,01h
;;		jz	short @F
;;		and	al,not 08h
;;		call	F000_SET_CT
;;@@:
		mov	dx,0CF9h	;enable INIT
		in	al,dx
		or	al,10h
		out	dx,al


ifdef	TIMER0PRG34H
		mov	al,34h
		out	43h,al			; select counter 0
		NEWIODELAY
		xor	al,al			; load counter with a value
		out	40h,al			; write lsb
		NEWIODELAY
		out	40h,al
endif	;TIMER0PRG34H

;R21 - start
;R18A - start
ifdef		USB_SUPPORT			;R18D
		mov	si,Offset USB_ITEM
		F000_call	GetItem_Value
		or	al,al
		jnz	short @F

;R20A - start
		mov	eax,80000A04h
		mov	dx,0CF8h
		out	dx,eax
		mov	dx,0CFCh
		in	al,dx
		and	al,not 03h
		out	dx,al

		mov	eax,80000A10h
		mov	dx,0CF8h
		out	dx,eax
		mov	eax,0FFFFFFFFh
		mov	dx,0CFCh
		out	dx,eax
;R20A - end		
;R18D - start
		mov	cx,0a3ch
		F000_call	Get_Ct
		cmp	al,0ffh
		je	short USB_IRQ_FAIL
		mov	cl,al
		mov	ax,1
		shl	ax,cl
		mov	bx,ax
		mov	dx,4d0h
		test	bl,bl
		jnz	short IRQ_0_7

		xchg	bl,bh
		inc	dx
IRQ_0_7:
		in	al,dx
		not	bl
		and	al,bl
		out	dx,al

USB_IRQ_FAIL:
;R18D - end

		mov	cx,0862h
;R18B		mov	bx,00bfh
;R18C		mov	bx,0030h		;R18B
		mov	bx,8030h		;R18C USB remapping disable
						;     Interrupt remapping reserved
		F000_call	Get_Set_Ct
	@@:
endif;		USB_SUPPORT			;R18D
;R18A - end
;R21 - end

		ret
CT_FINAL_INIT1	endp


ifdef	SHOW_DRAM_TYPE
 ifdef	STRING_BANK_SHOW_ROW				;R04
RAM_TYPE_0	db	'Row 0 DRAM Type   : ',0	;R04
RAM_TYPE_1	db	'Row 1 DRAM Type   : ',0	;R04
 else	;STRING_BANK_SHOW_ROW				;R04
RAM_TYPE_0	db	'Bank0 DRAM Type   : ',0
RAM_TYPE_1	db	'Bank1 DRAM Type   : ',0
 endif	;STRING_BANK_SHOW_ROW				;R04
 ifdef	DRAM_3_BANK
  ifdef	STRING_BANK_SHOW_ROW				;R04
RAM_TYPE_2	db	'Row 2 DRAM Type   : ',0	;R04
  else	;STRING_BANK_SHOW_ROW				;R04
RAM_TYPE_2	db	'Bank2 DRAM Type   : ',0
  endif	;STRING_BANK_SHOW_ROW				;R04
 endif	;DRAM_3_BANK
NONE_TYPE	db	'None',0
EDO_RAM 	db	'EDO',0
NORMAL_RAM	db	'FP',0
SDRAM		db	'SDRAM',0
ct_show_cfg_show	EQU	1
endif	;SHOW_DRAM_TYPE
ifdef	SHOW_SRAM_TYPE
 ifdef	Skip_SRAM_TYPE_If_None
SRAM_TYPE	db	'Cache SRAM Type   : Pipeline',0
 else	;Skip_SRAM_TYPE_If_None
SRAM_TYPE	db	'Cache SRAM Type   :',0
P_BURST_TYPE	db	'Pipeline',0
 ifndef	SHOW_DRAM_TYPE
NONE_TYPE	db	'None',0
 endif	;SHOW_DRAM_TYPE
 endif	;Skip_SRAM_TYPE_If_None
ct_show_cfg_show	EQU	1
endif	;SHOW_SRAM_TYPE

ifdef	ct_show_cfg_show
F000_Display_String:
		F000_call	Display_String
		ret
endif	;ct_show_cfg_show


Ct_Show_Config1	proc	Far
ifdef	ct_show_cfg_show
		push	word ptr CURSOR_X[bp]
		push	cs
		pop	ds
endif	;ct_show_cfg_show

ifdef	SHOW_DRAM_TYPE
		mov	cx,60h
		mov	si,offset RAM_TYPE_0
		mov	BYTE PTR CURSOR_Y[bp],10
bank_type_loop:
		mov	BYTE PTR CURSOR_X[bp],42
		push	si
		call	F000_Display_String

		mov	si,cx
		mov	cl,63h
		call	F000_Get_Ct
		mov	cx,si
		sub	cl,60h
		mov	ah,01h
		shl	ah,cl
		mov	cx,si
		test	al,ah
		mov	si,offset NONE_TYPE
		jz	short ram_type_ok0

		call	F000_Get_Ct
		test	al,80h
		mov	si,offset SDRAM
		jnz	short ram_type_ok0
		test	al,40h
		mov	si,offset EDO_RAM
		jnz	short ram_type_ok0
		mov	si,offset NORMAL_RAM
ram_type_ok0:
		call	F000_Display_String
		pop	si
		add	si,offset RAM_TYPE_1 - offset RAM_TYPE_0
		inc	BYTE PTR CURSOR_Y[bp]
		inc	cx
 ifdef	DRAM_3_BANK
		cmp	cl,62h
 else	;DRAM_3_BANK
		cmp	cl,61h
 endif	;DRAM_3_BANK
		jbe	short bank_type_loop
endif	;SHOW_DRAM_TYPE
ifdef	SHOW_SRAM_TYPE
 ifdef	Skip_SRAM_TYPE_If_None
		F000_call	Get_Cache_Size
		test	al,al
		jz	short Skip_Show_Cache_Type
 endif	;Skip_SRAM_TYPE_If_None

		mov	word ptr CURSOR_X[bp],12*256 + 42
		mov	si,offset SRAM_TYPE
		call	F000_Display_String

 ifndef	Skip_SRAM_TYPE_If_None
		F000_call	Get_Cache_Size
		test	al,al
		mov	si,offset NONE_TYPE
		jz	short SHOW_CACHE_CFG

		mov	si,offset P_BURST_TYPE
SHOW_CACHE_CFG:
		mov	word ptr CURSOR_X[bp],12*256 + 62
		call	F000_Display_String
 endif	;Skip_SRAM_TYPE_If_None
Skip_Show_Cache_Type:
endif	;SHOW_SRAM_TYPE

ifdef	ct_show_cfg_show
		pop	word ptr CURSOR_X[bp]
endif;	ct_show_cfg_show

ifndef	No_Cacheable_item
		extrn	SysCache_Item:near
		extrn	VideoCache_Item:near

;Set system BIOS cacheability
		mov	si,offset DGROUP:SysCache_Item
		call	F000_GetItem_Or
		jz	short No_SysBios_Cache

		mov	cx,76h
		mov	bx,40FFh
		call	F000_Get_Set_Ct
No_SysBios_Cache:

;Set video BIOS cacheability
		mov	si,offset DGROUP:VideoCache_Item
		call	F000_GetItem_Or
		jz	short No_VideoBios_Cache

		mov	cx,70h
		mov	bx,44FFh
		call	F000_Get_Set_Ct
No_VideoBios_Cache:
endif	;No_Cacheable_item

;R14 		xor	bx,bx
;R14 		call	Check_Cyrix_75x2
;R14 		or	bx,bx
;R14 		jz	short skip_EDO_to_FP
;R14 		mov	cx,62h
;R14 EDO_to_FP:
;R14 		call	F000_Get_Ct
;R14 		test	al,10h
;R14 		jnz	short skip_EDO_to_FP	;skip SDRAM
;R14 		and	al,not 18h		;force EDO to FP
;R14 		call	F000_Set_Ct
;R14 		add	cl,4
;R14 		cmp	cl,6Ah
;R14 		jbe	short EDO_to_FP
;R14 skip_EDO_to_FP:
		ret
Ct_Show_Config1 endp

;R08 - start
ifdef	GEMLIGHT_JUMPERLESS
SET_GPCS	proc	near
		mov	bx,ax
		mov	cx,0863h
		add	cl,bh
		mov	al,11h
		call	F000_Set_Ct
		mov	cx,0866h
		shl	bh,1
		add	cl,bh
		mov	dx,6A7Ch	;io port 6A7Ch
		mov	al,dh
		call	F000_Set_Ct
		dec	cx
		mov	al,dl
		call	F000_Set_Ct
		mov	al,bl
		out	dx,al
		mov	al,02h		;release io port
		call	F000_Set_Ct
		ret
SET_GPCS	endp
gemlight_volt_tbl:
;R08A		db	11b,0,11b,11b,10b,11b,01b
;R08D		db	11b,0,11b,10b,00b,10b,00b	;R08A
;R08H		db	11b,0,11b,10b,00b,01b,00b	;R08D
		db	11b,0,11b,10b,00b,01b,00b,01b	;R08H
endif	;GEMLIGHT_JUMPERLESS
;R08 - end


;R30 - start
SDA             EQU     10h	;I2C Data 
SCL             EQU     08h	;I2C Clock

;ͻ
;  Set_Start                                                               
;  Input:  None                                                            
;  Output: None                                                            
;                                                                          
;  SDA  ----\___                                                           
;  SCL  -------\                                                           
;       1   2                                                              
;        4us 4us                                                           
;ͼ
		Public	Set_Start
Set_Start       proc	Near

	mov	cx,086dh
	call	F000_Get_Ct
	or	al, (SCL + SDA)
	mov	cx,086dh
	call	F000_Set_Ct
        NEWIODELAY      
        NEWIODELAY      
        NEWIODELAY      

	mov	cx,086dh
	call	F000_Get_Ct
        and     al,NOT SDA
	mov	cx,086dh
	call	F000_Set_Ct
        NEWIODELAY      
        NEWIODELAY      
        NEWIODELAY      

;For 1'st clock low time

	mov	cx,086dh
	call	F000_Get_Ct
        and     al,NOT SCL
	mov	cx,086dh
	call	F000_Set_Ct

        ret
Set_Start       endp

;ͻ
;  Wr_Byte                                                                 
;                                                                          
;  Input:   BL:Data to I2C Bus                                             
;  Output: None                                                            
;ͼ
		Public	Wr_Byte
Wr_Byte		proc	Near
        mov     dx,bx
        mov     cx ,8
write_B:
        push    cx
        NEWIODELAY      
        NEWIODELAY      
        NEWIODELAY      

        xor     dh,dh   
        shl     dx,1    
        shl     dh,4            ;;if SDA=10h, SCL=08h
	mov	bl,dh

	push	dx

	mov	cx,086dh
	call	F000_Get_Ct

        and     al,NOT SDA              
        or      al,bl		;data                   

	mov	cx,086dh
	call	F000_Set_Ct
        NEWIODELAY      

	mov	cx,086dh
	call	F000_Get_Ct
        or      al,SCL				;clock
	mov	cx,086dh
	call	F000_Set_Ct
        NEWIODELAY      
        NEWIODELAY      
        NEWIODELAY      

	mov	cx,086dh
	call	F000_Get_Ct
        and     al,NOT SCL			;clock
	mov	cx,086dh
	call	F000_Set_Ct

	pop	dx
        pop     cx
        loop    write_B
        ret
Wr_Byte endp

;ͻ
;  Wait_ACK                                                                
;                                                                          
;  Input:  None                                                            
;  Output: CLR :  Acknowledge                                              
;          STC : !Acknowledge                                              
;ͼ
		Public	Wait_ACK
Wait_ACK        proc	Near
        NEWIODELAY      
        NEWIODELAY      
        NEWIODELAY      

	mov	cx,086dh
	call	F000_Get_Ct
        or      al, SCL				;clock
	mov	cx,086dh
	call	F000_Set_Ct

; Wait SDA low
        NEWIODELAY      
        NEWIODELAY      
        NEWIODELAY      

	mov	cx,086dh
	call	F000_Get_Ct
        mov     bl, al				;clock
	and	al,NOT SCL
	mov	cx,086dh
	call	F000_Set_Ct

        test    bl, SDA
        jnz     short ACK_Err_ret
        clc
        ret
ACK_Err_ret:
        stc
        ret
Wait_ACK        endp

;ͻ
;  Set_Stop                                                                
;                                                                          
;  Input:  None                                                            
;  Output: None                                                            
;  SDA  ___/-----                                                          
;  SCL  ---------                                                          
;       1  2   3                                                           
;        4us 4us                                                           
;ͼ
		Public	Set_Stop        
Set_Stop        proc	Near
        NEWIODELAY      
        NEWIODELAY      


	mov	cx,086dh
	call	F000_Get_Ct
        or      al,SCL                  
        and     al,NOT SDA              
	mov	cx,086dh
	call	F000_Set_Ct

        NEWIODELAY      
        NEWIODELAY      
        NEWIODELAY

	mov	cx,086dh
	call	F000_Get_Ct
        or      al,SDA
        and     al,NOT SDA              
	mov	cx,086dh
	call	F000_Set_Ct

        NEWIODELAY      
        NEWIODELAY      
        NEWIODELAY      
        ret
Set_Stop        endp
;R30 - end

		Public	Ct_Get_Row_Map
Ct_Get_Row_Map	Proc	Near

		xor	bx,bx
		mov	cx,0060h
	@@:
		call	F000_Get_Ct
		and	al,11000000b
		cmp	al,11000000b
		jne	short No_SDRAM_Found
		or	bl,11000000b
No_SDRAM_Found:
		shr	bl,2
		inc	cx
		cmp	cx,0062h
		jbe	short @B

		mov	al,bl

		ret
Ct_Get_Row_Map	Endp
		Public	F000_Get_Cmos2
F000_Get_Cmos2	Proc	Near
		OUT	70h,AL			; address to interface
		jcxz	short $+2
		ALIGN	4
		IN	AL,71h
		jcxz	short $+2
		ret
F000_Get_Cmos2	Endp

		Public	F000_Set_Cmos2
F000_Set_Cmos2	Proc	Near
		OUT	70h,AL			; address to interface
		jcxz	short $+2
		xchg	al,ah			;ah=index,al=value	   
		ALIGN 4
		OUT	71h,AL			; and output it
		jcxz	short $+2
		ret
F000_Set_Cmos2	Endp
;R31 - start
ifdef   Jumpless_Support
		JUMPLESS_FOR_CHIPPOST_ASM	EQU	1
		include	JUMPLESS.INC
endif;   Jumpless_Support
;R31 - end

ECODE		ENDS

		END

