
Device(COPR) {					// math Coprocessor Device
                Name(_HID,EISAID("PNP0C04"))		// Hardware Device ID

                Name(_CRS,Buffer(){
                        0x47,		// IO port descriptor
                        0x01,		// 16 Bit Decode
                        0xF0,		// Range min. base low for  math coproc
                        0x00,		// Range min. base high for math coproc 
                        0xF0,		// Range max. base low for  math coproc 
                        0x00,		// Range max. base high for math coproc 
                        0x01,		// Allignment
                        0x10,		// No. Contiguous ports


                        0x22,		// IRQ rescriptor
                        0x00,		// Low part of IRQ mask, 
                        0x20,		// High part of IRQ mask  IRQ 13
                        

                        0x79,		// End tag
                        0x00
                        })		// End of _CRS


}					// End of Math Coprocessor


