
Device(DMA1) {				// 8257 DMA
                Name(_HID,EISAID("PNP0200"))	// Hardware Device ID

                Name(_CRS,Buffer(){
                
                        0x2A,		// DMA Desc Tag
                        0x10,

                        0x04,  		// DD_FLAG_WIDTH_8 + DD_FLAG_MASTER + DD_FLAG_SPEED_COMP

                        0x47,		// IO port descriptor
                        0x01,		// 16 Bit Decode
                        0x00,		// Range min. base low for DMA
                        0x00,		// Range min. base high for DMA
                        0x00,		// Range max. base low for DMA
                        0x00,		// Range max. base high for DMA
                        0x01,		// Allignment
                        0x10,		// No. Contiguous ports 0x00 - 0x0f

                        0x47,		// IO port descriptor
                        0x01,		// 16 Bit Decode
                        0x80,		// Range min. base low for DMA
                        0x00,		// Range min. base high for DMA
                        0x80,		// Range max. base low for DMA
                        0x00,		// Range max. base high for DMA
                        0x01,		// Allignment
                        0x11,		// No. Contiguous ports 80h - 90h

                        0x47,		// IO port descriptor
                        0x01,		// 16 Bit Decode
                        0x94,		// Range min. base low for DMA
                        0x00,		// Range min. base high for DMA
                        0x94,		// Range max. base low for DMA
                        0x00,		// Range max. base high for DMA
                        0x01,		// Allignment
                        0x0C,		// No. Contiguous ports 94h - 9Fh
                        
                        0x47,		// IO port descriptor
                        0x01,		// 16 Bit Decode
                        0xC0,		// Range min. base low for DMA
                        0x00,		// Range min. base high for DMA
                        0xC0,		// Range max. base low for DMA
                        0x00,		// Range max. base high for DMA
                        0x01,		// Allignment
                        0x20,		/////////

                        

                        0x79,		// End Tag
                        0x00
                        })		// End of _CRS
                        
                }			// End of DMA


