
Device(PIC) {				// 8259 PIC
                Name(_HID,EISAID("PNP0000"))	// Hardware Device ID

                Name(_CRS,Buffer(){
                        0x47,		// IO port descriptor
                        0x01,		// 16 Bit Decode
                        0x20,		// Range min. base low for PIC
                        0x00,		// Range min. base high for PIC
                        0x20,		// Range max. base low for PIC
                        0x00,		// Range max. base high for PIC
                        0x01,		// Allignment
                        0x02,		// No. Contiguous ports

                        0x47,		// IO port descriptor
                        0x01,		// 16 Bit Decode
                        0xA0,		// Range min. base low for PIC
                        0x00,		// Range min. base high for PIC
                        0xA0,		// Range max. base low for PIC
                        0x00,		// Range max. base high for PIC
                        0x01,		// Allignment
                        0x02,		// No. Contiguous ports

                        0x22,		// IRQ rescriptor
                        0x04,		///////
                        0x00,		// High part of IRQ mask
                        

                        0x79,		// End Tag
                        0x00
                        })		// End of _CRS
                        
                }			// End of PIC


