;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R02	11/14/97 DNL	Rename all I2C file as I2C.SMB
;R01	05/15/97 DNL	Added Intel PIIX4 SMB HOST controller support
;R00	04/24/97 RAX	Init Ver.
;----------------------------------------------------------------------------
.386p
		PAGE	56,132
		TITLE	SMBHOST.ASM   --   SMB HOST Controller BIOS Interface
.XLIST

		INCLUDE	BIOS.CFG
		INCLUDE	SMB.INC
		INCLUDE	COMMON.MAC

ifdef	SMBIOS_INTERFACE
		COMPILE_FOR_SMB_HOST	=	1

;R02		ifdef	M388XX_SMBus
;R02			include	M388XX.SMB
;R02		endif	;M388XX_SMBus
;R02
;R02;		ifdef	430TX_SMBus
;R02;			include	430TX.SMB
;R02;		endif	;430TX_SMBus
;R02		ifdef	PIIX4_SMBus			;R01
;R02			include	PIIX4.SMB		;R01
;R02		endif	;PIIX4_SMBus			;R01
;R02 - strat
			include	I2C.SMB
;R02 - end
endif	;SMBIOS_INTERFACE

;[]=======================================================================[]
G_RAM		SEGMENT	USE16 AT 0

		ORG	04H*4
		INCLUDE	SEG_0.INC

		ORG	400H
		INCLUDE	G_RAM.INC

G_RAM		ENDS


PM_RAM		SEGMENT	USE16 AT 0 			;define PM RAM segment
							;
		ORG	0				;
		INCLUDE	PM_RAM.INC			;
							;
PM_RAM		ENDS					;

;[]=======================================================================[]

.LIST

DGROUP		GROUP	FCODE
FCODE		SEGMENT	USE16 DWORD Public 'CODE'
		ASSUME	CS:DGROUP

ifdef	SMBIOS_INTERFACE

		COMPILE_FOR_SMB_HOST	=	2

;R02		ifdef	M388XX_SMBus
;R02			include	M388XX.SMB
;R02		endif	;M388XX_SMBus
;R02
;R02;		ifdef	430TX_SMBus
;R02;			include	430TX.SMB
;R02;		endif	;430TX_SMBus
;R02		ifdef	PIIX4_SMBus			;R01
;R02			include	PIIX4.SMB		;R01
;R02		endif	;PIIX4_SMBus			;R01
;R02 - strat
			include	I2C.SMB
;R02 - end

endif	;SMBIOS_INTERFACE

FCODE		ENDS
		END


