;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	  Name	Description
;----------------------------------------------------------------------------
;R42A	11/03/97 LAW	Change year default to 1997
;R50	10/27/97 KGN	move defin LCD_CRT_OPTION to common.equ
;R49	07/15/97 RAX	Add Switch support FDD 3.5in only.
;R48	05/26/97 DNL	Add "Support_1_FDD" definition to save more space
;R47	05/20/97 RCH	Modify codes to display memory size up to 1GB
;R46	05/07/97 DRS	Add "Absent" item to process none VGA sitution.
;			It's special for GIANTEC 
;R45	02/24/97 KVN	Change HDD size display digital to 5 for support over
;			10GB HDD
;R44	02/18/97 DNL	Added "TV_OUT_SUPPORT" definition to support VGA TV-out
;			function
;R43	11/15/96 RAY	Move some strings to E000 to save F000 area
;R42	10/15/96 RAY	Change the max. year option to 2079
;R41	10/14/96 DNL	Added no CRT auto detection support
;R40	10/11/96 DNL	Added LCD only model support
;R39	10/04/96 KVN	Added boot HDD selectable function
;R08A	09/26/96 LRY	'Skip_HDD_Type_1_To_46',  removed HD type table
;R38	09/05/96 RAX	Fixed default error
;R37	08/07/96 RAY	Save codes
;R32C	08/02/96 DNL	Change default setting for Notebook Power Management
;R36	05/22/96 KVN	Fixed don't use POST_FUNC_CALL if not in POST (e.g. from
;			MODBIN enter setup) otherwise will cause hang
;R32B	04/11/96 DNL	Added auto-detect display type option
;R32A	03/14/96 DNL	Added CRT&LCD display type option for BIOS
;R35    03/12/96 KVN    Added VGA FEATURE CONNECTOR
;R34	02/10/96 RCH	Change default of Drive A to 3.5" 1.44Mb due to most
;			of PC are using 1.44Mb instead of 1.2Mb
;R33	12/06/95 DNL	Added codes for Support_1_FDD definition
;R32	11/20/95 DNL	Added CRT&LCD display type option for notebook BIOS
;R31	11/03/95 KVN	Added floppy 3 mode 1.2Mb format
;R30	11/01/95 DNL	Added "Ct_FDD_3_MODE" definition to support FDD 3 Mode
;R29	10/16/95 TNY	Add Support_1_FDD definition.
;R28	09/14/95 KVN	Fix cylinder x head > 65536 then HDD size show error
;R16A	09/11/95 KVN	Added FDD 3 mode auto analysis
;R23A	08/03/95 RAY	No_Support_4_IDE should placed after "include bios.cfg"
;R27	07/28/95 DNL	Define "IDE_PRIMARY_ONLY" to support no slave IDE mode
;R26	07/21/95 KVN	Added HDD access AUTO mode
;R24A	07/21/95 KVN	Remove HDD access mode error
;R25	07/19/95 KVN	Open HDD access mode for MODBINable
;R24	07/15/95 KVN	Added HDD access mode error
;R23	06/14/95 KVN	Open Support_4_IDE feature become standard feature
;R22	06/13/95 KVN	Reduce Post_func_call and F000_call code size
;R21	06/09/95 KVN	Open Post_Auto_IDE_Detect feature become standard
;R20	05/17/95 HTR	Add DRIVE A defaule 1.44MB option
;R19	04/19/95 RAY	Public Temp_Year_Item
;R18	04/14/95 BEN	Fixed for standard CMOS setup can not modifiable BIOS
;		 	default in MODBIN.
;R17	03/30/95 AVN	Fixed if FDD 3 Mode Support And POST Fail If Enter
;		 	Stdsetup So Do It in Cfeature.asm
;R16	03/20/95 DNL	Added FDD 3 mode support
;R15	01/26/95 RCH	Change default year to 1995
;R14	11/09/94 KVN	Fixed MSD.EXE utility 'DISK Drives' test error
;R13	10/14/94 KVN	Change HDD size unit to be 1,000,000MB
;R12	10/06/94 RAY	modify position of HDD strings for Low Level Format
;		 	in 4 IDE version
;R11	09/21/94 AVN	Change Show String under SETUP/DOS for 4 IDE Support.
;R10	09/09/94 RCH	Some customer need "AUTO" for hard drive as default
;R09	09/08/94 RAY	Set year item minimum = 1994
;R08	09/08/94 RAY	Add "Skip_HDD_Type_1_To_46" option
;R07	08/26/94 RAY	Fix bug for HDD update if user key in the type
;R06	08/26/94 RAY	Do not load default for RTC
;R05	08/17/94 KVN	Fixed up bug for MODBIN.EXE
;R04	08/17/94 KVN	Added POST auto IDE detect function
;R03	08/15/94 RCH	Re-write routine "Check_Valid_HDD_Type" to support 4
;		 	HDD drives
;R02	06/17/94 RAY	Modify string: "DRIVE C" in case MODBIN will show
;		 	it wrong!
;R00	06/02/94 RAY	Initial Revision for HDD LBA/LARGE mode & 4 IDE

		PAGE	56,132
		.286

IDE_LBA_MODE_SUPPORT	EQU	1
;R23A ifndef	No_Support_4_IDE					;R23
;R23A Support_4_IDE		EQU	1				;R23
;R23A endif	;No_Support_4_IDE					;R23

		include	bios.cfg

ifndef	No_Support_4_IDE					;R23A
Support_4_IDE		EQU	1				;R23A
endif	;No_Support_4_IDE					;R23A

		include	bsetup.inc
		include	common.mac
		include	common.equ

ifndef No_Post_Auto_IDE_Detect			;R21
Post_Auto_IDE_Detect	equ	1		;R21
HardDrive_AUTO_DEFAULT	equ	1		;R21
endif ;No_Post_Auto_IDE_Detect			;R21

;R49 start
ifdef	Notebook_Power_Management
ifndef	Desktop_System
ifndef	FDD_3_Mode
	FDD_1M44_2M88_ONLY		EQU	1
endif	;FDD_3_Mode
endif;	Desktop_System
endif;	Notebook_Power_Management
;R49 end
		EXTRN	AWARD_TITLE:NEAR
		EXTRN	AX_TO_DEC2:NEAR
		EXTRN	DESTROY_KEY_THEN_RET:NEAR
		EXTRN	DISPLAY_STRING:NEAR
		EXTRN	DISPLAY_WHOLE_ITEM:NEAR
		EXTRN	DISP_ITEMTITLE:NEAR
		EXTRN	DISP_ITEMVAR:NEAR
		EXTRN	DOWN_LINE:NEAR
		EXTRN	GET_ITEMSTAT_AX:NEAR
		EXTRN	GO_MOST_RIGHT_ITEM:NEAR
		EXTRN	HEX_TO_BCD:NEAR
		EXTRN	MOVE_CURSOR:NEAR
		EXTRN	READ_ITEM_VALUE:NEAR
		EXTRN	READ_MEMORY:NEAR
		EXTRN	SEQ_DOWN_BY_MENU_LIST:NEAR
		EXTRN	SEQ_UP_BY_MENU_LIST:NEAR
		EXTRN	SET_CMOS12H:NEAR
		EXTRN	SET_ITEMSTAT_AX:NEAR
		EXTRN	SHOW_SIX_DIGIT:NEAR
		EXTRN	TEST_ITEMSTAT:NEAR
		EXTRN	UP_LINE:NEAR
		EXTRN	VHILITE:NEAR
		EXTRN	VNORMAL:NEAR
		EXTRN	VREVERSE:NEAR
		EXTRN	WRITE_ITEM_VALUE:NEAR
		extrn	Get_Cmos:Near
		extrn	Set_Cmos:Near
		extrn	HDISK_PARMS:near

;R22		extrn	POST_func_end:Near	;128k
;R22		extrn	POST_VECT:Near		;128k
		extrn	Post_call_proc:near	;R22

ifdef	IDE_LBA_MODE_SUPPORT
		extrn	Tran_CHS_LBA:near
		extrn	Tran_CHS_LARGE:near
endif	;IDE_LBA_MODE_SUPPORT

		extrn	PAGE_NAME_Y:ABS
		extrn	START_Y:ABS
		extrn	BLAX_To_Dec6:near

		Public	StdCMOS_Special_Do
		Public	StdCMOS_Special_Show
		Public	StdCMOS_Key_List
		Public	StdCMOS_StartUp_Str
		Public	StdCMOS_Start
		Public	StdCMOS_End
		Public	HDDC_ITEM
		Public	HDDD_ITEM
ifdef	Support_4_IDE
		Public	HDDE_ITEM
		Public	HDDF_ITEM
		Public	SNAMEKE		;R11
		Public	SNAMEKF		;R11
endif	;Support_4_IDE
		Public	SECOND_ITEM
		Public	CENTURY_ITEM
		Public	YEAR_ITEM
		Public	TEMP_YEAR_ITEM	;R19
		Public	MONTH_ITEM
		Public	DATE_ITEM
		Public	HOUR_ITEM
		Public	MINUTE_ITEM
		Public	SECOND_ITEM
		public	DayLight_Item
		Public	NULLSTR
;R43		Public	HELP_BORDER
		Public	STD_HELP_STR
;R43		Public	CLEAR_HELP
		Public	SNAMEKC
		Public	SNAMEKD
		Public	RESHOW_HDD
ifdef	Support_Calender_In_Setup
		Public	TOGGLE_CALENDER
endif	;Support_Calender_In_Setup
		Public	WRITE_TIME_TO_CMOS1
		Public	CHECK_VALID_HDD_TYPE
		Public	Ena_Str
		Public	Dis_Str
		Public	Std_Help_Str

		Public	Video_Item
		Public	DRIVE_A_ITEM
ifndef	Support_1_FDD				;R48
		Public	DRIVE_B_ITEM
endif	;Support_1_FDD				;R48
		Public	Transfer_Hdd_Parms

		Public	NUM_OF_IDE_ITEM

ifdef	Support_4_IDE
	NUM_OF_IDE_ITEM		EQU	4
	LAST_HDD_TYPE_ITEM	EQU	(offset HDDF_ITEM)
	LAST_HDD_ITEM		EQU	(offset HDDF_ITEM)+HDD_TYPE_DIFF-ITEM_SIZE
else	;Support_4_IDE
	NUM_OF_IDE_ITEM		EQU	2
	LAST_HDD_TYPE_ITEM	EQU	(offset HDDD_ITEM)
	LAST_HDD_ITEM		EQU	(offset HDDD_ITEM)+HDD_TYPE_DIFF-ITEM_SIZE
endif	;Support_4_IDE

HDPARMS 	STRUC
MaxCyl		DW	?			; Maximum cylinder number
MaxHead		DB	?			; Maximum number of heads
		DW	?			; Not used
MaxPreComp	DW	?			; Starting write precomp cylinder
		DB	?			; Not used
		DB	?			; Control byte - bit 3 on for more than 8 heads
		DB	?			; Not used
		DB	?			; Not used
		DB	?			; Not used
MaxLandZone	DW	?			; Landing Zone
MaxSector 	DB	?			; Number of sectors/track
		DB	?			; Not used
HDPARMS		ENDS
HDP_SIZE	EQU	SIZE HDPARMS

DGROUP		GROUP	FCODE
FCODE		SEGMENT	WORD PUBLIC 'CODE'
		ASSUME	CS:DGROUP,DS:DGROUP
;---------------------------------------------------------------------------------------------------------------------------

;-----------------------------------------------------------------------

StdCMOS_Special_Do:
		dw	StdCMOS_Do_NO

ifdef	IDE_LBA_MODE_SUPPORT
		dw	LAST_HDD_ITEM+ITEM_SIZE	    ,offset Move_HDD_Cursor	
		dw	Offset HDDC_ITEM+ITEM_SIZE*7,offset Do_LBA
		dw	Offset HDDD_ITEM+ITEM_SIZE*7,offset Do_LBA
	ifdef	Support_4_IDE
		dw	Offset HDDE_ITEM+ITEM_SIZE*7,offset Do_LBA
		dw	Offset HDDF_ITEM+ITEM_SIZE*7,offset Do_LBA
	endif	;Support_4_IDE
endif	;IDE_LBA_MODE_SUPPORT

		dw	offset Year_Item	    ,offset Do_Year
		dw	Offset Century_Item	    ,Offset Do_Century
		dw	Offset DATE_ITEM	    ,Offset Do_Date
		dw	Offset Month_Item	    ,Offset Do_Month
		dw	Offset HOUR_ITEM	    ,Offset Write_Time_To_CMOS
		dw	Offset MINUTE_ITEM	    ,Offset Write_Time_To_CMOS
		dw	Offset SECOND_ITEM	    ,Offset Write_Time_To_CMOS
		dw	offset Temp_Year_Item       ,offset Do_Temp_Year

StdCMOS_Do_NO	EQU	(($ - offset StdCMOS_Special_Do)-2)/4


StdCMOS_Special_Show:
		dw	StdCMOS_Show_NO
		dw	Offset EXTITEM		    ,Offset Show_Ext_Mem
ifdef	Support_Calender_In_Setup
		dw	Offset TEMP_EXTMEM_ITEM	    ,Offset Show_Ext_Mem
endif	;Support_Calender_In_Setup
		dw	Offset OTHERITEM	    ,Offset Show_Other_Mem
		dw	Offset TOTALITEM	    ,Offset Show_Total_Mem
		dw	offset Year_Item	    ,offset Show_Year

ifdef	Support_Calender_In_Setup
		dw	Offset Century_Item ,Offset ReShow_Calender
		dw	Offset DATE_ITEM    ,Offset ReShow_Calender
		dw	Offset Month_Item   ,Offset ReShow_Calender
		dw	offset Calender_Item,offset Show_Calender
else	;Support_Calender_In_Setup
		dw	Offset Century_Item ,offset Reshow_Week_Day
		dw	Offset DATE_ITEM    ,offset Reshow_Week_Day
		dw	Offset Month_Item   ,offset Reshow_Week_Day
endif	;Support_Calender_In_Setup

		dw	offset Day_Of_Week_Item	    ,offset Show_Week_Day
		dw	offset Temp_Year_Item	    ,offset Show_Temp_Year

StdCMOS_Show_NO	EQU	(($ - offset StdCMOS_Special_Show)-2)/4

StdCMOS_Key_List:
		dw	offset Seq_Up_By_Menu_List	;function for UP_ARROW
		dw	offset Seq_Down_By_Menu_List	;function for DOWN_ARROW
		dw	offset Seq_Up_By_Menu_List	;function for LEFT_ARROW
		dw	offset Seq_Down_By_Menu_List	;function for RIGHT_ARROW

;--------------------------------------------------------------------------------

StdCMOS_StartUp_Str	label	near

		db	V_WARN
ifdef	Support_4_IDE
;R11		BORDER1	<,40,14,79,21,0>
		BORDER1	<,40,15,79,21,0>	;R11
else	;Support_4_IDE
 		BORDER1	<,40,12,79,21,0>
endif	;Support_4_IDE

		BORDER1	<,0,START_Y+3,79,24,1>
 		BORDER1	<,0,21,79,24,1>

		BORDER1	<,0,21,79,21,0>
		POS	<,0,21>
		db	''
		POS	<,79,21>
		db	''

		POS	<,40,21>
		db	''

ifdef	Support_4_IDE
;R11		POS	<,79,14>
		POS	<,79,15>			;R11
else 	;Support_4_IDE
		POS	<,79,12>
endif	;Support_4_IDE

		db	''

		STRSHOW	<,,,offset AWARD_Title>
		POS	<,30,PAGE_NAME_Y>
		db	'STANDARD CMOS SETUP'

ifdef	Support_4_IDE					;R11
		STRSHOW	<,,,Offset CYL_HEAD_STR_1>	;R11
endif	;Support_4_IDE					;R11


	;Help menu

		POS	<,2,22>
		db	'ESC : Quit'
		POS	<,2,23>
		db	'F1  : Help'
		POS	<,27,22>
		db	'      : Select Item'
		POS	<,27,23>
		db	'(Shift)F2 : Change Color'

		POS	<,57,22>
		db	'PU/PD/+/- : Modify'
ifdef	Support_Calender_In_Setup
		POS	<,57,23>
		db	'F3 : Toggle Calender'
endif	;Support_Calender_In_Setup
		db	0			;end of string

MegaByte	db	'('
		ADDX	<,4>
		db	'Mb)',0

;R43Help_Border	Label	Near
;R43		db	V_WARN
;R43		BORDER1	<,21,8,60,22,1+Empty_Border>
;R43		POS	<,22,21>
;R43		db	V_HILITE,'Press F1 or ESC to exit help'
;R43		db	0

;R43Clear_Help	Label	Near
;R43		db	V_NORMAL
;R43		CLEAR	<,21,8,60,22>
;R43		db	0

ifdef	Support_4_IDE					;R11
		Public	CYL_HEAD_STR_1			;R11
CYL_HEAD_STR_1:						;R11
		db	V_NORMAL			;R11
		BORDER1	<,5,9,75,9,0>			;R11
		POS	<,5,8>				;R11
		db	'HARD DISKS'			;R11
		ADDX	<,9>				;R11
		db	'TYPE'				;R11
;R45		ADDX	<,3>				;R11
		ADDX	<,4>				;R45
		db	'SIZE'				;R11
		STRSHOW	<,24,8,Offset CYL_HEAD_STR>	;R11
		db	0				;R11
endif	;Support_4_IDE					;R11


StdCMOS_START	LABEL	NEAR
;------------------------------------------------------------------
Yaxis	=	5

Month_Item	label	near
;R06		menuitem <NOMODBIN+KEYIN+DIGIT3,\
		menuitem <NOMODBIN+KEYIN+DIGIT3+NODEFAULT,\
			  offset SnameD,NOCT,0,CMOS08,11111111b,\
			  offset Mstr,1,12,5,Yaxis,1,1,offset Help_Date>

DATE_ITEM	label	near
;R06		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2,\
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+NODEFAULT,\
			  offset NullStr,NOCT,0,CMOS07,11111111b,\
			  offset NullStr,1,31, 32,Yaxis,1,1,offset Help_Date>

Century_Item	label	near
;R06		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+SHOWONLY,\
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+SHOWONLY+NODEFAULT,\
			  offset NullStr,NOCT,0,CMOS32,11111111b,\
			  offset NullStr,19,20,35,Yaxis,19,19,offset Help_Date>

Year_Item	label	near
;R06		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+SHOWONLY,\
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+SHOWONLY+NODEFAULT,\
			  offset NullStr,NOCT,0,CMOS09,11111111b,\
			  offset NullStr,0,99,37,Yaxis,95,95,offset Help_Date>
;R15			  offset NullStr,0,99,37,Yaxis,94,94,offset Help_Date>

Temp_Year_Item	label	near
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT4+CT_RVS,\
			  offset NullStr,NOCT,0,TEMP_YEAR,0FFFFh,\
			  offset NullStr,1994,2079,35,Yaxis,1997,1997,offset Help_Date>
;R42A			  offset NullStr,1994,2079,35,Yaxis,1996,1996,offset Help_Date>
;R42			  offset NullStr,1994,2099,35,Yaxis,1994,1994,offset Help_Date>
;R09			  offset NullStr,1900,2099,35,Yaxis,1994,1994,offset Help_Date>

Day_Of_Week_Item	label	near
		menuitem <NOMODBIN+SHOWONLY,\
			  offset NullStr,NOCT,0,DAY_OF_WEEK1,11111111b,\
			  offset Week_Day_Str,0,6,23,Yaxis,0,1,offset Help_Date>

;------------------------------------------------------------------
Yaxis	= Yaxis + 1
HOUR_ITEM	label	near
;R06		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2,\
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+NODEFAULT,\
			  offset SnameT,NOCT,0,CMOS04,11111111b,\
			  offset NullStr,0,23, 5,Yaxis,0,0,offset Help_Time>

MINUTE_ITEM	label	near
;R06		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2,\
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+NODEFAULT,\
			  offset DotStr,NOCT,0,CMOS02,11111111b,\
			  offset NullStr,0,59,26,Yaxis,0,0,offset Help_Time>

SECOND_ITEM	label	near
;R06		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2,\
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT2+NODEFAULT,\
			  offset DotStr,NOCT,0,CMOS00,11111111b,\
			  offset NullStr,0,59,31,Yaxis,0,0,offset Help_Time>

;------------------------------------------------------------------

DayLight_Item	label	near
		menuitem <0+ITEMDISABLE,\
			  offset Day_Light,NOCT,0,11h,00000100b,\
			  offset Dis_Str,0,1, 5,Yaxis+1,0,0,offset NullStr>

;------------------------------------------------------------------
MEMORY_X = 47
MEMORY_Y = 14

ifdef	Support_4_IDE
;R11MEMORY_Y = 15
MEMORY_Y = 16		;R11
endif	;Support_4_IDE

BASEITEM	label	near
		menuitem <NOMODBIN+SHOWONLY+CT_RVS+SHOWNUM+DIGIT5+NODEFAULT,\
			  offset SnameBase,NOCT,0,CMOS15,0ffffh,\
			  offset NullStr,0,0FFFFh,MEMORY_X,MEMORY_Y,0,1,offset NullStr>

MEMORY_Y = MEMORY_Y + 1
EXTITEM		label	near
		menuitem <NOMODBIN+SHOWONLY+CT_RVS+SHOWNUM+DIGIT5+NODEFAULT,\
			  offset SnameExt,NOCT,0,CMOS30,0ffffh,\
			  offset NullStr,0,0FFFFh,MEMORY_X,MEMORY_Y,0,1,offset NullStr>

MEMORY_Y = MEMORY_Y + 1
OTHERITEM	Label	near
		menuitem <NOMODBIN+SHOWONLY+NODEFAULT,\
			  offset SnameOther,NOCT,0,0,0ffffh,\
			  offset NullStr,0,0FFFFh,MEMORY_X,MEMORY_Y,0,1,offset NullStr>

MEMORY_Y = MEMORY_Y + 2
TOTAL_MEM_X		EQU	MEMORY_Y - 1
TOTALITEM	Label	near
		menuitem <NOMODBIN+SHOWONLY+NODEFAULT,\
			  offset SnameTotal,NOCT,0,0,0ffffh,\
			  offset NullStr,0,0FFFFh,MEMORY_X,MEMORY_Y,0,1,offset NullStr>

MEMORY_Y = MEMORY_Y - 1
;------------------------------------------------------------------
ifdef	Support_Calender_In_Setup
Calender_Item	Label	Near
		menuitem <NOMODBIN+SHOWONLY+ITEMDISABLE,\
			  offset Calender_Border,NOCT,0,KERNAL_CONTROL,00000001b,\
			  offset NullStr,0,0, 0,0,0,0,offset NullStr>


;------------------------------------------------------------------
TEMP_MEM_X = 47
TEMP_MEM_Y = 6
		menuitem <NOMODBIN+SHOWONLY+CT_RVS+SHOWNUM+DIGIT5+NODEFAULT+ITEMDISABLE,\
			  offset SnameBase1,NOCT,0,CMOS15,0ffffh,\
			  offset NullStr,0,0FFFFh,TEMP_MEM_X,TEMP_MEM_Y,0,1,offset NullStr>
TEMP_EXTMEM_ITEM:
		menuitem <NOMODBIN+SHOWONLY+CT_RVS+SHOWNUM+DIGIT5+NODEFAULT+ITEMDISABLE,\
			  offset SnameExt,NOCT,0,CMOS30,0ffffh,\
			  offset NullStr,0,0FFFFh,TEMP_MEM_X,TEMP_MEM_Y+1,0,1,offset NullStr>
;------------------------------------------------------------------
endif	;Support_Calender_In_Setup

;R10 - start
ifdef	HardDrive_AUTO_DEFAULT
HDC_D4		EQU	47		;auto
ifdef	IDE_PRIMARY_ONLY		;R27
HDD_D4		EQU	0		;R27
else	;IDE_PRIMARY_ONLY		;R27
HDD_D4		EQU	47		;auto
endif	;IDE_PRIMARY_ONLY		;R27
HDE_D4		EQU	47		;auto
ifdef	IDE_PRIMARY_ONLY		;R27
HDF_D4		EQU	0		;R27
else	;IDE_PRIMARY_ONLY		;R27
HDF_D4		EQU	47		;auto
endif	;IDE_PRIMARY_ONLY		;R27
else;	HardDrive_AUTO_DEFAULT
HDC_D4		EQU	0		;none
HDD_D4		EQU	0		;none
HDE_D4		EQU	0		;none
HDF_D4		EQU	0		;none
endif;	HardDrive_AUTO_DEFAULT
;R10 - end

HDD_X	=	5
Yaxis	=	Yaxis + 3
ifdef	Support_4_IDE		;R11
Yaxis	=	Yaxis + 1	;R11
endif	;Support_4_IDE		;R11
HDDC_ITEM	menuitem <KEYIN+SHOWNUM+DIGIT4,\
			  offset SnameKc,NOCT,2,CMOS19,11111111b,\
			  offset NullStr,0,49, HDD_X,Yaxis,0,HDC_D4,offset Help_Hdd>
;Size
HDD_X	=	HDD_X + 17
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X + 9	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+SHOWONLY+CT_RVS+SHOWNUM+DIGIT5,\
			  offset NullStr,NOCT,0,HDDSIZE,0ffffh,\
			  offset NullStr,0,0ffffh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Cylinder
HDDC_CYL_ITEM	Label	Near
HDD_X	=	HDD_X + 11
ifdef	IDE_LBA_MODE_SUPPORT
HDD_X	=	HDD_X - 2
endif	;IDE_LBA_MODE_SUPPORT
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 2	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5,\
			  offset NullStr,NOCT,0,CYLINDER,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Head
HDD_X	=	HDD_X + 8
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 2	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT4,\
			  offset NullStr,NOCT,0,HEAD,0ffh,\
			  offset NullStr,0,0ffh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Precomp
HDD_X	=	HDD_X + 8
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 1	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5,\
			  offset NullStr,NOCT,0,PRECOMP,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Landzone
HDD_X	=	HDD_X + 10
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 4	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5,\
			  offset NullStr,NOCT,0,LANDZONE,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Sector
HDD_X	=	HDD_X + 9
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 1	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT4,\
			  offset NullStr,NOCT,0,SECTOR,0ffh,\
			  offset NullStr,0,0ffh, HDD_X,Yaxis,0,0,offset Help_Hdd>

ifdef	IDE_LBA_MODE_SUPPORT
HDD_X	=	HDD_X + 7
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 1	;R11
HDD_X	=	HDD_X - 1	;R11
endif	;Support_4_IDE		;R11
;R25		menuitem <NOMODBIN,\
;R39		menuitem <0,\
;R39			  offset NullStr,NOCT,0,CMOS3B,00001100b,\
;R39			  offset HDD_CHS_LBA,0,3,HDD_X,Yaxis,0,0ch,offset Help_Hdd>	;R26
;R39 start
		menuitem <0,\
			  offset NullStr,NOCT,0,CMOS_LBA_LGA,00110000b,\
			  offset HDD_CHS_LBA,0,3,HDD_X,Yaxis,0,30h,offset Help_Hdd>	;R26
;R39 end
;R26			  offset HDD_CHS_LBA,0,2,HDD_X,Yaxis,0,0,offset Help_Hdd>
endif	;IDE_LBA_MODE_SUPPORT

;------------------------------------------------------------------

		Public	HDD_TYPE_DIFF
HDD_TYPE_DIFF	EQU	($ - offset HDDC_ITEM)

HDD_X	=	5
ifdef	IDE_PRIMARY_ONLY			;R27
	SLAVE_ITEM = ITEMDISABLE		;R27
else	;IDE_PRIMARY_ONLY			;R27
	SLAVE_ITEM = 0				;R27
Yaxis	= Yaxis + 1
endif	;IDE_PRIMARY_ONLY			;R27

HDDD_ITEM	menuitem <KEYIN+SHOWNUM+DIGIT4+SLAVE_ITEM,\
  		  offset SnameKd,NOCT,2,CMOS1A,11111111b,\
		  offset NullStr,0,48, HDD_X,Yaxis,0,HDD_D4,offset Help_Hdd>

;Size
HDD_X	=	HDD_X + 17
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X + 9	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+SHOWONLY+CT_RVS+SHOWNUM+DIGIT5+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,HDDSIZE,0ffffh,\
			  offset NullStr,0,0ffffh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Cylinder
HDDD_CYL_ITEM	Label	Near
HDD_X	=	HDD_X + 11
ifdef	IDE_LBA_MODE_SUPPORT
HDD_X	=	HDD_X - 2
endif	;IDE_LBA_MODE_SUPPORT
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 2	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,CYLINDER,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Head
HDD_X	=	HDD_X + 8
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 2	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT4+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,HEAD,0ffh,\
			  offset NullStr,0,0ffh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Precomp
HDD_X	=	HDD_X + 8
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 1	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,PRECOMP,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Landzone
HDD_X	=	HDD_X + 10
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 4	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,LANDZONE,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Sector
HDDD_Sector_Item	Label	near
HDD_X	=	HDD_X + 9
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 1	;R11
endif	;Support_4_IDE		;R11
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT4+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,SECTOR,0ffh,\
			  offset NullStr,0,0ffh, HDD_X,Yaxis,0,0,offset Help_Hdd>

ifdef	IDE_LBA_MODE_SUPPORT
HDD_X	=	HDD_X + 7
ifdef	Support_4_IDE		;R11
HDD_X	=	HDD_X - 1	;R11
HDD_X	=	HDD_X - 1	;R11
endif	;Support_4_IDE		;R11
;R25		menuitem <NOMODBIN,\
;R39		menuitem <0+SLAVE_ITEM,\
;R39			  offset NullStr,NOCT,0,CMOS3C,00001100b,\
;R39			  offset HDD_CHS_LBA,0,3,HDD_X,Yaxis,0,0ch,offset Help_Hdd>	;R26
;R39 start
		menuitem <0+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,CMOS_LBA_LGA,11000000b,\
			  offset HDD_CHS_LBA,0,3,HDD_X,Yaxis,0,0c0h,offset Help_Hdd>
;R39 end
;R26			  offset HDD_CHS_LBA,0,2,HDD_X,Yaxis,0,0,offset Help_Hdd>
endif	;IDE_LBA_MODE_SUPPORT

;------------------------------------------------------------------
ifdef	Support_4_IDE
HDD_X	=	5
Yaxis	= Yaxis + 1
HDDE_ITEM	menuitem <KEYIN+SHOWNUM+DIGIT4,\
	  		  offset SnameKe,NOCT,2,CMOS_HDDE,01111111b,\
			  offset NullStr,0,51, HDD_X,Yaxis,0,HDE_D4,offset Help_Hdd>

;Size
HDD_X	=	HDD_X + 17
HDD_X	=	HDD_X + 9	;R11
		menuitem <NOMODBIN+SHOWONLY+CT_RVS+SHOWNUM+DIGIT5,\
			  offset NullStr,NOCT,0,HDDSIZE,0ffffh,\
			  offset NullStr,0,0ffffh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Cylinder
HDDE_CYL_ITEM	Label	Near
HDD_X	=	HDD_X + 11
ifdef	IDE_LBA_MODE_SUPPORT
HDD_X	=	HDD_X - 2
endif	;IDE_LBA_MODE_SUPPORT
HDD_X	=	HDD_X - 2	;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5,\
			  offset NullStr,NOCT,0,CYLINDER,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Head
HDD_X	=	HDD_X + 8
HDD_X	=	HDD_X - 2	;R11
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT4,\
			  offset NullStr,NOCT,0,HEAD,0ffh,\
			  offset NullStr,0,0ffh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Precomp
HDD_X	=	HDD_X + 8
HDD_X	=	HDD_X - 1	;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5,\
			  offset NullStr,NOCT,0,PRECOMP,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Landzone
HDD_X	=	HDD_X + 10
HDD_X	=	HDD_X - 4	;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5,\
			  offset NullStr,NOCT,0,LANDZONE,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Sector
HDDE_Sector_Item	Label	near
HDD_X	=	HDD_X + 9
HDD_X	=	HDD_X - 1	;R11
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT4,\
			  offset NullStr,NOCT,0,SECTOR,0ffh,\
			  offset NullStr,0,0ffh, HDD_X,Yaxis,0,0,offset Help_Hdd>

ifdef	IDE_LBA_MODE_SUPPORT
HDD_X	=	HDD_X + 7
HDD_X	=	HDD_X - 1	;R11
HDD_X	=	HDD_X - 1	;R11
;R25		menuitem <NOMODBIN,\
		menuitem <0,\
			  offset NullStr,NOCT,0,CMOS_LBA_LGA,00000011b,\
			  offset HDD_CHS_LBA,0,3,HDD_X,Yaxis,0,3,offset Help_Hdd>	;R26
;R26			  offset HDD_CHS_LBA,0,2,HDD_X,Yaxis,0,0,offset Help_Hdd>
endif	;IDE_LBA_MODE_SUPPORT

;------------------------------------------------------------------
HDD_X	=	5
Yaxis	= Yaxis + 1
HDDF_ITEM	menuitem <KEYIN+SHOWNUM+DIGIT4+SLAVE_ITEM,\
	  		  offset SnameKf,NOCT,2,CMOS_HDDF,01111111b,\
			  offset NullStr,0,50, HDD_X,Yaxis,0,HDF_D4,offset Help_Hdd>

;Size
HDD_X	=	HDD_X + 17
HDD_X	=	HDD_X + 9	;R11
		menuitem <NOMODBIN+SHOWONLY+CT_RVS+SHOWNUM+DIGIT5+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,HDDSIZE,0ffffh,\
			  offset NullStr,0,0ffffh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Cylinder
HDDF_CYL_ITEM	Label	Near
HDD_X	=	HDD_X + 11
ifdef	IDE_LBA_MODE_SUPPORT
HDD_X	=	HDD_X - 2
endif	;IDE_LBA_MODE_SUPPORT
HDD_X	=	HDD_X - 2	;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,CYLINDER,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Head
HDD_X	=	HDD_X + 8
HDD_X	=	HDD_X - 2	;R11
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT4+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,HEAD,0ffh,\
			  offset NullStr,0,0ffh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Precomp
HDD_X	=	HDD_X + 8
HDD_X	=	HDD_X - 1	;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,PRECOMP,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Landzone
HDD_X	=	HDD_X + 10
HDD_X	=	HDD_X - 4	;R11
		menuitem <NOMODBIN+CT_RVS+KEYIN+SHOWNUM+DIGIT5+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,LANDZONE,0ffffh,\
			  offset NullStr,0,0FFFFh, HDD_X,Yaxis,0,0,offset Help_Hdd>
;Sector
HDDF_Sector_Item	Label	near
HDD_X	=	HDD_X + 9
HDD_X	=	HDD_X - 1	;R11
		menuitem <NOMODBIN+KEYIN+SHOWNUM+DIGIT4+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,SECTOR,0ffh,\
			  offset NullStr,0,0ffh, HDD_X,Yaxis,0,0,offset Help_Hdd>

ifdef	IDE_LBA_MODE_SUPPORT
HDD_X	=	HDD_X + 7
HDD_X	=	HDD_X - 1	;R11
HDD_X	=	HDD_X - 1	;R11
;R25		menuitem <NOMODBIN,\
		menuitem <0+SLAVE_ITEM,\
			  offset NullStr,NOCT,0,CMOS_LBA_LGA,00001100b,\
			  offset HDD_CHS_LBA,0,3,HDD_X,Yaxis,0,0ch,offset Help_Hdd>	;R38h
;R38			  offset HDD_CHS_LBA,0,3,HDD_X,Yaxis,0,0,offset Help_Hdd>	;R26
;R26			  offset HDD_CHS_LBA,0,2,HDD_X,Yaxis,0,0,offset Help_Hdd>
endif	;IDE_LBA_MODE_SUPPORT

;------------------------------------------------------------------
endif	;Support_4_IDE

Yaxis	= Yaxis + 2
;Drive A
DRIVE_A_ITEM:

ifdef	DEFAULT_NO_FLOPPY
		menuitem <0,\
			  offset SnameA,NOCT,11110000b,CMOS10,11110000b,\
			  offset Vstr,0,5, 5,Yaxis,0,00h,offset Std_Help_Str>;R18
else	;DEFAULT_NO_FLOPPY

;R20 - Start
;R34ifdef	DRIVE_A_DEFAULE_1M44
		menuitem <0,\
			  offset SnameA,NOCT,11110000b,CMOS10,11110000b,\
			  offset Vstr,0,5, 5,Yaxis,0,40h,offset Std_Help_Str>
;R34else	;DRIVE_A_DEFAULE_1M44
;R34;R20 - End
;R34		menuitem <0,\
;R34			  offset SnameA,NOCT,11110000b,CMOS10,11110000b,\
;R34			  offset Vstr,0,5, 5,Yaxis,0,20h,offset Std_Help_Str>
;R34endif	;DRIVE_A_DEFAULE_1M44	;R20
endif	;DEFAULT_NO_FLOPPY

;------------------------------------------------------------------
Yaxis	= Yaxis + 1
;Drive B
;R29 - start
ifndef	Support_1_FDD	
DRIVE_B_ITEM:
		menuitem <0,\
			  offset SnameB,NOCT,00001111b,CMOS10,00001111b,\
			  offset Vstr,0,5, 5,Yaxis,0,0,offset Std_Help_Str>;R18
else	;Support_1_FDD	
;R48 DRIVE_B_ITEM:
;R48 		menuitem <0+ITEMDISABLE,\
;R48 			  offset SnameB,NOCT,00001111b,CMOS10,00001111b,\
;R48 			  offset Vstr,0,5, 5,Yaxis,0,0,offset Std_Help_Str>;R18
endif	;Support_1_FDD	
;R29 - end

;R35 - start
ifdef S3VGA_TV_Tuner
		PUBLIC  VGA_FEAT_ITEM
VGA_FEAT_ITEM:
		menuitem <0,\
			  offset VGA_FEAT_STR,NOCT,00000001b,37H,00000001b,\
			  offset DIS_STR,0,1, 5,Yaxis+1,1,1,offset Std_Help_Str>;R18
endif; S3VGA_TV_Tuner
;R35 - end
;------------------------------------------------------------------
;R16 - start
ifdef	FDD_3_Mode
ifndef	FDD_3_Mode_in_Cfeature				;R17
Yaxis	= Yaxis + 1
		Public	DRIVE_MODE_ITEM
DRIVE_MODE_ITEM:
;R31		menuitem <0,\
;R31			  offset Mode_Str,NOCT,00100000b,3Ch,00100000b,\
;R31			  offset Dis_str,0,1, 5,Yaxis,0,0h,offset Std_Help_Str>;R18
;R33 - start
ifdef	Support_1_FDD	
		menuitem <0,\
			  offset Mode_Str,NOCT,00000001b,FDD_3mode_CMOS,FDD_3mode_CMOS_Bits,\
			  offset Mode_Val,0,1, 5,Yaxis,0,FDD_3mode_DEFAULT,offset Std_Help_Str>
else	;Support_1_FDD	
;R33 - end
;R31 start
		menuitem <0,\
			  offset Mode_Str,NOCT,00000011b,FDD_3mode_CMOS,FDD_3mode_CMOS_Bits,\
			  offset Mode_Val,0,3, 5,Yaxis,0,0h,offset Std_Help_Str>
;R31 end
endif	;Support_1_FDD	
;R33 - end
endif;	FDD_3_Mode_in_Cfeature				;R17
endif	;FDD_3_Mode
;R16 - end

;R32A - start
;R50ifdef	Notebook_Power_Management	
;R50ifndef	NO_LCD_DISPLAY
;R50	LCD_CRT_OPTION		EQU	1
;R50endif	;NO_LCD_DISPLAY
;R50endif	;Notebook_Power_Management	
;R32A - end

;video
Video_Item:
Yaxis	= Yaxis + 2
;R32A - start
ifdef	LCD_CRT_OPTION				
		menuitem <0+HIDDEN,\
			  offset SnameV,NOCT,00110000b,CMOS14,00110000b,\
			  offset Dstr,0,3, 5,Yaxis,0,0,offset Std_Help_Str>;R18
else	;LCD_CRT_OPTION
;R32A - end
		menuitem <0,\
			  offset SnameV,NOCT,00110000b,CMOS14,00110000b,\
			  offset Dstr,0,3, 5,Yaxis,0,0,offset Std_Help_Str>;R18
endif	;LCD_CRT_OPTION				;R32A

;R32 - start
;R32A ifdef	Notebook_Power_Management	
;R32A ifndef	NO_LCD_DISPLAY					
ifdef	LCD_CRT_OPTION				;R32A
		Public	Disp_Mode_Item
Disp_Mode_Item:
;R32A Yaxis	= Yaxis + 2
;R32A ifdef	Support_4_IDE
;R32A Yaxis	= Yaxis - 1  
;R32A endif	;Support_4_IDE
;R40 - start
LCD_ITEM_Status	=	0
ifdef	LCD_ONLY
LCD_ITEM_Status	=	HIDDEN
endif	;LCD_ONLY
;R40 - end
		menuitem <0+LCD_ITEM_Status,\
			  offset Disp_Mode,NOCT,00000011b,DISP_CMOS,DISP_CMOS_BITE,\
			  offset Disp_Str,0,3, 5,Yaxis,0,DISP_CMOS_BITE,offset Std_Help_Str>	;R32C
;R32C			  offset Disp_Str,0,3, 5,Yaxis,0,0,offset Std_Help_Str>	;R32B
;R32B			  offset Disp_Str,0,2, 5,Yaxis,0,0,offset Std_Help_Str>
endif	;LCD_CRT_OPTION				;R32A
;R32A endif	;NO_LCD_DISPLAY					
;R32A endif	;Notebook_Power_Management	
;R32 - end

;R44 - start
ifdef	TV_OUT_SUPPORT
		Public	TV_OUT_ITEM
TV_OUT_ITEM	Label	Near
Yaxis	= Yaxis + 1
		menuitem <0,\
			  offset TV_Out_Mode,NOCT,00000011b,TV_CMOS,TV_CMOS_BITE,\
			  offset TV_Out_Str,0,3, 5,Yaxis,0,0,offset Std_Help_Str>
endif	;TV_OUT_SUPPORT
;R44 - end
;------------------------------------------------------------------
		public	HaltOn_Item
HaltOn_Item	label	near
Yaxis	= Yaxis + 2
ifdef	Support_4_IDE		;R11
Yaxis	= Yaxis - 1		;R11
endif	;Support_4_IDE		;R11
		menuitem <0,\
			  offset SnameH,NOCT,7,CMOS3E,00000111b,\
			  offset Hstr,0,6, 5,Yaxis,0,0,offset Std_Help_Str>	;R24A
;R24A			  offset Hstr,0,7, 5,Yaxis,0,0,offset Std_Help_Str>	;R24
;R24			  offset Hstr,0,6, 5,Yaxis,0,0,offset Std_Help_Str>

;------------------------------------------------------------------
DLAST_ITEM	LABEL	NEAR

StdCMOS_END	LABEL	NEAR

Nullstr		db	0
DotStr		db	': ',0
SnameD		db	'Date (mm:dd:yy) : '
		ADDX	<,5>
		db	0
SnameT		db	'Time (hh:mm:ss) : ',0

Day_Light	db	'Daylight Saving : ',0

SnameA		db	'Drive A : ',0
SnameB		db	'Drive B : ',0
SnameV		db	'Video   : ',0
SnameH		db	'Halt On : ',0

;R32 - start
;R32A ifdef	Notebook_Power_Management	
;R32A ifndef	NO_LCD_DISPLAY				
ifdef	LCD_CRT_OPTION				;R32A
Disp_Mode	db	'LCD&CRT : ',0
Disp_Str	db	'Both',0
		db	'LCD ',0
		db	'CRT ',0
;R32B		db	'None',1
ifdef	NO_CRT_AUTO_DETECT			;R41
		db	'None',1		;R41
else	;NO_CRT_AUTO_DETECT			;R41
		db	'Auto',0		;R32B
endif	;NO_CRT_AUTO_DETECT			;R41
endif	;LCD_CRT_OPTION				;R32A
;R32A endif	;NO_LCD_DISPLAY				
;R32A endif	;Notebook_Power_Management	
;R32 - end
;R02 SnameKc		STRSHOW <,,,offset SnameKd>
;R02 		SUBX	<,4>
;R02 		db	'C'
;R02 		SUBY	<,1>

;R44 - start
ifdef	TV_OUT_SUPPORT
TV_Out_Mode	db	'TV Mode : ',0
TV_Out_Str	db	'Disable',0
		db	'NTSC   ',0
		db	'PAL    ',0
		db	'       ',1
endif	;TV_OUT_SUPPORT
;R44 - end

;R02 - starts
SnameKc:
ifdef	Support_4_IDE					;R11
		db	'Primary Master   : '		;R11
		db	0				;R11
else	;Support_4_IDE					;R11
		db	'Drive C : '
		STRSHOW <,21,,offset MegaByte>
		POS	<,12,>
		SUBY	<,1>
endif	;Support_4_IDE					;R11
;R02 - ends

		Public	CYL_HEAD_STR
CYL_HEAD_STR:
ifdef	IDE_LBA_MODE_SUPPORT
	ifdef	Support_4_IDE					;R11
		ADDX	<,15>					;R11
		db	'CYLS HEAD PRECOMP LANDZ SECTOR  MODE'	;R11
		SUBX	<,15+36>				;R11
	else	;Support_4_IDE					;R11
		ADDX	<,20>
		db	'CYLS.  HEADS  PRECOMP  LANDZONE  SECTORS  MODE'
		SUBX	<,59+4>
	endif	;Support_4_IDE					;R11
else	;IDE_LBA_MODE_SUPPORT
		ADDX	<,22>
		db	'CYLS.  HEADS  PRECOMP  LANDZONE  SECTORS'
		SUBX	<,59>
endif	;IDE_LBA_MODE_SUPPORT

ifdef	Support_4_IDE						;R11
		ADDY	<,2>					;R11
else	;Support_4_IDE						;R11
		ADDY	<,1>
endif	;Support_4_IDE						;R11

		db	0

SnameKd:
ifdef	Support_4_IDE						;R11
		db	'Primary Slave    : '			;R11
else	;Support_4_IDE						;R11
		db	'Drive D : '
		STRSHOW <,21,,offset MegaByte>
		SUBX	<,14>
endif	;Support_4_IDE						;R11
		db	0

ifdef	Support_4_IDE
;R05 start
SnameKe:
;R11		db	'Drive E : '
;R11		STRSHOW <,21,,offset MegaByte>
;R11		SUBX	<,14>
		db	'Secondary Master : '		;R11
		db	0

SnameKf:
;R11		db	'Drive F : '
;R11		STRSHOW <,21,,offset MegaByte>
;R11		SUBX	<,14>
		db	'Secondary Slave  : '		;R11
		db	0
;R05 end
comment %							;R05
SnameKe		STRSHOW <,,,offset SnameKd>
		SUBX	<,4>
		db	'E'
		ADDX	<,3>
		db	0

SnameKf		STRSHOW <,,,offset SnameKd>
		SUBX	<,4>
		db	'F'
		ADDX	<,3>
		db	0
%								;R05

endif	;Support_4_IDE

ifdef	IDE_LBA_MODE_SUPPORT
HDD_CHS_LBA		db	'NORMAL',0
			db	' LBA  ',0
			db	'LARGE ',0
			db	' AUTO ',0		;R26
LBA_Dont_Care_Str	db	'------',0
endif	;IDE_LBA_MODE_SUPPORT

SnameBase:
ifdef	Support_Calender_In_Setup
		STRSHOW	<,,,offset Clear_Calender>
		CLEAR	<,TEMP_MEM_X,TEMP_MEM_Y,TEMP_MEM_X+25,TEMP_MEM_Y+1>
endif	;Support_Calender_In_Setup

SnameBase1:
		ADDX	<,4>
		db	'Base'
		STRSHOW	<,,,offset Mem_K_Str>
;R47		ADDX	<,1>
		ADDX	<,2>				;R47
		db	0

SnameExt	db	'Extended'
		STRSHOW	<,,,offset Mem_K_Str>
		db	0

;R47 SnameEms	db	'Expanded'
;R47 		STRSHOW	<,,,offset Mem_K_Str>
;R47 		db	0

SnameOther	ADDX	<,3>
		db	'Other'
Mem_K_Str	db	' Memory:'
;R47		ADDX	<,6>
		ADDX	<,7>				;R47
		db	'K'
;R47		SUBX	<,7>
		SUBX	<,8>				;R47
		db	0

SnameTotal	BORDER1	<,47,TOTAL_MEM_X,69,TOTAL_MEM_X,0>
		ADDY	<,1>
		SUBX	<,19>
		db	'Total'
		STRSHOW	<,,,offset Mem_K_Str>
		db	0

ifdef	FDD_3_Mode					;R16
;R31Mode_Str	db	'3 Mode  : ',0			;R16
Mode_Str	db	'Floppy 3 Mode Support : ',0	;R31
Mode_Val	db	'Disabled',0			;R31
		db	'Drive A ',0			;R31
ifndef	Support_1_FDD					;R33
		db	'Drive B ',0			;R31
		db	'Both    ',0			;R31
endif	;Support_1_FDD					;R33
;R16AVstr		db	'None           ',0		;R16
;R16A		db	'360K , 5.25 in.',0		;R16
;R16A		db	'1.2M, 5/3 in.',0		;R16
;R16A		db	'720K , 3.5 in. ',0		;R16
;R16A		db	'1.44M, 3.5 in. ',0		;R16
;R16A		db	'2.88M, 3.5 in. ',0		;R16
;R16Aelse	;FDD_3_Mode				;R16
endif	;FDD_3_Mode					;R16A
ifdef	Ct_FDD_3_Mode					;R30
Mode_Str	db	'3 Mode  : ',0			;R30
Vstr		db	'None           ',0		;R30
		db	'360K , 5.25 in.',0		;R30
		db	'1.2M, 5/3 in.',0		;R30
		db	'720K , 3.5 in. ',0		;R30
		db	'1.44M, 3.5 in. ',0		;R30
		db	'2.88M, 3.5 in. ',0		;R30
else	;Ct_FDD_3_Mode					;R30
Vstr		db	'None           ',0
ifndef	FDD_1M44_2M88_ONLY				;R49
		db	'360K , 5.25 in.',0
		db	'1.2M , 5.25 in.',0
		db	'720K , 3.5 in. ',0
else	;FDD_1M44_2M88_ONLY				;R49
		db	'360K , 5.25 in.',1		;R49
		db	'1.2M , 5.25 in.',1		;R49
		db	'720K , 3.5 in. ',1		;R49
endif	;FDD_1M44_2M88_ONLY				;R49
		db	'1.44M, 3.5 in. ',0
ifndef	FDD_1M44_ONLY					;R49
		db	'2.88M, 3.5 in. ',0
else;	FDD_1M44_ONLY					;R49
		db	'2.88M, 3.5 in. ',1		;R49
endif;	FDD_1M44_ONLY					;R49

;R16Aendif	;FDD_3_Mode					;R16
endif	;Ct_FDD_3_Mode					;R30

ifndef	Special_for_GIANTEC			;R46
Dstr		db	'EGA/VGA',0
		db	'CGA 40 ',0
		db	'CGA 80 ',0
		db	'MONO   ',0
else	;Special_for_GIANTEC			;R46
Dstr		db	'EGA/VGA',0		;R46
		db	'Absent ',0		;R46
		db	'CGA 80 ',0		;R46
		db	'MONO   ',0		;R46
endif	;Special_for_GIANTEC			;R46

;R24Acomment %						;R24
Hstr		db	'All Errors      ',0
		db	'No Errors       ',0
		db	'All,But Keyboard',0
		db	'Invalid         ',1
		db	'All,But Diskette',0
		db	'Invalid         ',1
		db	'All,But Disk/Key',0
;R24A%							;R24
comment %						;R24A
;R24 start
Hstr		db	'All Errors             ',0
		db	'No Errors              ',0
		db	'All,But Keyboard       ',0
		db	'Invalid                ',1
		db	'All,But Diskette       ',0
		db	'Invalid                ',1
		db	'All,But Disk/Key       ',0
		db	'All,But HDD Access Mode',0
;R24 end
%							;R24A

Ena_Str		db	'Enabled ',0
Dis_Str		db	'Disabled',0
		db	'Enabled ',0

Mstr		db	'Jan',0
		db	'Feb',0
		db	'Mar',0
		db	'Apr',0
		db	'May',0
		db	'Jun',0
		db	'Jul',0
		db	'Aug',0
		db	'Sep',0
		db	'Oct',0
		db	'Nov',0
		db	'Dec',0

Week_Day_Str	db	'Sun,',0
		db	'Mon,',0
		db	'Tue,',0
		db	'Wed,',0
		db	'Thu,',0
		db	'Fri,',0
		db	'Sat,',0

ifdef Post_Auto_IDE_Detect		;R04
Auto_Str	db	'Auto',0	;R04
endif ;Post_Auto_IDE_Detect		;R04
User_Str	db	'User',0
None_Str	db	'None',0

;; Help strings

Std_Help_Str:
		db	'Available Options:',NEWLINE,0

Help_Date:
		db	'DATE:',NEWLINE,NEWLINE
		db	'  Change the day, month, year',NEWLINE
		db	'  and century.',0

Help_Time:
		db	'TIME:',NEWLINE,NEWLINE
		db	'  Change the internal clock.',0

Help_Hdd:
		db	'FIXED DISK',NEWLINE,NEWLINE
		db	'  Selects the type of fixed disk.',NEWLINE
		db	'  ''User type'' will let you select the',NEWLINE
		db	'  number of cylinders, heads, etc.',NEWLINE,NEWLINE
		db	'  Note: PRECOMP=65535 means NONE !',0

ifdef S3VGA_TV_Tuner					;R35
VGA_FEAT_STR    db      'VGA Feature Connector: ',0	;R35
endif; S3VGA_TV_Tuner					;R35

;;; First Page ----------------------------------------------------- end

ifdef	Support_Calender_In_Setup
Cal_Xaxis	EQU	46
Cal_Yaxis	EQU	12
Calender_Border:
		STRSHOW	<,,,offset Clear_Calender>
		BORDER1	<,Cal_Xaxis,Cal_Yaxis+2,Cal_Xaxis+28,Cal_Yaxis+2,0>
		POS	<,Cal_Xaxis+1,Cal_Yaxis+1>
		db	'Sun Mon Tue Wed Thu Fri Sat'
		db	0
Clear_Calender:
		db	V_NORMAL
		CLEAR	<,Cal_Xaxis,Cal_Yaxis+1,Cal_Xaxis+28,Cal_Yaxis+8>
		db	0
endif	;Support_Calender_In_Setup


;************************************************************************
;*									*
;*									*
;*									*
;*			SUBROUTINES					*
;*									*
;*									*
;*									*
;************************************************************************



;************************************************************************
;*		SUBROUTINES for Date & Time				*
;************************************************************************

;[]===========================================================[]
;Write_Time_To_CMOS	-   1. Write date & time into CMOS
;			    2. Show Day of Week
;[]===========================================================[]
Write_Time_To_CMOS	Proc	Near
		cmp	al,Special_After
		jne	short Do_Time_Exit

Write_Time_To_CMOS1:

		pusha
		call	Read_Item_Value
		mov	ah,dl
		call	Hex_To_Bcd

		push	ax
		mov	ax,820bh		; stop update
		call	Set_cmos
		pop	ax

		mov	al,[bx].CmosLoc		;get CMOS location to update
		call	Set_Cmos
		mov	ax,020bh		; resume update
		call	Set_cmos
Time_No_Change:
		popa
Do_Time_Exit:
		clc
		ret
Write_Time_To_CMOS	Endp

;[]===========================================================[]
;[]===========================================================[]
Do_Century	Label	Near
Do_Month	Label	Near
Do_Date		Label	Near
Do_Year		Proc	Near
		cmp	al,Special_After
		jne	short @F
		call	Check_MonthDay_Max
		call	Write_Time_To_CMOS1
@@:
		ret
Do_Year		Endp

;[]===========================================================[]
;[]===========================================================[]
Do_Temp_Year	Proc	Near
		cmp	al,Special_After
		jne	short @F

;After normal Century-Year input

		mov	ax,TEMP_YEAR[bp]
		xor	dx,dx
		mov	cx,100
		div	cx
		mov	CMOS32[bp],ax
		mov	CMOS09[bp],dx
		push	bx
		mov	bx,offset Year_Item
		call	Write_Time_To_CMOS1
		mov	bx,offset Century_Item
		call	Write_Time_To_CMOS1
		call	Check_MonthDay_Max
		pop	bx
@@:
		clc
		ret
Do_Temp_Year	Endp

;[]==============================================================[]
;[]==============================================================[]
Show_Year	Proc	Near
		cmp	al,Special_After
		jne	short Show_Year_End

		push	bx
		mov	bx,offset Temp_Year_Item
		call	Display_Whole_Item
		pop	bx

Show_Year_End:
		clc
		ret
Show_Year	Endp

;[]===========================================================[]
;[]===========================================================[]
Show_Temp_Year	Proc	Near
		cmp	al,Special_Before
		jne	short After_Show_Temp_Year

		mov	al,CMOS32[bp]	;get century
		xor	ah,ah
		mov	cx,100
		mul	cx
		mov	cx,ax
		mov	al,CMOS09[bp]
		xor	ah,ah
		add	ax,cx

		mov	dx,ax
		call	Write_Item_Value
		mov	ax,dx

		jmp	short Show_Temp_Year_Exit

After_Show_Temp_Year:

ifdef	Support_Calender_In_Setup

		call	ReShow_Calender1

else	;Support_Calender_In_Setup

		call	Reshow_Week_Day

endif	;Support_Calender_In_Setup

Show_Temp_Year_Exit:

		clc
		ret
Show_Temp_Year	Endp

Reshow_Week_Day	Proc	Near
;R37		push	word ptr ATTRIBUTE[bp]
;R37		push	word ptr CURSOR_X[bp]
.386							;R37
		push	dword ptr ATTRIBUTE[bp]		;R37
		mov	bx,offset Day_Of_Week_Item
		call	Display_Whole_Item
		pop	dword ptr ATTRIBUTE[bp]		;R37
.286							;R37
;R37		pop	word ptr CURSOR_X[bp]
;R37		pop	word ptr ATTRIBUTE[bp]
		ret
Reshow_Week_Day	Endp

;[]==============================================================[]
;Show_Week_Day	 -  Calculate the day of week
;Subroutine type -  Pre-Show
;
;Output - Day_Of_Week[bp]
;[]==============================================================[]
Show_Week_Day	Proc	Near

		cmp	al,Special_Before
		jne	short Show_Week_Day_Exit

;--------------------------------------------------
;	calculate no. of days since 1-1-xx00
;--------------------------------------------------

		pusha
		mov	ax,365			;365 days per year
		xor	cx,cx
		mov	cl,CMOS09[bp]		;YEAR[bp]
		mul	cx			;no of days in ax

;add 1 day for 	every four years

		shr	cx,2
		add	ax,cx

;e.g. add 31 if it is February
;	  31+28 for March ....

		mov	si,offset cs:Day_Accum
		mov	cl,byte ptr CMOS08[bp]	;MONTH[bp]
		xor	ch,ch
		sub	cx,1
		shl	cx,1
		add	si,cx
		add	ax,cs:[si]

		test	byte ptr CMOS09[bp],03h	;YEAR[bp]
		jnz	short @F
		cmp	byte ptr CMOS08[bp],2	;MONTH[bp]
		ja	short @F
		dec	ax
@@:

;add day of month

		mov	cl,CMOS07[bp]		;DAY_OF_MONTH[bp]
		xor	ch,ch
		add	ax,cx

;tune for 19xx & 20xx

		cmp	byte ptr CMOS32[bp],19	;Century[bp]
		je	short @F
		add	ax,6
@@:

;--------------------------------------------------
;get the residue of ax/7 in dx
;  dx = 0 - Sunday
;  dx = 1 - Monday ...
;--------------------------------------------------

@@:		sub	ax,7
		jae	short @B
		add	ax,7
		mov	dx,ax

		call	Write_Item_Value

		popa

Show_Week_Day_Exit:

		clc
		ret

Show_Week_Day	Endp

;[]===========================================================[]
;[]===========================================================[]
Check_MonthDay_Max	Proc	Near
		pusha
		mov	si,offset cs:Day_Accum
		mov	al,CMOS08[bp]		;Month[bp]
		xor	ah,ah
		shl	ax,1
		sub	ax,2
		add	si,ax

		mov	ax,cs:[si+2]
		sub	ax,cs:[si]

		test	byte ptr CMOS09[bp],03h	;YEAR[bp],03h
		jnz	short @F
		cmp	byte ptr CMOS08[bp],2	;MONTH[bp],2
		jne	short @F
		inc	ax
@@:
		cmp	byte ptr CMOS07[bp],al	;DAY_OF_MONTH[bp]
		jbe	short Check_MonthDay_Exit

		mov	ah,al
		cmp	bx,offset Date_Item
		jne	short @F

		cmp	word ptr LAST_KEY[bp],PGUP
		je	short @F
		cmp	word ptr LAST_KEY[bp],K_MINUS
		je	short @F
		mov	ah,1
	@@:
		mov	byte ptr CMOS07[bp],ah	;DAY_OF_MONTH[bp]
		mov	bx,offset Date_Item
		call	Write_Time_To_CMOS1
		call	Display_Whole_Item

Check_MonthDay_Exit:

		popa
		ret
Check_MonthDay_Max	Endp

;[]========================================================================[]
;	no. of days accumulated since JAN 1 at 1st of each month
;[]========================================================================[]
Day_Accum	dw	00					;January
		dw	00+31					;February
		dw	00+31+28				;March
		dw	00+31+28+31				;April
		dw	00+31+28+31+30				;May
		dw	00+31+28+31+30+31			;June
		dw	00+31+28+31+30+31+30			;July
		dw	00+31+28+31+30+31+30+31			;August
		dw	00+31+28+31+30+31+30+31+31		;September
		dw	00+31+28+31+30+31+30+31+31+30		;October
		dw	00+31+28+31+30+31+30+31+31+30+31	;November
		dw	00+31+28+31+30+31+30+31+31+30+31+30	;December
		dw	00+31+28+31+30+31+30+31+31+30+31+30+31	;January

ifdef	Support_Calender_In_Setup
;[]===========================================================[]
;[]===========================================================[]
Toggle_Calender	Proc	Near
		push	bx
		cmp	ax,K_F3
		jne	short @F
		cmp	word ptr PAGE_START[bp],offset StdCMOS_START
		jne	short @F
		mov	bx,offset BASEITEM
Next_Mem_Item:
		push	cx
		call	Get_ItemStat_AX
		xor	ax,ITEMDISABLE
		call	Set_ItemStat_AX
		call	Display_Whole_Item
		add	bx,ITEM_SIZE
		pop	cx
		cmp	bx,offset TEMP_EXTMEM_ITEM
		jbe	short Next_Mem_Item
@@:
		pop	bx
		ret
Toggle_Calender	Endp

;[]===========================================================[]
;[]===========================================================[]
ReShow_Calender	Proc	Near

		cmp	al,Special_After
		jne	short ReShow_Calender_Exit

ReShow_Calender1:

		pusha

;R37		push	word ptr CURSOR_X[bp]
;R37		push	word ptr ATTRIBUTE[bp]
;R37 - starts
.386
		push	dword ptr ATTRIBUTE[bp]
.286
;R37 - ends
		mov	bx,Offset Day_Of_Week_Item
		call	Display_Whole_Item

		mov	bx,offset Calender_Item
		CHK_ITEMSTAT ITEMDISABLE
		jnz	short @F
		call	Show_Calender
@@:
;R37 - starts
.386
		pop	dword ptr ATTRIBUTE[bp]
.286
;R37 - ends
;R37		pop	word ptr ATTRIBUTE[bp]
;R37		pop	word ptr CURSOR_X[bp]
		popa

ReShow_Calender_Exit:

		clc
		ret
ReShow_Calender	Endp

;[]===========================================================[]
;[]===========================================================[]
Show_Calender	PROC	NEAR

		cmp	word ptr PAGE_START[bp],offset StdCMOS_START
		jne	short @B
		cmp	byte ptr IN_F1_HELP[bp],0
		jne	short @B

		push	bx
		call	Vnormal
		lea	bx,Day_Of_week_Item
		call	Read_Item_Value		;dl = day of week
		inc	dl			;Week of first day = (dl+1)-(day % 7)
		mov	al,CMOS07[bp]		;get DAY_OF_MONTH
		xor	ah,ah
		mov	cl,7
		div	cl
		sub	dl,ah
		jnc	short not_over
		add	dl,7
not_over:					;dl = week of first day

		sub	dl,7
		jae	short not_over
		add	dl,7

		push	dx			;holding dl for show previous month
		shl	dl,2			;show this month -------- start
		add	dl,Cal_Xaxis+2		;screen position of first day
		mov	CURSOR_X[bp],dl
		mov	byte ptr CURSOR_Y[bp],Cal_Yaxis+3
		xor	bh,bh
		mov	bl,CMOS08[bp]		;MONTH[bp]
		shl	bx,1
		mov	cx,Day_Accum[bx]
		sub	cx,Day_Accum[bx-2]
		cmp	bl,4			;Is February?
		jnz	short not_February
		test	byte ptr CMOS09[bp],3	;YEAR[bp]
		jnz	short not_February
		inc	cl
not_February:
		mov	ax,1
		call	VHilite
		call	show_week_loop		;show this month -------- end
		call	Vnormal			;show next month -------- start
		xor	ch,ch
		mov	cl,Cal_Xaxis+30
		sub	cl,CURSOR_X[bp]
		shr	cl,2
		cmp	byte ptr CURSOR_Y[bp],Cal_Yaxis+8
		je	short Not_bottom
		add	cl,7
Not_bottom:
		mov	ax,1
		call	show_week_loop		;show next month -------- end
		pop	dx			;show previous month -------- start
		or	dl,dl			;is Sunday?
		jz	short Not_show_prev	;No show previous month
		xor	bh,bh
		mov	bl,CMOS08[bp]		;MONTH[bp]
		dec	bl			;get previous month
		jnz	short not_zero_month
		mov	bl,12			;force set bl = December
not_zero_month:
		shl	bx,1
		mov	ax,Day_Accum[bx]
		sub	ax,Day_Accum[bx-2]
		cmp	bl,4			;Is February?
		jnz	short not_February_1
		test	byte ptr CMOS09[bp],3	;YEAR[bp]
		jnz	short not_February_1
		inc	al
not_February_1:
		sub	al,dl
		inc	al
		mov	cl,dl
		xor	ch,ch
		mov	byte ptr CURSOR_X[bp],Cal_Xaxis+2
		mov	byte ptr CURSOR_Y[bp],Cal_Yaxis+3
		call	show_week_loop
Not_show_prev:					;show previous month -------- end
		pop	bx

		stc

		ret
Show_Calender	ENDP

;[]===========================================================[]
;[]===========================================================[]
show_week_loop:
		push	cx
		push	ax
		and	byte ptr ATTRIBUTE[bp],not 80h
		cmp	al,CMOS07[bp]
		jne	short Not_Today
		push	bx
		mov	bx,Color_Offset[bp]
		mov	bl,[bx].CNORMAL
		cmp	byte ptr ATTRIBUTE[bp],bl
		pop	bx
		je	short Not_Today

		or	byte ptr ATTRIBUTE[bp],80h
Not_Today:
		call	AX_To_DEC2
		call	Show_SIX_DIGIT
		add	byte ptr CURSOR_X[bp],2
		cmp	byte ptr CURSOR_X[bp],Cal_Xaxis+28
		jb	short show_next
		mov	byte ptr CURSOR_X[bp],Cal_Xaxis+2
		inc	byte ptr CURSOR_Y[bp]
show_next:
		pop	ax
		pop	cx
		inc	ax
		loop	show_week_loop
		ret
endif	;Support_Calender_In_Setup

;************************************************************************
;*		SUBROUTINES for Memory Items				*
;************************************************************************
;[]===========================================================[]
; Show Total memory
; Subroutine type : Pre-Show
;[]===========================================================[]
Show_Total_Mem	Proc	Near
		mov	cl,READ_TOTAL
		jmp	short Show_Mem
Show_Total_Mem	Endp

;[]===========================================================[]
; Show Other memory
; Subroutine type : Pre-Show
;[]===========================================================[]
Show_Other_Mem	Proc	Near
		mov	cl,READ_OTHER
		jmp	short Show_Mem
Show_Other_Mem	Endp

;[]===========================================================[]
; Show EXT memory
; Subroutine type : Pre-Show
;[]===========================================================[]
Show_Ext_Mem	Proc	Near
		mov	cl,READ_EXT
		jmp	short Show_Mem
Show_Ext_Mem	Endp

;[]===========================================================[]
; Show EMS memory
; Subroutine type : Pre-Show
;[]===========================================================[]
Show_EMS_Mem	Proc	Near
		mov	cl,READ_EMS
		jmp	short Show_Mem
Show_EMS_Mem	Endp

;[]===========================================================[]
; Show Memory
; input : cl = memory type to show
; Subroutine type : Pre-Show
;[]===========================================================[]
Show_Mem	Proc	Near
		cmp	al,Special_Before
		jne	short Show_Mem_Exit

		call	Read_Memory

		call	BLAX_To_Dec6
		call	Show_SIX_DIGIT
		stc
Show_Mem_Exit:
		ret
Show_Mem	Endp

;************************************************************************
;*		SUBROUTINES for HDD Items				*
;************************************************************************
;[]===========================================================[]
;[]===========================================================[]
		Public	Do_HDD
Do_HDD		Proc	Near

		pusha

		cmp	al,Special_After
		je	short Do_Post_HDD

;---------------------------------------------------------------------
Do_Pre_HDD:
		call	Move_HDD_Cursor
		call	Read_Item_Value
		mov	LAST_HDD_TYPE[bp],dl
		jmp	short Do_HDD_Exit

;---------------------------------------------------------------------
Do_Post_HDD:
		call	Skip_HDD_Type
		call	Prg_HDD_Parms_Attr

		push	word ptr CMOS19[bp]
		call	Set_CMOS12h
		pop	word ptr CMOS19[bp]

Do_HDD_Exit:
		popa
		clc
		ret

Do_HDD		Endp

;[]===========================================================[]
;[]===========================================================[]
		Public	Skip_HDD_Type
Skip_HDD_Type	Proc	Near

		call	Read_Item_Value

		xor	ax,ax
		jmp	short @F

Skip_This_HDD:
		mov	ax,1
		cmp	word ptr LAST_KEY[bp],PGDN
		je	short @F
		cmp	word ptr LAST_KEY[bp],K_PLUS
		je	short @F
		mov	ax,-1
		cmp	word ptr LAST_KEY[bp],PGUP
		je	short @F
		cmp	word ptr LAST_KEY[bp],K_MINUS
		je	short @F
;R08		mov	dl,LAST_HDD_TYPE[bp]
;R08		xor	dh,dh
;R08		xor	ax,ax
		mov	ax,1					;R08
	@@:
		add	dx,ax

;R08 - starts
ifdef	Skip_HDD_Type_1_To_46
		or	dl,dl
		jz	short @F
		cmp	dl,46
		jbe	short Skip_This_HDD
	@@:
endif	;Skip_HDD_Type_1_To_46
;R08 - ends
		cmp	dl,46			;R14
		je	short Skip_This_HDD	;R14

		mov	cx,NO_OF_SKIP_HDD
		mov	di,offset Skip_HDD_Type_Tbl
		cmp	bx,offset HDDC_ITEM
		je	short @F
		add	di,cx

ifdef	Support_4_IDE
		cmp	bx,offset HDDD_ITEM
		je	short @F
		add	di,cx
		cmp	bx,offset HDDE_ITEM
		je	short @F
		add	di,cx
endif	;Support_4_IDE

	@@:
		cmp	dl,cs:[di]
		je	short Skip_This_HDD
		inc	di
		loop	@B

		call	Write_Item_Value
		ret

Skip_HDD_Type	Endp

;[]===========================================================[]
;[]===========================================================[]
Skip_HDD_Type_Tbl:

ifdef	Support_4_IDE

ifdef Post_Auto_IDE_Detect		;R04
		db	15,48,50,51	;R04
		db	15,49,50,51	;R04
		db	15,48,49,50	;R04
		db	15,48,49,51	;R04
else ;Post_Auto_IDE_Detect		;R04
		db	15,47,48,50,51	;drive C skip these options
		db	15,47,49,50,51	;drive D skip these options
		db	15,47,48,49,50	;drive E skip these options
		db	15,47,48,49,51	;drive F skip these options
endif ;Post_Auto_IDE_Detect		;R04

else	;Support_4_IDE

ifdef Post_Auto_IDE_Detect		;R04
		db	15,48		;R04
		db	15,49		;R04
else ;Post_Auto_IDE_Detect		;R04
		db	15,47,48	;drive C skip these options
		db	15,47,49	;drive D skip these options
endif ;Post_Auto_IDE_Detect		;R04

endif	;Support_4_IDE

NO_OF_SKIP_HDD	EQU	($ - offset Skip_HDD_Type_Tbl)/NUM_OF_IDE_ITEM

;R03 - start
HDD_Type_Cmos:
		db	CMOS19		;Drive 0
		db	CMOS1A		;Drive 1
		db	67H		;Drive 2
		db	70H		;Drive 3
;R03 - end

;[]===========================================================[]
;[]===========================================================[]
		Public	Show_HDD
Show_HDD	Proc	Near

;-----------------
;Before_Show_HDD:
;-----------------
		cmp	al,Special_Before
		jne	short After_Show_HDD

;R08 - starts
ifdef	Skip_HDD_Type_1_To_46
		call	Check_If_HDD_Type_Item
		jne	short @F
		call	Skip_HDD_Type
	@@:
endif	;Skip_HDD_Type_1_To_46
;R08 - ends

		cmp	byte ptr HDD_CURSOR_FLG[bp],0ffh
		je	short @F

		push	word ptr ATTRIBUTE[bp]
		call	Prg_HDD_Parms_Attr	;program the ITEMSTAT of cyl, head...
		jnc	short Skip_ReShow_HDD	;ITEMSTATs not changed
		call	ReShow_HDD
Skip_ReShow_HDD:
		pop	word ptr ATTRIBUTE[bp]
		call	Show_HDD_Cursor
	@@:
		ret

;-----------------
After_Show_HDD:
;-----------------
		call	Check_If_HDD_Type_Item
		jne	short Show_User_Exit
Show_User:
		call	Read_Item_Value
		mov	si,offset None_Str
		or	dx,dx
		jz	short @F
		cmp	dx,48
		mov	si,offset User_Str
		jae	short @F
ifdef Post_Auto_IDE_Detect				;R04
		cmp	dx,47				;R04
		mov	si,offset Auto_Str		;R04
		je	short @F			;R04
endif ;Post_Auto_IDE_Detect				;R04
		ret
	@@:
		sub	byte ptr CURSOR_X[bp],4
		call	Display_String
Show_User_Exit:
		ret

Show_HDD	Endp

ifdef	IDE_LBA_MODE_SUPPORT
;-------------------------------------------
;-------------------------------------------
Check_If_LBA_Item	Proc	Near
		pusha
		call	Get_HDD_CMOS_Info
		add	dx,HDD_TYPE_DIFF-ITEM_SIZE	;point LBA item
		cmp	bx,dx
		popa
		ret
Check_If_LBA_Item	Endp
endif	;IDE_LBA_MODE_SUPPORT

;-------------------------------------------
;-------------------------------------------
		Public	Check_If_HDD_Type_Item
Check_If_HDD_Type_Item	Proc	Near
		cmp	bx,offset HDDC_ITEM
		je	short @F
		cmp	bx,offset HDDD_ITEM

ifdef	Support_4_IDE
		je	short @F
		cmp	bx,offset HDDE_ITEM
		je	short @F
		cmp	bx,offset HDDF_ITEM
endif	;Support_4_IDE

	@@:
		ret
Check_If_HDD_Type_Item	Endp

;---------------------------------------------------------------------
;input	:	BX = Item offset
;
;output	:	CY : not a HDD item: type, head., size...
;
;		NC : it is a HDD item
;		     BX = HDD type item offset, e.g. offset HDDC_ITEM
;		     SI = CMOS location for HDD type
;		     DI = CMOS location for User define parameter
;		     CH = CMOS location for LBA/CHS
;		     CL = which bit in CH define LBA/CHS
;		     ZF =  ZF: default type(0-46)
;			   NZ: user type
;
;Destroy :	DX, SI, DI, FLAGS
;---------------------------------------------------------------------
		Public	Get_HDD_CMOS_Info
Get_HDD_CMOS_Info	Proc	Near

		push	ax

;--------------------------------
;Check if BX is a HDD item or not
;--------------------------------

		cmp	bx,offset HDDC_ITEM
		jb	short Not_Hard_Drive_Item

		cmp	bx,LAST_HDD_TYPE_ITEM+HDD_TYPE_DIFF
		jae	short Not_Hard_Drive_Item

;--------------------------------------------------
;return DX = HDD type item offset
;	SI = CMOS location for HDD type
;	DI = CMOS location for User Type parameters
;--------------------------------------------------

ifdef	Support_4_IDE
		mov	di,DRV_50_CYL
		mov	si,offset HDDF_ITEM
	ifdef	IDE_LBA_MODE_SUPPORT
		mov	cx,7904h
	endif	;IDE_LBA_MODE_SUPPORT
		cmp	bx,si
		jae	short Chk_If_Size_Item

		mov	di,DRV_51_CYL
		mov	si,offset HDDE_ITEM
	ifdef	IDE_LBA_MODE_SUPPORT
		mov	cx,7901h
	endif	;IDE_LBA_MODE_SUPPORT
		cmp	bx,si
		jae	short Chk_If_Size_Item
endif	;Support_4_IDE

		mov	di,DRV_48_CYL
		mov	si,offset HDDD_ITEM
	ifdef	IDE_LBA_MODE_SUPPORT
		mov	cx,3C04h
	endif	;IDE_LBA_MODE_SUPPORT
		cmp	bx,si
		jae	short Chk_If_Size_Item

		mov	di,DRV_49_CYL
		mov	si,offset HDDC_ITEM
	ifdef	IDE_LBA_MODE_SUPPORT
		mov	cx,3B04h
	endif	;IDE_LBA_MODE_SUPPORT

Chk_If_Size_Item:

		mov	dl,cs:[si].CmosLoc
		xor	dh,dh
		xchg	dx,si

		mov	ax,dx
		add	ax,ITEM_SIZE			;point to HDD size
		cmp	bx,ax				;HDD size item?
		je	short Not_Hard_Drive_Item	;yes!

	ifdef	IDE_LBA_MODE_SUPPORT
		add	ax,6*ITEM_SIZE			;point to LBA item
		cmp	bx,ax				;HDD LBA item?
		je	short Not_Hard_Drive_Item	;yes!
	endif	;IDE_LBA_MODE_SUPPORT

;--------------------------------
;decide if it is user type or not
;--------------------------------

		xor	al,al				;indicates type 1-46

;R04		cmp	byte ptr [bp+si],46
		mov	ah,Post_Auto_type[bp]			;R04
		cmp	[bp+si],ah				;R04
		jbe	short HDD_Type_Not_User

		mov	al,1			;indicates user type

HDD_Type_Not_User:

		or	al,al			;ZF: default type
						;NZ: user type
		pop	ax
		clc				;it is a HDD type(any type)
		ret

Not_Hard_Drive_Item:

		pop	ax
		stc				;it is not a HDD type item
		ret
Get_HDD_CMOS_Info	Endp

;[]===========================================================[]
;Input : BX - Point to any HDD parms items such as
;	      cylinders, sectors, head ....
;output: IF (BX == HDDC) or (BX == HDDD)
;	  {
;	   IF (HDD type >= 1) && (HDD type <= 47)
;	     {
;	      set the ITEMSTAT of the items related to be show-only
;	     }
;	   ELSE
;	     {
;	      set the ITEMSTAT of the items related to be
;	      not show-only, i.e. editable
;	     };
;	   stc
;	   ret
;	  }
;	 ELSE
;	   {
;	    call	Transfer_Hdd_Parms
;	    clc
;	   };
;
;[]===========================================================[]
Prg_HDD_Parms_Attr	Proc	Near

		call	Check_If_HDD_Type_Item
		je	short HDD_Item_Yes

		call	Transfer_Hdd_Parms
		clc
		ret

;-------------------------------
HDD_Item_Yes:
		call	Read_Item_Value
		cmp	dx,48

ifndef Post_Auto_IDE_Detect				;R04
ifdef	IDE_LBA_MODE_SUPPORT
	mov	di,ITEMDISABLE
endif	;IDE_LBA_MODE_SUPPORT
endif ;Post_Auto_IDE_Detect				;R04

		mov	dx,SHOWONLY
		jb	short Not_User_Type
		xor	dx,dx
ifdef	IDE_LBA_MODE_SUPPORT
ifndef Post_Auto_IDE_Detect				;R04
		xor	di,di
endif ;Post_Auto_IDE_Detect				;R04
		call	Chk_If_LBA_Mode		;LBA mode?
		je	short @F		;yes!
		call	Chk_If_LARGE_Mode	;LARGE mode?
		jne	short Not_User_Type	;no!
	@@:
		mov	dx,SHOWONLY
endif	;IDE_LBA_MODE_SUPPORT

Not_User_Type:
		push	bx
		add	bx,ITEM_SIZE*2
		mov	cx,5

Prg_HDD_Para_ItemStat:

		call	Get_ItemStat_AX
		and	ax,not SHOWONLY
		or	ax,dx
		call	Set_ItemStat_AX
		add	bx,ITEM_SIZE
		loop	short Prg_HDD_Para_ItemStat

ifdef IDE_LBA_MODE_SUPPORT
ifdef Post_Auto_IDE_Detect				;R04
		push	bx				;R04
		sub	bx,ITEM_SIZE*7			;R04
		call	Read_Item_Value			;R04
		xor	di,di				;R04
		cmp	dx,47				;R04
		jae	short @F			;R04
		mov	di,ITEMDISABLE			;R04
	@@:						;R04
		pop	bx				;R04
endif ;Post_Auto_IDE_Detect				;R04
		call	Get_ItemStat_AX
		and	ax,not ITEMDISABLE
		or	ax,di
		call	Set_ItemStat_AX

		push	word ptr CURSOR_X[bp]
		push	word ptr HDD_CURSOR_FLG[bp]

		mov	byte ptr HDD_CURSOR_FLG[bp],0ffh	;prevent recursive
		call	Display_Whole_Item
		or	di,di			;item disable?
		jz	short @F		;no
		mov	ax,word ptr [bx].Item_Xaxis
		mov	CURSOR_X[bp],ax
		call	VNORMAL
		mov	si,offset LBA_Dont_Care_Str
		call	Display_String
	@@:
		pop	word ptr HDD_CURSOR_FLG[bp]
		pop	word ptr CURSOR_X[bp]
endif ;IDE_LBA_MODE_SUPPORT

		pop	bx

		stc
		ret
Prg_HDD_Parms_Attr	Endp

;[]===========================================================[]
;Update_User_Type - 1. put parms for shown into corresponding
;		       stack area & re-show HDD size
;		    2. if Drive C = Drive D
;		       re-show Drive C & Drive D
;
;Input : BX - Point to any HDD parms items such as
;	      cylinders, sectors, head ....
;Subroutine type : Post-Do
;[]===========================================================[]
		Public	Update_User_Type
Update_User_Type	Proc	Near

		pusha

		cmp	al,Special_After
		jne	short Update_User_Type_Exit

		call	Get_HDD_CMOS_Info
		jc	short Update_User_Type_Exit	;not HDD Item
		jz	short Update_User_Type_Exit	;not user type

;put parms for shown into corresponding stack area

		mov	ax,CYLINDER[bp]
		mov	[bp+di+0],ax

		mov	al,HEAD[bp]
		mov	[bp+di+2],al

		mov	ax,PRECOMP[bp]
		mov	[bp+di+3],ax

		mov	ax,LANDZONE[bp]
		mov	[bp+di+5],ax

		mov	al,SECTOR[bp]
		mov	[bp+di+7],al

		push	dx
		call	Transfer_Hdd_Parms
		pop	dx
		mov	bx,dx
		add	bx,ITEM_SIZE
		call	Display_Whole_Item		;Display HDD Size

Update_User_Type_Exit:

		popa
		clc
		ret
Update_User_Type	Endp

;[]===========================================================[]
;ReShow_HDD - show items including HDD type, sector, head
;	      cylinder, precomp, landing zone & HDD size
;
;input - BX : HDD C or D
;[]===========================================================[]
ReShow_HDD	proc	near
		push	ax			;save registers
		push	bx
		push	cx

		call	Transfer_Hdd_Parms	;get all HDD parms

;R37		push	word ptr ATTRIBUTE[bp]	;save attribute
;R37		push	word ptr CURSOR_X[bp]	;save cursor position
;R37 - starts
.386
		push	dword ptr ATTRIBUTE[bp]
.286
;R37 - ends

		mov	cx,(HDD_TYPE_DIFF/ITEM_SIZE)-1

Disp_Next_HDD_Item:

		add	bx,ITEM_SIZE		;point to next item
		push	cx			;save counter

;[]-----------------------------------------------------------------------[]
;  special treatment for Auto IDE Detection & HDD Low Level Format
;  Input : byte ptr USE_ITEMSTAT_BUF[bp]=0 : Normal call
;					 1 : call from routine: IDE_DETECT
;					     add CURSOR_Y[bp],0
;					 2 : call from routime: HDD_LFormat
;					     add CURSOR_Y[bp],8
;				    OTHERS : call from routine: IDE_DETECT
;					     CURSOR_Y[bp] = USE_ITEMSTAT_BUF[bp]
;[]-----------------------------------------------------------------------[]
		cmp	byte ptr USE_ITEMSTAT_BUF[bp],0	;normal call?
		je	short Normal_ReShow_HDD		;yes

		call	Vnormal				;normal attribute
		call	Disp_ItemTitle
ifdef	Support_4_IDE					;R12
		mov	al,7				;R12
else	;Support_4_IDE					;R12
		mov	al,9				;cursor Y difference
endif	;Support_4_IDE					;R12
		cmp	byte ptr USE_ITEMSTAT_BUF[bp],2	;from HDD_LFormat?
		je	short @F			;yes
		xor	al,al				;cursor Y difference

		cmp	byte ptr USE_ITEMSTAT_BUF[bp],1	;from IDE_DETECT?
		je	short @F			;yes

		sub	byte ptr CURSOR_X[bp],5
		call	VReverse

		mov	al,USE_ITEMSTAT_BUF[bp]		;cursor Y difference
		mov	byte ptr CURSOR_Y[bp],0		;use new CURSOR_Y

@@:
		add	CURSOR_Y[bp],al			;use new CURSOR_Y
		call	Disp_ItemVar			;show Items

		jmp	short @F

Normal_ReShow_HDD:
;---------------------------------------------------------------------------
		call	Display_Whole_Item		;display item
@@:
		pop	cx				;restore counter
		loop	short Disp_Next_HDD_Item	;show next
;R37 - starts
.386
		pop	dword ptr ATTRIBUTE[bp]
.286
;R37 - ends
;R37		pop	word ptr CURSOR_X[bp]		;restore cursor position
;R37		pop	word ptr ATTRIBUTE[bp]		;restore attribute

		pop	cx				;restore registers
		pop	bx
		pop	ax
		ret
ReShow_HDD	endp

;[]===========================================================[]
;input : BX point to any HDD item
;output: CYLINDER[bp]
;	 HEAD[bp]
;	 PRECOMP[bp]
;	 LANDZONE[bp]
;	 SECTOR[bp]
;[]===========================================================[]
Transfer_Hdd_Parms	proc	near

;Clear all HDD parms in the first place

		xor	ax,ax
		mov	CYLINDER[bp],ax
		mov	HEAD[bp],al
		mov	SECTOR[bp],al
		mov	PRECOMP[bp],ax
		mov	LANDZONE[bp],ax

		push	si
;R36 start
		mov	ax,cs
		cmp	ax,dgroup
		je	short @F
		jmp	Not_Hdd
@@:
;R36 end

		call	Get_HDD_CMOS_Info
		jnc	short @F
		jmp	Not_Hdd
	@@:
		jz	short Std_Hdd_Parm

		mov	ax,[bp+di+0]		;transfer cylinder no.
		mov	CYLINDER[bp],ax

		mov	al,[bp+di+2]		;transfer head no.
		mov	HEAD[bp],al

		mov	ax,[bp+di+3]		;transfer precomp
		mov	PRECOMP[bp],ax

		mov	ax,[bp+di+5]		;transfer landing zone
		mov	LANDZONE[bp],ax

		mov	al,[bp+di+7]		;transfer sector no.
		mov	SECTOR[bp],al

ifdef IDE_LBA_MODE_SUPPORT
		call	Chk_If_LARGE_Mode		;LARGE mode now?
		mov	si,offset Tran_CHS_LARGE
		je	short Trans_LBA_LARGE		;yes!

		call	Chk_If_LBA_Mode			;LBA mode now?
		jne	short No_LBA_LARGE		;no, skip!
		mov	si,offset Tran_CHS_LBA		;routine to call
		mov	word ptr PRECOMP[bp],0
Trans_LBA_LARGE:
		push	bx
		mov	bx,CYLINDER[bp]
		mov	al,SECTOR[bp]
		mov	ah,HEAD[bp]
		POST_func_call	si
		mov	CYLINDER[bp],bx
		mov	SECTOR[bp],al
		mov	HEAD[bp],ah
		pop	bx
No_LBA_LARGE:
endif ;IDE_LBA_MODE_SUPPORT

	  	jmp	short Move_Exit

;-------------------
;transfer type 1-47
;-------------------

Std_Hdd_Parm:
ifndef	Skip_HDD_Type_1_To_46						;R08A
		cmp	byte ptr [bp+si],0	;Hard disk exist?
		je	short Move_Exit
else	;Skip_HDD_Type_1_To_46						;R08A
		cmp	byte ptr [bp+si],47	;Hdd type 0 or auto?	;R08A
		jbe	short Move_Exit					;R08A
endif	;Skip_HDD_Type_1_To_46						;R08A

		push	bx
		mov	al,[bp+si]		;Hdd type no.
		xor	ah,ah
		dec	ax
		mov	cl,HDP_SIZE
		mul	cl

		mov	bx,offset cs:HDISK_PARMS
		add	bx,ax

		mov	ax,cs:[bx].MaxCyl
		mov	CYLINDER[bp],ax
		mov	al,cs:[bx].MaxHead
		mov	HEAD[bp],al
		mov	al,cs:[bx].MaxSector
		mov	SECTOR[bp],al

		mov	ax,cs:[bx].MaxPreComp
		mov	PRECOMP[bp],ax
		mov	ax,cs:[bx].MaxLandZone
		mov	LANDZONE[bp],ax
		pop	bx

Move_Exit:
;-------------------
;calculate HDD size
;-------------------

		push	cx
;R28		mov	ax,CYLINDER[bp]
		xor	ah,ah					;R28
		mov	al,HEAD[bp]				;R28
		xor	ch,ch
;R28		mov	cl,HEAD[bp]
;R28		mul	cx
		mov	cl,SECTOR[bp]
;R28		shl	cx,3					;R13
		shl	cx,2					;R28
		mul	cx
		mul	word ptr CYLINDER[bp]			;R28
;R13		mov	cx,2048
;R28		mov	cx,15625				;R13
		mov	cx,15625/2				;R28
		div	cx
		mov	HDDSIZE[bp],ax
		pop	cx

Not_Hdd:
		pop	si
		ret

Transfer_Hdd_Parms	endp

;[]===========================================================[]
;[]===========================================================[]
Check_Valid_HDD_Type	Proc	Near
;R03 Chk_DrvC:
;R03 		mov	si,CMOS19
;R03 		cmp	byte ptr CMOS19[bp],47
;R03 		jne	short @F
;R03 		call	Invalid_HDD
;R03 		jmp	short Chk_DrvD
;R03 	@@:
;R03 		cmp	byte ptr CMOS19[bp],48
;R03 		jne	short Chk_DrvD
;R03 		call	Invalid_HDD
;R03 Chk_DrvD:
;R03 		mov	si,CMOS1A
;R03 		cmp	byte ptr CMOS1A[bp],47
;R03 		jne	short @F
;R03 		call	Invalid_HDD
;R03 		jmp	short Check_Valid_Exit
;R03 	@@:
;R03 		cmp	byte ptr CMOS1A[bp],49
;R03 		jne	short Check_Valid_Exit
;R03 		call	Invalid_HDD
;R03 Check_Valid_Exit:
;R03 		ret
;R03 
;R03 Invalid_HDD:
;R03 		mov	byte ptr [bp+si],0

;R03 - start
		mov	si,offset HDD_Type_Cmos
		mov	di,offset Skip_HDD_Type_Tbl
		mov	cx,NUM_OF_IDE_ITEM		;number of HDD to do

Next_Hdd_Drive:		

		push	di
		push	si
		push	cx

		mov	si,cs:[si]
		and	si,00ffH			;use byte only

		mov	al,byte ptr [bp+si]

		cmp	al,51				;invalid HDD type
		ja	short Invalid_HDD

		mov	cx,NO_OF_SKIP_HDD
Next_Invalid_Hdd:
		cmp	al,cs:[di]
		je	short Invalid_HDD
		inc	di
		loop	short Next_Invalid_Hdd
		jmp	short Check_Next_Invalid

Invalid_HDD:
		mov	byte ptr [bp+si],0
Check_Next_Invalid:

		pop	cx
		pop	si
		pop	di
		add	di,NO_OF_SKIP_HDD
		inc	si
		loop	short Next_Hdd_Drive
;R03 - end

		ret

Check_Valid_HDD_Type	Endp

;[]===========================================================[]
;[]===========================================================[]
Move_HDD_Cursor	Proc	Near

;------------------------------------------------------------
;Try to move the KEYIN_ITEM_OFF[bp] according to LAST_KEY[bp]
;------------------------------------------------------------

		mov	di,LAST_KEY[bp]
		mov	ax,KEYIN_ITEM_OFF[bp]

;------------------------------------------------------------------------
Try_Move_HDD_LA:

		cmp	di,LEFT_ARROW		;input key = LEFT_ARROW ?
		jne	short Try_Move_HDD_RA	;no, try next!

		mov	bx,ax

ifdef	IDE_LBA_MODE_SUPPORT
		pusha
		mov	ax,OLDITEM[bp]
		cmp	ax,KEYIN_ITEM_OFF[bp]
		popa
		je	short TRY_LA_1
endif	;IDE_LBA_MODE_SUPPORT

		call	Move_Cursor		;check where will KEYIN_ITEM go

		call	Check_If_HDD_Type_Item	;does KEYIN_ITEM go to HDD type item?
		jne	short Only_KEYIN_Moves	;no, so only KEYIN item moves

	TRY_LA_1:

		call	Up_Line			;if go up...

		mov	bx,si
		call	Check_If_HDD_Type_Item	;does Up_Line cause bx to go to HDD type item?
		je	short KEYIN_OLD_Together;yes, put KEYIN & OLITEM together

		mov	bx,si			;go up --> HOUR item
		call	Go_Most_Right_Item	;so, according to AMI's setup,
		mov	bx,si
		jmp	short KEYIN_OLD_Together;go to SECOND item

;------------------------------------------------------------------------
Try_Move_HDD_RA:
		cmp	di,K_CR1		;input key = ENTER ?
		je	short RA_Cont		;yes, continue
		cmp	di,RIGHT_ARROW		;input key = RIGHT_ARROW ?
		jne	short Try_Move_HDD_UA	;no, try next
	RA_Cont:
		mov	bx,ax
		call	Move_Cursor		;check where will KEYIN_ITEM go

		call	Check_If_HDD_Type_Item	;KEYIN_ITEM go to next HDD type item?
		je	short @F		;yes, so put KEYIN & OLITEM together

ifdef	IDE_LBA_MODE_SUPPORT
		call	Check_If_LBA_Item
		je	short @F
endif	;IDE_LBA_MODE_SUPPORT

		cmp	bx,LAST_HDD_ITEM	;KEYIN_ITEM go to HDD para. item?
		jbe	short Only_KEYIN_Moves	;yes, so only KEYIN item moves
	@@:
		jmp	short KEYIN_OLD_Together;put KEYIN & OLITEM together

;------------------------------------------------------------------------
Try_Move_HDD_UA:

		cmp	di,UP_ARROW		;input key = UP_ARROW ?
		jne	short Try_Move_HDD_DA	;no, try next

		mov	bx,OLDITEM[bp]		;OLITEM[bp] = HDD type item
		jmp	short TRY_LA_1

;------------------------------------------------------------------------
Try_Move_HDD_DA:

		cmp	di,DOWN_ARROW		;input key = DOWN_ARROW ?
		je	short @F		;yes, continue
		clc
		ret				;exit
	@@:
		mov	bx,OLDITEM[bp]		;OLITEM[bp] = HDD type item
		call	Down_Line		;OLITEM go down and put
		mov	bx,si
						;  KEYIN & OLITEM together

;------------------------------------------------------------------------
KEYIN_OLD_Together:

		call	ReDisp_KEYIN

		cmp	OLDITEM[bp],bx
		je	short @F
		xchg	OLDITEM[bp],bx
		call	Display_Whole_Item
		mov	bx,OLDITEM[bp]
	@@:
		jmp	short Move_HDD_Exit0

;------------------------------------------------------------------------
Only_KEYIN_Moves:
		call	ReDisp_KEYIN
		mov	bx,OLDITEM[bp]

;------------------------------------------------------------------------
Move_HDD_Exit0:
		mov	byte ptr HDD_CURSOR_FLG[bp],0
		jmp	Destroy_Key_Then_Ret

Move_HDD_Cursor	Endp

ReDisp_KEYIN:
		mov	byte ptr HDD_CURSOR_FLG[bp],0ffh
		pusha
		push	word ptr OLDITEM[bp]		;R07
		xchg	KEYIN_ITEM_OFF[bp],bx
		call	Check_If_HDD_Type_Item		;R07
		jne	short @F			;R07
		mov	byte ptr HDD_CURSOR_FLG[bp],0	;R07
		mov	word ptr OLDITEM[bp],-1		;R07
	@@:						;R07
		call	Display_Whole_Item
		pop	word ptr OLDITEM[bp]		;R07
		popa
		ret

;[]===========================================================[]
;[]===========================================================[]
Show_HDD_Cursor	Proc	Near
		push	bx

		mov	si,Color_Offset[bp]
		mov	dl,[si].CREVERSE
		cmp	byte ptr ATTRIBUTE[bp],dl
		jne	short Show_HDD_Cursor_End

		mov	bx,OLDITEM[bp]
		cmp	bx,KEYIN_ITEM_OFF[bp]		;KEYIN_ITEM=OLDITEM?
		je	short Seperate_Cursor		;yes, try to seperate

;---------------------------------------------------------------------------
Merge_Cursor:

		call	Get_HDD_CMOS_Info
		jnz	short Show_HDD_Cursor_End	;NZ = user type

		mov	KEYIN_ITEM_OFF[bp],dx
		jmp	short Show_HDD_Cursor_End

;---------------------------------------------------------------------------
Seperate_Cursor:

		call	Get_HDD_CMOS_Info
		jz	short Show_HDD_Cursor_End	;ZF = type 0-46

		call	Check_If_HDD_Type_Item

		pushf
		mov	OLDITEM[bp],dx
		mov	bx,dx
		call	Reverse_It

	ifdef	IDE_LBA_MODE_SUPPORT
		mov	KEYIN_ITEM_OFF[bp],bx
		call	Chk_If_LBA_Mode			;LBA mode ?
		je	short @F			;yes
		call	Chk_If_LARGE_Mode		;LARGE mode?
		je	short @F			;yes
	endif	;IDE_LBA_MODE_SUPPORT

		add	bx,ITEM_SIZE*2
		mov	KEYIN_ITEM_OFF[bp],bx
		call	Reverse_It
@@:
		popf
		je	short Cur_In_HDD_Type

		pop	ax				;abandon original BX
		stc
		ret

Cur_In_HDD_Type:
Show_HDD_Cursor_End:

		pop	bx
		clc
		ret

Reverse_It:
		mov	byte ptr HDD_CURSOR_FLG[bp],0ffh
		call	Vnormal
		push	word ptr CURSOR_X[bp]
		call	Disp_ItemTitle
		call	VReverse
		call	Disp_ItemVar
		pop	word ptr CURSOR_X[bp]
		mov	byte ptr HDD_CURSOR_FLG[bp],0
		ret

Show_HDD_Cursor	Endp

ifdef	IDE_LBA_MODE_SUPPORT
Do_LBA		Proc	Near

		cmp	al,Special_Before
		je	short Do_LBA_Before

		pusha
		call	Get_HDD_CMOS_Info
		mov	bx,dx
		call	Prg_HDD_Parms_Attr
		call	ReShow_HDD
		popa

	Do_LBA_Exit:

		clc
		ret

Do_LBA_Before:
		cmp	word ptr LAST_KEY[bp],LEFT_ARROW
		jne	short Try_Do_LBA_UP
		call	Get_HDD_CMOS_Info
		mov	OLDITEM[bp],dx
		sub	bx,ITEM_SIZE
		CHK_ITEMSTAT SHOWONLY
		jz	@F
		mov	bx,dx
		jmp	KEYIN_OLD_Together
	@@:
		jmp	Only_KEYIN_Moves
Try_Do_LBA_UP:
		cmp	word ptr LAST_KEY[bp],UP_ARROW
		jne	short Try_Do_LBA_DOWN
		jmp	Move_HDD_CURSOR
Try_Do_LBA_DOWN:
		cmp	word ptr LAST_KEY[bp],DOWN_ARROW
		jne	short Do_LBA_Exit
		jmp	Move_HDD_CURSOR

Do_LBA		Endp

		Public	Chk_If_LARGE_Mode
Chk_If_LARGE_Mode:
		mov	al,2
		jmp	short Detect_LBA_LARGE

;input : bx = hdd item offset
;output: zf = 1 disable
;	 zf = 0 enable
		Public	Chk_If_LBA_Mode
Chk_If_LBA_Mode:
		mov	al,1

Detect_LBA_LARGE:

		pusha
		call	Get_HDD_CMOS_Info

		mov	bx,dx
		add	bx,HDD_TYPE_DIFF-ITEM_SIZE
		push	ax
		call	Read_Item_Value
		pop	ax
		cmp	dl,al

		popa
		ret

endif	;IDE_LBA_MODE_SUPPORT

FCODE		ENDS
		END
