
Device(TMR) {					// Timer
                Name(_HID,EISAID("PNP0100"))		// Hardware Device ID

                Name(_CRS,Buffer(){
                        0x47,		// IO port descriptor
                        0x01,		// 16 Bit Decode
                        0x40,		// Range min. base low for timer
                        0x00,		// Range min. base high for timer
                        0x40,		// Range max. base low for timer
                        0x00,		// Range max. base high for timer
                        0x01,		// Allignment
                        0x04,		// No. Contiguous ports

                        0x22,		// IRQ rescriptor
                        0x01,		// Low part of IRQ mask, IRQ 0
                        0x00,		// High part of IRQ mask
                        

                        0x79,		// End tag
                        0x00
                        })		// End of _CRS


}					// End of TMR


