@echo off
::----------------------------------------------------------------------------
::Rev	Date	  Name	Description
::----------------------------------------------------------------------------
::R02	07/09/97  DNL	Added ACPI function support
::R01	12/28/96  RCH	Added bat file for supporting special ROM combining.
::			like full screen logo.
::R00	01/22/96  RAY	Initial revision for using NMAKE.EXE

if "%1"=="" goto :noinput

:yesinput
if "%1"=="%_last%" goto :mklast
set _last=%1
goto :mknew

:noinput
if "%_last%"=="" goto :error
goto :mklast

:mknew
echo. 
echo About to build the entire BIOS...
echo. 
touch bios.cfg
goto :mkbios

:mklast
echo. 
echo Making the same version as last build

:mkbios
echo. 
echo Building %_last%.BIN
echo. 
::R02 - start
getasl R
::R02 - end
nmake "NAME=%_last%" /nologo /f bios.mak
echo. 
::R01
::if not errorlevel 1 CKCMOS /F
if errorlevel 1 goto :end
if exist AddRom.bat call AddRom.bat
CKCMOS /F
::R01
echo. 
goto :end

:error
echo.
echo Error! No previous version to build. Use SETTYPE.BAT
echo        or type full part number
echo.
echo  Example (1):
echo.
echo      settype 2a59c000
echo      bios
echo.
echo  Example (2):
echo.
echo      bios 2a59c000
echo.
goto :end

:end
