;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R48	12/28/97 LAW	added EPALOGO_FLAG for check at post is use "EPA_LOGO_Use_Graphics"
;			or "FULL_SCREEN_LOGO" 
;R47	12/15/97 BAR	Added check INTEL/TI 28F020 EEPROM,this type not support PNP function
;R46	10/23/97 KVN	Show all IDE device on system config table if define
;			support LS120/ZIP/CDROM in BIOS.CFG
;R45	10/07/97 BAR	Add ATAPI EED support.
;R44	09/23/97 RAX	Add Cardbus support.
;R43	08/25/97 DNL	Add FAT32 0V file support
;R42 	08/21/97 BAR	Add a S.M.A.R.T. flag to support S.M.A.R.T. detect
;R41 	08/08/97 DNL	Add a ACPI flag to support ACPI table size dynamic assign
;R40	06/18/97 TNY	Always show sensor values in runtime.
;R39	06/17/97 LAW	added "FDC_FIFO_SELECTABLE" for Winbond 83877/83977...
;			use BorderWare Firewall Server install hang at boot
;R38    06/04/97 PTY	Add code dor RPB
;R37	05/21/97 LAW	Record EPALOGO High for Post 4Eh Earse LOGO use
;R36	05/20/97 RCH	Modify codes to display memory size up to 1GB
;R35	01/15/97 KVN	Remove P6 micro code to ROM driver pool from 0E000h
;			POST location
;R34	11/07/96 KVN	Added "Ultra_DMA33_support" definition for Ultra DMA33
;			function support
;R33	11/06/96 KVN	Fixed some PCMCIA ROM card emulate boot to C error
;R32	10/22/96 RCH	Support CPU clock over 255MHz for Klamath CPU.
;R31	09/25/96 DNL	Add SMM_CALL flag for notebook power management
;R30	09/23/96 DNL	Add CHANGE_COLOR,NO_BORDER function for display_string
;R29	09/18/96 KVN	Change store text screen buffer address become 0:7000h
;			in FULL_SCREEN_LOGO to avoid USB issue software SMI then
;			destroy original text screen buffer data (3000h:0f000h)
;			because this area is register store stack in SMI
;R28	08/16/96 KVN	Add a flag for update DMI pool (DMIPOST.ASM R17)
;R27	08/09/96 RAY	Add 2 new macros for the use of auto COM & LPT:
;			DEF_ITEM_LABEL & DEF_ITEMVAL
;R26	05/27/96 TNY	Add one user-defined byte for PASSWORD_LOOPS.
;R25	04/26/96 KVN	show all CDROM drive on SYSCFG if be connected,because
;			it just detect and display 1 CDROM on current BIOS
;R24	04/09/96 DNL	Added new [BP] for IDE HDD exist or not
;R23	03/27/96 KVN	Fixed bug for execute awdflash.exe hang if support one
;			full 640X464 logo
;R17A	02/12/96 RAY	Always enable NEW_PNP_SETUP
;R22	01/12/96 KVN	Added full screen logo display function
;R21	01/11/96 KVN	Fixed HDD can't boot when anyone HDD failure
;R20	01/09/95 RCH	Fixed NCR SCSI/ROM not found if HDD type of D,E & F
;			are "AUTO" type
;R19	12/15/95 RAY	Add CPU level information, i.e. 486, 586 or 686 ...
;R18	10/26/95 AVN	Add NEW_IO_FEATURE Definition For Audio Setup.
;R17	09/22/95 KEN	Add NEW_PNP_SETUP definition.
;R16	08/26/95 RAY	Add [BP] for Super IO
;R15	07/19/95 KVN	Fixed POST stack overflow when add 3 mode support
;R14	06/27/95 KVN	Add Ide detect counter
;R13	05/20/95 RAY	Add new [BP] for CPU brand name & SMI type
;R12	01/25/95 RAY	Add new [BP] for NEW_IDE_MODE_3	
;R11	09/13/94 DNL	add IDE_PARM_FLAG in stack to support IDE mode 3
;R10	09/05/94 KVN	Change POST auto IDE detect skip key is 'F4'
;R09	08/17/94 KVN	Added POST auto IDE detect function
;R08	06/02/94 RAY	Support 4 IDE
;R07	04/18/94 RAY	add CPU_INT_CLOCK in stack
;R06	03/08/94 RAY	Support one more page
;R05	05/13/93 RAY	Add Power Mangement support	
;R04	03/18/93 RAY	Add bit:SPECIALPRG in ItemStat
;R03	02/19/93 RAY	Reserve CALLTYPE in stack to identify who is calling
;   		 	setup, i.e. POST or MODBIN
;R02	02/15/93 RAY	Add CALLROUTINE function for display_string
;R01	02/11/93 RAY	1. Flag NOPROGRAM becomes useless, define NOCT
;   		   	in CtReg will have the same effect
;   			2. Add NODEFAULT flag
;R00	---	 ---	Initial Revision

   ROMITEM	STRUC
    RomStat	db	?	;Item status ?
    RomReg	dw	?	;Chipset register index value of this item	
    RomRegMask	dw	?	;Which bits do this item use?			
    RomValue	dw	?	;Power on default value				
   ROMITEM	ENDS
ROMITEM_SIZE	EQU	SIZE ROMITEM

CHK_ITEMSTAT	MACRO	PATTERN
		push	cx
		mov	cx,PATTERN
		call	Test_ItemStat
		pop	cx
		ENDM

;R27 - starts
DEF_ITEM_LABEL	MACRO	_LABEL
_LABEL:
TTMMPP	=	0
		endm

DEF_ITEMVAL	MACRO	STRING, VAL
		db	STRING
	IFNB	<VAL>
		PUBLIC	VAL&_CMOS_VAL
	VAL&_CMOS_VAL	=	TTMMPP
	ENDIF
		TTMMPP = TTMMPP + 1
		endm
;R27 - ends

V_DONE			EQU	0		; terminate string...
V_DONE_1		EQU	1		; item is invalid
V_BORDER		EQU	2		; draw border
V_CLEAR			EQU	3
V_STRSHOW		EQU	4
V_POS			EQU	5
V_HILITE		EQU	6		; set attr. to hilited
V_REVERSE		EQU	7		; set attr. to reversed
V_NORMAL		EQU	8		; set attr. to normal
V_BLINK			EQU	9		; set attr. to blink 
V_WARN			EQU	10		; set attr. to warning (red?)
NEWLINE			EQU	11
V_ADDX			EQU	12
V_SUBX			EQU	13
V_ADDY			EQU	14
V_SUBY			EQU	15
V_CALLROUTINE		EQU	16		;R02
V_CHG_COLOR		EQU	17		;R30

V_Special		EQU	20

;R02 Starts
CALLROUTINE	STRUC
		DB	V_CALLROUTINE
		dw	?
CALLROUTINE	ENDS
;R02 Ends

ADDX		STRUC
		DB	V_ADDX
		DB	?
ADDX		ENDS

SUBX		STRUC
		DB	V_SUBX
		DB	?
SUBX		ENDS

ADDY		STRUC
		DB	V_ADDY
		DB	?
ADDY		ENDS

SUBY		STRUC
		DB	V_SUBY
		DB	?
SUBY		ENDS

BORDER1		STRUC
		DB	V_BORDER
LeftX		DB	?		; left edge
LeftY		DB	?		; top edge
RightX		DB	?		; right edge
RightY		DB	?		; bottom edge
Btype		DB	?		; border type (0=SINGLE, 1=DOUBLE)
BORDER1		ENDS

POS		STRUC			; position cursor...
		DB	V_POS
		DB	-1		;   column
		DB	-1		;   row
POS		ENDS

CLEAR		STRUC
		DB	V_CLEAR
		DB	?		; left edge
		DB	?		; top edge
		DB	?		; right edge
		DB	?		; bottom edge
CLEAR		ENDS


STRSHOW		STRUC
		DB	V_STRSHOW
StartX		DB	-1		; left edge
StartY		DB	-1		; top edge
StrAddr		DW	?		; offset of string
STRSHOW		ENDS

NOCT		EQU	-1

;**************************************************************************
   MENUITEM	STRUC
    ItemStat	dw	?	;Item status
    ItemName	dw	?	;String offset of item name
    CtReg	dw	?	;Chipset register index value of this item
    CtRegMask	dw	?	;Which bits do this item use?
    CmosLoc	db	?	;CMOS location of this item
    CmosMask	dw	?	;Which CMOS bits do this item use?
    ItemValName	dw	?	;String offset of the first item value
    ItemMin	dw	?	;Minimum value of this item
    ItemMax	dw	?	;Maximum value of this item
    Item_Xaxis	db	?	;X-axis position of this item
    Item_Yaxis	db	?	;Y-axis position of this item
    RomDefault	dw	?	;Power on default value
    SetupDef	dw	?	;Setup default value if CMOS checksum failed    
    HelpOffset	dw	?	;Offset address of help string
   MENUITEM	ENDS
ITEM_SIZE	EQU	SIZE MENUITEM
;ItemStat bit definition:
;	B10 - 1 : Indicate start of a group
;	B9 - 1 : Display 'None' if the value is zero
;	B8 - 1 : This item don't use CMOS but need temporary memory
;	B7 - 1 : Display Only (unselectable , such as "BASE MEMORY" )
;	B6 - 1 : Blink attribute ( such as "VIRUS WARNING" )
;	B5 - 1 : Don't program chipset during POST ( like "Shadow" )
;	B4 - 1 : Item is disabled
;	B3 - 1 : Display 5 digits of two bytes interger (like memory size)
;	B2 - 1 : Display 2 digits of one byte BCD (like date & time )
;	B1 - 1 : Update CMOS if value changed (like date & time)
;	B0 - 1 : Display 4 digits of one byte integer (like HDD)
;*************************************************************************
CT_RVS		EQU	0000000000000001b
CT_RIS		EQU	0000000000000010b
SHOWONLY	EQU	0000000000000100b
ITEMDISABLE	EQU	0000000000001000b

;R04
SPECIALPRG	EQU	0000000000010000b ;the subroutine PRG_CHIPSET_DEFAULT
					  ; in CT_TABLE.ASM will detect this 
					  ; bit before every time a menuitem
					  ; is to be programmed into chip!
					  ;
					  ; 0: normal programming
					  ; 1: call Cf_Special_Prg
					  ;     returen Carry FLAG
					  ;	 = Don't program this item
					  ;     else normal programming
					  ;
					  ;This bit is special useful when
					  ;a item has different meaning
					  ;upon different CPU. This bit can
					  ;avoid the same item from being
					  ;progammed for more than once!
;R04

;R01 NOPROGRAM	EQU	0000000000100000b
PMITEM		EQU	0000000000100000b		;R05
NODEFAULT	EQU	0000000001000000b		;R01
NOMODBIN	EQU	0000000010000000b
KEYIN		EQU	0000000100000000b
SHOWNUM		EQU	0000001000000000b
SHOWHEX		EQU	0000010000000000b
NO_OF_DIGIT	EQU	0001100000000000b
     DIGIT2	EQU	0000000000000000b
     DIGIT3	EQU	0000100000000000b
     DIGIT4	EQU	0001000000000000b
     DIGIT5	EQU	0001100000000000b
EARLYPROG	EQU	0010000000000000b
AUTOPROG	EQU	0100000000000000b
HIDDEN		EQU	1000000000000000b

K_PAD5		EQU	004Ch
CMOS		EQU	70h
REG20		EQU	20H
REG30		EQU	30H
REG3D		EQU	3DH
REG3E		EQU	3EH

CMOS00		EQU	0
CMOS02		EQU	2
CMOS04		EQU	4
CMOS06		EQU	6
CMOS07		EQU	07H
CMOS08		EQU	08H
CMOS09		EQU	09H
CMOS0E		EQU	0eh
CMOS10		EQU	10H
CMOS11		EQU	11H
CMOS12		EQU	12H
CMOS14		EQU	14H
CMOS15		EQU	15H
CMOS19		EQU	19H
CMOS17		EQU	17H
CMOS1A		EQU	1AH
CMOS1C		EQU	1CH		;security
DRV_48_CYL	EQU	1eh
DRV_48_HEADS	EQU	20h
DRV_48_PRECOMP	EQU	21h
DRV_48_LANDING	EQU	23h
DRV_48_SECTORS	EQU	25h
DRV_49_CYL	EQU	26h
DRV_49_HEADS	EQU	28h
DRV_49_PRECOMP	EQU	29h
DRV_49_LANDING	EQU	2bh
DRV_49_SECTORS	EQU	2dh
CMOS30		EQU	30H
CMOS32		EQU	32H
CMOS3B		EQU	3BH
CMOS3C		EQU	3CH
CMOS3E		EQU	3EH
CMOS3F		EQU	3FH
CMOS42		EQU	42H
CMOS43		EQU	43H
CMOS44		EQU	44H

;R08 - starts
CMOS_HDDE	EQU	67h
DRV_51_CYL	EQU	68h
DRV_51_HEADS	EQU	6Ah
DRV_51_PRECOMP	EQU	6Bh
DRV_51_LANDING	EQU	6Dh
DRV_51_SECTORS	EQU	6Fh
CMOS_HDDF	EQU	70h
DRV_50_CYL	EQU	71h
DRV_50_HEADS	EQU	73h
DRV_50_PRECOMP	EQU	74h
DRV_50_LANDING	EQU	76h
DRV_50_SECTORS	EQU	78h
CMOS_LBA_LGA	EQU	79h
;R08 - ends

CMOS7F		EQU	7FH

ATTRIBUTE	EQU	80H
CURSOR_X 	EQU	81H
CURSOR_Y 	EQU	82H
;R36 OPERATION	EQU	83H
;R36 OLDITEM   	EQU	84H	;This need two bytes to save previous item
;R36 SIX_DIGIT	EQU	86H	;reserve 6 digits to do interger and ascii convertion
;R36 - start
OLDITEM		EQU	83H	;This need two bytes to save previous item
SIX_DIGIT	EQU	85H	;reserve 7 digits to do interger and ascii convertion
;R36 - end
CUR_PAGE	EQU	8DH
PAGE_START	EQU	8EH	;need two bytes to save offset of first item
PAGE_END	EQU	90H	;need two bytes to save offset of last item
STROFFSET	EQU	92H	;need two bytes to save offset of startup string
CYLINDER	EQU	94H	;need two bytes
HEAD		EQU	96H
PRECOMP		EQU	97H	;need two bytes
LANDZONE	EQU	99H	;need two bytes
SECTOR		EQU	9BH
HDDSIZE		EQU	9CH	;need two bytes
MONOCHROME	EQU	9Eh	;0 - MONO , 1 - COLOR

LAST_HDD_TYPE	EQU	09Fh
LAST_KEY	EQU	0A0h
KEYIN_BUF	EQU	0A2h	;need 10 bytes
LMARGIN_X	EQU	0B1h	;need one byte
DAY_OF_WEEK1	EQU	0B2h
TEMP_YEAR	EQU	0B3h

KERNAL_CONTROL	EQU	0B5h	;1 byte

ITEMSTAT_BUF	EQU	0B6h	;need 50 words	;temp year
;R15 STACK_POINTER	EQU	ITEMSTAT_BUF+100	;need 1 word to store SP
STACK_POINTER	EQU	ITEMSTAT_BUF+132	;R15

UP_ARROW_FUNC		EQU	STACK_POINTER+2
DOWN_ARROW_FUNC		EQU	STACK_POINTER+4
LEFT_ARROW_FUNC		EQU	STACK_POINTER+6
RIGHT_ARROW_FUNC	EQU	STACK_POINTER+8
USE_ITEMSTAT_BUF	EQU	STACK_POINTER+10	;1 byte
KERNAL_ITEM		EQU	STACK_POINTER+11	;1 word

KEYIN_ITEM_OFF		EQU	STACK_POINTER+13	;1 word
HDD_CURSOR_FLG		EQU	STACK_POINTER+15	;1 byte
IN_F1_HELP		EQU	STACK_POINTER+16	;1 byte
Color_Offset		EQU	STACK_POINTER+17	;1 word
CALLTYPE		EQU	STACK_POINTER+19	;1 byte	;R03

;R15 USERINTSTACK	EQU	1A0H
USERINTSTACK	EQU	1C0H					;R15
CURSOR_STAT	EQU	USERINTSTACK+0	;number of CURSOR_OFF calls
CLIP_LEFT	EQU	USERINTSTACK+2	;left edge of clip area
CLIP_TOP	EQU	USERINTSTACK+3	;top edge of clip area
CLIP_RIGHT	EQU	USERINTSTACK+4	;right edge of clip area
CLIP_BTM	EQU	USERINTSTACK+5	;btm edge of clip area
VIS_LEFT	EQU	USERINTSTACK+6 ;left edge of visible area	
VIS_TOP		EQU	USERINTSTACK+7 ;top edge of visible area	
VIS_RIGHT	EQU	USERINTSTACK+8 ;right edge of visible area	
VIS_BTM		EQU	USERINTSTACK+9 ;right edge of visible area	
BLOCK_LEFT_EDGE EQU	USERINTSTACK+10;left edge of block

CPU_INT_CLOCK	EQU	USERINTSTACK+12		;word		;R32
;R32 ERASE_STRING	EQU	USERINTSTACK+12	;flag of erase string
STND_FONT_OFF	EQU	USERINTSTACK+14
STND_FONT_SEG	EQU	USERINTSTACK+16		;word
;R32 CPU_INT_CLOCK	EQU	USERINTSTACK+18	;byte		;R07
Post_Auto_type	EQU	USERINTSTACK+19		;byte		;R09
IDE_Detect_Skip_Key	EQU	USERINTSTACK+20	;word		;R10
;R11 start
;R12 ifdef	IDE_MODE_3_SUPPORT
IDE_PARM_Flag	EQU	USERINTSTACK+22		;byte
	Mode_3_Support		EQU	10000000b
	Mode_3_In_Drive_0	EQU	00000001b
	Mode_3_In_Drive_1	EQU	00000010b
	Mode_3_In_Drive_2	EQU	00000100b
	Mode_3_In_Drive_3	EQU	00001000b
;R12 endif	;IDE_MODE_3_SUPPORT
;R11 end

;R12 - starts
;------------- NEW_IDE_MODE_3 -------------------
HDD_0_MODE		EQU	USERINTSTACK+23
HDD_1_MODE		EQU	USERINTSTACK+24
HDD_2_MODE		EQU	USERINTSTACK+25
HDD_3_MODE		EQU	USERINTSTACK+26
;------------- NEW_IDE_MODE_3 -------------------
;R12 - ends

;R13 - starts
CPU_BRAND			EQU	USERINTSTACK+27		;byte
	CPU_BRAND_INTEL		EQU	00000001b
	CPU_BRAND_AMD		EQU	00000010b
	CPU_BRAND_CYRIX		EQU	00000011b
	CPU_BRAND_UMC		EQU	00000100b
	CPU_BRAND_IBM		EQU	00000101b
	CPU_BRAND_TI 		EQU	00000110b

CPU_SMI_TYPE			EQU	USERINTSTACK+28		;byte
	SMI_NONE		EQU	00000000b
	SMI_TYPE_INTEL		EQU	00000001b
	SMI_TYPE_OLD_AMD	EQU	00000010b
	SMI_TYPE_CYRIX		EQU	00000100b
	SMI_TYPE_IBM		EQU	00001000b
;R13 - ends

IDE_Detect_Counter	EQU	USERINTSTACK+29	;byte		;R14

;R16 - starts
SIO_COM_SETTING		EQU	USERINTSTACK+30

   SIO_COM1_MASK	EQU	00001111b
	SIO_COM1_NONE	EQU	00000000b
	SIO_COM1_3F8	EQU	00000001b
	SIO_COM1_2F8	EQU	00000010b
	SIO_COM1_3E8	EQU	00000011b
	SIO_COM1_2E8	EQU	00000100b

   SIO_COM2_MASK	EQU	11110000b
	SIO_COM2_NONE	EQU	00000000b
	SIO_COM2_3F8	EQU	00010000b
	SIO_COM2_2F8	EQU	00100000b
	SIO_COM2_3E8	EQU	00110000b
	SIO_COM2_2E8	EQU	01000000b

SIO_LPT_SETTING		EQU	USERINTSTACK+31

   SIO_LPT_MASK		EQU	00001111b
	SIO_LPT_NONE	EQU	00000000b
	SIO_LPT_3BC	EQU	00000001b
	SIO_LPT_378	EQU	00000010b
	SIO_LPT_278	EQU	00000011b

   SIO_LPT_ECP		EQU	10000000b

;R16 - ends

;R19 - starts
CPU_LEVEL			EQU	USERINTSTACK+32		;byte
	LEVEL_386		EQU	00000001b
	LEVEL_486		EQU	00000010b
	LEVEL_586		EQU	00000011b
	LEVEL_686		EQU	00000100b
;R19 - ends
;R20 start
Post_Temp_Byte		EQU	USERINTSTACK+33		;byte
	DriveC_AUTO	EQU	00000001b	;set if drive C is AUTO type
	DriveD_AUTO	EQU	00000010b	;set if drive D is AUTO type
	DriveE_AUTO	EQU	00000100b	;set if drive E is AUTO type
	DriveF_AUTO	EQU	00001000b	;set if drive F is AUTO type
	Text_POST	EQU	00010000b	;R22 if set then display text post
DO_NOT_UPDATE_TIME	EQU	00100000b	;R40
	DMI_UPDATE	EQU	10000000b	;R28
;R20 end
POST_HDD_Err_Flag	EQU	USERINTSTACK+34		;R21 byte
HDD_EXIST_Flag		EQU	USERINTSTACK+35		;R24 byte
;R25 start
CDROM_Exist_Flag	EQU	USERINTSTACK+36		;byte
	PM_CDROM	EQU	00000001b	;set if Primary Master connect CDROM
	PS_CDROM	EQU	00000010b	;set if Primary Slave connect CDROM
	SM_CDROM	EQU	00000100b	;set if Secondary Master connect CDROM
	SS_CDROM	EQU	00001000b	;set if Secondary Slave connect CDROM
;R25 end

PASSWORD_LOOPS		EQU	USERINTSTACK+37	;byte	;R26
IDE_HDD0_CYL_SEC	EQU	USERINTSTACK+38	;word	;R33
IDE_HDD0_HEAD		EQU	USERINTSTACK+40	;byte	;R33
;R34 - starts
;------------- NEW_IDE_MODE_3 -------------------
HDD_0_UltraDMA		EQU	USERINTSTACK+41	;byte
HDD_1_UltraDMA		EQU	USERINTSTACK+42	;byte
HDD_2_UltraDMA		EQU	USERINTSTACK+43	;byte
HDD_3_UltraDMA		EQU	USERINTSTACK+44	;byte
;------------- NEW_IDE_MODE_3 -------------------
;R34 - ends

EPALOGO_HIGH		EQU	USERINTSTACK+45	;byte	;R37
EPALOGO_FLAG		EQU	USERINTSTACK+45	;byte	;R48

FDC_FIFO_FLAG		EQU	USERINTSTACK+46	;byte	;R39
ACPI_TABLE_FLAG		EQU	USERINTSTACK+47	;dword	;R41
;------------- HDD S.M.A.R.T. Function -----------
HDD_SMART_FLAG		EQU	USERINTSTACK+51	;byte	;R42
;------------- STD FAT32 support -----------
FAT32_SECTOR_FLAG	EQU	USERINTSTACK+52	;dword	;R43
FAT32_ROOT_FLAG		EQU	USERINTSTACK+56	;dword	;R43
;------------- Cardbus support -------------
Cardbus_SlotID		EQU	USERINTSTACK+60	;word	;R44
Cardbus_Vendor		EQU	USERINTSTACK+62	;byte	;R44
	Ti_Cardbus	EQU	00000001b		;R44
	O2_Cardbus	EQU	00000010b		;R44
	Cirrus_Cardbus	EQU	00000100b		;R44
;------------- ATAPI EED support. -----------
;R45 -start
IDE_EXist_FLAG		EQU	USERINTSTACK+63	;byte	
IDE_0_Specific_FLAG	EQU	USERINTSTACK+64	;byte	
IDE_1_Specific_FLAG	EQU	USERINTSTACK+65	;byte	
IDE_2_Specific_FLAG	EQU	USERINTSTACK+66	;byte	
IDE_3_Specific_FLAG	EQU	USERINTSTACK+67 ;byte	
	FastPIO		EQU	00000001b
	DMAenabl	EQU	00000010b
	BlockPIO	EQU	00000100b
	CHSenabl	EQU	00001000b
	LBAenabl	EQU	00010000b
	RemoveablMedia	EQU	00100000b
	ATAPIDev	EQU    	01000000b
	ATAPI_DRQ	EQU	10000000b

IDE_0_DMA_Mode		EQU	USERINTSTACK+68	;byte	
IDE_1_DMA_Mode		EQU	USERINTSTACK+69	;byte	
IDE_2_DMA_Mode		EQU	USERINTSTACK+70	;byte	
IDE_3_DMA_Mode		EQU	USERINTSTACK+71	;byte	
;R45 - end
;R46 start
IDE_device_item		equ	USERINTSTACK+72	;word
;	bit 0 -3  : for IDE 0
;	bit 4 -7  : for IDE 1
;	bit 8 -11 : for IDE 2
;	bit 12-15 : for IDE 3
;    value define : 0000 = none
;		    0001 = HDD
;		    0002 = CDROM
;		    0003 = LS120
;		    0004 = ZIP 100
;R46 end
Bulk_Flash_type		equ	USERINTSTACK+74	;byte	;R47

;-----------------------------------------------------------------------
BLACK		EQU	0
BLUE		EQU	1
GREEN		EQU	2
CYAN		EQU	3
RED		EQU	4
MAGENTA		EQU	5
BROWN		EQU	6
LIGHTGRAY	EQU	7
DARKGRAY	EQU	8
LIGHTBLUE	EQU	9
LIGHTGREEN	EQU	10
LIGHTCYAN	EQU	11
LIGHTRED	EQU	12
LIGHTMAGENTA	EQU	13
YELLOW		EQU	14
WHITE		EQU	15

Color_Style	STRUC
		CNORMAL		DB	?
		CHILITE		DB	?
		CREVERSE	DB	?
		CWARN		DB	?
Color_Style	ENDS
;

COLO_NORMAL	EQU	1FH
COLO_HILITE	EQU	1EH
COLO_REVERSE	EQU	4FH
COLO_WARN	EQU	07h

NORMAL1		EQU	07H
HILITE1		EQU	0FH
REVERSE1	EQU	70H
WARN1		EQU	70h

K_PLUS		EQU	4E2bH
K_MINUS		EQU	4A2dH
K_F1		EQU	3B00H
K_F2		EQU	3C00H
K_SHFT_F2	EQU	5500h
K_F3		EQU	3D00H
K_F4		EQU	3E00H
K_F5		EQU	3F00H
K_F6		EQU	4000H
K_F7		EQU	4100H
K_F10		EQU	4400H
UP_ARROW	EQU	4800H
DOWN_ARROW	EQU	5000H
LEFT_ARROW	EQU	4B00H
RIGHT_ARROW	EQU	4D00H
PGUP		EQU	4900H
PGDN		EQU	5100H
K_TAB		EQU	0F09h
K_BS1		EQU	0E08h
K_SHFTTAB	EQU	0F00h

K_CR1		EQU	1C0Dh
K_ESC1		EQU	011Bh

DOUBLE_BORDER	EQU	01h
Empty_Border	EQU	02h
LINE_BORDER	EQU	04h
NO_BORDER	EQU	08h			;R30


Special_Before	EQU	0AAh
Special_After	EQU	055h
READ_TOTAL	EQU	0
READ_BASE	EQU	1
READ_EXT	EQU	2
READ_EMS	EQU	3
READ_OTHER	EQU	4


ECHO_ASTERISK	EQU	80h
EDIT_PUNCT	EQU	10h
EDIT_HEX	EQU	08h
EDIT_DEC	EQU	04h
EDIT_LOWER	EQU	02h
EDIT_UPPER	EQU	01h


PAGE_KERNAL	EQU	1
PAGE_STDCMOS	EQU	2
PAGE_BFEATURE	EQU	3
PAGE_CFEATURE	EQU	4
PAGE_PFEATURE	EQU	5
PAGE_PCI	EQU	6	;R06
;R17A ifdef	NEW_PNP_SETUP		;R17
PAGE_PNP	EQU	7
;R17A endif	;NEW_PNP_SETUP

;R18 - start
ifdef	NEW_IO_FEATURE
;R17A ifdef	NEW_PNP_SETUP
PAGE_IO		EQU	8
;R17A else	;NEW_PNP_SETUP
;R17A PAGE_IO		EQU	7
;R17A endif	;NEW_PNP_SETUP
endif	;NEW_IO_FEATURE
;R18 - end
;r38 start
ifdef RPB_ENABLED                   ;R32

ifdef NEW_IO_FEATURE
PAGE_COUNT = PAGE_IO
else ; NEW_IO_FEATURE
PAGE_COUNT = PAGE_PNP
endif ; NEW_IO_FEATURE

ifdef RPB_FEATUREPAGE_ENABLED
PAGE_RPBFEAT    EQU PAGE_COUNT + 1
endif ; RPB_FEATUREPAGE_ENABLED

PAGE_RPBMENU    EQU PAGE_COUNT + 2

endif ; RPB_ENABLED
;r38 end
POST_CALL	EQU	0AAh	;R03
MODBIN_CALL	EQU	001h	;R03
DOS_CALL	EQU	002h	;R05
SMM_CALL	EQU	003h	;R31

;R35LOGO_Segment	EQU	4000h			;R22
Temp_CBROM_Segment	EQU	4000h			;R35
;R29 Temp_VGA_Seg	EQU	3000h			;R22
;R29 Temp_VGA_Off	EQU	0f000h			;R22
Temp_EXP_Seg	EQU	0				;R35
Temp_EXP_Off	EQU	6000h				;R35
Temp_VGA_Seg	EQU	0				;R29
Temp_VGA_Off	EQU	7000h				;R29
Temp_Scrn_Size	EQU	80*25				;R22
Exp_Data_Seg	EQU	3000h				;R23
