;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;                       EF_ORG.ASM

;----------------------------------------------------------------------------
;Rev    Date      Name  Description
;----------------------------------------------------------------------------
;R04	05/29/97 KVN	Added a new segment for store more BIOS code
;R03	06/01/96 KVN	Disable interrupt flag (CLI) to prevent SP or BP be
;			destroy by any interrupt to fix system hang at POST_82S
;			(80h port is 52h) sometimes
;R02	04/24/96 KVN	Fixed Segment define error
;R01A	04/24/96 KVN	Fixed R01 coding mistake so that will overwrite 0E000:0
;			code address
;R01	04/20/96 RCH	Don't reserve last 4Kb for INT 10H if it is in F-seg.
;R00	11/01/95 KVN	1. Move "F000_call_proc" from AVIDEO.ASM for F000_call
;			2. Release full E000 segment size for none PNP bios

        PAGE    60,132
                TITLE   FIXORG  -   ALLOW MIDDLE ORG AT 8000H FOR BIOS

;R01A .286
.386P						;R01A
;[]-----------------------------------[]
;
;   Award Software 386/486 BIOS
;    Base + Initialization Rtns
;   Initial Revision 03-FEB-1994
;
;[]-----------------------------------[]

.XLIST
.LIST
;R00 start
		extrn	F000_func_end:Near
		extrn	F000_VECT:Near
		INCLUDE COMMON.MAC
;R00 end
		INCLUDE	BIOS.CFG

ifndef	PNP_BIOS				;R01
AVIDEO_AT_F000		EQU	1		;R01
endif	;PNP_BIOS				;R01

EGROUP		GROUP	ECODE
;R01A start
ifdef	AVIDEO_AT_F000
ECODE		SEGMENT	USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP
else	;AVIDEO_AT_F000
;R01A end
;R01A ifndef	AVIDEO_AT_F000				;R01
;R02 ECODE		SEGMENT DWORD COMMON 'ECODE'
ECODE		SEGMENT USE16 DWORD COMMON 'ECODE'		;R02
                ASSUME  CS:EGROUP

		org	0f000h
;R00 start
		DB	55h,0aah			;signature
		db	08H				;4kb
		retf
		DB	'(c) COPYRIGHT 1984,1995 Award Software Inc.'
		DB	'ALL RIGHTS RESERVED'
endif;	AVIDEO_AT_F000				;R01

		public	F000_call_proc
F000_call_proc:
		push	offset F000_func_end
;R04		push	0e000h
		push	ax
		pushf				;R03
		cli				;R03
		xchg	bp,sp
;R03		mov	ax,[bp+2]
;R03		xchg	ax,[bp+8]
;R03		mov	[bp+2],ax
		mov	ax,[bp+4]		;R03
;R04		xchg	ax,[bp+10]		;R03
		xchg	ax,[bp+6]		;R04
		mov	[bp+4],ax		;R03
		xchg	bp,sp
		popf				;R03
		pop	ax
		FAR_JMP <OFFSET F000_VECT>,0F000h
;R00 end

ECODE           ENDS

                END

