;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;----------------------------------------------------------------------------
;Rev    Date      Name  Description
;----------------------------------------------------------------------------
;R03	11/19/96 TNY	Add "No_Support_HiScan" definition.
;R02	09/06/96 AVN	Move Dummy Flash Routine From F000h:8000h to End of
;			This File, For SiS596 Compiler Code Cover F000h:8000h
;			and Copy Flash Routine Will Cover BIOS Code.
;R01	08/20/96 AVN	Detect EEPROM Type at post 6, to support 2M EEPROM
;			for save more code in F segment.
;			POST 6s Will copy correct flash hook to f800h:4

        PAGE    60,132
                TITLE   FIXORG  -   ALLOW MIDDLE ORG AT 8000H FOR BIOS

.286
;[]-----------------------------------[]
;
;   Award Software 386/486 BIOS
;    Base + Initialization Rtns
;   Initial Revision 03-FEB-1994
;
;[]-----------------------------------[]

.XLIST
.LIST
		INCLUDE	BIOS.CFG

DGROUP		GROUP	FCODE
FCODE           SEGMENT DWORD COMMON 'CODE'
		assume	cs:dgroup			;R01

ifndef	No_Support_HiScan				;R03
                ORG     8000H
endif;	No_Support_HiScan				;R03

;R02 ifdef	Flash_16K_8K_8K_Unit				;R01
;R02 		Public	_2M_FLASH_ENTRY_POINT		;R01
;R02 _2M_FLASH_ENTRY_POINT	label	near			;R01
;R02 endif;	Flash_16K_8K_8K_Unit				;R01

FCODE           ENDS

                END

