;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;
;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;--------------------------2A5II---------------------------------------------
;R04	12/10/97 PAL	Added ACPI Function for Enable or Disable
;R03	10/06/97 AVN	Added 'HOT_KEY_AS_SUSPEND' Support
;R02	05/16/97 AVN	Added Hot Key (Ctrl+Alt+Backspace) Support
;R01	04/03/97 LRY	Special for Abit.
;R00	01/07/97 LRY	Initial version

		PAGE	56,132
		.286

		include bios.cfg
		include bsetup.inc
		include setup.ext
		include CMOS.EQU
		Extrn	Common_Startup_Str:Near
		extrn	PAGE_NAME_Y:ABS
		Extrn	Ena_Str:Near
		Extrn	Dis_Str:Near
		Extrn	Std_Help_Str:Near
		extrn	Get_Cmos:Near
		extrn	Set_Cmos:Near
		EXTRN	NULLSTR:Near
		extrn	GetItem_Value:near
		extrn	Vnormal:near
		public	PM_Feature_Str

		Public	PM_Feature_Special_Do
		Public	PM_Feature_Special_Show
		Public	PM_Feature_Key_List
		Public	PM_Feature_StartUp_Str
		Public	PM_Feature_Start
		Public	PM_Feature_End
		Public	PM_STAT

		Public	PM_Auto_Table
		Public	PM_EndAuto_Table
		Public	PM_Auto_String

Y_Start 	EQU	4
Xaxis		=	2
Yaxis		=	Y_Start - 1
DEFINE_ITEM	MACRO	MENU_NAME,GAP
IFB	<GAP>
	Yaxis = Yaxis + 1
ELSE	;
 IF	Yaxis GT 3		;if Yaxis great than the top row, process gap
  IFDEF LAST_GAP_POSITION
   IF	Xaxis+Yaxis NE LAST_GAP_POSITION
	Yaxis = Yaxis + 1
   ENDIF;
  ELSE	;
	Yaxis = Yaxis + 1
  ENDIF ;LAST_GAP_POSITION
	LAST_GAP_POSITION = Xaxis + Yaxis
 ENDIF	;
	Yaxis = Yaxis + GAP
ENDIF	;GAP
IF	Yaxis GT 23
	Xaxis = 42
	Yaxis = 4
 IFNB	<GAP>
  IF	GAP EQ 0
	Yaxis = 3
  ENDIF	;
 ENDIF	;
ENDIF	;
IFNB	<MENU_NAME>
	PUBLIC	MENU_NAME
	MENU_NAME:
ENDIF
		ENDM

DGROUP		GROUP	FCODE
FCODE		SEGMENT WORD PUBLIC 'CODE'
		ASSUME	CS:DGROUP,DS:DGROUP

PM_Feature_Special_Do:
		dw	PM_Feature_Do_NO
PM_Feature_Do_NO	EQU	(($ - offset PM_Feature_Special_Do)-2)/4

PM_Feature_Special_Show:
		dw	PM_Feature_Show_NO
ifdef	PM_SUPPORT
		dw	Offset PM_Option_Item	,Offset Show_Auto_Cfg
ifdef	No_New_HDD_Timer_String
		dw	offset HDD_Timer_Item	,offset Show_Hdd_Timer
endif	;No_New_HDD_Timer_String
ifdef	NETWORK_SUSPEND_DISABLE
		dw	offset NetCard_Item	,offset Show_NetCard
endif	;NETWORK_SUSPEND_DISABLE
ifdef	REDUCE_P5_SETUP
		dw	offset Doze_Speed_Item	,offset P5_Unshow
		dw	offset Standby_Speed_Item,offset P5_Unshow
		dw	offset Suspend_Item	,offset P5_Unshow
endif	;REDUCE_P5_SETUP
endif;	PM_SUPPORT
PM_Feature_Show_NO	EQU	(($ - offset PM_Feature_Special_Show)-2)/4

PM_Feature_Key_List	Label	Near
		dw	offset Seq_Up		;function for UP_ARROW
		dw	offset Seq_Down 	;function for DOWN_ARROW
		dw	offset Go_Left_Item	;function for LEFT_ARROW
		dw	offset Go_Right_Item	;function for RIGHT_ARROW

PM_Feature_StartUp_Str	label	near
		STRSHOW <,,,offset Common_StartUp_Str>
;R04 - start
ifdef	No_Help_In_PMFEAT
		CLEAR	<,41,18,78,23>
		POS	<,40,18>
		db	''
		POS	<,79,18>
		db	''
endif;	No_Help_In_PMFEAT
;R04 - end
		POS	<,29,PAGE_NAME_Y>
PM_Feature_Str:
		db	'POWER MANAGEMENT SETUP'
		db	0

;----------------------------------------------------------------------------

		ALIGN	4
		db	0
PM_Auto_Table	label	near
		db	(Offset PM_Set2_Table-Offset PM_Set1_Table)/ROMITEM_SIZE
ifdef	PM_SUPPORT
PM_Set1_Ptr	dw	offset PM_Set1_Table		;PM Disable
PM_Set2_Ptr	dw	offset PM_Set2_Table		;Min PM Saving
PM_Set3_Ptr	dw	offset PM_Set3_Table		;Max PM Saving
PM_Set4_Ptr	dw	offset PM_Set4_Table
endif	;PM_SUPPORT
PM_EndAuto_Table	label	near

;------------------------  PM Disable Table   ------------------------------
PM_Set1_Table:
		ROMITEM <PMITEM+CT_RIS,0FFE1h,11111111b,00000000b>
		ROMITEM <PMITEM+CT_RIS,0FFE2h,11111111b,00000000b>
		ROMITEM <PMITEM+CT_RIS,0086Dh,00000001b,00000000b>	;R02
;------------------------ Min PM Saving Table ------------------------------
PM_Set2_Table:
		ROMITEM <PMITEM+CT_RIS,0FFE1h,11111111b,10001000b>
		ROMITEM <PMITEM+CT_RIS,0FFE2h,11111111b,10001000b>
		ROMITEM <PMITEM+CT_RIS,0086Dh,00000001b,00000001b>	;R02
;------------------------ Max PM Saving Table ------------------------------
PM_Set3_Table:
		ROMITEM <PMITEM+CT_RIS,0FFE1h,11111111b,00010001b>
		ROMITEM <PMITEM+CT_RIS,0FFE2h,11111111b,00010001b>
		ROMITEM <PMITEM+CT_RIS,0086Dh,00000001b,00000001b>	;R02
;------------------------     PM Setting 4    ------------------------------
PM_Set4_Table:
		ROMITEM <PMITEM+CT_RIS,0FFE1h,11111111b,00000000b>
		ROMITEM <PMITEM+CT_RIS,0FFE2h,11111111b,00000000b>
		ROMITEM <PMITEM+CT_RIS,0086Dh,00000001b,00000001b>	;R02

;[]======================================================================[]
;
;			Menuitems
;
;[]======================================================================[]
PF_CMOS 	EQU	60H
PM_Feature_START	Label	Near
Xaxis	=	2
Yaxis	=	3
ifdef	PM_SUPPORT
;R04 - start
ifdef	ACPI_Support
DEFINE_ITEM	ACPI_Option_Item
menuitem <0,\
	  offset ACPI_Option_Str		 ,NOCT,10000000b,PF_CMOS+5,10000000b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	   00000000b,offset Std_Help_Str>
endif;	ACPI_Support
;R04 - end

DEFINE_ITEM	PM_Option_Item
ifdef	PM_DEFAULT_DISABLE
menuitem <PMITEM,\
	  offset PM_Option_Str		 ,NOCT,00000111b,PF_CMOS+0,00000111b,\
	  offset PM_Option_Var,0,4,Xaxis,Yaxis,00000001b,	   00000001b,offset Std_Help_Str>
else;	PM_DEFAULT_DISABLE
menuitem <PMITEM,\
	  offset PM_Option_Str		 ,NOCT,00000111b,PF_CMOS+0,00000111b,\
	  offset PM_Option_Var,0,4,Xaxis,Yaxis,00000001b,	   00000011b,offset Std_Help_Str>
endif;	PM_DEFAULT_DISABLE

DEFINE_ITEM	Wait_APM_Item
menuitem <PMITEM,\
	  offset Wait_APM_Str		,NOCT,00001000b,PF_CMOS+0,00001000b,\
	  offset Wait_APM_Val,0,1,Xaxis,Yaxis,00001000b,	  00001000b,offset Std_Help_Str>

DEFINE_ITEM	Video_Off_Item
menuitem <PMITEM,\
	  offset Video_Off_Str	       ,NOCT,00000011b,PF_CMOS+0,00110000b,\
	  offset Video_Off_Val,0,3,Xaxis,Yaxis,00000010b,	 00100000b,offset Std_Help_Str>

DEFINE_ITEM	VGA_Type_Item
menuitem <PMITEM,\
	  Offset VGA_Type_Str,		 NOCT,00000011b,PF_CMOS+5,00110000b,\
	  Offset VGA_Type_Val,0,3,Xaxis,Yaxis,00000001b,	  00010000b,offset Std_Help_Str>

;R01 - start
ifdef	ABIT_GPCS
DEFINE_ITEM	ABIT_fan_Item
menuitem <PMITEM,\
	  Offset ABIT_fan_Str,	    NOCT,00000011b,PF_CMOS+5,01000000b,\
	  Offset Dis_Str,0,1,Xaxis,Yaxis,00000000b,	     01000000b,offset Std_Help_Str>
endif	;ABIT_GPCS
;R01 - end

DEFINE_ITEM	Suspend_Sw_Item
menuitem <3,\
	  offset Switch_Str	       ,94h,100010000b,PF_CMOS+0,11000000b,\
	  offset Switch_Val,0,3,Xaxis,Yaxis,100010000b,	     11000000b,offset Std_Help_Str>

DEFINE_ITEM	Doze_Speed_Item
menuitem <0,\
	  offset DozeSpeed_Str		 ,NOCT,00001111b,PF_CMOS+6,00001111b,\
	  offset DozeSpeed_Val,0,7,Xaxis,Yaxis,00000001b,	   00000001b,offset Std_Help_Str>

DEFINE_ITEM	Standby_Speed_Item
menuitem <0,\
	  offset StbySpeed_Str		 ,NOCT,11110000b,PF_CMOS+6,11110000b,\
	  offset StbySpeed_Val,0,7,Xaxis,Yaxis,00100000b,	   00100000b,offset Std_Help_Str>

ifdef	NETWORK_SUSPEND_DISABLE
DEFINE_ITEM	NetCard_Item
menuitem <0,\
	  offset NetCard_Str		 ,NOCT,00010000b,PF_CMOS+5,01000000b,\
	  offset Dis_Str,0,1,Xaxis,Yaxis,00000000b,	   00000000b,offset Std_Help_Str>
endif	;NETWORK_SUSPEND_DISABLE

IFDEF	NoteBook_Power_Management
DEFINE_ITEM	Suspend_Option_Item
menuitem <2+PMITEM,\
Offset Suspend_Option_Str,  NOCT,00000011b,NF_CMOS,11000000b,\
Offset Suspend_Option_Val,0,2,Xaxis,Yaxis,00000000b,	      00000000b,offset NullStr>
ENDIF	;NoteBook_Power_Management

ifndef	NO_SUPPORT_APM12
DEFINE_ITEM    Modem_IRQ_Item
	menuitem <PMITEM,\
	offset Modem_Event_Str,NOCT,00Fh,56h,11110000b,\
	offset Modem_Event_Val,0,15,Xaxis,Yaxis,03h,30h,offset Std_Help_Str>
endif	;NO_SUPPORT_APM12

;R02 - start
DEFINE_ITEM	SOFTWARE_P_D
	menuitem <PMITEM+AUTOPROG,\
	offset SOFTWARE_P_D_Str,086Dh,001h,PF_CMOS+3,00010000b,\
	offset Dis_Str,0,1,Xaxis,Yaxis,01h,10h,offset Std_Help_Str>
;R02 - end

DEFINE_ITEM	,1
menuitem <SHOWONLY,\
	  offset Timer_Val_Str,NOCT,0,KERNAL_CONTROL,00000001b,\
	  offset NullStr,0,0,Xaxis,Yaxis,0,0,offset NullStr>

DEFINE_ITEM	HDD_Timer_Item
menuitem <PMITEM,\
	  offset HDD_Timer_Str		  ,NOCT,11110000b,PF_CMOS+1,00011111b,\
	  offset HDD_Timer_Val,0,16,Xaxis,Yaxis,00000000b,	    00000000b,offset NullStr>

DEFINE_ITEM	Doze_Item
menuitem <PMITEM+AUTOPROG,\
	  offset Doze_Str	  ,0FFE1h,00001111b,PF_CMOS+2,00001111b,\
	  offset Doze_Val,0,8,Xaxis,Yaxis,00000000b,	      00000000b,offset NullStr>

DEFINE_ITEM	Standby_Item
menuitem <PMITEM+AUTOPROG,\
	  offset Standby_Str	     ,0FFE1h,11110000b,PF_CMOS+2,11110000b,\
	  offset Standby_Val,0,8,Xaxis,Yaxis,00000000b, 	 00000000b,offset NullStr>

DEFINE_ITEM	Suspend_Item
menuitem <PMITEM+AUTOPROG,\
	  offset Suspend_Str	     ,0FFE2h,00001111b,PF_CMOS+3,00001111b,\
	  offset Suspend_Val,0,8,Xaxis,Yaxis,00000000b, 	 00000000b,offset NullStr>


DEFINE_ITEM	,1
menuitem <SHOWONLY,\
	  offset PM_Event_Str,NOCT,0,KERNAL_CONTROL,00000001b,\
	  offset NullStr,0,0,Xaxis,Yaxis,0,0,offset NullStr>

DEFINE_ITEM	COM_Event_Item
menuitem <2,\
	  offset COM_Event_Str     ,NOCT,00100000b,PF_CMOS+1,00100000b,\
	  offset Dis_Str,0,1,Xaxis,Yaxis,00100000b,	     00100000b,offset Std_Help_Str>

DEFINE_ITEM	LPT_Event_Item
menuitem <2,\
	  offset LPT_Event_Str      ,90h,00001000b,PF_CMOS+1,01000000b,\
	  offset Dis_Str,0,1,Xaxis,Yaxis,00001000b,	     01000000b,offset Std_Help_Str>

DEFINE_ITEM	HDD_Event_Item
menuitem <2,\
	  offset HDD_Event_Str      ,90h,10000000b,PF_CMOS+1,10000000b,\
	  offset Dis_Str,0,1,Xaxis,Yaxis,10000000b,	     10000000b,offset Std_Help_Str>

DEFINE_ITEM	VGA_Event_Item
ifdef	VGA_EVENT_DEFAULE_ENABLE
	Vga_Event_dft	EQU	40h
else	;VGA_EVENT_DEFAULE_ENABLE
	Vga_Event_dft	EQU	0
endif	;VGA_EVENT_DEFAULE_ENABLE
menuitem <2,\
	  offset Vga_Event_Str	   ,NOCT,00100000b,PF_CMOS+3,01000000b,\
	  offset Dis_Str,0,1,Xaxis,Yaxis,00000000b,Vga_Event_dft,offset Std_Help_Str>

IF	Xaxis LE 40
	Xaxis = 42
	Yaxis = 3
ENDIF

DEFINE_ITEM
menuitem <2,\
	  offset IRQ3_Event_Str    ,874h,00001000b,PF_CMOS+3,10000000b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ4_Event_Str    ,874h,00010000b,PF_CMOS+4,00000001b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ5_Event_Str    ,874h,00100000b,PF_CMOS+4,00000010b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ6_Event_Str    ,874h,01000000b,PF_CMOS+4,00000100b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ7_Event_Str    ,874h,10000000b,PF_CMOS+4,00001000b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ8_Event_Str    ,875h,00000001b,PF_CMOS+4,00010000b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000001b,	     00010000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ9_Event_Str    ,875h,00000010b,PF_CMOS+4,00100000b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ10_Event_Str   ,875h,00000100b,PF_CMOS+4,01000000b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ11_Event_Str   ,875h,00001000b,PF_CMOS+4,10000000b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ12_Event_Str   ,875h,00010000b,PF_CMOS+5,00000001b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ13_Event_Str   ,875h,00100000b,PF_CMOS+5,00000010b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ14_Event_Str   ,875h,01000000b,PF_CMOS+5,00000100b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

DEFINE_ITEM
menuitem <2,\
	  offset IRQ15_Event_Str   ,875h,10000000b,PF_CMOS+5,00001000b,\
	  offset Ena_Str,0,1,Xaxis,Yaxis,00000000b,	     00000000b,offset Std_Help_Str>

endif;	PM_SUPPORT

PM_Feature_END		Label	Near
IF (offset PM_Feature_END) EQ (offset PM_Feature_START)
	PM_STAT 	EQU	0 + ITEMDISABLE
ELSE
	PM_STAT 	EQU	0
ENDIF
;---------------------------------------------------------------------

;R04 - start
ifdef	ACPI_Support
ACPI_Option_Str         db      'ACPI Function      : ',0
endif;	ACPI_Support
;R04 - end

PM_Option_Str		db	'Power Management   : ',0
PM_Option_Var		db	'User Define',0
PM_Auto_String		db	'Disable    ',0
			db	'Min Saving ',0
			db	'Max Saving ',0
			db	'PM Set 4   ',1
			db	'PM Set 5   ',1
			db	'PM Set 6   ',1
			db	'PM Set 7   ',1

ifdef	PM_SUPPORT

ifdef	No_New_HDD_Timer_String
HDD_Timer_Str		db	'HDD Power Down     : ',0
else	;No_New_HDD_Timer_String
HDD_Timer_Str		db	'HDD Off After      : ',0
endif	;No_New_HDD_Timer_String

HDD_Timer_Val		db	'Disable',0
			db	'1 Min  ',0
			db	'2 Min  ',0
			db	'3 Min  ',0
			db	'4 Min  ',0
			db	'5 Min  ',0
			db	'6 Min  ',0
			db	'7 Min  ',0
			db	'8 Min  ',0
			db	'9 Min  ',0
			db	'10 Min ',0
			db	'11 Min ',0
			db	'12 Min ',0
			db	'13 Min ',0
			db	'14 Min ',0
			db	'15 Min ',0
;Rkvn start
ifdef	No_Suspend_Off_HDD
NO_HDD_DWDN_IMMEDIATELY	EQU	1
endif	;No_Suspend_Off_HDD
;Rkvn end
ifdef	NO_HDD_DWDN_IMMEDIATELY
	ifdef	No_New_HDD_Timer_String
			db	'When Suspend',1
	else	;No_New_HDD_Timer_String
			db	'Suspend',1
	endif	;No_New_HDD_Timer_String
else	;NO_HDD_DWDN_IMMEDIATELY
	ifdef	No_New_HDD_Timer_String
			db	'When Suspend',0
	else	;No_New_HDD_Timer_String
			db	'Suspend',0
	endif	;No_New_HDD_Timer_String
endif	;NO_HDD_DWDN_IMMEDIATELY


DozeSpeed_Str		db	'Doze Speed (div by): ',0
DozeSpeed_Val		db	'1',0
			db	'2',0
			db	'3',0
			db	'4',0
			db	'5',0
			db	'6',0
			db	'7',0
			db	'8',0

StbySpeed_Str		db	'Stdby Speed(div by): ',0
StbySpeed_Val		db	'1',0
			db	'2',0
			db	'3',0
			db	'4',0
			db	'5',0
			db	'6',0
			db	'7',0
			db	'8',0
ifndef	NO_SUPPORT_APM12
Modem_Event_Str		db	'MODEM Use IRQ      : ',0
Modem_Event_Val		db	'NA',0
			db	'??',1
			db	'??',1
			db	'3 ',0
			db	'4 ',0
			db	'5 ',0
			db	'??',1
			db	'7 ',0
			db	'??',1
			db	'9 ',0
			db	'10',0
			db	'11',0
			db	'??',1
			db	'??',1
			db	'??',1
			db	'??',1
endif	;NO_SUPPORT_APM12

;R02 - start
ifdef	HOT_KEY_AS_SUSPEND					;R03
SOFTWARE_P_D_Str	db	'Hot Key Suspend    : ',0	;R03
else;	HOT_KEY_AS_SUSPEND					;R03
SOFTWARE_P_D_Str	db	'Hot Key Power Off  : ',0
endif;	HOT_KEY_AS_SUSPEND					;R03
;R02 - end

Timer_Val_Str:
			ADDX	<,7>
			db	V_WARN,'** PM Timers **',0

PM_Event_Str:
			ADDX	<,7>
			db	V_WARN,'** PM Events **',0

Doze_Str		db	'Doze Mode          : ',0

Standby_Str		db	'Standby Mode       : ',0

Suspend_Str		db	'Suspend Mode       : ',0
Doze_Val:
Standby_Val:
Suspend_Val		db	'Disable',0
			db	'20 Sec ',0             ;(3-1)*9
			db	'1 Min  ',0             ;(8-1)*9
			db	'5 Min  ',0             ;(33-1)*9
			db	'10 Min ',0             ;(66-1)*9
			db	'15 Min ',0             ;(101-1)*9
			db	'20 Min ',0             ;(134-1)*9
			db	'30 Min ',0             ;(201-1)*9
			db	'40 Min ',0             ;(256-1)*9

Video_Off_Str		db	'Video Off Option   : ',0
Video_Off_Val		db	'Always On       ',0
			db	'Suspend -> Off  ',0
			db	'Susp,Stby -> Off',0
			db	'All Modes -> Off',0

VGA_Type_Str		db	'Video Off Method   : ',0
VGA_Type_Val		db	'Blank Screen  ',0
			db	'V/H SYNC+Blank',0
			db	'              ',1
			db	'DPMS Supported',0

Switch_Str		db	'Switch Function    : ',0
Switch_Val		db	'Disabled  ',0
			db	'Deturbo   ',0
			db	'Break     ',0
			db	'Break/Wake',0

COM_Event_Str		db	'COM Ports Activity : ',0
LPT_Event_Str		db	'LPT Ports Activity : ',0
HDD_Event_Str		db	'HDD Ports Activity : ',0
Hold_Event_Str		db	'PCI/ISA Master Act.: ',0
Irq_Event_Str		db	'IRQ1-15 Activity   : ',0
VGA_Event_Str		db	'VGA Activity       : ',0

IRQ1_Event_Str		db	'IRQ1  (Keyboard)   : ',0
IRQ3_Event_Str		db	'IRQ3  (COM 2)      : ',0
IRQ4_Event_Str		db	'IRQ4  (COM 1)      : ',0
IRQ5_Event_Str		db	'IRQ5  (LPT 2)      : ',0
IRQ6_Event_Str		db	'IRQ6  (Floppy Disk): ',0
IRQ7_Event_Str		db	'IRQ7  (LPT 1)      : ',0
IRQ8_Event_Str		db	'IRQ8  (RTC Alarm)  : ',0
IRQ9_Event_Str		db	'IRQ9  (IRQ2 Redir) : ',0
IRQ10_Event_Str 	db	'IRQ10 (Reserved)   : ',0
IRQ11_Event_Str 	db	'IRQ11 (Reserved)   : ',0
IRQ12_Event_Str 	db	'IRQ12 (PS/2 Mouse) : ',0
IRQ13_Event_Str 	db	'IRQ13 (Coprocessor): ',0
IRQ14_Event_Str 	db	'IRQ14 (Hard Disk)  : ',0
IRQ15_Event_Str 	db	'IRQ15 (Reserved)   : ',0

Wait_APM_Str		db	'PM Control by APM  : ',0
Wait_APM_Val		db	'No ',0
			db	'Yes',0


IFDEF	NoteBook_Power_Management
Suspend_Option_Str	db	'Suspend Option     : ',0
Suspend_Option_Val	db	'Static Suspend',0
			db	'0V Suspend    ',0
			db	'5V Suspend    ',1
ENDIF	;NoteBook_Power_Management

ifdef	NETWORK_SUSPEND_DISABLE
NetCard_Str		db	'Network Installed  : ',0
endif	;NETWORK_SUSPEND_DISABLE
;R01 - start
ifdef	ABIT_GPCS
ABIT_fan_Str		db	'CPU Fan Off in Sus.: ',0
endif	;ABIT_GPCS
;R01 - end

ifdef	No_New_HDD_Timer_String
Show_Hdd_Timer	Proc	Near
		cmp	al,Special_Before
		je	short Show_Hdd_Timer_Exit

		call	VNormal
		mov	si,offset Blank_5
		call	Display_String

Show_Hdd_Timer_Exit:

		ret

Show_Hdd_Timer	Endp

Blank_5 	db	'     ',0
endif	;No_New_HDD_Timer_String

ifdef	REDUCE_P5_SETUP
P5_Unshow	Proc	Near
		cmp	byte ptr CPU_INT_CLOCK[bp],70
		jae	short @F			;P5 need special
		call	Self_Disable
		stc
@@:
		ret
P5_Unshow	Endp
endif	;REDUCE_P5_SETUP

ifdef	NETWORK_SUSPEND_DISABLE
Show_NetCard	Proc	Near
		mov	di,offset Show_NetCard_Tbl
		mov	cx,1
		call	If_CX_Then_Dis
		clc
		ret
Show_NetCard	Endp
Show_NetCard_Tbl:
		dw	offset Suspend_Item
		dw	-1
endif	;NETWORK_SUSPEND_DISABLE

endif	;PM_SUPPORT


FCODE		ENDS
		END
