;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;                       PM_RAM.ASM

;----------------------------------------------------------------------------
;Rev    Date      Name  Description
;----------------------------------------------------------------------------
;R01B	01/15/97  KVN	Always no overflow error message even BIOS run time
;			code over 0FE000h
;R01A	01/13/97  DNL	Rewrite codes to make R01 reasonable
;R01	01/13/96  RAY	Add customization PM_RAM_SIZE & default the PM RAM
;			size for notebook as 96 bytes

.386P
;[]-----------------------------------[]
;
;   Award Software 386/486 BIOS
;    Base + Initialization Rtns
;   Initial Revision 17-Apr-1990
;
;[]-----------------------------------[]

.XLIST
.LIST
		INCLUDE	BIOS.CFG

DGROUP		GROUP	FCODE
;R01A FCODE		SEGMENT	USE16 PARA PUBLIC 'CODE'
;R01B FCODE           SEGMENT DWORD COMMON 'CODE'		;R01A
FCODE		SEGMENT	USE16 PARA PUBLIC 'CODE'		;R01B
                ASSUME  CS:DGROUP

ifdef	PM_SUPPORT

;R01A ifndef	PM_RAM_SIZE					;R01
;R01A ifdef	NOTEBOOK_POWER_MANAGEMENT			;R01
;R01A 	PM_RAM_SIZE	EQU	96			;R01
;R01A else	;NOTEBOOK_POWER_MANAGEMENT			;R01
;R01A 	PM_RAM_SIZE	EQU	64
;R01A endif	;NOTEBOOK_POWER_MANAGEMENT			;R01
;R01A endif	;PM_RAM_SIZE					;R01
;R01A 
;R01A 		DB	PM_RAM_SIZE dup (0)

;R01A - start
;R01BPM_RAM_ORG	=	( PM_RAM_SEGMENT - 0F000h ) shl 4
;R01B		ORG	PM_RAM_ORG

PM_RAM_SIZE	EQU	( 0FE00h - PM_RAM_SEGMENT ) shl 4
		DB	PM_RAM_SIZE dup (0)
;R01A - end

endif	;PM_SUPPORT

FCODE           ENDS
		END
