;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

		PAGE	60,132
		TITLE	POST  -- 386 ROM/BIOS POST
;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;----------------------------------------------------------------------------
;R14	12/24/97 TNY	Add "Show_Press_TAB_Middle" definition.
;R13A	12/24/97 LAW	Cann't show Halt_err_msg, If use full_screen_logo 
;R13	12/18/97 LAW	change "EPA_LOGO_Use_Graphics" with "FULL_SCREEN_LOGO"
;			switch to "Graphics_post"
;R12	11/25/97 LAW	change postmsg position for define "EPA_LOGO_Use_Graphics"
;R11	04/03/97 RCH	Change year of copyright and fix spelling error
;R09A	03/11/97 RCH	Redefine setup key string changeable switch
;R10	03/07/97 TNY	Add "No_Show_Graphic_POST_MSG" definition.
;R09	11/20/96 RAY	Add special option key for entering setup
;R08	10/29/96 STV	Added HDD low level format write-protected error message  
;R07	09/23/96 DNL	Added codes for Notebook Power Management
;R06	07/23/96 KGN	Add defin No_ENTER_SETUP_Message for Special Customer
;R05	05/10/96 KVN	Display exact HDD fail drive
;R04	04/17/96 RAY	Somebody don't want 'DEL' key to enter setup
;R03	01/12/96 KVN	Added full screen logo display function
;R02	11/16/95 KVN	Remove all POST message to E000h
;R01A	07/21/95 KVN	Remove HDD access mode error
;R01	07/15/95 KVN	Added HDD access mode error


		INCLUDE BIOS.CFG

		INCLUDE	COMMON.MAC
		INCLUDE	POST.MAC					

		INCLUDE	POST.EQU  

		INCLUDE	SETUP.EXT
		INCLUDE	USERINT.EXT

ifndef	NO_HDD_LOW_LEVEL_FORMAT
		extrn	BASE_HIGH:ABS
		extrn	BASE_WIDE:ABS
		extrn	SECOND_ROW:ABS
endif	;NO_HDD_LOW_LEVEL_FORMAT
		extrn	Disp_Access_mode:near	;R01


;R02DGROUP		GROUP	FCODE
;R02FCODE		SEGMENT	PARA PUBLIC 'CODE'
;R02		ASSUME	CS:DGROUP,DS:DGROUP
;R02 start
EGROUP		GROUP	ECODE
ECODE		SEGMENT PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP,DS:EGROUP
;R02 end

;--------------- Low Level Format String (LOFORMAT.ASM) -----------------
ifndef	NO_HDD_LOW_LEVEL_FORMAT
		public	No_Hdd_Str
		public	Init_Hdd_Str
		public	PREFORMAT_STR
		public	main_key
		public	CY_HD
		public	func_command
		public	format_key
		public	drive_write_protected_msg     ;R08
		public	format_warn
		public	search_intl
		public	cyl_head_same
		public	func0_window
		public	func1_window
		public	func2_window
		public	drive_err_msg
		public	test_intl_msg	
		public	CY_HD_LEN
		public	func_len
		public	FUNC_MAX
		public	for_key_len
		public	for_warn_len
		public	ch_same_len
		public	func0_len
		public	func1_len
		public	func2_len
		public	tmout_msg_len
		public	wprotect_msg_len      ;R08
		public	func_win_str
		public	clear_track_str

No_Hdd_Str:
		db	V_REVERSE
		BORDER1	<,24,11,52,14,0+Empty_Border>
;		CLEAR	<,25,12,51,13>
		POS	<,26,12>
		db	'HARD DISK INSTALL FAILURE'
		POS	<,26,13>
		db	'PRESS ANY KEY TO CONTINUE'
		db	0
Init_Hdd_Str:
		db	V_REVERSE
		BORDER1	<,24,8,52,11,0+Empty_Border>
;		CLEAR	<,25,12,51,13>
		POS	<,26,9>
		db	' HARD DISK initializing  '
		POS	<,26,10>
		db	' Please wait a moment... '
		ADDY	<,1>
		db	0

PREFORMAT_STR	DB	V_NORMAL
;		CLEAR	<,0,0,79,15>
		BORDER1	<,0,0,59,15,1+Empty_Border>
		BORDER1	<,59,0,79,15,1+Empty_Border>		
		POS	<,13,1>
		DB	'Hard Disk Low Level Format Utility'
		POS	<,11,2>
		DB	''
		POS	<,BASE_WIDE+1,1>
		DB	'  NO.  CYLS HEAD'
		POS	<,BASE_WIDE,2>			
		DB	''			
		BORDER1	<,0,15,79,21,1>				
;
		DB	V_REVERSE
		POS	<,BASE_WIDE+2,>
		DB	'BAD TRACKS TABLE'
;;main_key	DB	V_WARN
main_key	DB	V_NORMAL
		BORDER1	<,0,21,79,24,1+Empty_Border>		
		POS	<,2,BASE_HIGH+6>
		DB	'Up/Down-Select item           ENTER-Accept                  ESC-Exit/Abort'
		POS	<,9,BASE_HIGH+7>
		DB	'Copyright (c) Award Software, Inc. 1992-97 All Rights Reserved'	;R11
		POS	<,59,0>
		DB	''
		POS	<,0,15>
		DB	''
		POS	<,59,15>
		DB	''
		POS	<,79,15>
		DB	''
		POS	<,0,21>
		DB	''
		POS	<,79,21>
		DB	''
CY_HD		DB	V_REVERSE
		POS	<,30-CY_HD_LEN/2,BASE_HIGH-2>
		DB	' DRIVE : C   CYLINDER :    0   HEAD :  0 '
CY_HD_LEN	EQU	$-offset CY_HD-1
CY_HD_LEN_half	EQU	CY_HD_LEN/2
		DB	0
;
;full_screen	DB	V_NORMAL
;		CLEAR	<,0,0,79,24>
;		DB	0
;
func_command	POS	<,31-func_len/2,4>
		DB	'   SELECT DRIVE   ',0
func_len	EQU	$-offset func_command
func_len_half	EQU	func_len/2
		POS	<,31-func_len/2,5>
		DB	'  BAD TRACK LIST  ',0
		POS	<,31-func_len/2,6>
		DB	'    PREFORMAT     ',0
FUNC_MAX	EQU	($-offset func_command)/func_len-1
format_key:	
		POS	<,30-for_key_len/2,BASE_HIGH-1>
		DB	'    <<< Press [ESC] to abort >>>    ',0
for_key_len	EQU	$-offset format_key-4
for_key_len_half	EQU	for_key_len/2
format_warn:
		POS	<,30-for_warn_len/2,BASE_HIGH-3>
		DB	'Enter will destroy all data on current drive...(y/n)',0
for_warn_len	EQU	$-offset format_warn-4
for_warn_len_half	EQU	for_warn_len/2
search_intl:
		POS	<,30-for_key_len/2,BASE_HIGH-1>
		DB	' Search optimum interleave ..WAIT.. ',0
cyl_head_same:	
		POS	<,30-ch_same_len/2,BASE_HIGH-1>
		DB	' CYLINDER & HEAD number already exist !! ',0
ch_same_len	EQU	$-offset cyl_head_same-4
ch_same_len_half	EQU	ch_same_len/2
func0_window	DB	V_NORMAL
		POS	<,1+30-func0_len/2,SECOND_ROW+3>
		DB	'Current select drive is :'
		DB	0
func0_len	EQU	$-offset func0_window
func1_window	DB	V_NORMAL
		POS	<,1+30-func1_len/2,SECOND_ROW+1>
		DB	' Auto scan bad track '
func1_len	EQU	$-offset func1_window
func1_len_half	EQU	func1_len/2
		POS	<,1+30-func1_len/2,SECOND_ROW+2>
		DB	'    Add bad track'
		POS	<,1+30-func1_len/2,SECOND_ROW+3>
		DB	'  Modify bad track'
		POS	<,1+30-func1_len/2,SECOND_ROW+4>
		DB	'  Delete bad track'
		POS	<,1+30-func1_len/2,SECOND_ROW+5>
		DB	'Clear bad track table'
		DB	0
func2_window	DB	V_NORMAL
		POS	<,1+30-func2_len/2,SECOND_ROW+2>
		DB	'   Interleave (1-8) :   (0 for auto detect)'
func2_len	EQU	$-offset func2_window
		POS	<,1+30-func2_len/2,SECOND_ROW+3>
		DB	'Auto scan bad track :'
		POS	<,1+30-func2_len/2,SECOND_ROW+4>
		DB	'              START :'
		DB	0

;R08 start
drive_write_protected_msg:
		POS	<,30-tmout_msg_len/2,BASE_HIGH-1>
		DB	' Drive write-protected. Press any key to continue...',0
wprotect_msg_len	EQU	$-offset drive_write_protected_msg-4
wprotect_msg_len_half	EQU	tmout_msg_len/2

;R08 end
drive_err_msg:
		POS	<,30-tmout_msg_len/2,BASE_HIGH-1>
		DB	' Drive not ready. Press any key to continue... ',0
tmout_msg_len	EQU	$-offset drive_err_msg-4
tmout_msg_len_half	EQU	tmout_msg_len/2
test_intl_msg	DB	V_HILITE
		BORDER1	<,46,SECOND_ROW-2,75,SECOND_ROW+4>
		DB	V_NORMAL
		POS	<,47,SECOND_ROW-1>
		DB	' Interleave   Transfer-rate '
		POS	<,47,SECOND_ROW>
		DB	'     1             0 KB     '
		POS	<,47,SECOND_ROW+1>
		DB	'     2             0 KB     '
		POS	<,47,SECOND_ROW+2>
		DB	'     3             0 KB     '
		POS	<,47,SECOND_ROW+3>
		DB	'     4             0 KB     '
		DB	0
func_win_str	DB	V_NORMAL
		CLEAR	<,1+1,SECOND_ROW+1,BASE_WIDE-2,BASE_HIGH-3>
		DB	0
clear_track_str	DB	V_NORMAL
		CLEAR	<,BASE_WIDE+1,3,78,BASE_HIGH-2>
		DB	0
endif	;NO_HDD_LOW_LEVEL_FORMAT
;----------------------------------------------------------------------------

;--------------- POSTMSG.001 -----------------
ifndef	Special_Bad_CMOS_Message
			PUBLIC	CKSM_ERROR_MSG
CKSM_ERROR_MSG:
			db	'CMOS checksum error - Defaults loaded',0
endif	;Special_Bad_CMOS_Message

			PUBLIC	BATTERY_FAIL_MSG
BATTERY_FAIL_MSG:
			db	'CMOS battery failed',0

			PUBLIC	OVERRIDE_ENABLE_STR
OVERRIDE_ENABLE_STR:
			db	'Override enabled - Defaults loaded',0

ifdef	PM_SUPPORT					;128k
		public	PM_Sign_On_Msg			;128k
PM_Sign_On_Msg:
		db	', An Energy Star Ally',0	;128k
endif;	PM_SUPPORT					;128k

;--------------- POSTMSG1.001 -----------------
			PUBLIC	TEST_MEM_MSG
			PUBLIC	OK_MSG
			PUBLIC	K1_MSG
			Public	CPU_Type_Clk
			PUBLIC	VID_SWITCH_MSG
			PUBLIC	KBD_ERR_MSG
			PUBLIC	KEY_LOCK_MSG
;R131			PUBLIC	MFG_POST_MSG
  			PUBLIC	ROM_MODULE_MSG
;xxxx			PUBLIC	BIOS_CKSM_ERROR_STR
			PUBLIC	MEM_ERROR_MSG		

TEST_MEM_MSG:
			db	'Memory Test : ',0
OK_MSG:
			db	'K OK',0
K1_MSG:
			db	'K: ',0
CPU_Type_Clk:
			db	' CPU at ',0
VID_SWITCH_MSG:
			db	'Display switch is set incorrectly.',0
KEY_LOCK_MSG:
			db	'Keyboard is locked out - Unlock the key',0
KBD_ERR_MSG:
			db	'Keyboard error or no keyboard present',0
;R131 MFG_POST_MSG:
;R131 			db	'Manufacturing POST loop',0
ROM_MODULE_MSG:
			db	'ROM',0
;xxxxBIOS_CKSM_ERROR_STR:
;xxxx			db	'BIOS ROM checksum error - System halted',0
MEM_ERROR_MSG:
			db	'Memory test fail',0

;--------------- POSTMSG2.001 -----------------
		PUBLIC	HALT_ERR_MSG	   
ifdef	Graphics_Post					;R13A
		PUBLIC	FULL_HALT_MSG			;R13A
endif;	Graphics_Post					;R13A
		PUBLIC	TEST_EXT_MSG
		PUBLIC	TO_ENTER_SETUP
		PUBLIC	FLOPPY_RESET_MSG
		PUBLIC	FLOPPY_MISMATCH_MSG
;R05		PUBLIC	UNABLE_RESET_MSG
		PUBLIC	FIXED_DIAG_MSG
;R05		PUBLIC	UNABLE_INIT_MSG
;R05		PUBLIC	UNABLE_RECALIBRATE_MSG
;R05		PUBLIC	SECTOR_VERIFY_MSG
;R05 start
		public	HDD_Drive0_Err_Str
		public	HDD_Drive1_Err_Str
		public	HDD_Drive2_Err_Str
		public	HDD_Drive3_Err_Str
;R05 end

HALT_ERR_MSG:
;R13ifndef	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,0,23>
;R13else;	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,0,28>
;R13endif;	EPA_LOGO_Use_Graphics			;R12
ifndef	Graphics_Post					;R13
		POS	<,0,23>				;R13
else;	Graphics_Post					;R13
		POS	<,0,28>				;R13
endif;	Graphics_Post					;R13
		db	V_NORMAL,'Press '
		db	V_HILITE,'F1'
		db	V_NORMAL,' to continue,'
;R02		STRSHOW	<,,,offset DGROUP:To_Enter_Setup_1>
		STRSHOW	<,,,offset To_Enter_Setup_1>	;R02
		db	'      ',0
;R13A - start
ifdef	Graphics_Post
FULL_HALT_MSG:
		POS	<,0,23>
		db	V_NORMAL,'Press '
		db	V_HILITE,'F1'
		db	V_NORMAL,' to continue,'
		STRSHOW	<,,,offset To_Enter_Setup_1>
		db	'      ',0
endif;	Graphics_Post
;R13A - end

TEST_EXT_MSG:
		POS	<,14,>
		db	0

TO_ENTER_SETUP:
ifdef	No_ENTER_SETUP_Message			;R06
		db	0			;R06
endif	;No_ENTER_SETUP_Message			;R06
;R13ifndef	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,0,23>
;R13else;	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,0,28>			;R12
;R13endif;	EPA_LOGO_Use_Graphics			;R12
ifndef	Graphics_Post				;R13
		POS	<,0,23>			;R13
else;	Graphics_Post				;R13
		POS	<,0,28>			;R13
endif;	Graphics_Post				;R13
		db	V_NORMAL,'Press'
To_Enter_Setup_1:
		db	' '
ifdef	NO_DEL_KEY_ENTER_SETUP			;R04
;R09A 	ifdef	KEY_SETUP_SCAN_CODE				;R09
 	ifdef	KEY_SETUP_STRING				;R09A
		db	V_HILITE,KEY_SETUP_STRING		;R09
	else	;KEY_SETUP_SCAN_CODE				;R09
		db	V_HILITE,'CTRL+ALT+ESC'	;R04
 	endif	;KEY_SETUP_SCAN_CODE				;R09
else	;NO_DEL_KEY_ENTER_SETUP			;R04
		db	V_HILITE,'DEL'
endif	;NO_DEL_KEY_ENTER_SETUP			;R04
		db	V_NORMAL,' to enter SETUP',0

FLOPPY_RESET_MSG:
FLOPPY_MISMATCH_MSG:
		db	'Floppy disk(s) fail (  )'
		SUBX	<,3>
		db	0

;R05 UNABLE_RESET_MSG:
FIXED_DIAG_MSG:
;R05 UNABLE_INIT_MSG:
;R05 UNABLE_RECALIBRATE_MSG:
;R05 SECTOR_VERIFY_MSG:
;R05 		db	'Hard disk(s) fail (  )'
;R05 		SUBX	<,3>
;R05 		db	0
;R05 start
		db	'Hard disk(s) Diagnosis fail',0
HDD_Drive0_Err_Str:
		db	'Primary master hard disk fail',0
HDD_Drive1_Err_Str:
		db	'Primary slave hard disk fail',0
HDD_Drive2_Err_Str:
		db	'Secondary master hard disk fail',0
HDD_Drive3_Err_Str:
		db	'Secondary slave hard disk fail',0
;R05 end

;--------------- POSTMSG3.001 -----------------
		PUBLIC	SKIP_MEM_MSG
		PUBLIC	BTM_LINE_CLR
		Public	CLR_SKIP_MEM_MSG

SKIP_MEM_MSG:
ifdef	No_ENTER_SETUP_Message			;R06
		db	0			;R06
endif	;No_ENTER_SETUP_Message			;R06
ifdef	NO_DEL_KEY_ENTER_SETUP			;R04
;R13ifndef	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,33,23>		;R04
;R13else;	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,33,28>		;R12
;R13endif;	EPA_LOGO_Use_Graphics			;R12
ifndef	Graphics_Post					;R13
		POS	<,33,23>			;R13
else;	Graphics_Post					;R13
		POS	<,33,28>			;R13
endif;	Graphics_Post					;R13
else	;NO_DEL_KEY_ENTER_SETUP			;R04
;R13ifndef	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,24,23>
;R13else;	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,24,28>		;R12
;R13endif;	EPA_LOGO_Use_Graphics			;R12
ifndef	Graphics_Post					;R13
		POS	<,24,23>			;R13
else;	Graphics_Post					;R13
		POS	<,24,28>			;R13
endif;	Graphics_Post					;R13
endif	;NO_DEL_KEY_ENTER_SETUP			;R04
		db	V_NORMAL,', '
		db	V_HILITE,'ESC'
		db	V_NORMAL,' to skip memory test',0

CLR_SKIP_MEM_MSG:
ifdef	NO_DEL_KEY_ENTER_SETUP			;R04
;R13ifndef	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,33,23>		;R04
;R13else;	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,33,28>		;R12
;R13endif;	EPA_LOGO_Use_Graphics			;R12
ifndef	Graphics_Post					;R13
		POS	<,33,23>			;R13
else;	Graphics_Post					;R13
		POS	<,33,28>			;R13
endif;	Graphics_Post					;R13
else	;NO_DEL_KEY_ENTER_SETUP			;R04
;R13ifndef	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,24,23>
;R13else;	EPA_LOGO_Use_Graphics			;R12
;R13		POS	<,24,28>		;R12
;R13endif;	EPA_LOGO_Use_Graphics			;R12
ifndef	Graphics_Post					;R13
		POS	<,24,23>			;R13
else;	Graphics_Post					;R13
		POS	<,24,28>			;R13
endif;	Graphics_Post					;R13
endif	;NO_DEL_KEY_ENTER_SETUP			;R04
		db	V_NORMAL,'                         ',0

;R13ifndef	EPA_LOGO_Use_Graphics			;R12
;R13BTM_LINE_CLR:	CLEAR	<,0,22,79,24>
;R13else;	EPA_LOGO_Use_Graphics			;R12
;R13BTM_LINE_CLR:	CLEAR	<,0,27,79,29>		;R12
;R13endif;	EPA_LOGO_Use_Graphics			;R12
ifndef	Graphics_Post					;R13
BTM_LINE_CLR:	CLEAR	<,0,22,79,24>			;R13
else;	Graphics_Post					;R13
BTM_LINE_CLR:	CLEAR	<,0,27,79,29>			;R13
endif;	Graphics_Post					;R13
		db	0

;R03 start
;R13ifdef FULL_SCREEN_LOGO
ifdef	Graphics_Post					;R13
ifndef	No_Show_Graphic_POST_MSG			;R10
		public	Graphic_POST_MSG
Graphic_POST_MSG:
ifdef	Show_Press_TAB_Middle				;R14
		POS	<,15,29>			;R14
else;	Show_Press_TAB_Middle				;R14
		POS	<,0,29>
endif;	Show_Press_TAB_Middle				;R14
		db	V_NORMAL,'Press '
		db	V_HILITE,'TAB'
		db	V_NORMAL,' to show POST screen,'
		STRSHOW	<,,,offset To_Enter_Setup_1>
		db	'      ',0
endif;	No_Show_Graphic_POST_MSG			;R10
;R07 - start
ifdef	Notebook_Power_Management
		public	Resume_POST_MSG
Resume_POST_MSG:
		POS	<,0,29>
		db	V_NORMAL,'Resuming from disk, Press '	;R11
		db	V_HILITE,'TAB'
		db	V_NORMAL,' to show POST screen.'
		db	'      ',0
endif	;Notebook_Power_Management
;R07 - end
endif;	Graphics_Post					;R13
;R13endif ;FULL_SCREEN_LOGO
;R03 end
				 
comment %					;R01A
;R01 start
		public	HDD0_MODE_NOT_MATCH_MSG
HDD0_MODE_NOT_MATCH_MSG:
		db	'Primary Master '
		STRSHOW	<,,,offset DGROUP:HDD_MODE_NOT_MATCH_MSG>
		db	0
		public	HDD1_MODE_NOT_MATCH_MSG
HDD1_MODE_NOT_MATCH_MSG:
		db	'Primary slave '
		STRSHOW	<,,,offset DGROUP:HDD_MODE_NOT_MATCH_MSG>
		db	0
		public	HDD2_MODE_NOT_MATCH_MSG
HDD2_MODE_NOT_MATCH_MSG:
		db	'Secondary Master '
		STRSHOW	<,,,offset DGROUP:HDD_MODE_NOT_MATCH_MSG>
		db	0
		public	HDD3_MODE_NOT_MATCH_MSG
HDD3_MODE_NOT_MATCH_MSG:
		db	'Secondary Slave '
		STRSHOW	<,,,offset DGROUP:HDD_MODE_NOT_MATCH_MSG>
		db	0
HDD_MODE_NOT_MATCH_MSG:
		db	'HDD access mode ('
		CALLROUTINE	<,offset Disp_Access_mode>
		SUBX	<,1>
		db	') not match with SETUP',0
;R01 end
%						;R01A

;R02FCODE		ENDS
ECODE		ENDS				;R02
		END
