;	[]===========================================================[]
;
;	NOTICE: THIS PROGRAM BELONGS TO AWARD SOFTWARE INTERNATIONAL(R)
;	        INC. IT IS CONSIDERED A TRADE SECRET AND IS NOT TO BE 	
;	        DIVULGED OR USED BY PARTIES WHO HAVE NOT RECEIVED	
;	        WRITTEN AUTHORIZATION FROM THE OWNER.
;
; 	[]===========================================================[]
;

;		PAGE	60,132
;		TITLE	POST  -- 386 ROM/BIOS POST
;----------------------------------------------------------------------------
;Rev	Date	 Name	Description
;---------------------------------------------------------------------------
;R09	10/23/97 KVN	Show all IDE device on system config table if define
;			support LS120/ZIP/CDROM in BIOS.CFG
;R08	10/08/97 RIC	Add "ONCHIP_2ND_ALWAYS_DISABL" define.
;R07	08/21/97 BAR	Added S.M.A.R.T. function
;R06	07/05/97 RAY	Add X_GetItem_Value
;R05	07/01/97 JSN	Add Config_Tbl_Lines define.
;R04	06/12/97 KVN	Definition all GROUP of BIOS before all source file
;			that you can create any GROUP in every ASM file and
;			move source code into any GROUP to save another GROUP
;			code space
;R03	06/11/97 RCH	Fixed compiler error for without "NEW_IDE_MODE_3"
;			switch.
;R02A	06/10/97 KVN	Fixed compiler error in MP system
;R02	06/10/97 JKY	Fixed compiler error in NoteBook
;R01	06/06/97 KVN	Move 'Show_system_cfg' subroutine from E8POST.ASM to
;			save E8 code space


.386P
		INCLUDE BIOS.CFG
		INCLUDE COMMON.EQU
		INCLUDE COMMON.MAC

;R01 start
ifndef	No_Support_4_IDE
Support_4_IDE		EQU	1
endif	;No_Support_4_IDE

		include	post.equ

		public	SHOW_SYSTEM_CFG
		public	XCALL_PROC
		public	RIGHT_SIDE
		public	CDROM_STR
		public	ARMD_STR
		public	IOMEGA_ZIP_STR
		public	NONE_STR
		public	MB_STR
		public	HDD_MODE_STR

ifdef	NEW_IDE_MODE_3					;R03
		extrn	IdeA_Mode_Item:near
		extrn	IdeB_Mode_Item:near
 ifdef	Support_4_IDE					;R03
  ifndef  ONCHIP_2ND_ALWAYS_DISABLE			;R08
		extrn	IdeC_Mode_Item:near
		extrn	IdeD_Mode_Item:near
  endif;  ONCHIP_2ND_ALWAYS_DISABLE			;R08
 endif;	Support_4_IDE					;R03
endif;	NEW_IDE_MODE_3					;R03

		extrn	Display_String:near
		extrn	HDISK_PARMS:near
		extrn	Disp_Access_mode:near
		extrn	Get_HDD_CMOS_Info:near
		extrn	SHOW_SIX_DIGIT:near
		extrn	Disp_Dword_Int6:near
		extrn	SHOW_SIX_DIGIT:near
		extrn	AX_TO_HEX3:near
		extrn	AX_TO_DEC3:near
		extrn	AX_TO_DEC2:near
		extrn	Read_Item_Value:near
		extrn	Get_VarString_Offset:near
		extrn	post_call_proc:near
		extrn	MONO_STYLE:near
		extrn	DISP_STR_IN_BIOS:near
		extrn	CPU_DISPLAY:near
		extrn	DISP_STR_IN_POST:near
		extrn	DISP_EXTRA_CPU_INFO:near
		extrn	TRY_SHOW_PRATING:near
ifndef	Support_1_FDD					;R02
		extrn	SWAPFLOPPY_ITEM:near
endif	;Support_1_FDD					;R02
		extrn	F000_GETITEM_VALUE:near
		extrn	GETITEM_VALUE:near		;R06
		extrn	DRIVE_A_ITEM:near
ifndef	Support_1_FDD					;R02
		extrn	DRIVE_B_ITEM:near
endif	;Support_1_FDD					;R02
		extrn	TRAN_HDD_USER_TYPE:near
		extrn	F000_CALL_PROC:near
		extrn	GET_CACHE_SIZE:near
		extrn	F000_CALL_PROC:near
		extrn	EXTCACHE_ITEM:near
		extrn	CONVERT_P6L2_CACHE:near
		extrn	GET_CACHE_SIZE:near
		extrn	F000_CALL_PROC:near
		extrn	DISP_WORD_INT5:near
		extrn	F000_CALL_PROC:near
		extrn	F000_DISPLAY_CHAR:near
		extrn	VIDEO_ITEM:near
		extrn	CT_SHOW_CONFIG:near
		extrn	F000_CALL_PROC:near
		extrn	SYSTEM1_BYTE:near
		extrn	VCRLF:near
		extrn	DISP_WORD_HEX4:near
		extrn	F000_CALL_PROC:near
		extrn	DISP_WORD_HEX4:near
		extrn	F000_CALL_PROC:near
	ifdef	CONFIG_MECHANISM_1
		extrn	FPROC_QUALIFY_PCIBUS:far
	endif	;CONFIG_MECHANISM_1
		extrn	DISP_BYTE_INT2:near
		extrn	F000_CALL_PROC:near

		extrn	HDDC_ITEM:near
		extrn	HDDD_ITEM:near
ifdef	Support_4_IDE
		extrn	HDDE_ITEM:near
		extrn	HDDF_ITEM:near
endif	;Support_4_IDE
;R01 end

ifdef	MP_SUPPORT				;R02A
		extrn	If_MP_PLUGGED:near	;R02A
endif	;MP_SUPPORT				;R02A

;R02 start
IFDEF	NoteBook_Power_Management
		Extrn	Show_PM_Config:near
endif	;NoteBook_Power_Management
;R02 end

G_RAM		SEGMENT USE16 AT 0

		ORG	04H*4
		INCLUDE SEG_0.INC

		ORG	400H
		INCLUDE G_RAM.INC

G_RAM		ENDS

		PAGE

;R04 start
EGROUP		GROUP	ECODE
ECODE		SEGMENT USE16 PARA PUBLIC 'ECODE'
		ASSUME	CS:EGROUP
ECODE		ENDS

DGROUP		GROUP	FCODE
FCODE		SEGMENT PARA PUBLIC 'CODE'
		ASSUME	CS:DGROUP
FCODE		ENDS

DGROUP		GROUP	@DATAC
@DATAC		SEGMENT	USE16 DWORD COMMON 'DATAC'
		ASSUME	CS:DGROUP
@DATAC		ENDS
;R04 end

XGROUP		GROUP	XCODE
XCODE		SEGMENT USE16 PARA PUBLIC 'XCODE'
		ASSUME	CS:XGROUP,ES:XGROUP


X_call_VECT:
		retn
X_call_end:
		retf

		public	Xcall_proc
Xcall_proc:
		push	offset X_call_end
		push	ax
		pushf
		cli
		xchg	bp,sp
		mov	ax,[bp+4]
		xchg	ax,[bp+6]
		mov	[bp+4],ax
		xchg	bp,sp
		popf
		pop	ax
		jmp	short X_call_VECT

;R01 start
Show_System_Cfg Proc	Near
		push	ds
		push	es
		mov	ax,G_RAM
		mov	es,ax
		assume	es:G_RAM

		push	cs
		pop	ds

;--------------- Show Border ----------------------------------

		mov	word ptr Color_Offset[bp],offset Mono_Style
		mov	si,offset SYSTEM_CONFIG_MSG
		post_func_call	Disp_Str_In_BIOS

;--------------- Show CPU_Type ---------------------

		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+1) shl 8) + (LEFT_SIDE+20)
		push	0F000h
		pop	ds
		post_func_call	CPU_Display
		post_func_call	Disp_Str_In_POST
		post_func_call	Disp_Extra_CPU_Info
IF	BIOS_SUPPORT_586
ifdef	DISP_MHZ_FOR_AMD_CYRIX
		mov	di, 1				;show '-'
		post_func_call	Try_Show_PRating
	_11OLK:
endif	;DISP_MHZ_FOR_AMD_CYRIX
ENDIF	;BIOS_SUPPORT_586

;-------------- Show Math Coprocessor --------------

		push	cs
		pop	ds
		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+2) shl 8) + (LEFT_SIDE+20)
		mov	si,offset Not_Install_Str
		test	byte ptr FIXED_DISK_STEP[bp],01h
		jz	short @F
		mov	si,offset Install_Str
	@@:
		post_func_call	Disp_Str_In_BIOS

;---------------- Show CPU Clock ----------------------

		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+3) shl 8) + (LEFT_SIDE+20)

IF	BIOS_SUPPORT_586
ifndef	DISP_MHZ_FOR_AMD_CYRIX
		xor	di, di			;do not show '-'
 		post_func_call	Try_Show_PRating	;show p-rating for K5 & M1
		jnc	short End_Sys_Clk	;show p-rating successfully
	No_Show_P_Rating:
endif	;DISP_MHZ_FOR_AMD_CYRIX
ENDIF	;BIOS_SUPPORT_586

		call	SysCfg_CPU_Clock1

	End_Sys_Clk:
;---------------- Show Floppy Drive A ----------------------
ifndef	Support_1_FDD
ifndef	SWAP_FDD_SHOW
		test	byte ptr FLOPPY_TYPE[bp],00001111b
		jz	short @F
		mov	si,offset SwapFloppy_Item
;R06		post_func_call	F000_GetItem_Value
		call	X_GetItem_Value				;R06
		or	al,al
		jz	short @F
		rol	byte ptr FLOPPY_TYPE[bp],4
@@:
endif;	SWAP_FDD_SHOW
endif	;Support_1_FDD

		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+5) shl 8) + (LEFT_SIDE+20)
		mov	bx,offset DRIVE_A_ITEM
		call	Show_CMOS_Str

;---------------- Floppy Drive B ----------------------

ifndef	Support_1_FDD
		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+6) shl 8) + (LEFT_SIDE+20)
		mov	bx,offset DRIVE_B_ITEM
		call	Show_CMOS_Str
endif	;Support_1_FDD

;---------------- Show Hard Drive C ----------------------

		F000_call	Tran_HDD_User_Type

		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+7) shl 8) + (LEFT_SIDE+20)
		test	byte ptr CDROM_Exist_Flag[bp],PM_CDROM
		jz	short @F
		xor	di,di
;R09		call	Display_CDROM
		call	Display_ATAPI		;R09
		jmp	short Show_DriveD
@@:
		test	byte ptr FIXED_ERROR[bp],HDD_Drive0_Err
		jz	short @F
		call	Display_None
		jmp	short Show_DriveD
@@:
		mov	bx,offset HDDC_ITEM
		mov	al,CMOS12[bp]
		and	al,0f0h
		cmp	al,0f0h
		je	short @F
		shr	al,4
		mov	CMOS19[bp],al
	@@:
ifdef	NEW_IDE_MODE_3
		xor	di,di
endif	;NEW_IDE_MODE_3
		mov	al,es:[HDD_MODE_FLAG]
		and	al,3			; get drive C mode (LBA or Normal ...)
		call	SYSCFG_HDD

;---------------- Show Hard Drive D ----------------------
Show_DriveD:

ifndef	IDE_PRIMARY_ONLY
		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+8) shl 8) + (LEFT_SIDE+20)
		test	byte ptr CDROM_Exist_Flag[bp],PS_CDROM
		jz	short @F
		mov	di,1
;R09		call	Display_CDROM
		call	Display_ATAPI		;R09
		jmp	short Show_DriveE
@@:
		test	byte ptr FIXED_ERROR[bp],HDD_Drive1_Err
		jz	short @F
		call	Display_None
		jmp	short Show_DriveE
@@:
		mov	bx,offset HDDD_ITEM
		mov	al,CMOS12[bp]
		and	al,0fh
		cmp	al,0fh
		je	short @F
		mov	CMOS1A[bp],al
	@@:
		mov	di,1
		mov	al,es:[HDD_MODE_FLAG]
		shr	al,2
		and	al,3
		call	SYSCFG_HDD
endif	;IDE_PRIMARY_ONLY
Show_DriveE:
ifdef	Support_4_IDE

;---------------- Show Hard Drive E ----------------------
ifdef	IDE_PRIMARY_ONLY
		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+8) shl 8) + (LEFT_SIDE+20)
else	;IDE_PRIMARY_ONLY
		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+9) shl 8) + (LEFT_SIDE+20)
endif	;IDE_PRIMARY_ONLY
		test	byte ptr CDROM_Exist_Flag[bp],SM_CDROM
		jz	short @F
		mov	di,2
;R09		call	Display_CDROM
		call	Display_ATAPI		;R09
		jmp	short Show_DriveF
@@:
		test	byte ptr FIXED_ERROR[bp],HDD_Drive2_Err
		jz	short @F
		call	Display_None
		jmp	short Show_DriveF
@@:
		mov	bx,offset HDDE_ITEM
		mov	di,2
		mov	al,es:[HDD_MODE_FLAG]
		shr	al,4
		and	al,3			; get drive E mode (LBA or Normal ...)
		call	SYSCFG_HDD

;---------------- Show Hard Drive F ----------------------
Show_DriveF:

ifndef	IDE_PRIMARY_ONLY
		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+10) shl 8) + (LEFT_SIDE+20)
		test	byte ptr CDROM_Exist_Flag[bp],SS_CDROM
		jz	short @F
		mov	di,3
;R09		call	Display_CDROM
		call	Display_ATAPI		;R09
		jmp	short Show_Drive_End
@@:
		test	byte ptr FIXED_ERROR[bp],HDD_Drive3_Err
		jz	short @F
		call	Display_None
		jmp	short Show_Drive_End
@@:
		mov	bx,offset HDDF_ITEM
		mov	di,3
		mov	al,es:[HDD_MODE_FLAG]
		shr	al,6
		and	al,3			; get drive F mode (LBA or Normal ...)
		call	SYSCFG_HDD
Show_Drive_End:

endif	;IDE_PRIMARY_ONLY
endif	;Support_4_IDE

;---------------- Show Base Memory --------------------

		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+1) shl 8) + (RIGHT_SIDE+20)
		xor	eax,eax
		mov	ax,CMOS15[bp]	;BASE_MEMORY[bp]
		call	short SYSCFG_Mem

;---------------- Show Extended Memory --------------------

		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+2) shl 8) + (RIGHT_SIDE+20)
		mov	eax,EXT_MEM_SIZE[bp]
		call	SYSCFG_Mem

;---------------- Show Cache Size --------------------------

ifdef	Skip_Cache_Size_If_None
		F000_call	Get_Cache_Size
		or	al,al
		jz	SYSCFG_Cache_Mem_Exit
endif	;Skip_Cache_Size_If_None

		push	cs
		pop	ds
		mov	si, offset Cache_Mem_Size_Str
		post_func_call	Disp_Str_In_BIOS

		mov	si,offset ExtCache_Item
;R06		post_func_call	F000_GetItem_Value
		call	X_GetItem_Value				;R06
		or	al,al
		jz	short Disp_Cache_None

;Get L2 cache size by execute CPUID (0fh,0A2h) for P6
; bit 3-0 = 42H : 256k
;	    43H : 512k
		mov	al,byte ptr FIXED_DISK_STEP[bp]
		and	al,CPU_TYPE_MASK
		cmp	al,TYPE_P6	      	;P6 CPU ?
		jne	short Not_P6_CPU

		mov	eax,2			;read cache isze
		db	0Fh,0A2h		;OP code: CPUID

		post_func_call	Convert_P6L2_Cache	;convert cache size

	   	jmp	short Show_L2_Size
Not_P6_CPU:

		F000_call	Get_Cache_Size

Show_L2_Size:

		or	al,al
		jnz	short @F
Disp_Cache_None:
		add	byte ptr CURSOR_X[bp],3
		call	Display_None
		jmp	short SYSCFG_Cache_Mem_Exit
	@@:
		add	byte ptr CURSOR_X[bp],1
		mov	cl,al
		dec	cl
		mov	ax,16
		shl	ax,cl
		F000_call	Disp_Word_Int5
		mov	al,'K'
		post_func_call	F000_Display_Char

SYSCFG_Cache_Mem_Exit:

ifdef	MP_SUPPORT
ifdef	P6_BIOS_ONLY	

;Display secondary CPU's L2 cache size if dual CPUs are plugged

;R02A		call	If_MP_PLUGGED 		;2 CPUs installed ?
		post_func_call	If_MP_PLUGGED 		;R02A 2 CPUs installed ?
		jc	short SYSCFG_Cache_Mem_Exit1;no, no display

		mov	al,'/'
		post_func_call	F000_Display_Char
		
		push	es
		xor	ax,ax					
		mov	es,ax					
		mov	dl,byte ptr es:[0502H]		;get cache size	
		pop	es
		
;R02A		call	Convert_P6L2_Cache	;convert cache size
		post_func_call	Convert_P6L2_Cache	;R02A ;convert cache size

		or	al,al
		jnz	short @F

		call	Display_None
		jmp	short SYSCFG_Cache_Mem_Exit1
	@@:
		mov	cl,al
		dec	cl
		mov	ax,16
		shl	ax,cl
		F000_call	Disp_Word_Int5
		mov	al,'K'
		post_func_call	F000_Display_Char

SYSCFG_Cache_Mem_Exit1:

endif;	P6_BIOS_ONLY	
endif;	MP_SUPPORT

;---------------- Show Display Type ----------------------

		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+5) shl 8) + (RIGHT_SIDE+20)
		mov	bx,offset Video_Item
		call	Show_CMOS_Str

;---------------- Show Serial Ports -----------------------

		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+6) shl 8) + (RIGHT_SIDE+20)
		mov	si,offset G_RAM:COMM_PORT_ADDRS
		mov	di,offset G_RAM:PRNTR_PORT_ADDRS
		call	SYSCFG_Ports

;---------------- Show Parallel Ports -----------------------

		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+7) shl 8) + (RIGHT_SIDE+20)
		mov	si,offset G_RAM:PRNTR_PORT_ADDRS
		mov	di,offset G_RAM:EXT_SEGMENT
		call	SYSCFG_Ports

;-------------- Show OEM dependent message ----------------------

ifdef	Support_4_IDE
ifdef	IDE_PRIMARY_ONLY
		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+11) shl 8) + (RIGHT_SIDE+20)
else	;IDE_PRIMARY_ONLY
		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+13) shl 8) + (RIGHT_SIDE+20)
endif	;IDE_PRIMARY_ONLY
else	;Support_4_IDE

		mov	word ptr CURSOR_X[bp],((SYSTEM_Y+11) shl 8) + (RIGHT_SIDE+20)

endif	;Support_4_IDE
;-------------- Show HDD S.M.A.R.T. Function message ------------
ifdef	HDD_SMART_Support
		call	show_HDD_smart			;R07
endif	;HDD_SMART_Support

IFDEF	NoteBook_Power_Management
;R02		call	Show_PM_Config
		POST_func_call	Show_PM_Config	    	;R02
ENDIF	;NoteBook_Power_Management

		F000_CALL Ct_Show_Config

ifndef	No_Show_PCI_Device
ifdef	PCI_BUS
		push	0f000H
		pop	ds
		lea	si,SYSTEM1_BYTE
		test	byte ptr [si],02H		;display PCI dev.
		jnz	short No_PciDisplay

		call	Show_PCI_Device

No_PciDisplay:
endif	;PCI_BUS
endif	;No_Show_PCI_Device

;-------------- End of showing System Configuration ----------------------

		F000_call	Vcrlf

		pop	es
		pop	ds
		ret
Show_System_Cfg Endp

Not_Install_Str db	'Not Installed',0
Install_Str	db	'Installed',0
None_Str	db	'None',0
CDROM_Str	db	'CDROM',0
ARMD_Str	db	'LS-120',0
IOMEGA_ZIP_Str	db	'ZIP-100',0
MB_Str		db	'MB',0
HDD_Mode_Str	db	',Mode',0
ifdef	Ultra_DMA33_support
HDD_UDMA_Str	db	',UDMA',0
endif	;Ultra_DMA33_support
;R07 start
ifdef	HDD_SMART_Support
HDD_SMART_TBL:
		dw	offset PriMast_Str
		dw	offset PriSlav_Str
		dw	offset SecMast_Str
		dw	offset SecSlav_Str
PriMast_Str:	db	'Primary Master   ',0
PriSlav_Str:	db	'Primary Slave    ',0
SecMast_Str:	db	'Secondary Master ',0
SecSlav_Str:	db	'Secondary Slave  ',0
HDD_SMART_Str:	db	'HDD S.M.A.R.T. capablity .... ',0
Enable_Str:	db	'Enabled',0
Disable_Str:	db	'Disabled',0
endif	;Support_HDD_SMART
;R07 end

		LEFT_SIDE	EQU	2
		RIGHT_SIDE	EQU	42
		SYSTEM_Y	EQU	2
		PERI_Y		EQU	SYSTEM_Y+4
System_Config_Msg:
		POS	<,30,0>
		db	V_WARN,'Award Software, Inc.'
		POS	<,29,1>
		db	V_WARN,'System Configurations'

ifdef	Support_4_IDE
ifdef	IDE_PRIMARY_ONLY
		BORDER1 <,0,SYSTEM_Y,79,SYSTEM_Y+9,1>
else	;IDE_PRIMARY_ONLY
 ifndef	Config_Tbl_Lines				             ;R05
		BORDER1 <,0,SYSTEM_Y,79,SYSTEM_Y+11,1>		
 else	;Config_Tbl_Lines					     ;R05
		BORDER1 <,0,SYSTEM_Y,79,SYSTEM_Y+Config_Tbl_Lines,1> ;R05
 endif	;Config_Tbl_Lines					     ;R05
endif	;IDE_PRIMARY_ONLY
else	;Support_4_IDE
		BORDER1 <,0,SYSTEM_Y,79,SYSTEM_Y+9,1>
endif	;Support_4_IDE

		BORDER1 <,1,PERI_Y,78,PERI_Y,0>
		POS	<,0,PERI_Y>
		db	''
		POS	<,79,PERI_Y>
		db	''

		POS	<,LEFT_SIDE,SYSTEM_Y+1>
		db	'CPU Type'
		ADDX	<,10>
		db	':'

		POS	<,LEFT_SIDE,SYSTEM_Y+2>
		db	'Co-Processor'
		ADDX	<,6>
		db	':'

ifndef	NO_CPU_CLOCK_DISPLAY
		POS	<,LEFT_SIDE,SYSTEM_Y+3>
		db	'CPU Clock'
		ADDX	<,9>
		db	':'
endif;	NO_CPU_CLOCK_DISPLAY

		POS	<,RIGHT_SIDE,SYSTEM_Y+1>
		db	'Base Memory'
		ADDX	<,7>
		db	':'

		POS	<,RIGHT_SIDE,SYSTEM_Y+2>
		db	'Extended Memory'
		ADDX	<,3>
		db	':'

		POS	<,LEFT_SIDE,PERI_Y+1>
		db	'Diskette Drive  A :'

ifndef	Support_1_FDD
		POS	<,LEFT_SIDE,PERI_Y+2>
		db	'Diskette Drive  B :'
endif	;Support_1_FDD

ifdef	Support_4_IDE
		POS	<,LEFT_SIDE,PERI_Y+3>
		db	'Pri. Master  Disk :'

ifdef	IDE_PRIMARY_ONLY
		POS	<,LEFT_SIDE,PERI_Y+4>
		db	'Sec. Master  Disk :'
else	;IDE_PRIMARY_ONLY
		POS	<,LEFT_SIDE,PERI_Y+4>
		db	'Pri. Slave   Disk :'

		POS	<,LEFT_SIDE,PERI_Y+5>
		db	'Sec. Master  Disk :'

		POS	<,LEFT_SIDE,PERI_Y+6>
		db	'Sec. Slave   Disk :'
endif	;IDE_PRIMARY_ONLY

else;	Support_4_IDE
		POS	<,LEFT_SIDE,PERI_Y+3>
		db	'Hard Disk Drive C :'

ifndef	IDE_PRIMARY_ONLY
		POS	<,LEFT_SIDE,PERI_Y+4>
		db	'Hard Disk Drive D :'
endif	;IDE_PRIMARY_ONLY
endif;	Support_4_IDE

		POS	<,RIGHT_SIDE,PERI_Y+1>
		db	'Display Type'
		ADDX	<,6>
		db	':'

		POS	<,RIGHT_SIDE,PERI_Y+2>
		db	'Serial Port(s)'
		ADDX	<,4>
		db	':'

		POS	<,RIGHT_SIDE,PERI_Y+3>
		db	'Parallel Port(s)  :'
		db	0

Cache_Mem_Size_Str:
		POS	<,RIGHT_SIDE,SYSTEM_Y+3>
		db	'Cache Memory'
		ADDX	<,6>
		db	':  '
		db	0

Show_CMOS_Str:
		push	0F000h
		pop	ds
		mov	byte ptr USE_ITEMSTAT_BUF[bp],1
		F000_call  Read_Item_Value
		F000_call  Get_VarString_Offset ;get string to show
		post_func_call	Disp_Str_In_BIOS
		ret
SYSCFG_Ports:
		mov	ax,es:[si]
		or	ax,ax
		jz	Display_None	;128k

SYSCFG_Ports_1:
		mov	ax,es:[si]
		inc	si
		inc	si
		or	ax,ax
		jz	short @F
		pusha
		F000_call AX_To_HEX3
		F000_call SHOW_Six_Digit
		inc	byte ptr CURSOR_X[bp]
		popa
		cmp	si,di
		jb	short SYSCFG_Ports_1
	@@:
		ret

SYSCFG_Mem:
		F000_call Disp_Dword_Int6
		mov	al,'K'
		post_func_call	F000_Display_Char
		ret

		public	SysCfg_CPU_Clock1
SysCfg_CPU_Clock1:

ifndef	NO_CPU_CLOCK_DISPLAY
		push	ds
		push	cs
		pop	ds

		mov	ax,CPU_INT_CLOCK[bp]

;Show 133Mhz if 132Mhz detected
		cmp	al,132
		jne	short Not_132
		mov	al,133
Not_132:

		push	ax
		F000_call	AX_To_DEC3
		pop	ax
		cmp	ax,100
		jae	short @F
		sub	byte ptr CURSOR_X[bp],1
	@@:
		F000_call	Show_SIX_DIGIT

		mov	si,offset Str_Mhz
		post_func_call	Disp_Str_In_BIOS
		pop	ds
endif;	NO_CPU_CLOCK_DISPLAY
		ret

;R09Display_CDROM:
Display_ATAPI:					;R09
		push	ds
		push	cs
		pop	ds
		mov	si,offset CDROM_Str
;R09 start
		mov	cx,di			;R09
		shl	cl,2			;R09
		mov	ax,IDE_device_item[bp]	;R09
		shr	ax,cl			;R09
		and	al,0fh			;R09
		cmp	al,2			;R09
		je	short @F		;R09
;R09 end
;R09		movzx	ax,byte ptr es:[ATAPI_Byte]
;R09		test	al,00000100b		;test ARMD exist?
;R09		jz	short @F
;R09		test	al,00110000b		; have 2 LS120/ZIP100 drive?
;R09		jz	short Only_check_first
;R09		push	ax
;R09		shr	al,4
;R09		and	al,3
;R09		cmp	ax,di
;R09		pop	ax
;R09		mov	ah,80h
;R09		je	short Get_ARMD_Str
;R09Only_check_first:
;R09		and	al,3
;R09		xor	ah,ah
;R09		cmp	ax,di
;R09		jne	short @F
;R09		mov	ah,40h
;R09Get_ARMD_Str:
		mov	si,offset ARMD_Str
		cmp	al,3			;R09 Is LS120?
		je	short @F		;R09 Yes,jump
;R09		test	byte ptr es:[ATAPI_Byte],ah
;R09		jz	short @F
		lea	si,IOMEGA_ZIP_Str
@@:
		post_func_call	Disp_Str_In_BIOS

		call	Show_PIO_UDMA
		pop	ds
		ret
Display_None:
		push	ds
		push	cs
		pop	ds
		mov	si,offset None_Str
		post_func_call	Disp_Str_In_BIOS
		pop	ds
		ret

SYSCFG_HDD:
		F000_call Read_Item_Value
		or	dl,dl
		jz	Display_None
		cmp	dl,46
		jb	short @F
		push	di
		push	dx
		F000_call	Get_HDD_CMOS_Info
		cmp	word ptr [bp+di+0],0		;CYLINDER
		pop	dx
		pop	di
		je	short Display_None
@@:

		push	cs
		pop	ds

		mov	ch,al
		F000_call	Disp_Access_mode
		call	Show_PIO_UDMA

SHOW_HDD_SIZE:
		mov	al,','
		post_func_call	F000_Display_Char
;-------------------
;calculate HDD size
;-------------------
		F000_call	Get_HDD_CMOS_Info
		push	ds
		push	bx
		jnz	short Get_User_Type
		movzx	ax,byte ptr [bp+si]		;Hdd type no.
		dec	al
		shl	ax,4
		mov	bx,offset HDISK_PARMS
		add	bx,ax
		push	0f000h
		pop	ds
		movzx	ax,byte ptr [bx+2]		;heads
		movzx	cx,byte ptr [bx+14]		;sectors
		mov	bx,[bx]				;cylinders
		jmp	short Disp_HDD_Size
Get_User_Type:
		movzx	ax,byte ptr [bp+di+2]		;heads
		movzx	cx,byte ptr [bp+di+7]		;sectors
		mov	bx,[bp+di+0]			;cylinders
Disp_HDD_Size:
		shl	cx,2
		mul	cx
		mul	bx
		pop	bx
		pop	ds
		mov	cx,15625/2
		div	cx
		mov	HDDSIZE[bp],ax
		F000_call Disp_Word_Int5
		mov	si,offset MB_Str
		post_func_call	Disp_Str_In_BIOS
		ret

ifdef	NEW_IDE_MODE_3
IdeMode_Item:
		dw      offset IdeA_Mode_Item
		dw      offset IdeB_Mode_Item
 ifdef	Support_4_IDE					;R03
 ifndef  ONCHIP_2ND_ALWAYS_DISABLE			;R08
		dw      offset IdeC_Mode_Item
		dw      offset IdeD_Mode_Item
 endif;  ONCHIP_2ND_ALWAYS_DISABLE			;R08
 endif;	Support_4_IDE					;R03
endif	;NEW_IDE_MODE_3

Show_PIO_UDMA:
ifdef	NEW_IDE_MODE_3
ifdef	Ultra_DMA33_support
		cmp	byte ptr HDD_0_UltraDMA[bp+di],0ffh
		je	short @F
		mov	si,offset HDD_UDMA_Str
		post_func_call	Disp_Str_In_BIOS
		add	di,HDD_0_UltraDMA
		jmp	short Show_Mode
@@:
endif	;Ultra_DMA33_support
		mov	si,offset HDD_Mode_Str
		post_func_call	Disp_Str_In_BIOS
		mov     si,di
		shl	si,1
		add	si,offset cs:IdeMode_Item
		mov     si,cs:[si]
;R06		post_func_call	F000_GetItem_Value
		call	X_GetItem_Value				;R06
		sub	al,1				;auto ?
		jnc	short Mode_Not_Auto
		add	di,HDD_0_MODE
Show_Mode:
		mov	al,[bp+di]
Mode_Not_Auto:
		F000_call	AX_To_DEC2
		F000_call	Show_SIX_DIGIT
endif	;NEW_IDE_MODE_3
		ret

Str_Mhz 	db	'MHz',0
;R07 Strat
ifdef	HDD_SMART_Support
Show_HDD_smart:
		push	ds
		pushad
		push	cs
		pop	ds
 		mov	cx,4
		xor	bx,bx
		mov	al,byte	ptr HDD_Smart_flag[bp]
Show_Smart_loop:
		push	ax
		and	al,03h
		jz	short Show_Smart_Next
		call	Show_Smart_Status		;Primary Master
Show_Smart_Next:
		pop	ax
		shr	al,2
		add	bx,2
		loop	short show_smart_loop
  		popad
		pop	ds
		ret
;[]==============================================================[]
;	Show Smart Status
;Input:	HDD_Smart_flag[bp]      	
;	bx=Which device
;	al=device status
;	   00=no install
;	   01=none capability
;	   10=disable S.M.A.R.T.
;	   11=enable S.M.A.R.T.						
;[]==============================================================[]
Show_Smart_Status:	
		push	ax
		mov	byte ptr CURSOR_X[bp],0		
		mov	si, word ptr cs:[HDD_SMART_TBL+BX]	;Show primary/secondary
		post_func_call	Disp_Str_In_BIOS
		mov	si,offset HDD_SMART_Str 
	       	post_func_call	Disp_Str_In_BIOS
		pop	ax
		cmp	al,01
		mov	si,offset None_Str		;display "None"
		jbe	short @F
		mov	si,offset Disable_Str		;display "Disable"
		cmp	al,02
		jbe	short @F
		mov	si,offset Enable_Str		;display "Enable"
@@:
	       	post_func_call	Disp_Str_In_BIOS
		inc	byte ptr CURSOR_Y[bp]		
		ret		
endif;	HDD_SMART_Support
;R07 end

ifndef	No_Show_PCI_Device
ifdef	PCI_BUS
Show_PCI_Device	proc	near
		push	ds
		pushad

		push	cs
		pop	ds

		mov	byte ptr CURSOR_X[bp],0
		inc	byte ptr CURSOR_Y[bp]

		mov	si,offset DEV
		call	F000_Display_String

		mov	byte ptr CURSOR_X[bp],0
		inc	byte ptr CURSOR_Y[bp]

		and	Post_Temp_Byte[BP], NOT 80h;Init flag for VGA found

		xor	si, si			;First Device
		xor	bh, bh			;Start from Bus 0
Next_Bus:

		xor	bl, bl			;Start from Device 0
Disp_PCI_Device:
		push	bx			;Save Bus&Slot No.
		shl	bl, 3			;Device Number in upper 5 bits

		mov	di, 0Ch			;Get PCI Device header type
		call	Get_PCI_CFG
		shr	eax, 16			;AL=add. 0E=Heater type
		xor	ch, ch			;Assume last func=0
		test	al, 80h
		jz	short Single_Func

		mov	ch, 07			;Device is multi func.
Single_Func:

		xor	cl, cl			;Start from Function 0
Next_Func:
		cmp	cl, ch			;Last function encountered
		ja	Next_Dev		;Yes, above last function

		push	cx
		and	bl, not 07h
		or	bl, cl

		mov	di, 4			;Get PCI Device command reg.
		call	Get_PCI_CFG
		test	al, 03h			;PCI Device disabled?
		jz	Skip_Show_PCI

		mov	di, 8			;Get Clase Code
		call	Get_PCI_CFG
		ror	eax, 16
		cmp	ax, 0001h		;compatible VGA?
		je	short _uha4		;yes
		ror	eax, 16
		rol	eax, 8
		cmp	al, 06h			;Bridge Device?
		jne	short not_host_bridge
		push	eax
		rol	eax,8
		cmp	al,07h
		pop	eax
		jne	Skip_Show_PCI
not_host_bridge:

		cmp	al, 03h			;Display control?
		jne	short Not_Vga
	_uha4:
		test	byte ptr Post_Temp_Byte[BP], 80h
		jnz	Skip_Show_PCI

		or	byte ptr Post_Temp_Byte[BP], 80h;Display controlere 
							;   found
Not_Vga:

		mov	di, 08h
		call	Get_PCI_CFG		;Get Class Code
		cmp	al, 0FFh		;No Device?
		je	Skip_Show_PCI

		xor	di, di
		call	Get_PCI_CFG		;Get Vendor&Device ID
		cmp	ax, 0FFFFh		;No Device?
		je	Skip_Show_PCI

		or	si, si			;First Device be showed
		jnz	short No_Show_PCI_Field	;No

		pushad

		mov	si,offset PCI_Field	;Show table head at first
		pusha				;   PCI device
		call	F000_Display_String
		popa

		mov	byte ptr CURSOR_X[bp],0
		inc	byte ptr CURSOR_Y[bp]
		mov	al,196
		mov	cx,80
	@@:
		post_func_call	F000_Display_Char
		loop	short @B

		call	Get_Cursor_Pos
		inc	dh
		xor	dl, dl
		call	Set_Cursor_Pos

		popad
No_Show_PCI_Field:

		pop	si			;Get Func No
		pop	di			;Get current Bus No and
		push	di			;  Device No
		push	si			;Save Func No

		push	eax			;Save Vendor&Device ID

		mov	byte ptr CURSOR_X[bp],2

		mov	ax, di
		xchg	ah, al
		call	F000_DISP_BYTE_INT2	;Display Bus No

		mov	byte ptr CURSOR_X[bp], 11

		xchg	ah, al
		call	F000_DISP_BYTE_INT2	;Display Device No

		mov	byte ptr CURSOR_X[bp], 21
		mov	al, bl
		and	al, 07
		call	F000_DISP_BYTE_INT2	;Function No

		pop	eax 			;Restore Vendor&Device ID

		pusha
		mov	byte ptr CURSOR_X[bp], 31
		F000_call	DISP_WORD_HEX4	;Display Vendor ID
		popa

		shr	eax, 16
		pusha
		mov	byte ptr CURSOR_X[bp], 43
		F000_call	DISP_WORD_HEX4	;Display Device ID
		popa

		mov	di, 8
		call	Get_PCI_CFG		;Get Class Code
		shr	eax, 16
		cmp	ax, 0001h		;compatible VGA ?
		jne	short _uy7a		;no !
		mov	ax, 0300h
_uy7a:
		mov	si, ax
		mov	al, ah

		cmp	al,MAX_CLS_NO		;check if valid class code
		jbe	short Good_ClsCode	;yes, show it
		xor	al,al			;no, set unknown device
Good_ClsCode:

		cmp	si, 0101h
		mov	si, offset IDE_DEV
		je	short Show_Dev

		xor	ah, ah
		shl	ax, 1
		push	bx
		mov	bx, ax
		mov	si, word ptr cs:[DEV_TBL+BX]
		pop	bx
Show_Dev:

		cmp	si, offset DEV0C
		jne	short Not_DEV0C
		pusha
		mov	di, 08h
		call	Get_PCI_CFG		;Get Class Code
		shr	eax,16			;Get Sub-Class Code
		cmp	al,05h			;Is ACPI?
		popa
		jne	short Not_DEV0C		;No, skip
		mov	si, offset DEV0C05
Not_DEV0C:
		cmp	si, offset DEV06
		jne	short Not_DEV06
		pusha
		mov	di, 08h
		call	Get_PCI_CFG		;Get Class Code
		shr	eax,16			;Get Sub-Class Code
		cmp	al,07h			;Is Cardbus?
		popa
		jne	short Not_DEV06		;No, skip
		mov	si, offset DEV0607
Not_DEV06:
		pusha
		mov	byte ptr CURSOR_X[bp], 52
		call	F000_Display_String
		popa

		pusha
		mov	byte ptr CURSOR_X[bp], 76
		cmp	si, offset IDE_DEV
		mov	al, 14
		je	short Show_IRQ

		mov	di, 3ch
		call	Get_PCI_CFG		;Get Interrupt Line
		or	al, al
		jz	short IRQ_NA

		cmp	al, 0fh
		ja	short IRQ_NA

Show_IRQ:

		call	F000_DISP_BYTE_INT2	;Display Slot No

		jmp	short End_IRQ_Show
IRQ_NA:
		mov	si, offset NA_Str
		call	F000_Display_String
End_IRQ_Show:
		call	Get_Cursor_Pos

ifdef	NO_SHOW_IDE_DEVICE
		cmp	si, offset IDE_DEV
		je	short NO_SHOW_IDE_DEV
endif;	NO_SHOW_IDE_DEVICE

		inc	dh
NO_SHOW_IDE_DEV:
		xor	dl,dl
		call	Set_Cursor_Pos

		popa

Skip_Show_PCI:
		pop	cx
		inc	cl
		jmp	Next_Func

Next_Dev:
		pop	bx			;Restore Bus&Device

		inc	bl
		cmp	bl, 32
		jb	Disp_PCI_Device

ifndef	NO_MULTI_PCI_SUPPORT			
endif	;NO_MULTI_PCI_SUPPORT			

ifndef	NO_MULTI_PCI_SUPPORT			
	ifdef	CONFIG_MECHANISM_1			
		inc	bh
		db	9ah		;-- far call fProc_Qualify_PciBus --
		dw	offset fProc_Qualify_PciBus
		dw	0f000h		;-------------------
		jnc	Next_Bus
	endif	;CONFIG_MECHANISM_1
endif	;NO_MULTI_PCI_SUPPORT			

		call	Get_Cursor_Pos
		inc	dh
		xor	dl,dl
		call	Set_Cursor_Pos

		popad
		pop	ds

		ret
Show_PCI_Device	endp

;Input:	DH - Row
;	DL - Column
;Output:None
;Description:Set the cursor position, if Row=23 then scroll up screen and 
;	     Row=22
Set_Cursor_Pos:
		pusha
		cmp	dh, 23
		jb	short No_Scroll

		push	dx

		mov	ax, 0601h	;Screen scroll up
		mov	bh, ATTRIBUTE[bp]
		mov	cx, (0 shl 8)  + 0
		mov	dx, (24 shl 8) + 79
		int	10h

		pop	dx
		dec	dh
No_Scroll:
		mov	word ptr CURSOR_X[bp], dx

		mov	ah, 02h		;Set Crusor position
		xor	bh, bh
		int	10h

		popa
		ret

;Input :Nnone
;Output:DH - Row
;	DL - Column
;Description:Get the cursor position
Get_Cursor_Pos:
		pusha

		mov	ah, 03h
		xor	bh, bh
		int	10h

		ror	edx, 16

		popa

		ror	edx, 16
		ret

F000_Disp_Byte_INT2:
		pusha
		F000_CALL	Disp_Byte_INT2
		popa
		ret

F000_Display_String:
		F000_call	Display_String
		ret

Get_PCI_CFG:
		push	ecx
		push	bx
		push	di

		mov	ax, 0b10ah
		int	1ah

		mov	eax, ecx
		pop	di
		pop	bx
		pop	ecx
		ret

PCI_Field:
db "Bus No. Device No. Func No. Vendor ID   Device ID   Device Class           IRQ", 0
;R301E PCI_Border:	BORDER1 <,0,16,79,16,0>

DEV_TBL:
		dw	offset DEV00
		dw	offset DEV01
		dw	offset DEV02
		dw	offset DEV03
		dw	offset DEV04
		dw	offset DEV05
		dw	offset DEV06
		dw	offset DEV07
		dw	offset DEV08
		dw	offset DEV09
		dw	offset DEV0A
		dw	offset DEV0B
		dw	offset DEV0C
MAX_CLS_NO	EQU	($ - offset DEV_TBL)/2 - 1

DEV:		db	"PCI device listing.....", 0
DEV00:		db	"Unknown PCI Device",0
DEV01:		db	"Mass Storage Controller",0
DEV02:		db	"Network Controller",0
DEV03:		db	"Display Controller",0
DEV04:		db	"Multimedia Device",0
DEV05:		db	"Memory Montroller",0
DEV06:		db	"Bridge Device",0
DEV07:		db	"Simple COMM. Controller",0
DEV08:		db	"Base System Peripherals", 0
DEV09:		db	"Input Device",0
DEV0A:		db	"Docking Stations",0
DEV0B:		db	"Processors", 0
DEV0C:		db	"Serial Bus Controller",0
IDE_DEV		db	"IDE Controller",0
NA_Str		db	"NA",0
DEV0C05		db	"SMBus Controller",0
DEV0607		db	"PCI/CardBus bridge",0
endif	;PCI_BUS
endif	;No_Show_PCI_Device
;R01 end

;R06 - starts
		Public	X_GetItem_Value
X_GetItem_Value	Proc	Near
		F000_Call GetItem_Value
		ret
X_GetItem_Value	Endp
;R06 - ends

XCODE		ENDS
		END
